#line 1 "ad_loongarch_gen.cpp"
//
// Copyright (c) 2003, 2013, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2015, 2022, Loongson Technology. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_loongarch.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"
#include "opto/rootnode.hpp"


//------------------------- MachOper Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachOper *State::MachOperGenerator(int opcode){

  switch(opcode) {
  case UNIVERSE:
    return new UniverseOper( );
  case LABEL:
    return new labelOper( );
  case SREGI:
    return new sRegIOper( );
  case SREGP:
    return new sRegPOper( );
  case SREGF:
    return new sRegFOper( );
  case SREGD:
    return new sRegDOper( );
  case SREGL:
    return new sRegLOper( );
  case METHOD:
    return new methodOper( );
  case VECX:
    return new vecXOper( );
  case VECY:
    return new vecYOper( );
  case FLAGSREG:
    return new FlagsRegOper( );
  case IMMI:
    return new immIOper(_leaf->get_int() );
  case IMMIU1:
    return new immIU1Oper(_leaf->get_int() );
  case IMMIU2:
    return new immIU2Oper(_leaf->get_int() );
  case IMMIU3:
    return new immIU3Oper(_leaf->get_int() );
  case IMMIU4:
    return new immIU4Oper(_leaf->get_int() );
  case IMMIU5:
    return new immIU5Oper(_leaf->get_int() );
  case IMMIU6:
    return new immIU6Oper(_leaf->get_int() );
  case IMMIU8:
    return new immIU8Oper(_leaf->get_int() );
  case IMMI10:
    return new immI10Oper(_leaf->get_int() );
  case IMMI12:
    return new immI12Oper(_leaf->get_int() );
  case IMMI_M65536:
    return new immI_M65536Oper(_leaf->get_int() );
  case IMMI_M1:
    return new immI_M1Oper(_leaf->get_int() );
  case IMMI_0:
    return new immI_0Oper(_leaf->get_int() );
  case IMMI_1:
    return new immI_1Oper(_leaf->get_int() );
  case IMMI_2:
    return new immI_2Oper(_leaf->get_int() );
  case IMMI_16:
    return new immI_16Oper(_leaf->get_int() );
  case IMMI_24:
    return new immI_24Oper(_leaf->get_int() );
  case IMMI_32:
    return new immI_32Oper(_leaf->get_int() );
  case IMMI_255:
    return new immI_255Oper(_leaf->get_int() );
  case IMMI_65535:
    return new immI_65535Oper(_leaf->get_int() );
  case IMMI_MAXI:
    return new immI_MaxIOper(_leaf->get_int() );
  case IMMI_M2047_2048:
    return new immI_M2047_2048Oper(_leaf->get_int() );
  case IMMI_0_3:
    return new immI_0_3Oper(_leaf->get_int() );
  case IMMI_0_31:
    return new immI_0_31Oper(_leaf->get_int() );
  case IMMI_0_4095:
    return new immI_0_4095Oper(_leaf->get_int() );
  case IMMI_1_4:
    return new immI_1_4Oper(_leaf->get_int() );
  case IMMI_32_63:
    return new immI_32_63Oper(_leaf->get_int() );
  case IMMI_M128_255:
    return new immI_M128_255Oper(_leaf->get_int() );
  case IMMI_NONNEG_MASK:
    return new immI_nonneg_maskOper(_leaf->get_int() );
  case IMML:
    return new immLOper(_leaf->get_long() );
  case IMMLU5:
    return new immLU5Oper(_leaf->get_long() );
  case IMML10:
    return new immL10Oper(_leaf->get_long() );
  case IMML12:
    return new immL12Oper(_leaf->get_long() );
  case IMML32:
    return new immL32Oper(_leaf->get_long() );
  case IMML_M121:
    return new immL_M121Oper(_leaf->get_long() );
  case IMML_M8:
    return new immL_M8Oper(_leaf->get_long() );
  case IMML_M7:
    return new immL_M7Oper(_leaf->get_long() );
  case IMML_M5:
    return new immL_M5Oper(_leaf->get_long() );
  case IMML_M4:
    return new immL_M4Oper(_leaf->get_long() );
  case IMML_0:
    return new immL_0Oper(_leaf->get_long() );
  case IMML_7:
    return new immL_7Oper(_leaf->get_long() );
  case IMML_MAXUI:
    return new immL_MaxUIOper(_leaf->get_long() );
  case IMML_M2047_2048:
    return new immL_M2047_2048Oper(_leaf->get_long() );
  case IMML_0_4095:
    return new immL_0_4095Oper(_leaf->get_long() );
  case IMML_NONNEG_MASK:
    return new immL_nonneg_maskOper(_leaf->get_long() );
  case IMMP:
    return new immPOper(_leaf->bottom_type()->is_ptr() );
  case IMMP_0:
    return new immP_0Oper(_leaf->bottom_type()->is_ptr() );
  case IMMP_NO_OOP_CHEAP:
    return new immP_no_oop_cheapOper(_leaf->bottom_type()->is_ptr() );
  case IMMN:
    return new immNOper(_leaf->bottom_type()->is_narrowoop() );
  case IMMN_0:
    return new immN_0Oper(_leaf->bottom_type()->is_narrowoop() );
  case IMMNKLASS:
    return new immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
  case IMMF:
    return new immFOper(_leaf->getf() );
  case IMMF_0:
    return new immF_0Oper(_leaf->getf() );
  case IMMD:
    return new immDOper(_leaf->getd() );
  case IMMD_0:
    return new immD_0Oper(_leaf->getd() );
  case MREGI:
    return new mRegIOper( );
  case NO_AX_MREGI:
    return new no_Ax_mRegIOper( );
  case MS0REGI:
    return new mS0RegIOper( );
  case MS1REGI:
    return new mS1RegIOper( );
  case MS3REGI:
    return new mS3RegIOper( );
  case MS4REGI:
    return new mS4RegIOper( );
  case MS5REGI:
    return new mS5RegIOper( );
  case MS6REGI:
    return new mS6RegIOper( );
  case MS7REGI:
    return new mS7RegIOper( );
  case MT0REGI:
    return new mT0RegIOper( );
  case MT1REGI:
    return new mT1RegIOper( );
  case MT2REGI:
    return new mT2RegIOper( );
  case MT3REGI:
    return new mT3RegIOper( );
  case MT8REGI:
    return new mT8RegIOper( );
  case MT4REGI:
    return new mT4RegIOper( );
  case MA0REGI:
    return new mA0RegIOper( );
  case MA1REGI:
    return new mA1RegIOper( );
  case MA2REGI:
    return new mA2RegIOper( );
  case MA3REGI:
    return new mA3RegIOper( );
  case MA4REGI:
    return new mA4RegIOper( );
  case MA5REGI:
    return new mA5RegIOper( );
  case MA6REGI:
    return new mA6RegIOper( );
  case MA7REGI:
    return new mA7RegIOper( );
  case MREGN:
    return new mRegNOper( );
  case T0_REGN:
    return new t0_RegNOper( );
  case T1_REGN:
    return new t1_RegNOper( );
  case T3_REGN:
    return new t3_RegNOper( );
  case T8_REGN:
    return new t8_RegNOper( );
  case A0_REGN:
    return new a0_RegNOper( );
  case A1_REGN:
    return new a1_RegNOper( );
  case A2_REGN:
    return new a2_RegNOper( );
  case A3_REGN:
    return new a3_RegNOper( );
  case A4_REGN:
    return new a4_RegNOper( );
  case A5_REGN:
    return new a5_RegNOper( );
  case A6_REGN:
    return new a6_RegNOper( );
  case A7_REGN:
    return new a7_RegNOper( );
  case S0_REGN:
    return new s0_RegNOper( );
  case S1_REGN:
    return new s1_RegNOper( );
  case S2_REGN:
    return new s2_RegNOper( );
  case S3_REGN:
    return new s3_RegNOper( );
  case S4_REGN:
    return new s4_RegNOper( );
  case S5_REGN:
    return new s5_RegNOper( );
  case S6_REGN:
    return new s6_RegNOper( );
  case S7_REGN:
    return new s7_RegNOper( );
  case MREGP:
    return new mRegPOper( );
  case NO_T8_MREGP:
    return new no_T8_mRegPOper( );
  case NO_AX_MREGP:
    return new no_Ax_mRegPOper( );
  case S1_REGP:
    return new s1_RegPOper( );
  case S3_REGP:
    return new s3_RegPOper( );
  case S4_REGP:
    return new s4_RegPOper( );
  case S5_REGP:
    return new s5_RegPOper( );
  case S6_REGP:
    return new s6_RegPOper( );
  case S7_REGP:
    return new s7_RegPOper( );
  case T0_REGP:
    return new t0_RegPOper( );
  case T1_REGP:
    return new t1_RegPOper( );
  case T2_REGP:
    return new t2_RegPOper( );
  case T3_REGP:
    return new t3_RegPOper( );
  case T8_REGP:
    return new t8_RegPOper( );
  case A0_REGP:
    return new a0_RegPOper( );
  case A1_REGP:
    return new a1_RegPOper( );
  case A2_REGP:
    return new a2_RegPOper( );
  case A3_REGP:
    return new a3_RegPOper( );
  case A4_REGP:
    return new a4_RegPOper( );
  case A5_REGP:
    return new a5_RegPOper( );
  case A6_REGP:
    return new a6_RegPOper( );
  case A7_REGP:
    return new a7_RegPOper( );
  case V0_REGP:
    return new v0_RegPOper( );
  case V1_REGP:
    return new v1_RegPOper( );
  case MREGL:
    return new mRegLOper( );
  case MREGI2L:
    return new mRegI2LOper( );
  case MREGL2I:
    return new mRegL2IOper( );
  case V0REGL:
    return new v0RegLOper( );
  case V1REGL:
    return new v1RegLOper( );
  case A0REGL:
    return new a0RegLOper( );
  case A1REGL:
    return new a1RegLOper( );
  case A2REGL:
    return new a2RegLOper( );
  case A3REGL:
    return new a3RegLOper( );
  case T0REGL:
    return new t0RegLOper( );
  case T1REGL:
    return new t1RegLOper( );
  case T3REGL:
    return new t3RegLOper( );
  case T8REGL:
    return new t8RegLOper( );
  case A4REGL:
    return new a4RegLOper( );
  case A5REGL:
    return new a5RegLOper( );
  case A6REGL:
    return new a6RegLOper( );
  case A7REGL:
    return new a7RegLOper( );
  case S0REGL:
    return new s0RegLOper( );
  case S1REGL:
    return new s1RegLOper( );
  case S3REGL:
    return new s3RegLOper( );
  case S4REGL:
    return new s4RegLOper( );
  case S7REGL:
    return new s7RegLOper( );
  case REGF:
    return new regFOper( );
  case REGD:
    return new regDOper( );
  case INDIRECT:
    return new indirectOper( );
  case INDOFFSET12:
    return new indOffset12Oper(_kids[1]->_leaf->get_long() );
  case INDOFFSET12I2L:
    return new indOffset12I2LOper(_kids[1]->_kids[0]->_leaf->get_int() );
  case INDINDEX:
    return new indIndexOper( );
  case INDINDEXI2L:
    return new indIndexI2LOper( );
  case INDIRECTNARROW:
    return new indirectNarrowOper( );
  case INDOFFSET12NARROW:
    return new indOffset12NarrowOper(_kids[1]->_leaf->get_long() );
  case CMPOP:
    return new cmpOpOper(_leaf->as_Bool()->_test._test );
  case CMPOPEQNE:
    return new cmpOpEqNeOper(_leaf->as_Bool()->_test._test );
  case STACKSLOTP:
    return new stackSlotPOper( );
  case STACKSLOTI:
    return new stackSlotIOper( );
  case STACKSLOTF:
    return new stackSlotFOper( );
  case STACKSLOTD:
    return new stackSlotDOper( );
  case STACKSLOTL:
    return new stackSlotLOper( );
  case _CONVI2L_IMMI12_:    return NULL;
  case _CONVI2L_MREGI_:    return NULL;
  case _DECODEN_MREGN_:    return NULL;
  case _LOADI_MEMORY_:    return NULL;
  case _LSHIFTI__LOADI_MEMORY__IMMI_24:    return NULL;
  case _LSHIFTI__LOADI_MEMORY__IMMI_16:    return NULL;
  case _LOADN_MEMORY_:    return NULL;
  case _LOADNKLASS_MEMORY_:    return NULL;
  case _ENCODEP_MREGP_:    return NULL;
  case _ENCODEPKLASS_MREGP_:    return NULL;
  case _LOADB_MEMORY_:    return NULL;
  case _LOADUB_MEMORY_:    return NULL;
  case _LOADS_MEMORY_:    return NULL;
  case _LSHIFTI__LOADS_MEMORY__IMMI_24:    return NULL;
  case _CMPI_MREGI_MREGI:    return NULL;
  case _CMPI_MREGI_IMMI:    return NULL;
  case _CMPP_MREGP_IMMP_0:    return NULL;
  case _CMPP__DECODEN_MREGN__IMMP_0:    return NULL;
  case _CMPP_MREGP_MREGP:    return NULL;
  case _CMPN_MREGN_IMMN_0:    return NULL;
  case _CMPN_MREGN_MREGN:    return NULL;
  case _CMPU_MREGI_MREGI:    return NULL;
  case _CMPU_MREGI_IMMI:    return NULL;
  case _CMPL_MREGLORI2L_MREGLORI2L:    return NULL;
  case _CMPUL_MREGLORI2L_MREGLORI2L:    return NULL;
  case _CMPL_MREGL_IMML:    return NULL;
  case _CMPUL_MREGL_IMML:    return NULL;
  case _CMPF_REGF_REGF:    return NULL;
  case _CMPD_REGD_REGD:    return NULL;
  case _BINARY_CMPOP__CMPI_MREGI_MREGI:    return NULL;
  case _BINARY_MREGI_MREGI:    return NULL;
  case _BINARY_CMPOP__CMPP_MREGP_MREGP:    return NULL;
  case _BINARY_CMPOP__CMPN_MREGN_MREGN:    return NULL;
  case _BINARY_CMPOP__CMPU_MREGI_MREGI:    return NULL;
  case _BINARY_MREGP_MREGP:    return NULL;
  case _BINARY_CMPOP__CMPF_REGF_REGF:    return NULL;
  case _BINARY_MREGN_MREGN:    return NULL;
  case _BINARY_CMPOP__CMPD_REGD_REGD:    return NULL;
  case _BINARY_CMPOP__CMPL_MREGLORI2L_MREGLORI2L:    return NULL;
  case _BINARY_MREGI_MREGIORL2I:    return NULL;
  case _BINARY_CMPOP__CMPUL_MREGLORI2L_MREGLORI2L:    return NULL;
  case _BINARY_MREGL_MREGL:    return NULL;
  case _CMPL_MREGL_MREGL:    return NULL;
  case _BINARY_CMPOP__CMPL_MREGL_MREGL:    return NULL;
  case _CMPUL_MREGL_MREGL:    return NULL;
  case _BINARY_CMPOP__CMPUL_MREGL_MREGL:    return NULL;
  case _BINARY_REGD_REGD:    return NULL;
  case _BINARY_REGF_REGF:    return NULL;
  case _BINARY_A4_REGP_MA5REGI:    return NULL;
  case _BINARY_A6_REGP_MA7REGI:    return NULL;
  case _BINARY_A6_REGP_IMMI_1_4:    return NULL;
  case _BINARY_A6_REGP_IMMI_1:    return NULL;
  case _BINARY_A5_REGP_MA6REGI:    return NULL;
  case _BINARY_A4_REGP_A5_REGP:    return NULL;
  case _LSHIFTI_MREGI_IMMI_1_4:    return NULL;
  case _ANDL_MREGLORI2L_IMML_M8:    return NULL;
  case _LSHIFTL__CONVI2L_MREGI__IMMI_1_4:    return NULL;
  case _CONVF2D_REGF_:    return NULL;
  case _SQRTD__CONVF2D_REGF__:    return NULL;
  case _NEGF_REGF_:    return NULL;
  case _NEGD_REGD_:    return NULL;
  case _BINARY__NEGF_REGF__REGF:    return NULL;
  case _BINARY_REGF__NEGF_REGF_:    return NULL;
  case _BINARY__NEGD_REGD__REGD:    return NULL;
  case _BINARY_REGD__NEGD_REGD_:    return NULL;
  case _BINARY_REGD_IMMD_0:    return NULL;
  case _XORI_MREGI_IMMI_M1:    return NULL;
  case _ANDL_MREGL_IMML_0_4095:    return NULL;
  case _CASTP2X_MREGP_:    return NULL;
  case _LSHIFTI_MREGI_IMMI_16:    return NULL;
  case _ANDL_MREGL_IMML_7:    return NULL;
  case _CONVL2I__ANDL_MREGL_IMML_7_:    return NULL;
  case _LSHIFTI__CONVL2I__ANDL_MREGL_IMML_7__IMMI_16:    return NULL;
  case _LSHIFTI_MREGI_IMMI_24:    return NULL;
  case _CONVL2I_MREGL_:    return NULL;
  case _RSHIFTL_MREGLORI2L_IMMI_32_63:    return NULL;
  case _URSHIFTL_MREGLORI2L_IMMI_0_31:    return NULL;
  case _CONVL2I__URSHIFTL_MREGLORI2L_IMMI_0_31_:    return NULL;
  case _URSHIFTL_MREGLORI2L_IMMI_32_63:    return NULL;
  case _URSHIFTI_MREGI_IMMI_0_31:    return NULL;
  case _ANDI_MREGI_IMMI_1:    return NULL;
  case _LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31:    return NULL;
  case _LSHIFTI_MREGI_IMMI_0_31:    return NULL;
  case _LSHIFTL_MREGLORI2L_IMMI_32_63:    return NULL;
  case _LSHIFTL_MREGLORI2L_IMMI_0_31:    return NULL;
  case _LOADUS_MEMORY_:    return NULL;
  case _LSHIFTL_MREGLORI2L_IMMI_0_3:    return NULL;
  case _ANDL__CONVI2L_MREGI__IMML_MAXUI:    return NULL;
  case _LSHIFTL__CONVI2L_MREGI__IMMI_32:    return NULL;
  case _CONVI2L__CONVL2I_MREGL__:    return NULL;
  case _CONVI2L__LOADI_MEMORY__:    return NULL;
  case _LOADL_MEMORY_:    return NULL;
  case _REPLICATEB_IMMIU5_:    return NULL;
  case _REPLICATES_IMMIU5_:    return NULL;
  case _REPLICATEI_IMMIU5_:    return NULL;
  case _REPLICATEL_IMMLU5_:    return NULL;
  case _SUBVI_VECX_VECX:    return NULL;
  case _SUBVL_VECX_VECX:    return NULL;
  case _SUBVI_VECY_VECY:    return NULL;
  case _SUBVL_VECY_VECY:    return NULL;
  case _MULVB_VECX_VECX:    return NULL;
  case _MULVS_VECX_VECX:    return NULL;
  case _MULVI_VECX_VECX:    return NULL;
  case _MULVL_VECX_VECX:    return NULL;
  case _BINARY_VECX_VECX:    return NULL;
  case _MULVB_VECY_VECY:    return NULL;
  case _MULVS_VECY_VECY:    return NULL;
  case _MULVI_VECY_VECY:    return NULL;
  case _MULVL_VECY_VECY:    return NULL;
  case _BINARY_VECY_VECY:    return NULL;
  case _NEGVF_VECX_:    return NULL;
  case _NEGVD_VECX_:    return NULL;
  case _NEGVF_VECY_:    return NULL;
  case _NEGVD_VECY_:    return NULL;
  case _BINARY__NEGVF_VECX__VECX:    return NULL;
  case _BINARY_VECX__NEGVF_VECX_:    return NULL;
  case _BINARY__NEGVD_VECX__VECX:    return NULL;
  case _BINARY_VECX__NEGVD_VECX_:    return NULL;
  case _BINARY__NEGVF_VECY__VECY:    return NULL;
  case _BINARY_VECY__NEGVF_VECY_:    return NULL;
  case _BINARY__NEGVD_VECY__VECY:    return NULL;
  case _BINARY_VECY__NEGVD_VECY_:    return NULL;
  case _LSHIFTCNTV_IMMI_:    return NULL;
  case _RSHIFTCNTV_IMMI_:    return NULL;
  case _REPLICATEB_IMMIU8_:    return NULL;
  case _ORV_VECX_VECX:    return NULL;
  case _REPLICATEB_IMMI_M1_:    return NULL;
  case _REPLICATES_IMMI_M1_:    return NULL;
  case _REPLICATEI_IMMI_M1_:    return NULL;
  case _ORV_VECX__REPLICATEB_IMMIU8_:    return NULL;
  case _ORV__REPLICATEB_IMMIU8__VECX:    return NULL;
  case _ORV_VECY_VECY:    return NULL;
  case _ORV_VECY__REPLICATEB_IMMIU8_:    return NULL;
  case _ORV__REPLICATEB_IMMIU8__VECY:    return NULL;
  case _XORV_VECX__REPLICATEB_IMMI_M1_:    return NULL;
  case _XORV__REPLICATEB_IMMI_M1__VECX:    return NULL;
  case _XORV_VECX__REPLICATES_IMMI_M1_:    return NULL;
  case _XORV__REPLICATES_IMMI_M1__VECX:    return NULL;
  case _XORV_VECX__REPLICATEI_IMMI_M1_:    return NULL;
  case _XORV__REPLICATEI_IMMI_M1__VECX:    return NULL;
  case _XORV_VECY__REPLICATEB_IMMI_M1_:    return NULL;
  case _XORV__REPLICATEB_IMMI_M1__VECY:    return NULL;
  case _XORV_VECY__REPLICATES_IMMI_M1_:    return NULL;
  case _XORV__REPLICATES_IMMI_M1__VECY:    return NULL;
  case _XORV_VECY__REPLICATEI_IMMI_M1_:    return NULL;
  case _XORV__REPLICATEI_IMMI_M1__VECY:    return NULL;
  case _BINARY_VECX_MREGI:    return NULL;
  case _BINARY_VECX_MREGL:    return NULL;
  case _BINARY_VECX_REGF:    return NULL;
  case _BINARY_VECX_REGD:    return NULL;
  case _BINARY_VECY_MREGI:    return NULL;
  case _BINARY_VECY_MREGL:    return NULL;
  case _BINARY_VECY_REGF:    return NULL;
  case _BINARY_VECY_REGD:    return NULL;
  
  default:
    fprintf(stderr, "Default MachOper Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  }
  return NULL;
};


//------------------------- MachNode Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachNode *State::MachNodeGenerator(int opcode){
  switch(opcode) {
  case loadI_rule: {
      loadINode *node = new loadINode();
      return node;
    }
  case loadI_convI2L_rule: {
      loadI_convI2LNode *node = new loadI_convI2LNode();
      return node;
    }
  case loadI2B_rule: {
      loadI2BNode *node = new loadI2BNode();
      return node;
    }
  case loadI2UB_rule: {
      loadI2UBNode *node = new loadI2UBNode();
      return node;
    }
  case loadI2S_rule: {
      loadI2SNode *node = new loadI2SNode();
      return node;
    }
  case loadI2US_rule: {
      loadI2USNode *node = new loadI2USNode();
      return node;
    }
  case loadL_rule: {
      loadLNode *node = new loadLNode();
      return node;
    }
  case loadL_unaligned_rule: {
      loadL_unalignedNode *node = new loadL_unalignedNode();
      return node;
    }
  case storeL_reg_rule: {
      storeL_regNode *node = new storeL_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_reg_volatile_rule: {
      storeL_reg_volatileNode *node = new storeL_reg_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_immL_0_rule: {
      storeL_immL_0Node *node = new storeL_immL_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_immL_0_volatile_rule: {
      storeL_immL_0_volatileNode *node = new storeL_immL_0_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN_rule: {
      loadNNode *node = new loadNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN2P_rule: {
      loadN2PNode *node = new loadN2PNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadP_rule: {
      loadPNode *node = new loadPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadKlass_rule: {
      loadKlassNode *node = new loadKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadNKlass_rule: {
      loadNKlassNode *node = new loadNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN2PKlass_rule: {
      loadN2PKlassNode *node = new loadN2PKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConI_rule: {
      loadConINode *node = new loadConINode();
      node->_opnd_array[1] = new immIOper(_leaf->get_int() );
      return node;
    }
  case loadConL_rule: {
      loadConLNode *node = new loadConLNode();
      node->_opnd_array[1] = new immLOper(_leaf->get_long() );
      return node;
    }
  case loadRange_rule: {
      loadRangeNode *node = new loadRangeNode();
      return node;
    }
  case storeP_rule: {
      storePNode *node = new storePNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP_volatile_rule: {
      storeP_volatileNode *node = new storeP_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmP_immP_0_rule: {
      storeImmP_immP_0Node *node = new storeImmP_immP_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmP_immP_0_volatile_rule: {
      storeImmP_immP_0_volatileNode *node = new storeImmP_immP_0_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeN_rule: {
      storeNNode *node = new storeNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeN_volatile_rule: {
      storeN_volatileNode *node = new storeN_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP2N_rule: {
      storeP2NNode *node = new storeP2NNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP2N_volatile_rule: {
      storeP2N_volatileNode *node = new storeP2N_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeNKlass_rule: {
      storeNKlassNode *node = new storeNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeNKlass_volatile_rule: {
      storeNKlass_volatileNode *node = new storeNKlass_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP2NKlass_rule: {
      storeP2NKlassNode *node = new storeP2NKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP2NKlass_volatile_rule: {
      storeP2NKlass_volatileNode *node = new storeP2NKlass_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmN_immN_0_rule: {
      storeImmN_immN_0Node *node = new storeImmN_immN_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmN_immN_0_volatile_rule: {
      storeImmN_immN_0_volatileNode *node = new storeImmN_immN_0_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeB_immB_0_rule: {
      storeB_immB_0Node *node = new storeB_immB_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeB_rule: {
      storeBNode *node = new storeBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadB_rule: {
      loadBNode *node = new loadBNode();
      return node;
    }
  case loadB_convI2L_rule: {
      loadB_convI2LNode *node = new loadB_convI2LNode();
      return node;
    }
  case loadUB_rule: {
      loadUBNode *node = new loadUBNode();
      return node;
    }
  case loadUB_convI2L_rule: {
      loadUB_convI2LNode *node = new loadUB_convI2LNode();
      return node;
    }
  case loadS_rule: {
      loadSNode *node = new loadSNode();
      return node;
    }
  case loadS2B_rule: {
      loadS2BNode *node = new loadS2BNode();
      return node;
    }
  case loadS_convI2L_rule: {
      loadS_convI2LNode *node = new loadS_convI2LNode();
      return node;
    }
  case storeI_immI_0_rule: {
      storeI_immI_0Node *node = new storeI_immI_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_immI_0_volatile_rule: {
      storeI_immI_0_volatileNode *node = new storeI_immI_0_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_rule: {
      storeINode *node = new storeINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_volatile_rule: {
      storeI_volatileNode *node = new storeI_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadF_rule: {
      loadFNode *node = new loadFNode();
      return node;
    }
  case loadConP_general_rule: {
      loadConP_generalNode *node = new loadConP_generalNode();
      node->_opnd_array[1] = new immPOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP_no_oop_cheap_rule: {
      loadConP_no_oop_cheapNode *node = new loadConP_no_oop_cheapNode();
      node->_opnd_array[1] = new immP_no_oop_cheapOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP_immP_0_rule: {
      loadConP_immP_0Node *node = new loadConP_immP_0Node();
      node->_opnd_array[1] = new immP_0Oper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConN_immN_0_rule: {
      loadConN_immN_0Node *node = new loadConN_immN_0Node();
      node->_opnd_array[1] = new immN_0Oper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConN_rule: {
      loadConNNode *node = new loadConNNode();
      node->_opnd_array[1] = new immNOper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConNKlass_rule: {
      loadConNKlassNode *node = new loadConNKlassNode();
      node->_opnd_array[1] = new immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
      return node;
    }
  case TailCalljmpInd_rule: {
      TailCalljmpIndNode *node = new TailCalljmpIndNode();
      return node;
    }
  case CreateException_rule: {
      CreateExceptionNode *node = new CreateExceptionNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case RethrowException_rule: {
      RethrowExceptionNode *node = new RethrowExceptionNode();
      return node;
    }
  case jmpDir_long_rule: {
      jmpDir_longNode *node = new jmpDir_longNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL));
      return node;
    }
  case jmpLoopEnd_long_rule: {
      jmpLoopEnd_longNode *node = new jmpLoopEnd_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEnd_reg_immI_long_rule: {
      jmpLoopEnd_reg_immI_longNode *node = new jmpLoopEnd_reg_immI_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpCon_flags_long_rule: {
      jmpCon_flags_longNode *node = new jmpCon_flags_longNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConP_0_long_rule: {
      branchConP_0_longNode *node = new branchConP_0_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConN2P_0_long_rule: {
      branchConN2P_0_longNode *node = new branchConN2P_0_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConP_long_rule: {
      branchConP_longNode *node = new branchConP_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_null_branch_long_rule: {
      cmpN_null_branch_longNode *node = new cmpN_null_branch_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_reg_branch_long_rule: {
      cmpN_reg_branch_longNode *node = new cmpN_reg_branch_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConIU_reg_reg_long_rule: {
      branchConIU_reg_reg_longNode *node = new branchConIU_reg_reg_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConIU_reg_imm_long_rule: {
      branchConIU_reg_imm_longNode *node = new branchConIU_reg_imm_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConI_reg_reg_long_rule: {
      branchConI_reg_reg_longNode *node = new branchConI_reg_reg_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConI_reg_imm_long_rule: {
      branchConI_reg_imm_longNode *node = new branchConI_reg_imm_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConL_regL_regL_long_rule: {
      branchConL_regL_regL_longNode *node = new branchConL_regL_regL_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConUL_regL_regL_long_rule: {
      branchConUL_regL_regL_longNode *node = new branchConUL_regL_regL_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConL_regL_immL_long_rule: {
      branchConL_regL_immL_longNode *node = new branchConL_regL_immL_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConUL_regL_immL_long_rule: {
      branchConUL_regL_immL_longNode *node = new branchConUL_regL_immL_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConF_reg_reg_long_rule: {
      branchConF_reg_reg_longNode *node = new branchConF_reg_reg_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConD_reg_reg_long_rule: {
      branchConD_reg_reg_longNode *node = new branchConD_reg_reg_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpDir_short_rule: {
      jmpDir_shortNode *node = new jmpDir_shortNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL));
      return node;
    }
  case jmpLoopEnd_short_rule: {
      jmpLoopEnd_shortNode *node = new jmpLoopEnd_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEnd_reg_immI_short_rule: {
      jmpLoopEnd_reg_immI_shortNode *node = new jmpLoopEnd_reg_immI_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpCon_flags_short_rule: {
      jmpCon_flags_shortNode *node = new jmpCon_flags_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConP_0_short_rule: {
      branchConP_0_shortNode *node = new branchConP_0_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConN2P_0_short_rule: {
      branchConN2P_0_shortNode *node = new branchConN2P_0_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConP_short_rule: {
      branchConP_shortNode *node = new branchConP_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_null_branch_short_rule: {
      cmpN_null_branch_shortNode *node = new cmpN_null_branch_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_reg_branch_short_rule: {
      cmpN_reg_branch_shortNode *node = new cmpN_reg_branch_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConIU_reg_reg_short_rule: {
      branchConIU_reg_reg_shortNode *node = new branchConIU_reg_reg_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConIU_reg_imm_short_rule: {
      branchConIU_reg_imm_shortNode *node = new branchConIU_reg_imm_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConI_reg_reg_short_rule: {
      branchConI_reg_reg_shortNode *node = new branchConI_reg_reg_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConI_reg_imm_short_rule: {
      branchConI_reg_imm_shortNode *node = new branchConI_reg_imm_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConL_regL_regL_short_rule: {
      branchConL_regL_regL_shortNode *node = new branchConL_regL_regL_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConUL_regL_regL_short_rule: {
      branchConUL_regL_regL_shortNode *node = new branchConUL_regL_regL_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConL_regL_immL_short_rule: {
      branchConL_regL_immL_shortNode *node = new branchConL_regL_immL_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConUL_regL_immL_short_rule: {
      branchConUL_regL_immL_shortNode *node = new branchConUL_regL_immL_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConF_reg_reg_short_rule: {
      branchConF_reg_reg_shortNode *node = new branchConF_reg_reg_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConD_reg_reg_short_rule: {
      branchConD_reg_reg_shortNode *node = new branchConD_reg_reg_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case CallRuntimeDirect_rule: {
      CallRuntimeDirectNode *node = new CallRuntimeDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case unnecessary_membar_acquire_rule: {
      unnecessary_membar_acquireNode *node = new unnecessary_membar_acquireNode();
      return node;
    }
  case membar_acquire_rule: {
      membar_acquireNode *node = new membar_acquireNode();
      return node;
    }
  case load_fence_rule: {
      load_fenceNode *node = new load_fenceNode();
      return node;
    }
  case membar_acquire_lock_rule: {
      membar_acquire_lockNode *node = new membar_acquire_lockNode();
      return node;
    }
  case unnecessary_membar_release_rule: {
      unnecessary_membar_releaseNode *node = new unnecessary_membar_releaseNode();
      return node;
    }
  case membar_release_rule: {
      membar_releaseNode *node = new membar_releaseNode();
      return node;
    }
  case store_fence_rule: {
      store_fenceNode *node = new store_fenceNode();
      return node;
    }
  case membar_release_lock_rule: {
      membar_release_lockNode *node = new membar_release_lockNode();
      return node;
    }
  case unnecessary_membar_volatile_rule: {
      unnecessary_membar_volatileNode *node = new unnecessary_membar_volatileNode();
      return node;
    }
  case membar_volatile_rule: {
      membar_volatileNode *node = new membar_volatileNode();
      return node;
    }
  case membar_storestore_rule: {
      membar_storestoreNode *node = new membar_storestoreNode();
      return node;
    }
  case membar_storestore_0_rule: {
      membar_storestore_0Node *node = new membar_storestore_0Node();
      return node;
    }
  case castX2P_rule: {
      castX2PNode *node = new castX2PNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castP2X_rule: {
      castP2XNode *node = new castP2XNode();
      return node;
    }
  case MoveF2I_reg_reg_rule: {
      MoveF2I_reg_regNode *node = new MoveF2I_reg_regNode();
      return node;
    }
  case MoveI2F_reg_reg_rule: {
      MoveI2F_reg_regNode *node = new MoveI2F_reg_regNode();
      return node;
    }
  case MoveD2L_reg_reg_rule: {
      MoveD2L_reg_regNode *node = new MoveD2L_reg_regNode();
      return node;
    }
  case MoveL2D_reg_reg_rule: {
      MoveL2D_reg_regNode *node = new MoveL2D_reg_regNode();
      return node;
    }
  case cmovI_cmpI_reg_reg_rule: {
      cmovI_cmpI_reg_regNode *node = new cmovI_cmpI_reg_regNode();
      return node;
    }
  case cmovI_cmpI_reg_reg2_rule: {
      cmovI_cmpI_reg_reg2Node *node = new cmovI_cmpI_reg_reg2Node();
      return node;
    }
  case cmovI_cmpI_dst_reg_rule: {
      cmovI_cmpI_dst_regNode *node = new cmovI_cmpI_dst_regNode();
      return node;
    }
  case cmovI_cmpP_reg_reg_rule: {
      cmovI_cmpP_reg_regNode *node = new cmovI_cmpP_reg_regNode();
      return node;
    }
  case cmovI_cmpN_reg_reg_rule: {
      cmovI_cmpN_reg_regNode *node = new cmovI_cmpN_reg_regNode();
      return node;
    }
  case cmovP_cmpU_reg_reg_rule: {
      cmovP_cmpU_reg_regNode *node = new cmovP_cmpU_reg_regNode();
      return node;
    }
  case cmovP_cmpF_reg_reg_rule: {
      cmovP_cmpF_reg_regNode *node = new cmovP_cmpF_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD));
      node->set_opnd_array(7, MachOperGenerator(REGD));
      return node;
    }
  case cmovP_cmpN_reg_reg_rule: {
      cmovP_cmpN_reg_regNode *node = new cmovP_cmpN_reg_regNode();
      return node;
    }
  case cmovN_cmpP_reg_reg_rule: {
      cmovN_cmpP_reg_regNode *node = new cmovN_cmpP_reg_regNode();
      return node;
    }
  case cmovP_cmpD_reg_reg_rule: {
      cmovP_cmpD_reg_regNode *node = new cmovP_cmpD_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD));
      node->set_opnd_array(7, MachOperGenerator(REGD));
      return node;
    }
  case cmovN_cmpN_reg_reg_rule: {
      cmovN_cmpN_reg_regNode *node = new cmovN_cmpN_reg_regNode();
      return node;
    }
  case cmovI_cmpU_reg_reg_rule: {
      cmovI_cmpU_reg_regNode *node = new cmovI_cmpU_reg_regNode();
      return node;
    }
  case cmovI_cmpL_reg_reg_rule: {
      cmovI_cmpL_reg_regNode *node = new cmovI_cmpL_reg_regNode();
      return node;
    }
  case cmovI_cmpUL_reg_reg_rule: {
      cmovI_cmpUL_reg_regNode *node = new cmovI_cmpUL_reg_regNode();
      return node;
    }
  case cmovP_cmpL_reg_reg_rule: {
      cmovP_cmpL_reg_regNode *node = new cmovP_cmpL_reg_regNode();
      return node;
    }
  case cmovP_cmpUL_reg_reg_rule: {
      cmovP_cmpUL_reg_regNode *node = new cmovP_cmpUL_reg_regNode();
      return node;
    }
  case cmovI_cmpD_reg_reg_rule: {
      cmovI_cmpD_reg_regNode *node = new cmovI_cmpD_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD));
      node->set_opnd_array(7, MachOperGenerator(REGD));
      return node;
    }
  case cmovP_cmpP_reg_reg_rule: {
      cmovP_cmpP_reg_regNode *node = new cmovP_cmpP_reg_regNode();
      return node;
    }
  case cmovP_cmpI_reg_reg_rule: {
      cmovP_cmpI_reg_regNode *node = new cmovP_cmpI_reg_regNode();
      return node;
    }
  case cmovL_cmpP_reg_reg_rule: {
      cmovL_cmpP_reg_regNode *node = new cmovL_cmpP_reg_regNode();
      return node;
    }
  case cmovN_cmpU_reg_reg_rule: {
      cmovN_cmpU_reg_regNode *node = new cmovN_cmpU_reg_regNode();
      return node;
    }
  case cmovN_cmpL_reg_reg_rule: {
      cmovN_cmpL_reg_regNode *node = new cmovN_cmpL_reg_regNode();
      return node;
    }
  case cmovN_cmpUL_reg_reg_rule: {
      cmovN_cmpUL_reg_regNode *node = new cmovN_cmpUL_reg_regNode();
      return node;
    }
  case cmovN_cmpI_reg_reg_rule: {
      cmovN_cmpI_reg_regNode *node = new cmovN_cmpI_reg_regNode();
      return node;
    }
  case cmovL_cmpU_reg_reg_rule: {
      cmovL_cmpU_reg_regNode *node = new cmovL_cmpU_reg_regNode();
      return node;
    }
  case cmovL_cmpF_reg_reg_rule: {
      cmovL_cmpF_reg_regNode *node = new cmovL_cmpF_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD));
      node->set_opnd_array(7, MachOperGenerator(REGD));
      return node;
    }
  case cmovL_cmpI_reg_reg_rule: {
      cmovL_cmpI_reg_regNode *node = new cmovL_cmpI_reg_regNode();
      return node;
    }
  case cmovL_cmpL_reg_reg_rule: {
      cmovL_cmpL_reg_regNode *node = new cmovL_cmpL_reg_regNode();
      return node;
    }
  case cmovL_cmpUL_reg_reg_rule: {
      cmovL_cmpUL_reg_regNode *node = new cmovL_cmpUL_reg_regNode();
      return node;
    }
  case cmovL_cmpL_reg_reg2_rule: {
      cmovL_cmpL_reg_reg2Node *node = new cmovL_cmpL_reg_reg2Node();
      return node;
    }
  case cmovL_cmpUL_reg_reg2_rule: {
      cmovL_cmpUL_reg_reg2Node *node = new cmovL_cmpUL_reg_reg2Node();
      return node;
    }
  case cmovL_cmpL_dst_reg_rule: {
      cmovL_cmpL_dst_regNode *node = new cmovL_cmpL_dst_regNode();
      return node;
    }
  case cmovL_cmpUL_dst_reg_rule: {
      cmovL_cmpUL_dst_regNode *node = new cmovL_cmpUL_dst_regNode();
      return node;
    }
  case cmovL_cmpN_reg_reg_rule: {
      cmovL_cmpN_reg_regNode *node = new cmovL_cmpN_reg_regNode();
      return node;
    }
  case cmovL_cmpD_reg_reg_rule: {
      cmovL_cmpD_reg_regNode *node = new cmovL_cmpD_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD));
      node->set_opnd_array(7, MachOperGenerator(REGD));
      return node;
    }
  case cmovD_cmpD_reg_reg_rule: {
      cmovD_cmpD_reg_regNode *node = new cmovD_cmpD_reg_regNode();
      return node;
    }
  case cmovF_cmpI_reg_reg_rule: {
      cmovF_cmpI_reg_regNode *node = new cmovF_cmpI_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGF));
      node->set_opnd_array(7, MachOperGenerator(REGF));
      return node;
    }
  case cmovD_cmpI_reg_reg_rule: {
      cmovD_cmpI_reg_regNode *node = new cmovD_cmpI_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGF));
      node->set_opnd_array(7, MachOperGenerator(REGF));
      return node;
    }
  case cmovD_cmpP_reg_reg_rule: {
      cmovD_cmpP_reg_regNode *node = new cmovD_cmpP_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGF));
      node->set_opnd_array(7, MachOperGenerator(REGF));
      return node;
    }
  case cmovI_cmpF_reg_reg_rule: {
      cmovI_cmpF_reg_regNode *node = new cmovI_cmpF_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD));
      node->set_opnd_array(7, MachOperGenerator(REGD));
      return node;
    }
  case cmovF_cmpF_reg_reg_rule: {
      cmovF_cmpF_reg_regNode *node = new cmovF_cmpF_reg_regNode();
      return node;
    }
  case cmpL3_reg_zero_rule: {
      cmpL3_reg_zeroNode *node = new cmpL3_reg_zeroNode();
      return node;
    }
  case cmpL3_reg_reg_rule: {
      cmpL3_reg_regNode *node = new cmpL3_reg_regNode();
      return node;
    }
  case cmpF3_reg_reg_rule: {
      cmpF3_reg_regNode *node = new cmpF3_reg_regNode();
      return node;
    }
  case cmpD3_reg_reg_rule: {
      cmpD3_reg_regNode *node = new cmpD3_reg_regNode();
      return node;
    }
  case clear_array_rule: {
      clear_arrayNode *node = new clear_arrayNode();
      return node;
    }
  case clear_array_imm_rule: {
      clear_array_immNode *node = new clear_array_immNode();
      return node;
    }
  case string_compareL_rule: {
      string_compareLNode *node = new string_compareLNode();
      return node;
    }
  case string_compareU_rule: {
      string_compareUNode *node = new string_compareUNode();
      return node;
    }
  case string_compareLU_rule: {
      string_compareLUNode *node = new string_compareLUNode();
      return node;
    }
  case string_compareUL_rule: {
      string_compareULNode *node = new string_compareULNode();
      return node;
    }
  case string_indexofUU_rule: {
      string_indexofUUNode *node = new string_indexofUUNode();
      return node;
    }
  case string_indexofLL_rule: {
      string_indexofLLNode *node = new string_indexofLLNode();
      return node;
    }
  case string_indexofUL_rule: {
      string_indexofULNode *node = new string_indexofULNode();
      return node;
    }
  case string_indexof_conUU_rule: {
      string_indexof_conUUNode *node = new string_indexof_conUUNode();
      return node;
    }
  case string_indexof_conLL_rule: {
      string_indexof_conLLNode *node = new string_indexof_conLLNode();
      return node;
    }
  case string_indexof_conUL_rule: {
      string_indexof_conULNode *node = new string_indexof_conULNode();
      return node;
    }
  case string_indexof_char_rule: {
      string_indexof_charNode *node = new string_indexof_charNode();
      node->set_opnd_array(4, MachOperGenerator(NO_AX_MREGI));
      node->set_opnd_array(5, MachOperGenerator(MREGL));
      node->set_opnd_array(6, MachOperGenerator(MREGL));
      node->set_opnd_array(7, MachOperGenerator(MREGL));
      return node;
    }
  case stringL_indexof_char_rule: {
      stringL_indexof_charNode *node = new stringL_indexof_charNode();
      node->set_opnd_array(4, MachOperGenerator(NO_AX_MREGI));
      node->set_opnd_array(5, MachOperGenerator(MREGL));
      node->set_opnd_array(6, MachOperGenerator(MREGL));
      node->set_opnd_array(7, MachOperGenerator(MREGL));
      return node;
    }
  case has_negatives_rule: {
      has_negativesNode *node = new has_negativesNode();
      return node;
    }
  case string_compress_rule: {
      string_compressNode *node = new string_compressNode();
      node->set_opnd_array(4, MachOperGenerator(NO_AX_MREGI));
      node->set_opnd_array(5, MachOperGenerator(MREGL));
      node->set_opnd_array(6, MachOperGenerator(MREGL));
      node->set_opnd_array(7, MachOperGenerator(MREGL));
      return node;
    }
  case string_inflate_rule: {
      string_inflateNode *node = new string_inflateNode();
      node->set_opnd_array(4, MachOperGenerator(MREGL));
      node->set_opnd_array(5, MachOperGenerator(MREGL));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case string_equals_rule: {
      string_equalsNode *node = new string_equalsNode();
      return node;
    }
  case encode_iso_array_rule: {
      encode_iso_arrayNode *node = new encode_iso_arrayNode();
      node->set_opnd_array(4, MachOperGenerator(NO_AX_MREGI));
      node->set_opnd_array(5, MachOperGenerator(MREGL));
      node->set_opnd_array(6, MachOperGenerator(MREGL));
      node->set_opnd_array(7, MachOperGenerator(MREGL));
      return node;
    }
  case encode_ascii_array_rule: {
      encode_ascii_arrayNode *node = new encode_ascii_arrayNode();
      node->set_opnd_array(4, MachOperGenerator(NO_AX_MREGI));
      node->set_opnd_array(5, MachOperGenerator(MREGL));
      node->set_opnd_array(6, MachOperGenerator(MREGL));
      node->set_opnd_array(7, MachOperGenerator(MREGL));
      return node;
    }
  case addI_Reg_Reg_rule: {
      addI_Reg_RegNode *node = new addI_Reg_RegNode();
      return node;
    }
  case addI_Reg_imm_rule: {
      addI_Reg_immNode *node = new addI_Reg_immNode();
      return node;
    }
  case addI_salI_Reg_Reg_immI_1_4_rule: {
      addI_salI_Reg_Reg_immI_1_4Node *node = new addI_salI_Reg_Reg_immI_1_4Node();
      return node;
    }
  case addI_salI_Reg_Reg_immI_1_4_0_rule: {
      addI_salI_Reg_Reg_immI_1_4_0Node *node = new addI_salI_Reg_Reg_immI_1_4_0Node();
      return node;
    }
  case addP_reg_reg_rule: {
      addP_reg_regNode *node = new addP_reg_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_reg_M8_rule: {
      addP_reg_reg_M8Node *node = new addP_reg_reg_M8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_imm12_rule: {
      addP_reg_imm12Node *node = new addP_reg_imm12Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_salL_Reg_RegI2L_immI_1_4_rule: {
      addP_salL_Reg_RegI2L_immI_1_4Node *node = new addP_salL_Reg_RegI2L_immI_1_4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addL_Reg_Reg_rule: {
      addL_Reg_RegNode *node = new addL_Reg_RegNode();
      return node;
    }
  case addL_Reg_imm_rule: {
      addL_Reg_immNode *node = new addL_Reg_immNode();
      return node;
    }
  case absI_rReg_rule: {
      absI_rRegNode *node = new absI_rRegNode();
      node->set_opnd_array(2, MachOperGenerator(MREGI));
      return node;
    }
  case absL_rReg_rule: {
      absL_rRegNode *node = new absL_rRegNode();
      node->set_opnd_array(2, MachOperGenerator(MREGL));
      return node;
    }
  case subI_Reg_Reg_rule: {
      subI_Reg_RegNode *node = new subI_Reg_RegNode();
      return node;
    }
  case subI_Reg_immI_M2047_2048_rule: {
      subI_Reg_immI_M2047_2048Node *node = new subI_Reg_immI_M2047_2048Node();
      return node;
    }
  case negI_Reg_rule: {
      negI_RegNode *node = new negI_RegNode();
      return node;
    }
  case negL_Reg_rule: {
      negL_RegNode *node = new negL_RegNode();
      return node;
    }
  case subL_Reg_immL_M2047_2048_rule: {
      subL_Reg_immL_M2047_2048Node *node = new subL_Reg_immL_M2047_2048Node();
      return node;
    }
  case subL_Reg_Reg_rule: {
      subL_Reg_RegNode *node = new subL_Reg_RegNode();
      return node;
    }
  case modI_Reg_Reg_rule: {
      modI_Reg_RegNode *node = new modI_Reg_RegNode();
      return node;
    }
  case modL_reg_reg_rule: {
      modL_reg_regNode *node = new modL_reg_regNode();
      return node;
    }
  case mulI_Reg_Reg_rule: {
      mulI_Reg_RegNode *node = new mulI_Reg_RegNode();
      return node;
    }
  case divI_Reg_Reg_rule: {
      divI_Reg_RegNode *node = new divI_Reg_RegNode();
      return node;
    }
  case divF_Reg_Reg_rule: {
      divF_Reg_RegNode *node = new divF_Reg_RegNode();
      return node;
    }
  case divD_Reg_Reg_rule: {
      divD_Reg_RegNode *node = new divD_Reg_RegNode();
      return node;
    }
  case mulL_reg_reg_rule: {
      mulL_reg_regNode *node = new mulL_reg_regNode();
      return node;
    }
  case mulHiL_reg_reg_rule: {
      mulHiL_reg_regNode *node = new mulHiL_reg_regNode();
      return node;
    }
  case divL_reg_reg_rule: {
      divL_reg_regNode *node = new divL_reg_regNode();
      return node;
    }
  case addF_reg_reg_rule: {
      addF_reg_regNode *node = new addF_reg_regNode();
      return node;
    }
  case subF_reg_reg_rule: {
      subF_reg_regNode *node = new subF_reg_regNode();
      return node;
    }
  case addD_reg_reg_rule: {
      addD_reg_regNode *node = new addD_reg_regNode();
      return node;
    }
  case subD_reg_reg_rule: {
      subD_reg_regNode *node = new subD_reg_regNode();
      return node;
    }
  case negF_reg_rule: {
      negF_regNode *node = new negF_regNode();
      return node;
    }
  case negD_reg_rule: {
      negD_regNode *node = new negD_regNode();
      return node;
    }
  case mulF_reg_reg_rule: {
      mulF_reg_regNode *node = new mulF_reg_regNode();
      return node;
    }
  case mulD_reg_reg_rule: {
      mulD_reg_regNode *node = new mulD_reg_regNode();
      return node;
    }
  case absF_reg_rule: {
      absF_regNode *node = new absF_regNode();
      return node;
    }
  case absD_reg_rule: {
      absD_regNode *node = new absD_regNode();
      return node;
    }
  case sqrtD_reg_rule: {
      sqrtD_regNode *node = new sqrtD_regNode();
      return node;
    }
  case sqrtF_reg_rule: {
      sqrtF_regNode *node = new sqrtF_regNode();
      return node;
    }
  case maddF_reg_reg_rule: {
      maddF_reg_regNode *node = new maddF_reg_regNode();
      return node;
    }
  case maddD_reg_reg_rule: {
      maddD_reg_regNode *node = new maddD_reg_regNode();
      return node;
    }
  case msubF_reg_reg_rule: {
      msubF_reg_regNode *node = new msubF_reg_regNode();
      return node;
    }
  case msubD_reg_reg_rule: {
      msubD_reg_regNode *node = new msubD_reg_regNode();
      return node;
    }
  case mnaddF_reg_reg_rule: {
      mnaddF_reg_regNode *node = new mnaddF_reg_regNode();
      return node;
    }
  case mnaddF_reg_reg_0_rule: {
      mnaddF_reg_reg_0Node *node = new mnaddF_reg_reg_0Node();
      return node;
    }
  case mnaddD_reg_reg_rule: {
      mnaddD_reg_regNode *node = new mnaddD_reg_regNode();
      return node;
    }
  case mnaddD_reg_reg_0_rule: {
      mnaddD_reg_reg_0Node *node = new mnaddD_reg_reg_0Node();
      return node;
    }
  case mnsubF_reg_reg_rule: {
      mnsubF_reg_regNode *node = new mnsubF_reg_regNode();
      return node;
    }
  case mnsubF_reg_reg_0_rule: {
      mnsubF_reg_reg_0Node *node = new mnsubF_reg_reg_0Node();
      return node;
    }
  case mnsubD_reg_reg_rule: {
      mnsubD_reg_regNode *node = new mnsubD_reg_regNode();
      return node;
    }
  case mnsubD_reg_reg_0_rule: {
      mnsubD_reg_reg_0Node *node = new mnsubD_reg_reg_0Node();
      return node;
    }
  case copySignF_reg_rule: {
      copySignF_regNode *node = new copySignF_regNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      return node;
    }
  case copySignD_reg_rule: {
      copySignD_regNode *node = new copySignD_regNode();
      node->set_opnd_array(4, MachOperGenerator(REGD));
      return node;
    }
  case andI_Reg_imm_0_4095_rule: {
      andI_Reg_imm_0_4095Node *node = new andI_Reg_imm_0_4095Node();
      return node;
    }
  case andI_Reg_immI_nonneg_mask_rule: {
      andI_Reg_immI_nonneg_maskNode *node = new andI_Reg_immI_nonneg_maskNode();
      return node;
    }
  case andL_Reg_immL_nonneg_mask_rule: {
      andL_Reg_immL_nonneg_maskNode *node = new andL_Reg_immL_nonneg_maskNode();
      return node;
    }
  case xorI_Reg_imm_0_4095_rule: {
      xorI_Reg_imm_0_4095Node *node = new xorI_Reg_imm_0_4095Node();
      return node;
    }
  case xorI_Reg_immI_M1_rule: {
      xorI_Reg_immI_M1Node *node = new xorI_Reg_immI_M1Node();
      return node;
    }
  case xorL_Reg_imm_0_4095_rule: {
      xorL_Reg_imm_0_4095Node *node = new xorL_Reg_imm_0_4095Node();
      return node;
    }
  case lbu_and_lmask_rule: {
      lbu_and_lmaskNode *node = new lbu_and_lmaskNode();
      return node;
    }
  case lbu_and_lmask_0_rule: {
      lbu_and_lmask_0Node *node = new lbu_and_lmask_0Node();
      return node;
    }
  case lbu_and_rmask_rule: {
      lbu_and_rmaskNode *node = new lbu_and_rmaskNode();
      return node;
    }
  case andI_Reg_Reg_rule: {
      andI_Reg_RegNode *node = new andI_Reg_RegNode();
      return node;
    }
  case andnI_Reg_nReg_rule: {
      andnI_Reg_nRegNode *node = new andnI_Reg_nRegNode();
      return node;
    }
  case andnI_Reg_nReg_0_rule: {
      andnI_Reg_nReg_0Node *node = new andnI_Reg_nReg_0Node();
      return node;
    }
  case ornI_Reg_nReg_rule: {
      ornI_Reg_nRegNode *node = new ornI_Reg_nRegNode();
      return node;
    }
  case ornI_Reg_nReg_0_rule: {
      ornI_Reg_nReg_0Node *node = new ornI_Reg_nReg_0Node();
      return node;
    }
  case andnI_nReg_Reg_rule: {
      andnI_nReg_RegNode *node = new andnI_nReg_RegNode();
      return node;
    }
  case andnI_nReg_Reg_0_rule: {
      andnI_nReg_Reg_0Node *node = new andnI_nReg_Reg_0Node();
      return node;
    }
  case ornI_nReg_Reg_rule: {
      ornI_nReg_RegNode *node = new ornI_nReg_RegNode();
      return node;
    }
  case ornI_nReg_Reg_0_rule: {
      ornI_nReg_Reg_0Node *node = new ornI_nReg_Reg_0Node();
      return node;
    }
  case andL_Reg_Reg_rule: {
      andL_Reg_RegNode *node = new andL_Reg_RegNode();
      return node;
    }
  case andL_Reg_imm_0_4095_rule: {
      andL_Reg_imm_0_4095Node *node = new andL_Reg_imm_0_4095Node();
      return node;
    }
  case andL2I_Reg_imm_0_4095_rule: {
      andL2I_Reg_imm_0_4095Node *node = new andL2I_Reg_imm_0_4095Node();
      return node;
    }
  case andL_Reg_immL_M8_rule: {
      andL_Reg_immL_M8Node *node = new andL_Reg_immL_M8Node();
      return node;
    }
  case andL_Reg_immL_M5_rule: {
      andL_Reg_immL_M5Node *node = new andL_Reg_immL_M5Node();
      return node;
    }
  case andL_Reg_immL_M7_rule: {
      andL_Reg_immL_M7Node *node = new andL_Reg_immL_M7Node();
      return node;
    }
  case andL_Reg_immL_M4_rule: {
      andL_Reg_immL_M4Node *node = new andL_Reg_immL_M4Node();
      return node;
    }
  case andL_Reg_immL_M121_rule: {
      andL_Reg_immL_M121Node *node = new andL_Reg_immL_M121Node();
      return node;
    }
  case orL_Reg_Reg_rule: {
      orL_Reg_RegNode *node = new orL_Reg_RegNode();
      return node;
    }
  case orL_Reg_P2XReg_rule: {
      orL_Reg_P2XRegNode *node = new orL_Reg_P2XRegNode();
      return node;
    }
  case orL_Reg_P2XReg_0_rule: {
      orL_Reg_P2XReg_0Node *node = new orL_Reg_P2XReg_0Node();
      return node;
    }
  case xorL_Reg_Reg_rule: {
      xorL_Reg_RegNode *node = new xorL_Reg_RegNode();
      return node;
    }
  case salI_Reg_imm_rule: {
      salI_Reg_immNode *node = new salI_Reg_immNode();
      return node;
    }
  case salI_Reg_imm_and_M65536_rule: {
      salI_Reg_imm_and_M65536Node *node = new salI_Reg_imm_and_M65536Node();
      return node;
    }
  case land7_2_s_rule: {
      land7_2_sNode *node = new land7_2_sNode();
      return node;
    }
  case i2s_rule: {
      i2sNode *node = new i2sNode();
      return node;
    }
  case i2b_rule: {
      i2bNode *node = new i2bNode();
      return node;
    }
  case salI_RegL2I_imm_rule: {
      salI_RegL2I_immNode *node = new salI_RegL2I_immNode();
      return node;
    }
  case salI_Reg_Reg_rule: {
      salI_Reg_RegNode *node = new salI_Reg_RegNode();
      return node;
    }
  case salL_Reg_imm_rule: {
      salL_Reg_immNode *node = new salL_Reg_immNode();
      return node;
    }
  case salL_Reg_Reg_rule: {
      salL_Reg_RegNode *node = new salL_Reg_RegNode();
      return node;
    }
  case sarL_Reg_imm_rule: {
      sarL_Reg_immNode *node = new sarL_Reg_immNode();
      return node;
    }
  case sarL2I_Reg_immI_32_63_rule: {
      sarL2I_Reg_immI_32_63Node *node = new sarL2I_Reg_immI_32_63Node();
      return node;
    }
  case sarL_Reg_Reg_rule: {
      sarL_Reg_RegNode *node = new sarL_Reg_RegNode();
      return node;
    }
  case slrL_Reg_Reg_rule: {
      slrL_Reg_RegNode *node = new slrL_Reg_RegNode();
      return node;
    }
  case slrL_Reg_immI_0_31_rule: {
      slrL_Reg_immI_0_31Node *node = new slrL_Reg_immI_0_31Node();
      return node;
    }
  case slrL_Reg_immI_0_31_and_max_int_rule: {
      slrL_Reg_immI_0_31_and_max_intNode *node = new slrL_Reg_immI_0_31_and_max_intNode();
      return node;
    }
  case slrL_P2XReg_immI_0_31_rule: {
      slrL_P2XReg_immI_0_31Node *node = new slrL_P2XReg_immI_0_31Node();
      return node;
    }
  case slrL_Reg_immI_32_63_rule: {
      slrL_Reg_immI_32_63Node *node = new slrL_Reg_immI_32_63Node();
      return node;
    }
  case slrL_Reg_immI_convL2I_rule: {
      slrL_Reg_immI_convL2INode *node = new slrL_Reg_immI_convL2INode();
      return node;
    }
  case slrL_P2XReg_immI_32_63_rule: {
      slrL_P2XReg_immI_32_63Node *node = new slrL_P2XReg_immI_32_63Node();
      return node;
    }
  case xorI_Reg_Reg_rule: {
      xorI_Reg_RegNode *node = new xorI_Reg_RegNode();
      return node;
    }
  case orI_Reg_imm_rule: {
      orI_Reg_immNode *node = new orI_Reg_immNode();
      return node;
    }
  case orI_Reg_Reg_rule: {
      orI_Reg_RegNode *node = new orI_Reg_RegNode();
      return node;
    }
  case rotI_shr_logical_Reg_rule: {
      rotI_shr_logical_RegNode *node = new rotI_shr_logical_RegNode();
      return node;
    }
  case rotI_shr_logical_Reg_0_rule: {
      rotI_shr_logical_Reg_0Node *node = new rotI_shr_logical_Reg_0Node();
      return node;
    }
  case orI_Reg_castP2X_rule: {
      orI_Reg_castP2XNode *node = new orI_Reg_castP2XNode();
      return node;
    }
  case orI_Reg_castP2X_0_rule: {
      orI_Reg_castP2X_0Node *node = new orI_Reg_castP2X_0Node();
      return node;
    }
  case shr_logical_Reg_imm_rule: {
      shr_logical_Reg_immNode *node = new shr_logical_Reg_immNode();
      return node;
    }
  case shr_logical_Reg_imm_nonneg_mask_rule: {
      shr_logical_Reg_imm_nonneg_maskNode *node = new shr_logical_Reg_imm_nonneg_maskNode();
      return node;
    }
  case rolI_Reg_immI_0_31_rule: {
      rolI_Reg_immI_0_31Node *node = new rolI_Reg_immI_0_31Node();
      return node;
    }
  case rolI_Reg_immI_0_31_0_rule: {
      rolI_Reg_immI_0_31_0Node *node = new rolI_Reg_immI_0_31_0Node();
      return node;
    }
  case rolL_Reg_immI_0_31_rule: {
      rolL_Reg_immI_0_31Node *node = new rolL_Reg_immI_0_31Node();
      return node;
    }
  case rolL_Reg_immI_0_31_0_rule: {
      rolL_Reg_immI_0_31_0Node *node = new rolL_Reg_immI_0_31_0Node();
      return node;
    }
  case rolL_Reg_immI_32_63_rule: {
      rolL_Reg_immI_32_63Node *node = new rolL_Reg_immI_32_63Node();
      return node;
    }
  case rolL_Reg_immI_32_63_0_rule: {
      rolL_Reg_immI_32_63_0Node *node = new rolL_Reg_immI_32_63_0Node();
      return node;
    }
  case rorI_Reg_immI_0_31_rule: {
      rorI_Reg_immI_0_31Node *node = new rorI_Reg_immI_0_31Node();
      return node;
    }
  case rorI_Reg_immI_0_31_0_rule: {
      rorI_Reg_immI_0_31_0Node *node = new rorI_Reg_immI_0_31_0Node();
      return node;
    }
  case rorL_Reg_immI_0_31_rule: {
      rorL_Reg_immI_0_31Node *node = new rorL_Reg_immI_0_31Node();
      return node;
    }
  case rorL_Reg_immI_0_31_0_rule: {
      rorL_Reg_immI_0_31_0Node *node = new rorL_Reg_immI_0_31_0Node();
      return node;
    }
  case rorL_Reg_immI_32_63_rule: {
      rorL_Reg_immI_32_63Node *node = new rorL_Reg_immI_32_63Node();
      return node;
    }
  case rorL_Reg_immI_32_63_0_rule: {
      rorL_Reg_immI_32_63_0Node *node = new rorL_Reg_immI_32_63_0Node();
      return node;
    }
  case rolI_reg_rule: {
      rolI_regNode *node = new rolI_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rolL_reg_rule: {
      rolL_regNode *node = new rolL_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rorI_imm_rule: {
      rorI_immNode *node = new rorI_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rorI_reg_rule: {
      rorI_regNode *node = new rorI_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rorL_imm_rule: {
      rorL_immNode *node = new rorL_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rorL_reg_rule: {
      rorL_regNode *node = new rorL_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case shr_logical_Reg_Reg_rule: {
      shr_logical_Reg_RegNode *node = new shr_logical_Reg_RegNode();
      return node;
    }
  case shr_arith_Reg_imm_rule: {
      shr_arith_Reg_immNode *node = new shr_arith_Reg_immNode();
      return node;
    }
  case shr_arith_Reg_Reg_rule: {
      shr_arith_Reg_RegNode *node = new shr_arith_Reg_RegNode();
      return node;
    }
  case convI2B_rule: {
      convI2BNode *node = new convI2BNode();
      return node;
    }
  case convI2L_reg_rule: {
      convI2L_regNode *node = new convI2L_regNode();
      return node;
    }
  case convL2I_reg_rule: {
      convL2I_regNode *node = new convL2I_regNode();
      return node;
    }
  case convL2D_reg_rule: {
      convL2D_regNode *node = new convL2D_regNode();
      return node;
    }
  case convD2I_reg_reg_rule: {
      convD2I_reg_regNode *node = new convD2I_reg_regNode();
      node->set_opnd_array(2, MachOperGenerator(REGD));
      return node;
    }
  case convD2L_reg_reg_rule: {
      convD2L_reg_regNode *node = new convD2L_reg_regNode();
      node->set_opnd_array(2, MachOperGenerator(REGD));
      return node;
    }
  case convF2I_reg_reg_rule: {
      convF2I_reg_regNode *node = new convF2I_reg_regNode();
      node->set_opnd_array(2, MachOperGenerator(REGF));
      return node;
    }
  case convF2L_reg_reg_rule: {
      convF2L_reg_regNode *node = new convF2L_reg_regNode();
      node->set_opnd_array(2, MachOperGenerator(REGF));
      return node;
    }
  case convL2F_reg_rule: {
      convL2F_regNode *node = new convL2F_regNode();
      return node;
    }
  case convI2F_reg_rule: {
      convI2F_regNode *node = new convI2F_regNode();
      return node;
    }
  case roundD_rule: {
      roundDNode *node = new roundDNode();
      return node;
    }
  case cmpLTMask_immI_0_rule: {
      cmpLTMask_immI_0Node *node = new cmpLTMask_immI_0Node();
      return node;
    }
  case cmpLTMask_rule: {
      cmpLTMaskNode *node = new cmpLTMaskNode();
      return node;
    }
  case convP2B_rule: {
      convP2BNode *node = new convP2BNode();
      return node;
    }
  case convI2D_reg_reg_rule: {
      convI2D_reg_regNode *node = new convI2D_reg_regNode();
      return node;
    }
  case convF2D_reg_reg_rule: {
      convF2D_reg_regNode *node = new convF2D_reg_regNode();
      return node;
    }
  case convD2F_reg_reg_rule: {
      convD2F_reg_regNode *node = new convD2F_reg_regNode();
      return node;
    }
  case encodeHeapOop_rule: {
      encodeHeapOopNode *node = new encodeHeapOopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeHeapOop_not_null_rule: {
      encodeHeapOop_not_nullNode *node = new encodeHeapOop_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeHeapOop_rule: {
      decodeHeapOopNode *node = new decodeHeapOopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeHeapOop_not_null_rule: {
      decodeHeapOop_not_nullNode *node = new decodeHeapOop_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeKlass_not_null_rule: {
      encodeKlass_not_nullNode *node = new encodeKlass_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeKlass_not_null_rule: {
      decodeKlass_not_nullNode *node = new decodeKlass_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case tlsLoadP_rule: {
      tlsLoadPNode *node = new tlsLoadPNode();
      return node;
    }
  case checkCastPP_rule: {
      checkCastPPNode *node = new checkCastPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castPP_rule: {
      castPPNode *node = new castPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castII_rule: {
      castIINode *node = new castIINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castLL_rule: {
      castLLNode *node = new castLLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castFF_rule: {
      castFFNode *node = new castFFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castDD_rule: {
      castDDNode *node = new castDDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castVVX_rule: {
      castVVXNode *node = new castVVXNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castVVY_rule: {
      castVVYNode *node = new castVVYNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Ret_rule: {
      RetNode *node = new RetNode();
      return node;
    }
  case tailjmpInd_rule: {
      tailjmpIndNode *node = new tailjmpIndNode();
      return node;
    }
  case CallStaticJavaDirect_rule: {
      CallStaticJavaDirectNode *node = new CallStaticJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallDynamicJavaDirect_rule: {
      CallDynamicJavaDirectNode *node = new CallDynamicJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallLeafNoFPDirect_rule: {
      CallLeafNoFPDirectNode *node = new CallLeafNoFPDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case prefetchAlloc_rule: {
      prefetchAllocNode *node = new prefetchAllocNode();
      return node;
    }
  case CallLeafDirect_rule: {
      CallLeafDirectNode *node = new CallLeafDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case loadUS_rule: {
      loadUSNode *node = new loadUSNode();
      return node;
    }
  case loadUS_convI2L_rule: {
      loadUS_convI2LNode *node = new loadUS_convI2LNode();
      return node;
    }
  case storeC_rule: {
      storeCNode *node = new storeCNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeC_0_rule: {
      storeC_0Node *node = new storeC_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConF_immF_0_rule: {
      loadConF_immF_0Node *node = new loadConF_immF_0Node();
      node->_opnd_array[1] = new immF_0Oper(_leaf->getf() );
      return node;
    }
  case loadConF_rule: {
      loadConFNode *node = new loadConFNode();
      node->_opnd_array[1] = new immFOper(_leaf->getf() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConD_immD_0_rule: {
      loadConD_immD_0Node *node = new loadConD_immD_0Node();
      node->_opnd_array[1] = new immD_0Oper(_leaf->getd() );
      return node;
    }
  case loadConD_rule: {
      loadConDNode *node = new loadConDNode();
      node->_opnd_array[1] = new immDOper(_leaf->getd() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_reg_rule: {
      storeF_regNode *node = new storeF_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_immF_0_rule: {
      storeF_immF_0Node *node = new storeF_immF_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadD_rule: {
      loadDNode *node = new loadDNode();
      return node;
    }
  case loadD_unaligned_rule: {
      loadD_unalignedNode *node = new loadD_unalignedNode();
      return node;
    }
  case storeD_reg_rule: {
      storeD_regNode *node = new storeD_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeD_immD_0_rule: {
      storeD_immD_0Node *node = new storeD_immD_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadSSI_rule: {
      loadSSINode *node = new loadSSINode();
      return node;
    }
  case storeSSI_rule: {
      storeSSINode *node = new storeSSINode();
      return node;
    }
  case loadSSL_rule: {
      loadSSLNode *node = new loadSSLNode();
      return node;
    }
  case storeSSL_rule: {
      storeSSLNode *node = new storeSSLNode();
      return node;
    }
  case loadSSP_rule: {
      loadSSPNode *node = new loadSSPNode();
      return node;
    }
  case storeSSP_rule: {
      storeSSPNode *node = new storeSSPNode();
      return node;
    }
  case loadSSF_rule: {
      loadSSFNode *node = new loadSSFNode();
      return node;
    }
  case storeSSF_rule: {
      storeSSFNode *node = new storeSSFNode();
      return node;
    }
  case loadSSD_rule: {
      loadSSDNode *node = new loadSSDNode();
      return node;
    }
  case storeSSD_rule: {
      storeSSDNode *node = new storeSSDNode();
      return node;
    }
  case cmpFastLock_rule: {
      cmpFastLockNode *node = new cmpFastLockNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(MREGI));
      node->_counters = _leaf->as_FastLock()->counters();
      node->_rtm_counters = _leaf->as_FastLock()->rtm_counters();
      node->_stack_rtm_counters = _leaf->as_FastLock()->stack_rtm_counters();
      return node;
    }
  case cmpFastUnlock_rule: {
      cmpFastUnlockNode *node = new cmpFastUnlockNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(MREGI));
      return node;
    }
  case storeImmCM_rule: {
      storeImmCMNode *node = new storeImmCMNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ShouldNotReachHere_rule: {
      ShouldNotReachHereNode *node = new ShouldNotReachHereNode();
      node->_halt_reason = _leaf->as_Halt()->_halt_reason;
      node->_reachable   = _leaf->as_Halt()->_reachable;
      return node;
    }
  case leaP12Narrow_rule: {
      leaP12NarrowNode *node = new leaP12NarrowNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaPIdxScale_rule: {
      leaPIdxScaleNode *node = new leaPIdxScaleNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case partialSubtypeCheck_rule: {
      partialSubtypeCheckNode *node = new partialSubtypeCheckNode();
      return node;
    }
  case storePConditional_rule: {
      storePConditionalNode *node = new storePConditionalNode();
      return node;
    }
  case storeIConditional_rule: {
      storeIConditionalNode *node = new storeIConditionalNode();
      return node;
    }
  case storeLConditional_rule: {
      storeLConditionalNode *node = new storeLConditionalNode();
      return node;
    }
  case loadPLocked_rule: {
      loadPLockedNode *node = new loadPLockedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndSwapI_rule: {
      compareAndSwapINode *node = new compareAndSwapINode();
      return node;
    }
  case compareAndSwapL_rule: {
      compareAndSwapLNode *node = new compareAndSwapLNode();
      return node;
    }
  case compareAndSwapP_rule: {
      compareAndSwapPNode *node = new compareAndSwapPNode();
      return node;
    }
  case compareAndSwapN_rule: {
      compareAndSwapNNode *node = new compareAndSwapNNode();
      return node;
    }
  case get_and_setI_rule: {
      get_and_setINode *node = new get_and_setINode();
      return node;
    }
  case get_and_setL_rule: {
      get_and_setLNode *node = new get_and_setLNode();
      return node;
    }
  case get_and_setN_rule: {
      get_and_setNNode *node = new get_and_setNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_setP_rule: {
      get_and_setPNode *node = new get_and_setPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_addL_rule: {
      get_and_addLNode *node = new get_and_addLNode();
      return node;
    }
  case get_and_addL_no_res_rule: {
      get_and_addL_no_resNode *node = new get_and_addL_no_resNode();
      return node;
    }
  case get_and_addI_rule: {
      get_and_addINode *node = new get_and_addINode();
      return node;
    }
  case get_and_addI_no_res_rule: {
      get_and_addI_no_resNode *node = new get_and_addI_no_resNode();
      return node;
    }
  case compareAndExchangeI_rule: {
      compareAndExchangeINode *node = new compareAndExchangeINode();
      node->set_opnd_array(4, MachOperGenerator(MREGI));
      return node;
    }
  case compareAndExchangeL_rule: {
      compareAndExchangeLNode *node = new compareAndExchangeLNode();
      node->set_opnd_array(4, MachOperGenerator(MREGL));
      return node;
    }
  case compareAndExchangeP_rule: {
      compareAndExchangePNode *node = new compareAndExchangePNode();
      node->set_opnd_array(4, MachOperGenerator(MREGP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangeN_rule: {
      compareAndExchangeNNode *node = new compareAndExchangeNNode();
      node->set_opnd_array(4, MachOperGenerator(MREGN));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case weakCompareAndSwapI_rule: {
      weakCompareAndSwapINode *node = new weakCompareAndSwapINode();
      return node;
    }
  case weakCompareAndSwapL_rule: {
      weakCompareAndSwapLNode *node = new weakCompareAndSwapLNode();
      return node;
    }
  case weakCompareAndSwapP_rule: {
      weakCompareAndSwapPNode *node = new weakCompareAndSwapPNode();
      return node;
    }
  case weakCompareAndSwapP_acq_rule: {
      weakCompareAndSwapP_acqNode *node = new weakCompareAndSwapP_acqNode();
      return node;
    }
  case weakCompareAndSwapN_rule: {
      weakCompareAndSwapNNode *node = new weakCompareAndSwapNNode();
      return node;
    }
  case minI_Reg_Reg_rule: {
      minI_Reg_RegNode *node = new minI_Reg_RegNode();
      return node;
    }
  case maxI_Reg_Reg_rule: {
      maxI_Reg_RegNode *node = new maxI_Reg_RegNode();
      return node;
    }
  case maxI_Reg_zero_rule: {
      maxI_Reg_zeroNode *node = new maxI_Reg_zeroNode();
      return node;
    }
  case zerox_long_reg_reg_rule: {
      zerox_long_reg_regNode *node = new zerox_long_reg_regNode();
      return node;
    }
  case combine_i2l_rule: {
      combine_i2lNode *node = new combine_i2lNode();
      return node;
    }
  case combine_i2l_0_rule: {
      combine_i2l_0Node *node = new combine_i2l_0Node();
      return node;
    }
  case convI2L_reg_reg_zex_rule: {
      convI2L_reg_reg_zexNode *node = new convI2L_reg_reg_zexNode();
      return node;
    }
  case convL2I2L_reg_reg_zex_rule: {
      convL2I2L_reg_reg_zexNode *node = new convL2I2L_reg_reg_zexNode();
      return node;
    }
  case loadUI2L_rmask_rule: {
      loadUI2L_rmaskNode *node = new loadUI2L_rmaskNode();
      return node;
    }
  case loadUI2L_lmask_rule: {
      loadUI2L_lmaskNode *node = new loadUI2L_lmaskNode();
      return node;
    }
  case loadUI2L_lmask_0_rule: {
      loadUI2L_lmask_0Node *node = new loadUI2L_lmask_0Node();
      return node;
    }
  case safePoint_poll_tls_rule: {
      safePoint_poll_tlsNode *node = new safePoint_poll_tlsNode();
      return node;
    }
  case roundFloat_nop_rule: {
      roundFloat_nopNode *node = new roundFloat_nopNode();
      return node;
    }
  case roundDouble_nop_rule: {
      roundDouble_nopNode *node = new roundDouble_nopNode();
      return node;
    }
  case bytes_reverse_int_rule: {
      bytes_reverse_intNode *node = new bytes_reverse_intNode();
      return node;
    }
  case bytes_reverse_long_rule: {
      bytes_reverse_longNode *node = new bytes_reverse_longNode();
      return node;
    }
  case bytes_reverse_unsigned_short_rule: {
      bytes_reverse_unsigned_shortNode *node = new bytes_reverse_unsigned_shortNode();
      return node;
    }
  case bytes_reverse_short_rule: {
      bytes_reverse_shortNode *node = new bytes_reverse_shortNode();
      return node;
    }
  case countLeadingZerosI_rule: {
      countLeadingZerosINode *node = new countLeadingZerosINode();
      return node;
    }
  case countLeadingZerosL_rule: {
      countLeadingZerosLNode *node = new countLeadingZerosLNode();
      return node;
    }
  case countTrailingZerosI_rule: {
      countTrailingZerosINode *node = new countTrailingZerosINode();
      return node;
    }
  case countTrailingZerosL_rule: {
      countTrailingZerosLNode *node = new countTrailingZerosLNode();
      return node;
    }
  case popCountI_rule: {
      popCountINode *node = new popCountINode();
      return node;
    }
  case popCountI_mem_rule: {
      popCountI_memNode *node = new popCountI_memNode();
      return node;
    }
  case popCountL_rule: {
      popCountLNode *node = new popCountLNode();
      return node;
    }
  case popCountL_mem_rule: {
      popCountL_memNode *node = new popCountL_memNode();
      return node;
    }
  case loadV16_rule: {
      loadV16Node *node = new loadV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadV32_rule: {
      loadV32Node *node = new loadV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV16_rule: {
      storeV16Node *node = new storeV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV32_rule: {
      storeV32Node *node = new storeV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl16B_rule: {
      repl16BNode *node = new repl16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl16B_imm_rule: {
      repl16B_immNode *node = new repl16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl8S_rule: {
      repl8SNode *node = new repl8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl8S_imm_rule: {
      repl8S_immNode *node = new repl8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl4I_rule: {
      repl4INode *node = new repl4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl4I_imm_rule: {
      repl4I_immNode *node = new repl4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl2L_rule: {
      repl2LNode *node = new repl2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl2L_imm_rule: {
      repl2L_immNode *node = new repl2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl4F_rule: {
      repl4FNode *node = new repl4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl2D_rule: {
      repl2DNode *node = new repl2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl32B_rule: {
      repl32BNode *node = new repl32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl32B_imm_rule: {
      repl32B_immNode *node = new repl32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl16S_rule: {
      repl16SNode *node = new repl16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl16S_imm_rule: {
      repl16S_immNode *node = new repl16S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl8I_rule: {
      repl8INode *node = new repl8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl8I_imm_rule: {
      repl8I_immNode *node = new repl8I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl4L_rule: {
      repl4LNode *node = new repl4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl4L_imm_rule: {
      repl4L_immNode *node = new repl4L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl8F_rule: {
      repl8FNode *node = new repl8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case repl4D_rule: {
      repl4DNode *node = new repl4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add16B_rule: {
      add16BNode *node = new add16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add16B_imm_rule: {
      add16B_immNode *node = new add16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add16B_imm_0_rule: {
      add16B_imm_0Node *node = new add16B_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add8S_rule: {
      add8SNode *node = new add8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add8S_imm_rule: {
      add8S_immNode *node = new add8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add8S_imm_0_rule: {
      add8S_imm_0Node *node = new add8S_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add4I_rule: {
      add4INode *node = new add4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add4I_imm_rule: {
      add4I_immNode *node = new add4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add4I_imm_0_rule: {
      add4I_imm_0Node *node = new add4I_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add2L_rule: {
      add2LNode *node = new add2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add2L_imm_rule: {
      add2L_immNode *node = new add2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add2L_imm_0_rule: {
      add2L_imm_0Node *node = new add2L_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add4F_rule: {
      add4FNode *node = new add4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add2D_rule: {
      add2DNode *node = new add2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add32B_rule: {
      add32BNode *node = new add32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add32B_imm_rule: {
      add32B_immNode *node = new add32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add32B_imm_0_rule: {
      add32B_imm_0Node *node = new add32B_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add16S_rule: {
      add16SNode *node = new add16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add16S_imm_rule: {
      add16S_immNode *node = new add16S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add16S_imm_0_rule: {
      add16S_imm_0Node *node = new add16S_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add8I_rule: {
      add8INode *node = new add8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add8I_imm_rule: {
      add8I_immNode *node = new add8I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add8I_imm_0_rule: {
      add8I_imm_0Node *node = new add8I_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add4L_rule: {
      add4LNode *node = new add4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add4L_imm_rule: {
      add4L_immNode *node = new add4L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add4L_imm_0_rule: {
      add4L_imm_0Node *node = new add4L_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add8F_rule: {
      add8FNode *node = new add8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case add4D_rule: {
      add4DNode *node = new add4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub16B_rule: {
      sub16BNode *node = new sub16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub16B_imm_rule: {
      sub16B_immNode *node = new sub16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub8S_rule: {
      sub8SNode *node = new sub8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub8S_imm_rule: {
      sub8S_immNode *node = new sub8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub4I_rule: {
      sub4INode *node = new sub4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub4I_imm_rule: {
      sub4I_immNode *node = new sub4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub2L_rule: {
      sub2LNode *node = new sub2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub2L_imm_rule: {
      sub2L_immNode *node = new sub2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub4F_rule: {
      sub4FNode *node = new sub4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub2D_rule: {
      sub2DNode *node = new sub2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub32B_rule: {
      sub32BNode *node = new sub32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub32B_imm_rule: {
      sub32B_immNode *node = new sub32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub16S_rule: {
      sub16SNode *node = new sub16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub16S_imm_rule: {
      sub16S_immNode *node = new sub16S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub8I_rule: {
      sub8INode *node = new sub8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub8I_imm_rule: {
      sub8I_immNode *node = new sub8I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub4L_rule: {
      sub4LNode *node = new sub4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub4L_imm_rule: {
      sub4L_immNode *node = new sub4L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub8F_rule: {
      sub8FNode *node = new sub8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sub4D_rule: {
      sub4DNode *node = new sub4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul16B_rule: {
      mul16BNode *node = new mul16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul8S_rule: {
      mul8SNode *node = new mul8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul4I_rule: {
      mul4INode *node = new mul4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul2L_rule: {
      mul2LNode *node = new mul2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul4F_rule: {
      mul4FNode *node = new mul4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul2D_rule: {
      mul2DNode *node = new mul2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul32B_rule: {
      mul32BNode *node = new mul32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul16S_rule: {
      mul16SNode *node = new mul16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul8I_rule: {
      mul8INode *node = new mul8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul4L_rule: {
      mul4LNode *node = new mul4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul8F_rule: {
      mul8FNode *node = new mul8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mul4D_rule: {
      mul4DNode *node = new mul4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case div4F_rule: {
      div4FNode *node = new div4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case div2D_rule: {
      div2DNode *node = new div2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case div8F_rule: {
      div8FNode *node = new div8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case div4D_rule: {
      div4DNode *node = new div4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs16B_rule: {
      abs16BNode *node = new abs16BNode();
      node->set_opnd_array(2, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs8S_rule: {
      abs8SNode *node = new abs8SNode();
      node->set_opnd_array(2, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs4I_rule: {
      abs4INode *node = new abs4INode();
      node->set_opnd_array(2, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs2L_rule: {
      abs2LNode *node = new abs2LNode();
      node->set_opnd_array(2, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs4F_rule: {
      abs4FNode *node = new abs4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs2D_rule: {
      abs2DNode *node = new abs2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs32B_rule: {
      abs32BNode *node = new abs32BNode();
      node->set_opnd_array(2, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs16S_rule: {
      abs16SNode *node = new abs16SNode();
      node->set_opnd_array(2, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs8I_rule: {
      abs8INode *node = new abs8INode();
      node->set_opnd_array(2, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs4L_rule: {
      abs4LNode *node = new abs4LNode();
      node->set_opnd_array(2, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs8F_rule: {
      abs8FNode *node = new abs8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case abs4D_rule: {
      abs4DNode *node = new abs4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case absd4I_rule: {
      absd4INode *node = new absd4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case absd2L_rule: {
      absd2LNode *node = new absd2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case absd8I_rule: {
      absd8INode *node = new absd8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case absd4L_rule: {
      absd4LNode *node = new absd4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max16B_rule: {
      max16BNode *node = new max16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max8S_rule: {
      max8SNode *node = new max8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max4I_rule: {
      max4INode *node = new max4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max2L_rule: {
      max2LNode *node = new max2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max4F_rule: {
      max4FNode *node = new max4FNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max2D_rule: {
      max2DNode *node = new max2DNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max32B_rule: {
      max32BNode *node = new max32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max16S_rule: {
      max16SNode *node = new max16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max8I_rule: {
      max8INode *node = new max8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max4L_rule: {
      max4LNode *node = new max4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max8F_rule: {
      max8FNode *node = new max8FNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case max4D_rule: {
      max4DNode *node = new max4DNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min16B_rule: {
      min16BNode *node = new min16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min8S_rule: {
      min8SNode *node = new min8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min4I_rule: {
      min4INode *node = new min4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min2L_rule: {
      min2LNode *node = new min2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min4F_rule: {
      min4FNode *node = new min4FNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min2D_rule: {
      min2DNode *node = new min2DNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min32B_rule: {
      min32BNode *node = new min32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min16S_rule: {
      min16SNode *node = new min16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min8I_rule: {
      min8INode *node = new min8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min4L_rule: {
      min4LNode *node = new min4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min8F_rule: {
      min8FNode *node = new min8FNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case min4D_rule: {
      min4DNode *node = new min4DNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case neg4I_rule: {
      neg4INode *node = new neg4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case neg4F_rule: {
      neg4FNode *node = new neg4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case neg2D_rule: {
      neg2DNode *node = new neg2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case neg8I_rule: {
      neg8INode *node = new neg8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case neg8F_rule: {
      neg8FNode *node = new neg8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case neg4D_rule: {
      neg4DNode *node = new neg4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sqrt4F_rule: {
      sqrt4FNode *node = new sqrt4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sqrt2D_rule: {
      sqrt2DNode *node = new sqrt2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sqrt8F_rule: {
      sqrt8FNode *node = new sqrt8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sqrt4D_rule: {
      sqrt4DNode *node = new sqrt4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd16B_rule: {
      madd16BNode *node = new madd16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd16B_0_rule: {
      madd16B_0Node *node = new madd16B_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd8S_rule: {
      madd8SNode *node = new madd8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd8S_0_rule: {
      madd8S_0Node *node = new madd8S_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd4I_rule: {
      madd4INode *node = new madd4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd4I_0_rule: {
      madd4I_0Node *node = new madd4I_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd2L_rule: {
      madd2LNode *node = new madd2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd2L_0_rule: {
      madd2L_0Node *node = new madd2L_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd4F_rule: {
      madd4FNode *node = new madd4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd2D_rule: {
      madd2DNode *node = new madd2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd32B_rule: {
      madd32BNode *node = new madd32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd32B_0_rule: {
      madd32B_0Node *node = new madd32B_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd16S_rule: {
      madd16SNode *node = new madd16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd16S_0_rule: {
      madd16S_0Node *node = new madd16S_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd8I_rule: {
      madd8INode *node = new madd8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd8I_0_rule: {
      madd8I_0Node *node = new madd8I_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd4L_rule: {
      madd4LNode *node = new madd4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd4L_0_rule: {
      madd4L_0Node *node = new madd4L_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd8F_rule: {
      madd8FNode *node = new madd8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case madd4D_rule: {
      madd4DNode *node = new madd4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub16B_rule: {
      msub16BNode *node = new msub16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub8S_rule: {
      msub8SNode *node = new msub8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub4I_rule: {
      msub4INode *node = new msub4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub2L_rule: {
      msub2LNode *node = new msub2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub4F_rule: {
      msub4FNode *node = new msub4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub2D_rule: {
      msub2DNode *node = new msub2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub32B_rule: {
      msub32BNode *node = new msub32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub16S_rule: {
      msub16SNode *node = new msub16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub8I_rule: {
      msub8INode *node = new msub8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub4L_rule: {
      msub4LNode *node = new msub4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub8F_rule: {
      msub8FNode *node = new msub8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case msub4D_rule: {
      msub4DNode *node = new msub4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmadd4F_rule: {
      nmadd4FNode *node = new nmadd4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmadd4F_0_rule: {
      nmadd4F_0Node *node = new nmadd4F_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmadd2D_rule: {
      nmadd2DNode *node = new nmadd2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmadd2D_0_rule: {
      nmadd2D_0Node *node = new nmadd2D_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmadd8F_rule: {
      nmadd8FNode *node = new nmadd8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmadd8F_0_rule: {
      nmadd8F_0Node *node = new nmadd8F_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmadd4D_rule: {
      nmadd4DNode *node = new nmadd4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmadd4D_0_rule: {
      nmadd4D_0Node *node = new nmadd4D_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmsub4F_rule: {
      nmsub4FNode *node = new nmsub4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmsub4F_0_rule: {
      nmsub4F_0Node *node = new nmsub4F_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmsub2D_rule: {
      nmsub2DNode *node = new nmsub2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmsub2D_0_rule: {
      nmsub2D_0Node *node = new nmsub2D_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmsub8F_rule: {
      nmsub8FNode *node = new nmsub8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmsub8F_0_rule: {
      nmsub8F_0Node *node = new nmsub8F_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmsub4D_rule: {
      nmsub4DNode *node = new nmsub4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nmsub4D_0_rule: {
      nmsub4D_0Node *node = new nmsub4D_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case muladd8Sto4I_rule: {
      muladd8Sto4INode *node = new muladd8Sto4INode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case muladd16Sto8I_rule: {
      muladd16Sto8INode *node = new muladd16Sto8INode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case shiftcntX_rule: {
      shiftcntXNode *node = new shiftcntXNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case shiftcntX_0_rule: {
      shiftcntX_0Node *node = new shiftcntX_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case shiftcntY_rule: {
      shiftcntYNode *node = new shiftcntYNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case shiftcntY_0_rule: {
      shiftcntY_0Node *node = new shiftcntY_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll16B_rule: {
      sll16BNode *node = new sll16BNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll16B_imm_rule: {
      sll16B_immNode *node = new sll16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll8S_rule: {
      sll8SNode *node = new sll8SNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll8S_imm_rule: {
      sll8S_immNode *node = new sll8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll4I_rule: {
      sll4INode *node = new sll4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll4I_imm_rule: {
      sll4I_immNode *node = new sll4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll2L_rule: {
      sll2LNode *node = new sll2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll2L_imm_rule: {
      sll2L_immNode *node = new sll2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll32B_rule: {
      sll32BNode *node = new sll32BNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll32B_imm_rule: {
      sll32B_immNode *node = new sll32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll16S_rule: {
      sll16SNode *node = new sll16SNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll16S_imm_rule: {
      sll16S_immNode *node = new sll16S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll8I_rule: {
      sll8INode *node = new sll8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll8I_imm_rule: {
      sll8I_immNode *node = new sll8I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll4L_rule: {
      sll4LNode *node = new sll4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sll4L_imm_rule: {
      sll4L_immNode *node = new sll4L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl16B_rule: {
      srl16BNode *node = new srl16BNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl16B_imm_rule: {
      srl16B_immNode *node = new srl16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl8S_rule: {
      srl8SNode *node = new srl8SNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl8S_imm_rule: {
      srl8S_immNode *node = new srl8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl4I_rule: {
      srl4INode *node = new srl4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl4I_imm_rule: {
      srl4I_immNode *node = new srl4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl2L_rule: {
      srl2LNode *node = new srl2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl2L_imm_rule: {
      srl2L_immNode *node = new srl2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl32B_rule: {
      srl32BNode *node = new srl32BNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl32B_imm_rule: {
      srl32B_immNode *node = new srl32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl16S_rule: {
      srl16SNode *node = new srl16SNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl16S_imm_rule: {
      srl16S_immNode *node = new srl16S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl8I_rule: {
      srl8INode *node = new srl8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl8I_imm_rule: {
      srl8I_immNode *node = new srl8I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl4L_rule: {
      srl4LNode *node = new srl4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case srl4L_imm_rule: {
      srl4L_immNode *node = new srl4L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra16B_rule: {
      sra16BNode *node = new sra16BNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra16B_imm_rule: {
      sra16B_immNode *node = new sra16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra8S_rule: {
      sra8SNode *node = new sra8SNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra8S_imm_rule: {
      sra8S_immNode *node = new sra8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra4I_rule: {
      sra4INode *node = new sra4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra4I_imm_rule: {
      sra4I_immNode *node = new sra4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra2L_rule: {
      sra2LNode *node = new sra2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra2L_imm_rule: {
      sra2L_immNode *node = new sra2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra32B_rule: {
      sra32BNode *node = new sra32BNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra32B_imm_rule: {
      sra32B_immNode *node = new sra32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra16S_rule: {
      sra16SNode *node = new sra16SNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra16S_imm_rule: {
      sra16S_immNode *node = new sra16S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra8I_rule: {
      sra8INode *node = new sra8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra8I_imm_rule: {
      sra8I_immNode *node = new sra8I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra4L_rule: {
      sra4LNode *node = new sra4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sra4L_imm_rule: {
      sra4L_immNode *node = new sra4L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotr4I_rule: {
      rotr4INode *node = new rotr4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotr4I_imm_rule: {
      rotr4I_immNode *node = new rotr4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotr2L_rule: {
      rotr2LNode *node = new rotr2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotr2L_imm_rule: {
      rotr2L_immNode *node = new rotr2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotr8I_rule: {
      rotr8INode *node = new rotr8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotr8I_imm_rule: {
      rotr8I_immNode *node = new rotr8I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotr4L_rule: {
      rotr4LNode *node = new rotr4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotr4L_imm_rule: {
      rotr4L_immNode *node = new rotr4L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotl4I_rule: {
      rotl4INode *node = new rotl4INode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotl4I_imm_rule: {
      rotl4I_immNode *node = new rotl4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotl2L_rule: {
      rotl2LNode *node = new rotl2LNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotl2L_imm_rule: {
      rotl2L_immNode *node = new rotl2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotl8I_rule: {
      rotl8INode *node = new rotl8INode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotl8I_imm_rule: {
      rotl8I_immNode *node = new rotl8I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotl4L_rule: {
      rotl4LNode *node = new rotl4LNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rotl4L_imm_rule: {
      rotl4L_immNode *node = new rotl4L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andV16_rule: {
      andV16Node *node = new andV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case and16B_imm_rule: {
      and16B_immNode *node = new and16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case and16B_imm_0_rule: {
      and16B_imm_0Node *node = new and16B_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andV32_rule: {
      andV32Node *node = new andV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case and32B_imm_rule: {
      and32B_immNode *node = new and32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case and32B_imm_0_rule: {
      and32B_imm_0Node *node = new and32B_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case orV16_rule: {
      orV16Node *node = new orV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case or16B_imm_rule: {
      or16B_immNode *node = new or16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case or16B_imm_0_rule: {
      or16B_imm_0Node *node = new or16B_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case orV32_rule: {
      orV32Node *node = new orV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case or32B_imm_rule: {
      or32B_immNode *node = new or32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case or32B_imm_0_rule: {
      or32B_imm_0Node *node = new or32B_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case xorV16_rule: {
      xorV16Node *node = new xorV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case xor16B_imm_rule: {
      xor16B_immNode *node = new xor16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case xor16B_imm_0_rule: {
      xor16B_imm_0Node *node = new xor16B_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case xorV32_rule: {
      xorV32Node *node = new xorV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case xor32B_imm_rule: {
      xor32B_immNode *node = new xor32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case xor32B_imm_0_rule: {
      xor32B_imm_0Node *node = new xor32B_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV16_rule: {
      norV16Node *node = new norV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV16_0_rule: {
      norV16_0Node *node = new norV16_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV16_1_rule: {
      norV16_1Node *node = new norV16_1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV16_2_rule: {
      norV16_2Node *node = new norV16_2Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV16_3_rule: {
      norV16_3Node *node = new norV16_3Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV16_4_rule: {
      norV16_4Node *node = new norV16_4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nor16B_imm_rule: {
      nor16B_immNode *node = new nor16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nor16B_imm_1_rule: {
      nor16B_imm_1Node *node = new nor16B_imm_1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nor16B_imm_0_rule: {
      nor16B_imm_0Node *node = new nor16B_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nor16B_imm_2_rule: {
      nor16B_imm_2Node *node = new nor16B_imm_2Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV32_rule: {
      norV32Node *node = new norV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV32_0_rule: {
      norV32_0Node *node = new norV32_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV32_1_rule: {
      norV32_1Node *node = new norV32_1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV32_2_rule: {
      norV32_2Node *node = new norV32_2Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV32_3_rule: {
      norV32_3Node *node = new norV32_3Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case norV32_4_rule: {
      norV32_4Node *node = new norV32_4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nor32B_imm_rule: {
      nor32B_immNode *node = new nor32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nor32B_imm_1_rule: {
      nor32B_imm_1Node *node = new nor32B_imm_1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nor32B_imm_0_rule: {
      nor32B_imm_0Node *node = new nor32B_imm_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case nor32B_imm_2_rule: {
      nor32B_imm_2Node *node = new nor32B_imm_2Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_rule: {
      andnV16Node *node = new andnV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_1_rule: {
      andnV16_1Node *node = new andnV16_1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_0_rule: {
      andnV16_0Node *node = new andnV16_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_2_rule: {
      andnV16_2Node *node = new andnV16_2Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_3_rule: {
      andnV16_3Node *node = new andnV16_3Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_5_rule: {
      andnV16_5Node *node = new andnV16_5Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_4_rule: {
      andnV16_4Node *node = new andnV16_4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_6_rule: {
      andnV16_6Node *node = new andnV16_6Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_7_rule: {
      andnV16_7Node *node = new andnV16_7Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_9_rule: {
      andnV16_9Node *node = new andnV16_9Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_8_rule: {
      andnV16_8Node *node = new andnV16_8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV16_10_rule: {
      andnV16_10Node *node = new andnV16_10Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_rule: {
      andnV32Node *node = new andnV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_1_rule: {
      andnV32_1Node *node = new andnV32_1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_0_rule: {
      andnV32_0Node *node = new andnV32_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_2_rule: {
      andnV32_2Node *node = new andnV32_2Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_3_rule: {
      andnV32_3Node *node = new andnV32_3Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_5_rule: {
      andnV32_5Node *node = new andnV32_5Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_4_rule: {
      andnV32_4Node *node = new andnV32_4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_6_rule: {
      andnV32_6Node *node = new andnV32_6Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_7_rule: {
      andnV32_7Node *node = new andnV32_7Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_9_rule: {
      andnV32_9Node *node = new andnV32_9Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_8_rule: {
      andnV32_8Node *node = new andnV32_8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnV32_10_rule: {
      andnV32_10Node *node = new andnV32_10Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_rule: {
      ornV16Node *node = new ornV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_1_rule: {
      ornV16_1Node *node = new ornV16_1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_0_rule: {
      ornV16_0Node *node = new ornV16_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_2_rule: {
      ornV16_2Node *node = new ornV16_2Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_3_rule: {
      ornV16_3Node *node = new ornV16_3Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_5_rule: {
      ornV16_5Node *node = new ornV16_5Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_4_rule: {
      ornV16_4Node *node = new ornV16_4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_6_rule: {
      ornV16_6Node *node = new ornV16_6Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_7_rule: {
      ornV16_7Node *node = new ornV16_7Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_9_rule: {
      ornV16_9Node *node = new ornV16_9Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_8_rule: {
      ornV16_8Node *node = new ornV16_8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV16_10_rule: {
      ornV16_10Node *node = new ornV16_10Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_rule: {
      ornV32Node *node = new ornV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_1_rule: {
      ornV32_1Node *node = new ornV32_1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_0_rule: {
      ornV32_0Node *node = new ornV32_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_2_rule: {
      ornV32_2Node *node = new ornV32_2Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_3_rule: {
      ornV32_3Node *node = new ornV32_3Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_5_rule: {
      ornV32_5Node *node = new ornV32_5Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_4_rule: {
      ornV32_4Node *node = new ornV32_4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_6_rule: {
      ornV32_6Node *node = new ornV32_6Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_7_rule: {
      ornV32_7Node *node = new ornV32_7Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_9_rule: {
      ornV32_9Node *node = new ornV32_9Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_8_rule: {
      ornV32_8Node *node = new ornV32_8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ornV32_10_rule: {
      ornV32_10Node *node = new ornV32_10Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add16B_rule: {
      reduce_add16BNode *node = new reduce_add16BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add8S_rule: {
      reduce_add8SNode *node = new reduce_add8SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add4I_rule: {
      reduce_add4INode *node = new reduce_add4INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add2L_rule: {
      reduce_add2LNode *node = new reduce_add2LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add4F_rule: {
      reduce_add4FNode *node = new reduce_add4FNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add2D_rule: {
      reduce_add2DNode *node = new reduce_add2DNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add32B_rule: {
      reduce_add32BNode *node = new reduce_add32BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add16S_rule: {
      reduce_add16SNode *node = new reduce_add16SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add8I_rule: {
      reduce_add8INode *node = new reduce_add8INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add4L_rule: {
      reduce_add4LNode *node = new reduce_add4LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add8F_rule: {
      reduce_add8FNode *node = new reduce_add8FNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_add4D_rule: {
      reduce_add4DNode *node = new reduce_add4DNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul16B_rule: {
      reduce_mul16BNode *node = new reduce_mul16BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul8S_rule: {
      reduce_mul8SNode *node = new reduce_mul8SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul4I_rule: {
      reduce_mul4INode *node = new reduce_mul4INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul2L_rule: {
      reduce_mul2LNode *node = new reduce_mul2LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul4F_rule: {
      reduce_mul4FNode *node = new reduce_mul4FNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul2D_rule: {
      reduce_mul2DNode *node = new reduce_mul2DNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul32B_rule: {
      reduce_mul32BNode *node = new reduce_mul32BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul16S_rule: {
      reduce_mul16SNode *node = new reduce_mul16SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul8I_rule: {
      reduce_mul8INode *node = new reduce_mul8INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul4L_rule: {
      reduce_mul4LNode *node = new reduce_mul4LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul8F_rule: {
      reduce_mul8FNode *node = new reduce_mul8FNode();
      node->set_opnd_array(3, MachOperGenerator(REGF));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_mul4D_rule: {
      reduce_mul4DNode *node = new reduce_mul4DNode();
      node->set_opnd_array(3, MachOperGenerator(REGD));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max16B_rule: {
      reduce_max16BNode *node = new reduce_max16BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max8S_rule: {
      reduce_max8SNode *node = new reduce_max8SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max4I_rule: {
      reduce_max4INode *node = new reduce_max4INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max2L_rule: {
      reduce_max2LNode *node = new reduce_max2LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max32B_rule: {
      reduce_max32BNode *node = new reduce_max32BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max16S_rule: {
      reduce_max16SNode *node = new reduce_max16SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max8I_rule: {
      reduce_max8INode *node = new reduce_max8INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_max4L_rule: {
      reduce_max4LNode *node = new reduce_max4LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min16B_rule: {
      reduce_min16BNode *node = new reduce_min16BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min8S_rule: {
      reduce_min8SNode *node = new reduce_min8SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min4I_rule: {
      reduce_min4INode *node = new reduce_min4INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min2L_rule: {
      reduce_min2LNode *node = new reduce_min2LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min32B_rule: {
      reduce_min32BNode *node = new reduce_min32BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min16S_rule: {
      reduce_min16SNode *node = new reduce_min16SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min8I_rule: {
      reduce_min8INode *node = new reduce_min8INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_min4L_rule: {
      reduce_min4LNode *node = new reduce_min4LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_and16B_rule: {
      reduce_and16BNode *node = new reduce_and16BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_and8S_rule: {
      reduce_and8SNode *node = new reduce_and8SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_and4I_rule: {
      reduce_and4INode *node = new reduce_and4INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_and2L_rule: {
      reduce_and2LNode *node = new reduce_and2LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_and32B_rule: {
      reduce_and32BNode *node = new reduce_and32BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_and16S_rule: {
      reduce_and16SNode *node = new reduce_and16SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_and8I_rule: {
      reduce_and8INode *node = new reduce_and8INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_and4L_rule: {
      reduce_and4LNode *node = new reduce_and4LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_or16B_rule: {
      reduce_or16BNode *node = new reduce_or16BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_or8S_rule: {
      reduce_or8SNode *node = new reduce_or8SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_or4I_rule: {
      reduce_or4INode *node = new reduce_or4INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_or2L_rule: {
      reduce_or2LNode *node = new reduce_or2LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_or32B_rule: {
      reduce_or32BNode *node = new reduce_or32BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_or16S_rule: {
      reduce_or16SNode *node = new reduce_or16SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_or8I_rule: {
      reduce_or8INode *node = new reduce_or8INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_or4L_rule: {
      reduce_or4LNode *node = new reduce_or4LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_xor16B_rule: {
      reduce_xor16BNode *node = new reduce_xor16BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_xor8S_rule: {
      reduce_xor8SNode *node = new reduce_xor8SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_xor4I_rule: {
      reduce_xor4INode *node = new reduce_xor4INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->set_opnd_array(5, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_xor2L_rule: {
      reduce_xor2LNode *node = new reduce_xor2LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_xor32B_rule: {
      reduce_xor32BNode *node = new reduce_xor32BNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_xor16S_rule: {
      reduce_xor16SNode *node = new reduce_xor16SNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_xor8I_rule: {
      reduce_xor8INode *node = new reduce_xor8INode();
      node->set_opnd_array(3, MachOperGenerator(MREGI));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_xor4L_rule: {
      reduce_xor4LNode *node = new reduce_xor4LNode();
      node->set_opnd_array(3, MachOperGenerator(MREGL));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->set_opnd_array(5, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case round2D_rule: {
      round2DNode *node = new round2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case round4D_rule: {
      round4DNode *node = new round4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt16Bto16S_rule: {
      cvt16Bto16SNode *node = new cvt16Bto16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt16Sto16B_rule: {
      cvt16Sto16BNode *node = new cvt16Sto16BNode();
      node->set_opnd_array(2, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt8Sto8I_rule: {
      cvt8Sto8INode *node = new cvt8Sto8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt8Sto8F_rule: {
      cvt8Sto8FNode *node = new cvt8Sto8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt8Ito8S_rule: {
      cvt8Ito8SNode *node = new cvt8Ito8SNode();
      node->set_opnd_array(2, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Ito4F_rule: {
      cvt4Ito4FNode *node = new cvt4Ito4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Ito4L_rule: {
      cvt4Ito4LNode *node = new cvt4Ito4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt8Ito8F_rule: {
      cvt8Ito8FNode *node = new cvt8Ito8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Ito4D_rule: {
      cvt4Ito4DNode *node = new cvt4Ito4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Lto4I_rule: {
      cvt4Lto4INode *node = new cvt4Lto4INode();
      node->set_opnd_array(2, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Lto4F_rule: {
      cvt4Lto4FNode *node = new cvt4Lto4FNode();
      node->set_opnd_array(2, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt2Lto2D_rule: {
      cvt2Lto2DNode *node = new cvt2Lto2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Lto4D_rule: {
      cvt4Lto4DNode *node = new cvt4Lto4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt8Fto8S_rule: {
      cvt8Fto8SNode *node = new cvt8Fto8SNode();
      node->set_opnd_array(2, MachOperGenerator(VECX));
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Fto4I_rule: {
      cvt4Fto4INode *node = new cvt4Fto4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt8Fto8I_rule: {
      cvt8Fto8INode *node = new cvt8Fto8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Fto4L_rule: {
      cvt4Fto4LNode *node = new cvt4Fto4LNode();
      node->set_opnd_array(2, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Fto4D_rule: {
      cvt4Fto4DNode *node = new cvt4Fto4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Dto4I_rule: {
      cvt4Dto4INode *node = new cvt4Dto4INode();
      node->set_opnd_array(2, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Dto4F_rule: {
      cvt4Dto4FNode *node = new cvt4Dto4FNode();
      node->set_opnd_array(2, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt2Dto2L_rule: {
      cvt2Dto2LNode *node = new cvt2Dto2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cvt4Dto4L_rule: {
      cvt4Dto4LNode *node = new cvt4Dto4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reinterpretX_rule: {
      reinterpretXNode *node = new reinterpretXNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reinterpretY_rule: {
      reinterpretYNode *node = new reinterpretYNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reinterpretX2Y_rule: {
      reinterpretX2YNode *node = new reinterpretX2YNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reinterpretY2X_rule: {
      reinterpretY2XNode *node = new reinterpretY2XNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert16B_rule: {
      insert16BNode *node = new insert16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert8S_rule: {
      insert8SNode *node = new insert8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert4I_rule: {
      insert4INode *node = new insert4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert2L_rule: {
      insert2LNode *node = new insert2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert4F_rule: {
      insert4FNode *node = new insert4FNode();
      node->set_opnd_array(4, MachOperGenerator(MREGI));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert2D_rule: {
      insert2DNode *node = new insert2DNode();
      node->set_opnd_array(4, MachOperGenerator(MREGI));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert32B_rule: {
      insert32BNode *node = new insert32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert16S_rule: {
      insert16SNode *node = new insert16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert8I_rule: {
      insert8INode *node = new insert8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert4L_rule: {
      insert4LNode *node = new insert4LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert8F_rule: {
      insert8FNode *node = new insert8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case insert4D_rule: {
      insert4DNode *node = new insert4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case blendV16_rule: {
      blendV16Node *node = new blendV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case blendV32_rule: {
      blendV32Node *node = new blendV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadmask16B_rule: {
      loadmask16BNode *node = new loadmask16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadmask32B_rule: {
      loadmask32BNode *node = new loadmask32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadmask16S_rule: {
      loadmask16SNode *node = new loadmask16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storemask16B_rule: {
      storemask16BNode *node = new storemask16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storemask32B_rule: {
      storemask32BNode *node = new storemask32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storemask16S_rule: {
      storemask16SNode *node = new storemask16SNode();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case anytrue_in_maskV16_rule: {
      anytrue_in_maskV16Node *node = new anytrue_in_maskV16Node();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case alltrue_in_maskV16_rule: {
      alltrue_in_maskV16Node *node = new alltrue_in_maskV16Node();
      node->set_opnd_array(3, MachOperGenerator(VECX));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case anytrue_in_maskV32_rule: {
      anytrue_in_maskV32Node *node = new anytrue_in_maskV32Node();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case alltrue_in_maskV32_rule: {
      alltrue_in_maskV32Node *node = new alltrue_in_maskV32Node();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cmpV16_rule: {
      cmpV16Node *node = new cmpV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case cmpV32_rule: {
      cmpV32Node *node = new cmpV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadcon16B_rule: {
      loadcon16BNode *node = new loadcon16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadcon32B_rule: {
      loadcon32BNode *node = new loadcon32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadShuffle16B_rule: {
      loadShuffle16BNode *node = new loadShuffle16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadShuffle32B_rule: {
      loadShuffle32BNode *node = new loadShuffle32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadShuffle16S_rule: {
      loadShuffle16SNode *node = new loadShuffle16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rearrange16B_rule: {
      rearrange16BNode *node = new rearrange16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rearrange32B_rule: {
      rearrange32BNode *node = new rearrange32BNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rearrange16S_rule: {
      rearrange16SNode *node = new rearrange16SNode();
      node->set_opnd_array(3, MachOperGenerator(VECY));
      node->set_opnd_array(4, MachOperGenerator(VECY));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case popcount4I_rule: {
      popcount4INode *node = new popcount4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case popcount8I_rule: {
      popcount8INode *node = new popcount8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndSwapP_shenandoah_rule: {
      compareAndSwapP_shenandoahNode *node = new compareAndSwapP_shenandoahNode();
      return node;
    }
  case compareAndSwapN_shenandoah_rule: {
      compareAndSwapN_shenandoahNode *node = new compareAndSwapN_shenandoahNode();
      return node;
    }
  case compareAndSwapPAcq_shenandoah_rule: {
      compareAndSwapPAcq_shenandoahNode *node = new compareAndSwapPAcq_shenandoahNode();
      return node;
    }
  case compareAndSwapNAcq_shenandoah_rule: {
      compareAndSwapNAcq_shenandoahNode *node = new compareAndSwapNAcq_shenandoahNode();
      return node;
    }
  case compareAndExchangeN_shenandoah_rule: {
      compareAndExchangeN_shenandoahNode *node = new compareAndExchangeN_shenandoahNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangeP_shenandoah_rule: {
      compareAndExchangeP_shenandoahNode *node = new compareAndExchangeP_shenandoahNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangeNAcq_shenandoah_rule: {
      compareAndExchangeNAcq_shenandoahNode *node = new compareAndExchangeNAcq_shenandoahNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangePAcq_shenandoah_rule: {
      compareAndExchangePAcq_shenandoahNode *node = new compareAndExchangePAcq_shenandoahNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case weakCompareAndSwapN_shenandoah_rule: {
      weakCompareAndSwapN_shenandoahNode *node = new weakCompareAndSwapN_shenandoahNode();
      return node;
    }
  case weakCompareAndSwapP_shenandoah_rule: {
      weakCompareAndSwapP_shenandoahNode *node = new weakCompareAndSwapP_shenandoahNode();
      return node;
    }
  case weakCompareAndSwapNAcq_shenandoah_rule: {
      weakCompareAndSwapNAcq_shenandoahNode *node = new weakCompareAndSwapNAcq_shenandoahNode();
      return node;
    }
  case weakCompareAndSwapPAcq_shenandoah_rule: {
      weakCompareAndSwapPAcq_shenandoahNode *node = new weakCompareAndSwapPAcq_shenandoahNode();
      return node;
    }
  case zLoadP_rule: {
      zLoadPNode *node = new zLoadPNode();
      node->set_opnd_array(2, MachOperGenerator(MREGP));
      node->set_opnd_array(3, MachOperGenerator(MREGP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case zCompareAndSwapP_rule: {
      zCompareAndSwapPNode *node = new zCompareAndSwapPNode();
      node->set_opnd_array(4, MachOperGenerator(MREGI));
      node->set_opnd_array(5, MachOperGenerator(MREGP));
      return node;
    }
  case zCompareAndSwapP_acq_rule: {
      zCompareAndSwapP_acqNode *node = new zCompareAndSwapP_acqNode();
      node->set_opnd_array(4, MachOperGenerator(MREGI));
      node->set_opnd_array(5, MachOperGenerator(MREGP));
      return node;
    }
  case zCompareAndSwapPWeak_rule: {
      zCompareAndSwapPWeakNode *node = new zCompareAndSwapPWeakNode();
      node->set_opnd_array(4, MachOperGenerator(MREGI));
      node->set_opnd_array(5, MachOperGenerator(MREGP));
      return node;
    }
  case zCompareAndSwapPWeak_acq_rule: {
      zCompareAndSwapPWeak_acqNode *node = new zCompareAndSwapPWeak_acqNode();
      node->set_opnd_array(4, MachOperGenerator(MREGI));
      node->set_opnd_array(5, MachOperGenerator(MREGP));
      return node;
    }
  case zCompareAndExchangeP_rule: {
      zCompareAndExchangePNode *node = new zCompareAndExchangePNode();
      node->set_opnd_array(4, MachOperGenerator(MREGP));
      node->set_opnd_array(5, MachOperGenerator(MREGP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case zCompareAndExchangeP_acq_rule: {
      zCompareAndExchangeP_acqNode *node = new zCompareAndExchangeP_acqNode();
      node->set_opnd_array(4, MachOperGenerator(MREGP));
      node->set_opnd_array(5, MachOperGenerator(MREGP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case zGetAndSetP_rule: {
      zGetAndSetPNode *node = new zGetAndSetPNode();
      node->set_opnd_array(3, MachOperGenerator(MREGP));
      node->set_opnd_array(4, MachOperGenerator(MREGP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  
  default:
    fprintf(stderr, "Default MachNode Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  };
  return NULL;
}
// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DLOONGARCH64=1
#ifndef LOONGARCH64
#  error "LOONGARCH64 must be defined"
#endif // LOONGARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
