#line 1 "ad_loongarch.cpp"
//
// Copyright (c) 2003, 2013, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2015, 2022, Loongson Technology. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_loongarch.hpp"
#include "adfiles/ad_loongarch.hpp"
#include "memory/allocation.inline.hpp"
#include "code/codeCache.hpp"
#include "code/compiledIC.hpp"
#include "code/nativeInst.hpp"
#include "code/vmreg.inline.hpp"
#include "gc/shared/collectedHeap.inline.hpp"
#include "oops/compiledICHolder.hpp"
#include "oops/compressedOops.hpp"
#include "oops/markWord.hpp"
#include "oops/method.hpp"
#include "oops/oop.inline.hpp"
#include "opto/c2_MacroAssembler.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/biasedLocking.hpp"
#include "runtime/safepointMechanism.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "utilities/powerOfTwo.hpp"

//SourceForm

#line 911 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"


#define   NO_INDEX    0
#define   RELOC_IMM64    Assembler::imm_operand
#define   RELOC_DISP32   Assembler::disp32_operand

#define V0_num    A0_num
#define V0_H_num  A0_H_num

#define __ _masm.

#define A0 RA0
#define A1 RA1
#define A2 RA2
#define A3 RA3
#define A4 RA4
#define A5 RA5
#define A6 RA6
#define A7 RA7
#define T0 RT0
#define T1 RT1
#define T2 RT2
#define T3 RT3
#define T4 RT4
#define T5 RT5
#define T6 RT6
#define T7 RT7
#define T8 RT8

RegMask _ANY_REG32_mask;
RegMask _ANY_REG_mask;
RegMask _PTR_REG_mask;

void reg_mask_init() {
  _ANY_REG32_mask = _ALL_REG32_mask;
  _ANY_REG_mask = _ALL_REG_mask;
  _PTR_REG_mask = _ALL_REG_mask;

  if (UseCompressedOops && (CompressedOops::ptrs_base() != NULL)) {
    _ANY_REG32_mask.Remove(OptoReg::as_OptoReg(r28->as_VMReg()));
    _ANY_REG_mask.SUBTRACT(_S5_LONG_REG_mask);
    _PTR_REG_mask.SUBTRACT(_S5_LONG_REG_mask);
  }

  // FP(r22) is not allocatable when PreserveFramePointer is on
  if (PreserveFramePointer) {
    _ANY_REG32_mask.Remove(OptoReg::as_OptoReg(r22->as_VMReg()));
    _ANY_REG_mask.SUBTRACT(_FP_REG_mask);
    _PTR_REG_mask.SUBTRACT(_FP_REG_mask);
  }
}

void PhaseOutput::pd_perform_mach_node_analysis() {
}

int MachNode::pd_alignment_required() const {
  return 1;
}

int MachNode::compute_padding(int current_offset) const {
  return 0;
}

// Emit exception handler code.
// Stuff framesize into a register and call a VM stub routine.
int HandlerImpl::emit_exception_handler(CodeBuffer& cbuf) {
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  C2_MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_exception_handler());
  if (base == NULL) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }

  int offset = __ offset();

  __ block_comment("; emit_exception_handler");

  cbuf.set_insts_mark();
  __ relocate(relocInfo::runtime_call_type);
  __ patchable_jump((address)OptoRuntime::exception_blob()->entry_point());
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// Emit deopt handler code.
int HandlerImpl::emit_deopt_handler(CodeBuffer& cbuf) {
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  C2_MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_deopt_handler());
  if (base == NULL) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }

  int offset = __ offset();

  __ block_comment("; emit_deopt_handler");

  cbuf.set_insts_mark();
  __ relocate(relocInfo::runtime_call_type);
  __ patchable_call(SharedRuntime::deopt_blob()->unpack());
  assert(__ offset() - offset <= (int) size_deopt_handler(), "overflow");
  __ end_a_stub();
  return offset;
}


const bool Matcher::match_rule_supported(int opcode) {
  if (!has_match_rule(opcode))
    return false;

  switch (opcode) {
    case Op_RoundDoubleMode:
      if (!UseLSX)
        return false;
    case Op_PopCountI:
    case Op_PopCountL:
      return UsePopCountInstruction;
    default:
      break;
  }

  return true;  // Per default match rules are supported.
}

const bool Matcher::match_rule_supported_vector(int opcode, int vlen, BasicType bt) {
  if (!match_rule_supported(opcode) || !vector_size_supported(bt, vlen))
    return false;

  switch (opcode) {
    case Op_RotateRightV:
    case Op_RotateLeftV:
      if (bt != T_INT && bt != T_LONG) {
        return false;
      }
      break;
    case Op_MaxReductionV:
    case Op_MinReductionV:
      if (bt == T_FLOAT || bt == T_DOUBLE) {
        return false;
      }
      break;
    case Op_VectorCastB2X:
    case Op_VectorLoadMask:
    case Op_VectorStoreMask:
    case Op_VectorLoadShuffle:
    case Op_VectorRearrange:
      if (vlen < 16)
        return false;
      break;
    case Op_VectorCastS2X:
      if (vlen < 8)
        return false;
      break;
    case Op_VectorCastI2X:
    case Op_VectorCastF2X:
      if (vlen < 4)
        return false;
      break;
    default:
      break;
  }

  return true;
}

// Vector calling convention not yet implemented.
const bool Matcher::supports_vector_calling_convention(void) {
  return false;
}

OptoRegPair Matcher::vector_return_value(uint ideal_reg) {
  Unimplemented();
  return OptoRegPair(0, 0);
}

const int Matcher::float_pressure(int default_pressure_threshold) {
  Unimplemented();
  return default_pressure_threshold;
}

bool Matcher::is_short_branch_offset(int rule, int br_size, int offset) {
  const int safety_zone = 3 * BytesPerInstWord;
  int offs = offset - br_size + 4;
  // To be conservative on LoongArch
  // branch node should be end with:
  //   branch inst
  offs = (offs < 0 ? offs - safety_zone : offs + safety_zone) >> 2;
  switch (rule) {
    case jmpDir_long_rule:
    case jmpDir_short_rule:
      return Assembler::is_simm(offs, 26);
    case jmpCon_flags_long_rule:
    case jmpCon_flags_short_rule:
    case branchConP_0_long_rule:
    case branchConP_0_short_rule:
    case branchConN2P_0_long_rule:
    case branchConN2P_0_short_rule:
    case cmpN_null_branch_long_rule:
    case cmpN_null_branch_short_rule:
    case branchConF_reg_reg_long_rule:
    case branchConF_reg_reg_short_rule:
    case branchConD_reg_reg_long_rule:
    case branchConD_reg_reg_short_rule:
      return Assembler::is_simm(offs, 21);
    default:
      return Assembler::is_simm(offs, 16);
  }
  return false;
}

MachOper* Matcher::pd_specialize_generic_vector_operand(MachOper* generic_opnd, uint ideal_reg, bool is_temp) {
  ShouldNotReachHere(); // generic vector operands not supported
  return NULL;
}

bool Matcher::is_generic_reg2reg_move(MachNode* m) {
  ShouldNotReachHere(); // generic vector operands not supported
  return false;
}

bool Matcher::is_generic_vector(MachOper* opnd)  {
  ShouldNotReachHere(); // generic vector operands not supported
  return false;
}

const RegMask* Matcher::predicate_reg_mask(void) {
  return NULL;
}

const TypeVect* Matcher::predicate_reg_type(const Type* elemTy, int length) {
  return NULL;
}

const int Matcher::scalable_vector_reg_size(const BasicType bt) {
  return -1;
}

// Vector ideal reg
const uint Matcher::vector_ideal_reg(int size) {
  assert(MaxVectorSize == 16 || MaxVectorSize == 32, "");
  switch(size) {
    case 16: return Op_VecX;
    case 32: return Op_VecY;
  }
  ShouldNotReachHere();
  return 0;
}

// Should the matcher clone input 'm' of node 'n'?
bool Matcher::pd_clone_node(Node* n, Node* m, Matcher::MStack& mstack) {
  return false;
}

// Should the Matcher clone shifts on addressing modes, expecting them
// to be subsumed into complex addressing expressions or compute them
// into registers?
bool Matcher::pd_clone_address_expressions(AddPNode* m, Matcher::MStack& mstack, VectorSet& address_visited) {
  return clone_base_plus_offset_address(m, mstack, address_visited);
}

// Max vector size in bytes. 0 if not supported.
const int Matcher::vector_width_in_bytes(BasicType bt) {
  return (int)MaxVectorSize;
}

// Limits on vector size (number of elements) loaded into vector.
const int Matcher::max_vector_size(const BasicType bt) {
  assert(is_java_primitive(bt), "only primitive type vectors");
  return vector_width_in_bytes(bt)/type2aelembytes(bt);
}

const int Matcher::min_vector_size(const BasicType bt) {
  int max_size = max_vector_size(bt);
  int size     = 0;

  if (UseLSX) size = 16;
  size = size / type2aelembytes(bt);
  return MIN2(size,max_size);
}

// Register for DIVI projection of divmodI
RegMask Matcher::divI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODI projection of divmodI
RegMask Matcher::modI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for DIVL projection of divmodL
RegMask Matcher::divL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Return whether or not this register is ever used as an argument.  This
// function is used on startup to build the trampoline stubs in generateOptoStub.
// Registers not mentioned will be killed by the VM call in the trampoline, and
// arguments in those registers not be available to the callee.
bool Matcher::can_be_java_arg( int reg ) {
  // Refer to: [sharedRuntime_loongarch_64.cpp] SharedRuntime::java_calling_convention()
  if (    reg == T0_num || reg == T0_H_num
       || reg == A0_num || reg == A0_H_num
       || reg == A1_num || reg == A1_H_num
       || reg == A2_num || reg == A2_H_num
       || reg == A3_num || reg == A3_H_num
       || reg == A4_num || reg == A4_H_num
       || reg == A5_num || reg == A5_H_num
       || reg == A6_num || reg == A6_H_num
       || reg == A7_num || reg == A7_H_num )
    return true;

  if (    reg == F0_num || reg == F0_H_num
       || reg == F1_num || reg == F1_H_num
       || reg == F2_num || reg == F2_H_num
       || reg == F3_num || reg == F3_H_num
       || reg == F4_num || reg == F4_H_num
       || reg == F5_num || reg == F5_H_num
       || reg == F6_num || reg == F6_H_num
       || reg == F7_num || reg == F7_H_num )
    return true;

  return false;
}

bool Matcher::is_spillable_arg( int reg ) {
  return can_be_java_arg(reg);
}

bool Matcher::use_asm_for_ldiv_by_con( jlong divisor ) {
  return false;
}

// Register for MODL projection of divmodL
RegMask Matcher::modL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return FP_REG_mask();
}

int CallStaticJavaDirectNode::compute_padding(int current_offset) const {
  const uintx m = alignment_required() - 1;
  return mask_bits(current_offset + m, ~m) - current_offset;
}

int CallDynamicJavaDirectNode::compute_padding(int current_offset) const {
  const uintx m = alignment_required() - 1;
  return mask_bits(current_offset + m, ~m) - current_offset;
}

int CallLeafNoFPDirectNode::compute_padding(int current_offset) const {
  const uintx m = alignment_required() - 1;
  return mask_bits(current_offset + m, ~m) - current_offset;
}

int CallLeafDirectNode::compute_padding(int current_offset) const {
  const uintx m = alignment_required() - 1;
  return mask_bits(current_offset + m, ~m) - current_offset;
}

int CallRuntimeDirectNode::compute_padding(int current_offset) const {
  const uintx m = alignment_required() - 1;
  return mask_bits(current_offset + m, ~m) - current_offset;
}

#ifndef PRODUCT
void MachBreakpointNode::format( PhaseRegAlloc *, outputStream* st ) const {
  st->print("BRK");
}
#endif

void MachBreakpointNode::emit(CodeBuffer &cbuf, PhaseRegAlloc* ra_) const {
  C2_MacroAssembler _masm(&cbuf);
  __ brk(5);
}

uint MachBreakpointNode::size(PhaseRegAlloc* ra_) const {
  return MachNode::size(ra_);
}



// !!!!! Special hack to get all type of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.
int MachCallStaticJavaNode::ret_addr_offset() {
  // bl
  return NativeCall::instruction_size;
}

int MachCallDynamicJavaNode::ret_addr_offset() {
  // lu12i_w IC_Klass,
  // ori IC_Klass,
  // lu32i_d IC_Klass
  // lu52i_d IC_Klass

  // bl
  return NativeMovConstReg::instruction_size + NativeCall::instruction_size;
}

//=============================================================================

// Figure out which register class each belongs in: rc_int, rc_float, rc_stack
enum RC { rc_bad, rc_int, rc_float, rc_stack };
static enum RC rc_class( OptoReg::Name reg ) {
  if( !OptoReg::is_valid(reg)  ) return rc_bad;
  if (OptoReg::is_stack(reg)) return rc_stack;
  VMReg r = OptoReg::as_VMReg(reg);
  if (r->is_Register()) return rc_int;
  assert(r->is_FloatRegister(), "must be");
  return rc_float;
}

// Helper methods for MachSpillCopyNode::implementation().
static int vec_mov_helper(CodeBuffer *cbuf, bool do_size, int src_lo, int dst_lo,
                          int src_hi, int dst_hi, uint ireg, outputStream* st) {
  int size = 0;
  if (cbuf) {
    MacroAssembler _masm(cbuf);
    int offset = __ offset();
    switch (ireg) {
      case Op_VecX:
        __ vori_b(as_FloatRegister(Matcher::_regEncode[dst_lo]), as_FloatRegister(Matcher::_regEncode[src_lo]), 0);
        break;
      case Op_VecY:
        __ xvori_b(as_FloatRegister(Matcher::_regEncode[dst_lo]), as_FloatRegister(Matcher::_regEncode[src_lo]), 0);
        break;
      default:
        ShouldNotReachHere();
    }
#ifndef PRODUCT
  } else if (!do_size) {
    switch (ireg) {
      case Op_VecX:
        st->print("vori.b    %s, %s, 0\t# spill", Matcher::regName[dst_lo], Matcher::regName[src_lo]);
        break;
      case Op_VecY:
        st->print("xvori.b    %s, %s, 0\t# spill", Matcher::regName[dst_lo], Matcher::regName[src_lo]);
        break;
      default:
        ShouldNotReachHere();
    }
#endif
  }
  size += 4;
  return size;
}

static int vec_spill_helper(CodeBuffer *cbuf, bool do_size, bool is_load,
                            int stack_offset, int reg, uint ireg, outputStream* st) {
  int size = 0;
  if (cbuf) {
    MacroAssembler _masm(cbuf);
    int offset = __ offset();
    if (is_load) {
      switch (ireg) {
        case Op_VecX:
          __ vld(as_FloatRegister(Matcher::_regEncode[reg]), SP, stack_offset);
          break;
        case Op_VecY:
          __ xvld(as_FloatRegister(Matcher::_regEncode[reg]), SP, stack_offset);
          break;
        default:
          ShouldNotReachHere();
      }
    } else { // store
      switch (ireg) {
        case Op_VecX:
          __ vst(as_FloatRegister(Matcher::_regEncode[reg]), SP, stack_offset);
          break;
        case Op_VecY:
          __ xvst(as_FloatRegister(Matcher::_regEncode[reg]), SP, stack_offset);
          break;
        default:
          ShouldNotReachHere();
      }
    }
#ifndef PRODUCT
  } else if (!do_size) {
    if (is_load) {
      switch (ireg) {
        case Op_VecX:
          st->print("vld    %s, [SP + %d]\t# spill", Matcher::regName[reg], stack_offset);
          break;
        case Op_VecY:
          st->print("xvld    %s, [SP + %d]\t# spill", Matcher::regName[reg], stack_offset);
          break;
        default:
          ShouldNotReachHere();
      }
    } else { // store
      switch (ireg) {
        case Op_VecX:
          st->print("vst    %s, [SP + %d]\t# spill", Matcher::regName[reg], stack_offset);
          break;
        case Op_VecY:
          st->print("xvst    %s, [SP + %d]\t# spill", Matcher::regName[reg], stack_offset);
          break;
        default:
          ShouldNotReachHere();
      }
    }
#endif
  }
  size += 4;
  return size;
}

static int vec_stack_to_stack_helper(CodeBuffer *cbuf, int src_offset,
                                      int dst_offset, uint ireg, outputStream* st) {
  int size = 0;
  if (cbuf) {
    MacroAssembler _masm(cbuf);
    switch (ireg) {
      case Op_VecX:
        __ vld(F23, SP, src_offset);
        __ vst(F23, SP, dst_offset);
        break;
      case Op_VecY:
        __ xvld(F23, SP, src_offset);
        __ xvst(F23, SP, dst_offset);
        break;
      default:
        ShouldNotReachHere();
    }
#ifndef PRODUCT
  } else {
    switch (ireg) {
      case Op_VecX:
        st->print("vld f23, %d(sp)\n\t"
                  "vst f23, %d(sp)\t# 128-bit mem-mem spill",
                  src_offset, dst_offset);
        break;
      case Op_VecY:
        st->print("xvld f23, %d(sp)\n\t"
                  "xvst f23, %d(sp)\t# 256-bit mem-mem spill",
                  src_offset, dst_offset);
        break;
      default:
        ShouldNotReachHere();
    }
#endif
  }
  size += 8;
  return size;
}

uint MachSpillCopyNode::implementation( CodeBuffer *cbuf, PhaseRegAlloc *ra_, bool do_size, outputStream* st ) const {
  // Get registers to move
  OptoReg::Name src_second = ra_->get_reg_second(in(1));
  OptoReg::Name src_first = ra_->get_reg_first(in(1));
  OptoReg::Name dst_second = ra_->get_reg_second(this );
  OptoReg::Name dst_first = ra_->get_reg_first(this );

  enum RC src_second_rc = rc_class(src_second);
  enum RC src_first_rc = rc_class(src_first);
  enum RC dst_second_rc = rc_class(dst_second);
  enum RC dst_first_rc = rc_class(dst_first);

  assert(OptoReg::is_valid(src_first) && OptoReg::is_valid(dst_first), "must move at least 1 register" );

  // Generate spill code!

  if( src_first == dst_first && src_second == dst_second )
    return 0;            // Self copy, no move

  if (bottom_type()->isa_vect() != NULL) {
    uint ireg = ideal_reg();
    assert((src_first_rc != rc_int && dst_first_rc != rc_int), "sanity");
    if (src_first_rc == rc_stack && dst_first_rc == rc_stack) {
      // mem -> mem
      int src_offset = ra_->reg2offset(src_first);
      int dst_offset = ra_->reg2offset(dst_first);
      vec_stack_to_stack_helper(cbuf, src_offset, dst_offset, ireg, st);
    } else if (src_first_rc == rc_float && dst_first_rc == rc_float) {
      vec_mov_helper(cbuf, do_size, src_first, dst_first, src_second, dst_second, ireg, st);
    } else if (src_first_rc == rc_float && dst_first_rc == rc_stack) {
      int stack_offset = ra_->reg2offset(dst_first);
      vec_spill_helper(cbuf, do_size, false, stack_offset, src_first, ireg, st);
    } else if (src_first_rc == rc_stack && dst_first_rc == rc_float) {
      int stack_offset = ra_->reg2offset(src_first);
      vec_spill_helper(cbuf, do_size, true,  stack_offset, dst_first, ireg, st);
    } else {
      ShouldNotReachHere();
    }
    return 0;
  }

  if (src_first_rc == rc_stack) {
    // mem ->
    if (dst_first_rc == rc_stack) {
      // mem -> mem
      assert(src_second != dst_first, "overlap");
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int src_offset = ra_->reg2offset(src_first);
        int dst_offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ ld_d(AT, Address(SP, src_offset));
          __ st_d(AT, Address(SP, dst_offset));
#ifndef PRODUCT
        } else {
          st->print("\tld_d    AT, [SP + #%d]\t# 64-bit mem-mem spill 1\n\t"
                    "st_d    AT, [SP + #%d]",
                    src_offset, dst_offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        // No pushl/popl, so:
        int src_offset = ra_->reg2offset(src_first);
        int dst_offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ ld_w(AT, Address(SP, src_offset));
          __ st_w(AT, Address(SP, dst_offset));
#ifndef PRODUCT
        } else {
          st->print("\tld_w    AT, [SP + #%d] spill 2\n\t"
                    "st_w    AT, [SP + #%d]\n\t",
                    src_offset, dst_offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_int) {
      // mem -> gpr
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(src_first);
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ ld_d(as_Register(Matcher::_regEncode[dst_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\tld_d    %s, [SP + #%d]\t# spill 3",
                    Matcher::regName[dst_first],
                    offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(src_first);
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          if (this->ideal_reg() == Op_RegI)
            __ ld_w(as_Register(Matcher::_regEncode[dst_first]), Address(SP, offset));
          else {
            if (Assembler::is_simm(offset, 12)) {
              __ ld_wu(as_Register(Matcher::_regEncode[dst_first]), Address(SP, offset));
            } else {
              __ li(AT, offset);
              __ ldx_wu(as_Register(Matcher::_regEncode[dst_first]), SP, AT);
            }
          }
#ifndef PRODUCT
        } else {
          if (this->ideal_reg() == Op_RegI)
            st->print("\tld_w    %s, [SP + #%d]\t# spill 4",
                      Matcher::regName[dst_first],
                      offset);
          else
            st->print("\tld_wu    %s, [SP + #%d]\t# spill 5",
                      Matcher::regName[dst_first],
                      offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_float) {
      // mem-> xmm
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(src_first);
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          if (Assembler::is_simm(offset, 12)) {
            __ fld_d( as_FloatRegister(Matcher::_regEncode[dst_first]), Address(SP, offset));
          } else {
            __ li(AT, offset);
            __ fldx_d( as_FloatRegister(Matcher::_regEncode[dst_first]), SP, AT);
          }
#ifndef PRODUCT
        } else {
          st->print("\tfld_d  %s, [SP + #%d]\t# spill 6",
                    Matcher::regName[dst_first],
                    offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(src_first);
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ fld_s( as_FloatRegister(Matcher::_regEncode[dst_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\tfld_s   %s, [SP + #%d]\t# spill 7",
                    Matcher::regName[dst_first],
                    offset);
#endif
        }
      }
    }
    return 0;
  } else if (src_first_rc == rc_int) {
    // gpr ->
    if (dst_first_rc == rc_stack) {
      // gpr -> mem
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ st_d(as_Register(Matcher::_regEncode[src_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\tst_d    %s, [SP + #%d] # spill 8",
                    Matcher::regName[src_first],
                    offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ st_w(as_Register(Matcher::_regEncode[src_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\tst_w    %s, [SP + #%d]\t# spill 9",
                    Matcher::regName[src_first], offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_int) {
      // gpr -> gpr
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ move(as_Register(Matcher::_regEncode[dst_first]),
                  as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\tmove(64bit)    %s <-- %s\t# spill 10",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
        return 0;
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          if (this->ideal_reg() == Op_RegI)
              __ move_u32(as_Register(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]));
          else
              __ add_d(as_Register(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]), R0);
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("move(32-bit)    %s <-- %s\t# spill 11",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
        return 0;
      }
    } else if (dst_first_rc == rc_float) {
      // gpr -> xmm
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ movgr2fr_d(as_FloatRegister(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("movgr2fr_d   %s, %s\t# spill 12",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ movgr2fr_w(as_FloatRegister(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("movgr2fr_w   %s, %s\t# spill 13",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    }
  } else if (src_first_rc == rc_float) {
    // xmm ->
    if (dst_first_rc == rc_stack) {
      // xmm -> mem
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          if (Assembler::is_simm(offset, 12)) {
            __ fst_d( as_FloatRegister(Matcher::_regEncode[src_first]), Address(SP, offset) );
          }
          else {
            __ li(AT, offset);
            __ fstx_d( as_FloatRegister(Matcher::_regEncode[src_first]), SP, AT);
          }
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("fst_d   %s, [SP + #%d]\t# spill 14",
                    Matcher::regName[src_first],
                    offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ fst_s(as_FloatRegister(Matcher::_regEncode[src_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("fst_s   %s, [SP + #%d]\t# spill 15",
                    Matcher::regName[src_first],
                    offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_int) {
      // xmm -> gpr
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ movfr2gr_d( as_Register(Matcher::_regEncode[dst_first]), as_FloatRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("movfr2gr_d   %s, %s\t# spill 16",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ movfr2gr_s( as_Register(Matcher::_regEncode[dst_first]), as_FloatRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("movfr2gr_s   %s, %s\t# spill 17",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_float) {
      // xmm -> xmm
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ fmov_d( as_FloatRegister(Matcher::_regEncode[dst_first]), as_FloatRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("fmov_d  %s <-- %s\t# spill 18",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (cbuf) {
          C2_MacroAssembler _masm(cbuf);
          __ fmov_s( as_FloatRegister(Matcher::_regEncode[dst_first]), as_FloatRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("fmov_s  %s <-- %s\t# spill 19",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    }
  }

  assert(0," foo ");
  Unimplemented();
  return 0;
}

#ifndef PRODUCT
void MachSpillCopyNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  implementation( NULL, ra_, false, st );
}
#endif

void MachSpillCopyNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  implementation( &cbuf, ra_, false, NULL );
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================
#ifndef PRODUCT
void MachEpilogNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  Compile *C = ra_->C;
  int framesize = C->output()->frame_size_in_bytes();

  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");

  st->print_cr("ld_d    RA, SP, %d # Restore RA @ MachEpilogNode", -wordSize);
  st->print("\t");
  st->print_cr("ld_d    FP, SP, %d # Restore FP @ MachEpilogNode", -wordSize*2);
  st->print("\t");
  if (Assembler::is_simm(framesize, 12)) {
    st->print_cr("addi_d   SP, SP, %d # Rlease stack @ MachEpilogNode", framesize);
  } else {
    st->print_cr("li   AT, %d # Rlease stack @ MachEpilogNode", framesize);
    st->print_cr("add_d   SP, SP, AT # Rlease stack @ MachEpilogNode");
  }
  if( do_polling() && C->is_method_compilation() ) {
    st->print("\t");
    st->print_cr("ld_d    AT, poll_offset[thread] #polling_word_offset\n\t"
                 "ld_w    AT, [AT]\t"
                 "# Safepoint: poll for GC");
  }
}
#endif

void MachEpilogNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile *C = ra_->C;
  C2_MacroAssembler _masm(&cbuf);
  int framesize = C->output()->frame_size_in_bytes();

  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");

  __ remove_frame(framesize);

  if (StackReservedPages > 0 && C->has_reserved_stack_access()) {
    __ reserved_stack_check();
  }

  Register thread = TREG;
#ifndef OPT_THREAD
  __ get_thread(thread);
#endif

  if( do_polling() && C->is_method_compilation() ) {
    Label dummy_label;
    Label* code_stub = &dummy_label;
    if (!C->output()->in_scratch_emit_size()) {
      code_stub = &C->output()->safepoint_poll_table()->add_safepoint(__ offset());
    }
    __ relocate(relocInfo::poll_return_type);
    __ safepoint_poll(*code_stub, thread, true /* at_return */, false /* acquire */, true /* in_nmethod */);
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_); // too many variables; just compute it the hard way
}

int MachEpilogNode::reloc() const {
  return 0; // a large enough number
}

const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

//=============================================================================

#ifndef PRODUCT
void BoxLockNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("ADDI_D %s, SP, %d   @BoxLockNode",Matcher::regName[reg],offset);
}
#endif


uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
   int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());

   if (Assembler::is_simm(offset, 12))
     return 4;
   else
     return 3 * 4;
}

void BoxLockNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  C2_MacroAssembler _masm(&cbuf);
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_encode(this);

  if (Assembler::is_simm(offset, 12)) {
    __ addi_d(as_Register(reg), SP, offset);
  } else {
    __ lu12i_w(AT, Assembler::split_low20(offset >> 12));
    __ ori(AT, AT, Assembler::split_low12(offset));
    __ add_d(as_Register(reg), SP, AT);
  }
}

int MachCallRuntimeNode::ret_addr_offset() {
  // pcaddu18i
  // jirl
  return NativeFarCall::instruction_size;
}

int MachCallNativeNode::ret_addr_offset() {
  Unimplemented();
  return -1;
}

//=============================================================================
#ifndef PRODUCT
void MachNopNode::format( PhaseRegAlloc *, outputStream* st ) const {
  st->print("NOP \t# %d bytes pad for loops and calls", 4 * _count);
}
#endif

void MachNopNode::emit(CodeBuffer &cbuf, PhaseRegAlloc * ) const {
  C2_MacroAssembler _masm(&cbuf);
  int i = 0;
  for(i = 0; i < _count; i++)
     __ nop();
}

uint MachNopNode::size(PhaseRegAlloc *) const {
  return 4 * _count;
}
const Pipeline* MachNopNode::pipeline() const {
  return MachNode::pipeline_class();
}

//=============================================================================

//=============================================================================
#ifndef PRODUCT
void MachUEPNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  st->print_cr("load_klass(T4, T0)");
  st->print_cr("\tbeq(T4, iCache, L)");
  st->print_cr("\tjmp(SharedRuntime::get_ic_miss_stub(), relocInfo::runtime_call_type)");
  st->print_cr("    L:");
}
#endif


void MachUEPNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  C2_MacroAssembler _masm(&cbuf);
  int  ic_reg = Matcher::inline_cache_reg_encode();
  Label L;
  Register receiver = T0;
  Register   iCache = as_Register(ic_reg);

  __ load_klass(T4, receiver);
  __ beq(T4, iCache, L);
  __ jmp((address)SharedRuntime::get_ic_miss_stub(), relocInfo::runtime_call_type);
  __ bind(L);
}

uint MachUEPNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}



//=============================================================================

const RegMask& MachConstantBaseNode::_out_RegMask = P_REG_mask();

int ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_postalloc_expand() const { return false; }
void MachConstantBaseNode::postalloc_expand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

void MachConstantBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  Compile* C = ra_->C;
  ConstantTable& constant_table = C->output()->constant_table();
  C2_MacroAssembler _masm(&cbuf);

  Register Rtoc = as_Register(ra_->get_encode(this));
  CodeSection* consts_section = cbuf.consts();
  int consts_size = consts_section->align_at_start(consts_section->size());
  assert(constant_table.size() == consts_size, "must be equal");

  if (consts_section->size()) {
    assert((CodeBuffer::SECT_CONSTS + 1) == CodeBuffer::SECT_INSTS,
           "insts must be immediately follow consts");
    // Materialize the constant table base.
    address baseaddr = cbuf.insts()->start() - consts_size + -(constant_table.table_base_offset());
    jint offs = (baseaddr - __ pc()) >> 2;
    guarantee(Assembler::is_simm(offs, 20), "Not signed 20-bit offset");
    __ pcaddi(Rtoc, offs);
  }
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  // pcaddi
  return 1 * BytesPerInstWord;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  Register r = as_Register(ra_->get_encode(this));
  st->print("pcaddi    %s, &constanttable (constant table base) @ MachConstantBaseNode", r->name());
}
#endif


//=============================================================================
#ifndef PRODUCT
void MachPrologNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  Compile* C = ra_->C;

  int framesize = C->output()->frame_size_in_bytes();
  int bangsize = C->output()->bang_size_in_bytes();
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");

  // Calls to C2R adapters often do not accept exceptional returns.
  // We require that their callers must bang for them.  But be careful, because
  // some VM calls (such as call site linkage) can use several kilobytes of
  // stack.  But the stack safety zone should account for that.
  // See bugs 4446381, 4468289, 4497237.
  if (C->output()->need_stack_bang(bangsize)) {
    st->print_cr("# stack bang"); st->print("\t");
  }
  st->print("st_d       RA, %d(SP)  @ MachPrologNode\n\t", -wordSize);
  st->print("st_d       FP, %d(SP)  @ MachPrologNode\n\t", -wordSize*2);
  if (PreserveFramePointer) {
    if (Assembler::is_simm((framesize - wordSize * 2), 12)) {
      st->print("addi_d   FP, SP, %d \n\t", framesize);
    } else {
      st->print("li   AT, %d \n\t", framesize);
      st->print("add_d   FP, AT \n\t");
    }
  }
  st->print("addi_d   SP, SP, -%d \t",framesize);
  if (C->stub_function() == NULL && BarrierSet::barrier_set()->barrier_set_nmethod() != NULL) {
    st->print("\n\t");
    st->print("ld_d  T1, guard, 0\n\t");
    st->print("membar  LoadLoad\n\t");
    st->print("ld_d  T2, TREG, thread_disarmed_offset\n\t");
    st->print("beq   T1, T2, skip\n\t");
    st->print("\n\t");
    st->print("jalr  #nmethod_entry_barrier_stub\n\t");
    st->print("b     skip\n\t");
    st->print("guard: int\n\t");
    st->print("\n\t");
    st->print("skip:\n\t");
  }
}
#endif


void MachPrologNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  C2_MacroAssembler _masm(&cbuf);

  int framesize = C->output()->frame_size_in_bytes();
  int bangsize = C->output()->bang_size_in_bytes();

  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");

#ifdef ASSERT
  address start = __ pc();
#endif

  if (C->clinit_barrier_on_entry()) {
    assert(!C->method()->holder()->is_not_initialized(), "initialization should have been started");

    Label L_skip_barrier;

    __ mov_metadata(T4, C->method()->holder()->constant_encoding());
    __ clinit_barrier(T4, AT, &L_skip_barrier);
    __ jmp((address)SharedRuntime::get_handle_wrong_method_stub(), relocInfo::runtime_call_type);
    __ bind(L_skip_barrier);
  }

  if (C->output()->need_stack_bang(bangsize)) {
    __ generate_stack_overflow_check(bangsize);
  }

  __ build_frame(framesize);

  assert((__ pc() - start) >= 1 * BytesPerInstWord, "No enough room for patch_verified_entry");

  if (C->stub_function() == NULL) {
    BarrierSetAssembler* bs = BarrierSet::barrier_set()->barrier_set_assembler();
    bs->nmethod_entry_barrier(&_masm);
  }

  C->output()->set_frame_complete(cbuf.insts_size());
  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    ConstantTable& constant_table = C->output()->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }
}


uint MachPrologNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_); // too many variables; just compute it the hard way
}

int MachPrologNode::reloc() const {
  return 0; // a large enough number
}

bool is_CAS(int opcode)
{
  switch(opcode) {
  // We handle these
  case Op_CompareAndSwapI:
  case Op_CompareAndSwapL:
  case Op_CompareAndSwapP:
  case Op_CompareAndSwapN:
  case Op_ShenandoahCompareAndSwapP:
  case Op_ShenandoahCompareAndSwapN:
  case Op_ShenandoahWeakCompareAndSwapP:
  case Op_ShenandoahWeakCompareAndSwapN:
  case Op_ShenandoahCompareAndExchangeP:
  case Op_ShenandoahCompareAndExchangeN:
  case Op_GetAndSetI:
  case Op_GetAndSetL:
  case Op_GetAndSetP:
  case Op_GetAndSetN:
  case Op_GetAndAddI:
  case Op_GetAndAddL:
    return true;
  default:
    return false;
  }
}

bool use_AMO(int opcode)
{
  switch(opcode) {
  // We handle these
  case Op_StoreI:
  case Op_StoreL:
  case Op_StoreP:
  case Op_StoreN:
  case Op_StoreNKlass:
    return true;
  default:
    return false;
  }
}

bool unnecessary_acquire(const Node *barrier)
{
  assert(barrier->is_MemBar(), "expecting a membar");

  if (UseBarriersForVolatile) {
    // we need to plant a dbar
    return false;
  }

  MemBarNode* mb = barrier->as_MemBar();

  if (mb->trailing_load_store()) {
    Node* load_store = mb->in(MemBarNode::Precedent);
    assert(load_store->is_LoadStore(), "unexpected graph shape");
    return is_CAS(load_store->Opcode());
  }

  return false;
}

bool unnecessary_release(const Node *n)
{
  assert((n->is_MemBar() && n->Opcode() == Op_MemBarRelease), "expecting a release membar");

  if (UseBarriersForVolatile) {
    // we need to plant a dbar
    return false;
  }

  MemBarNode *barrier = n->as_MemBar();

  if (!barrier->leading()) {
    return false;
  } else {
    Node* trailing = barrier->trailing_membar();
    MemBarNode* trailing_mb = trailing->as_MemBar();
    assert(trailing_mb->trailing(), "Not a trailing membar?");
    assert(trailing_mb->leading_membar() == n, "inconsistent leading/trailing membars");

    Node* mem = trailing_mb->in(MemBarNode::Precedent);
    if (mem->is_Store()) {
      assert(mem->as_Store()->is_release(), "");
      assert(trailing_mb->Opcode() == Op_MemBarVolatile, "");
      return use_AMO(mem->Opcode());
    } else {
      assert(mem->is_LoadStore(), "");
      assert(trailing_mb->Opcode() == Op_MemBarAcquire, "");
      return is_CAS(mem->Opcode());
    }
  }

  return false;
}

bool unnecessary_volatile(const Node *n)
{
  // assert n->is_MemBar();
  if (UseBarriersForVolatile) {
    // we need to plant a dbar
    return false;
  }

  MemBarNode *mbvol = n->as_MemBar();

  bool release = false;
  if (mbvol->trailing_store()) {
    Node* mem = mbvol->in(MemBarNode::Precedent);
    release = use_AMO(mem->Opcode());
  }

  assert(!release || (mbvol->in(MemBarNode::Precedent)->is_Store() && mbvol->in(MemBarNode::Precedent)->as_Store()->is_release()), "");
#ifdef ASSERT
  if (release) {
    Node* leading = mbvol->leading_membar();
    assert(leading->Opcode() == Op_MemBarRelease, "");
    assert(leading->as_MemBar()->leading_store(), "");
    assert(leading->as_MemBar()->trailing_membar() == mbvol, "");
   }
#endif

  return release;
}

bool needs_releasing_store(const Node *n)
{
  // assert n->is_Store();
  if (UseBarriersForVolatile) {
    // we use a normal store and dbar combination
    return false;
  }

  StoreNode *st = n->as_Store();

  return st->trailing_membar() != NULL;
}


#line 1474 "ad_loongarch.cpp"


//SourceForm

#line 33 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"


static void z_load_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp, uint8_t barrier_data) {
  if (barrier_data == ZLoadBarrierElided) {
    return;
  }
  Register thread = TREG;
#ifndef OPT_THREAD
  __ get_thread(thread);
#endif
  ZLoadBarrierStubC2* const stub = ZLoadBarrierStubC2::create(node, ref_addr, ref, tmp, barrier_data);
  __ ld_ptr(tmp, Address(thread, ZThreadLocalData::address_bad_mask_offset()));
  __ andr(tmp, tmp, ref);
  __ bnez(tmp, *stub->entry());
  __ bind(*stub->continuation());
}

static void z_load_barrier_slow_path(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp) {
  ZLoadBarrierStubC2* const stub = ZLoadBarrierStubC2::create(node, ref_addr, ref, tmp, ZLoadBarrierStrong);
  __ b(*stub->entry());
  __ bind(*stub->continuation());
}

static void z_compare_and_swap(MacroAssembler& _masm, const MachNode* node,
                               Register res, Register mem, Register oldval, Register newval,
                               Register tmp, bool weak, bool acquire) {
  // z-specific load barrier requires strong CAS operations.
  // Weak CAS operations are thus only emitted if the barrier is elided.
  Register thread = TREG;
#ifndef OPT_THREAD
  __ get_thread(thread);
#endif
  Address addr(mem);
  if (node->barrier_data() == ZLoadBarrierElided) {
    __ cmpxchg(addr, oldval, newval, tmp, false /* retold */, acquire /* acquire */,
               weak /* weak */, false /* exchange */);
    __ move(res, tmp);
  } else {
    __ move(tmp, oldval);
    __ cmpxchg(addr, tmp, newval, AT, true /* retold */, acquire /* acquire */,
               false /* weak */, false /* exchange */);
    __ move(res, AT);

    Label good;
    __ ld_ptr(AT, Address(thread, ZThreadLocalData::address_bad_mask_offset()));
    __ andr(AT, AT, tmp);
    __ beqz(AT, good);
    z_load_barrier_slow_path(_masm, node, addr, tmp, res /* used as tmp */);
    __ cmpxchg(addr, oldval, newval, tmp, false /* retold */, acquire /* acquire */, weak /* weak */, false /* exchange */);
    __ move(res, tmp);
    __ bind(good);
  }
}

static void z_compare_and_exchange(MacroAssembler& _masm, const MachNode* node,
                                   Register res, Register mem, Register oldval, Register newval, Register tmp,
                                   bool weak, bool acquire) {
  // z-specific load barrier requires strong CAS operations.
  // Weak CAS operations are thus only emitted if the barrier is elided.
  Register thread = TREG;
#ifndef OPT_THREAD
  __ get_thread(thread);
#endif
  Address addr(mem);
  __ cmpxchg(addr, oldval, newval, res, false /* retold */, acquire /* barrier */,
             weak && node->barrier_data() == ZLoadBarrierElided /* weak */, true /* exchange */);
  if (node->barrier_data() != ZLoadBarrierElided) {
    Label good;
    __ ld_ptr(tmp, Address(thread, ZThreadLocalData::address_bad_mask_offset()));
    __ andr(tmp, tmp, res);
    __ beqz(tmp, good);
    z_load_barrier_slow_path(_masm, node, addr, res /* ref */, tmp);
    __ cmpxchg(addr, oldval, newval, res, false /* retold */, acquire /* barrier */, weak /* weak */, true /* exchange */);
    __ bind(good);
  }
}


#line 1558 "ad_loongarch.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
  assert( DEFAULT_COST == 100, "Expect (100) to equal 100");
  assert( HUGE_COST == 1000000, "Expect (1000000) to equal 1000000");
  assert( MEMORY_REF_COST == 200, "Expect (DEFAULT_COST * 2) to equal 200");
  assert( BRANCH_COST == 300, "Expect (DEFAULT_COST * 3) to equal 300");
  assert( CALL_COST == 500, "Expect (DEFAULT_COST * 5) to equal 500");
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // S7
  'C', // S7_H
  'C', // S0
  'C', // S0_H
  'C', // S1
  'C', // S1_H
  'C', // S2
  'C', // S2_H
  'C', // S4
  'C', // S4_H
  'C', // S5
  'C', // S5_H
  'C', // S6
  'C', // S6_H
  'C', // S3
  'C', // S3_H
  'C', // T2
  'C', // T2_H
  'C', // T3
  'C', // T3_H
  'C', // T8
  'C', // T8_H
  'C', // T4
  'C', // T4_H
  'C', // T1
  'C', // T1_H
  'C', // T6
  'C', // T6_H
  'C', // A7
  'C', // A7_H
  'C', // A6
  'C', // A6_H
  'C', // A5
  'C', // A5_H
  'C', // A4
  'C', // A4_H
  'C', // T5
  'C', // T5_H
  'C', // A3
  'C', // A3_H
  'C', // A2
  'C', // A2_H
  'C', // A1
  'C', // A1_H
  'C', // A0
  'C', // A0_H
  'C', // T0
  'C', // T0_H
  'C', // S8
  'C', // S8_H
  'N', // RA
  'N', // RA_H
  'N', // SP
  'N', // SP_H
  'N', // FP
  'N', // FP_H
  'C', // T7
  'C', // T7_H
  'N', // TP
  'N', // TP_H
  'N', // RX
  'N', // RX_H
  'N', // R0
  'N', // R0_H
  'C', // F0
  'C', // F0_H
  'C', // F0_J
  'C', // F0_K
  'C', // F0_L
  'C', // F0_M
  'C', // F0_N
  'C', // F0_O
  'C', // F1
  'C', // F1_H
  'C', // F1_J
  'C', // F1_K
  'C', // F1_L
  'C', // F1_M
  'C', // F1_N
  'C', // F1_O
  'C', // F2
  'C', // F2_H
  'C', // F2_J
  'C', // F2_K
  'C', // F2_L
  'C', // F2_M
  'C', // F2_N
  'C', // F2_O
  'C', // F3
  'C', // F3_H
  'C', // F3_J
  'C', // F3_K
  'C', // F3_L
  'C', // F3_M
  'C', // F3_N
  'C', // F3_O
  'C', // F4
  'C', // F4_H
  'C', // F4_J
  'C', // F4_K
  'C', // F4_L
  'C', // F4_M
  'C', // F4_N
  'C', // F4_O
  'C', // F5
  'C', // F5_H
  'C', // F5_J
  'C', // F5_K
  'C', // F5_L
  'C', // F5_M
  'C', // F5_N
  'C', // F5_O
  'C', // F6
  'C', // F6_H
  'C', // F6_J
  'C', // F6_K
  'C', // F6_L
  'C', // F6_M
  'C', // F6_N
  'C', // F6_O
  'C', // F7
  'C', // F7_H
  'C', // F7_J
  'C', // F7_K
  'C', // F7_L
  'C', // F7_M
  'C', // F7_N
  'C', // F7_O
  'C', // F8
  'C', // F8_H
  'C', // F8_J
  'C', // F8_K
  'C', // F8_L
  'C', // F8_M
  'C', // F8_N
  'C', // F8_O
  'C', // F9
  'C', // F9_H
  'C', // F9_J
  'C', // F9_K
  'C', // F9_L
  'C', // F9_M
  'C', // F9_N
  'C', // F9_O
  'C', // F10
  'C', // F10_H
  'C', // F10_J
  'C', // F10_K
  'C', // F10_L
  'C', // F10_M
  'C', // F10_N
  'C', // F10_O
  'C', // F11
  'C', // F11_H
  'C', // F11_J
  'C', // F11_K
  'C', // F11_L
  'C', // F11_M
  'C', // F11_N
  'C', // F11_O
  'C', // F12
  'C', // F12_H
  'C', // F12_J
  'C', // F12_K
  'C', // F12_L
  'C', // F12_M
  'C', // F12_N
  'C', // F12_O
  'C', // F13
  'C', // F13_H
  'C', // F13_J
  'C', // F13_K
  'C', // F13_L
  'C', // F13_M
  'C', // F13_N
  'C', // F13_O
  'C', // F14
  'C', // F14_H
  'C', // F14_J
  'C', // F14_K
  'C', // F14_L
  'C', // F14_M
  'C', // F14_N
  'C', // F14_O
  'C', // F15
  'C', // F15_H
  'C', // F15_J
  'C', // F15_K
  'C', // F15_L
  'C', // F15_M
  'C', // F15_N
  'C', // F15_O
  'C', // F16
  'C', // F16_H
  'C', // F16_J
  'C', // F16_K
  'C', // F16_L
  'C', // F16_M
  'C', // F16_N
  'C', // F16_O
  'C', // F17
  'C', // F17_H
  'C', // F17_J
  'C', // F17_K
  'C', // F17_L
  'C', // F17_M
  'C', // F17_N
  'C', // F17_O
  'C', // F18
  'C', // F18_H
  'C', // F18_J
  'C', // F18_K
  'C', // F18_L
  'C', // F18_M
  'C', // F18_N
  'C', // F18_O
  'C', // F19
  'C', // F19_H
  'C', // F19_J
  'C', // F19_K
  'C', // F19_L
  'C', // F19_M
  'C', // F19_N
  'C', // F19_O
  'C', // F20
  'C', // F20_H
  'C', // F20_J
  'C', // F20_K
  'C', // F20_L
  'C', // F20_M
  'C', // F20_N
  'C', // F20_O
  'C', // F21
  'C', // F21_H
  'C', // F21_J
  'C', // F21_K
  'C', // F21_L
  'C', // F21_M
  'C', // F21_N
  'C', // F21_O
  'C', // F22
  'C', // F22_H
  'C', // F22_J
  'C', // F22_K
  'C', // F22_L
  'C', // F22_M
  'C', // F22_N
  'C', // F22_O
  'C', // F24
  'C', // F24_H
  'C', // F24_J
  'C', // F24_K
  'C', // F24_L
  'C', // F24_M
  'C', // F24_N
  'C', // F24_O
  'C', // F25
  'C', // F25_H
  'C', // F25_J
  'C', // F25_K
  'C', // F25_L
  'C', // F25_M
  'C', // F25_N
  'C', // F25_O
  'C', // F26
  'C', // F26_H
  'C', // F26_J
  'C', // F26_K
  'C', // F26_L
  'C', // F26_M
  'C', // F26_N
  'C', // F26_O
  'C', // F27
  'C', // F27_H
  'C', // F27_J
  'C', // F27_K
  'C', // F27_L
  'C', // F27_M
  'C', // F27_N
  'C', // F27_O
  'C', // F28
  'C', // F28_H
  'C', // F28_J
  'C', // F28_K
  'C', // F28_L
  'C', // F28_M
  'C', // F28_N
  'C', // F28_O
  'C', // F29
  'C', // F29_H
  'C', // F29_J
  'C', // F29_K
  'C', // F29_L
  'C', // F29_M
  'C', // F29_N
  'C', // F29_O
  'C', // F30
  'C', // F30_H
  'C', // F30_J
  'C', // F30_K
  'C', // F30_L
  'C', // F30_M
  'C', // F30_N
  'C', // F30_O
  'C', // F31
  'C', // F31_H
  'C', // F31_J
  'C', // F31_K
  'C', // F31_L
  'C', // F31_M
  'C', // F31_N
  'C', // F31_O
  'C', // F23
  'C', // F23_H
  'C', // F23_J
  'C', // F23_K
  'C', // F23_L
  'C', // F23_M
  'C', // F23_N
  'C' // no trailing comma // F23_O
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'E', // S7
  'E', // S7_H
  'E', // S0
  'E', // S0_H
  'E', // S1
  'E', // S1_H
  'E', // S2
  'E', // S2_H
  'E', // S4
  'E', // S4_H
  'E', // S5
  'E', // S5_H
  'E', // S6
  'E', // S6_H
  'E', // S3
  'E', // S3_H
  'C', // T2
  'C', // T2_H
  'C', // T3
  'C', // T3_H
  'C', // T8
  'C', // T8_H
  'C', // T4
  'C', // T4_H
  'C', // T1
  'C', // T1_H
  'C', // T6
  'C', // T6_H
  'C', // A7
  'C', // A7_H
  'C', // A6
  'C', // A6_H
  'C', // A5
  'C', // A5_H
  'C', // A4
  'C', // A4_H
  'C', // T5
  'C', // T5_H
  'C', // A3
  'C', // A3_H
  'C', // A2
  'C', // A2_H
  'C', // A1
  'C', // A1_H
  'C', // A0
  'C', // A0_H
  'C', // T0
  'C', // T0_H
  'E', // S8
  'E', // S8_H
  'N', // RA
  'N', // RA_H
  'N', // SP
  'N', // SP_H
  'N', // FP
  'N', // FP_H
  'C', // T7
  'C', // T7_H
  'N', // TP
  'N', // TP_H
  'N', // RX
  'N', // RX_H
  'N', // R0
  'N', // R0_H
  'C', // F0
  'C', // F0_H
  'C', // F0_J
  'C', // F0_K
  'C', // F0_L
  'C', // F0_M
  'C', // F0_N
  'C', // F0_O
  'C', // F1
  'C', // F1_H
  'C', // F1_J
  'C', // F1_K
  'C', // F1_L
  'C', // F1_M
  'C', // F1_N
  'C', // F1_O
  'C', // F2
  'C', // F2_H
  'C', // F2_J
  'C', // F2_K
  'C', // F2_L
  'C', // F2_M
  'C', // F2_N
  'C', // F2_O
  'C', // F3
  'C', // F3_H
  'C', // F3_J
  'C', // F3_K
  'C', // F3_L
  'C', // F3_M
  'C', // F3_N
  'C', // F3_O
  'C', // F4
  'C', // F4_H
  'C', // F4_J
  'C', // F4_K
  'C', // F4_L
  'C', // F4_M
  'C', // F4_N
  'C', // F4_O
  'C', // F5
  'C', // F5_H
  'C', // F5_J
  'C', // F5_K
  'C', // F5_L
  'C', // F5_M
  'C', // F5_N
  'C', // F5_O
  'C', // F6
  'C', // F6_H
  'C', // F6_J
  'C', // F6_K
  'C', // F6_L
  'C', // F6_M
  'C', // F6_N
  'C', // F6_O
  'C', // F7
  'C', // F7_H
  'C', // F7_J
  'C', // F7_K
  'C', // F7_L
  'C', // F7_M
  'C', // F7_N
  'C', // F7_O
  'C', // F8
  'C', // F8_H
  'C', // F8_J
  'C', // F8_K
  'C', // F8_L
  'C', // F8_M
  'C', // F8_N
  'C', // F8_O
  'C', // F9
  'C', // F9_H
  'C', // F9_J
  'C', // F9_K
  'C', // F9_L
  'C', // F9_M
  'C', // F9_N
  'C', // F9_O
  'C', // F10
  'C', // F10_H
  'C', // F10_J
  'C', // F10_K
  'C', // F10_L
  'C', // F10_M
  'C', // F10_N
  'C', // F10_O
  'C', // F11
  'C', // F11_H
  'C', // F11_J
  'C', // F11_K
  'C', // F11_L
  'C', // F11_M
  'C', // F11_N
  'C', // F11_O
  'C', // F12
  'C', // F12_H
  'C', // F12_J
  'C', // F12_K
  'C', // F12_L
  'C', // F12_M
  'C', // F12_N
  'C', // F12_O
  'C', // F13
  'C', // F13_H
  'C', // F13_J
  'C', // F13_K
  'C', // F13_L
  'C', // F13_M
  'C', // F13_N
  'C', // F13_O
  'C', // F14
  'C', // F14_H
  'C', // F14_J
  'C', // F14_K
  'C', // F14_L
  'C', // F14_M
  'C', // F14_N
  'C', // F14_O
  'C', // F15
  'C', // F15_H
  'C', // F15_J
  'C', // F15_K
  'C', // F15_L
  'C', // F15_M
  'C', // F15_N
  'C', // F15_O
  'C', // F16
  'C', // F16_H
  'C', // F16_J
  'C', // F16_K
  'C', // F16_L
  'C', // F16_M
  'C', // F16_N
  'C', // F16_O
  'C', // F17
  'C', // F17_H
  'C', // F17_J
  'C', // F17_K
  'C', // F17_L
  'C', // F17_M
  'C', // F17_N
  'C', // F17_O
  'C', // F18
  'C', // F18_H
  'C', // F18_J
  'C', // F18_K
  'C', // F18_L
  'C', // F18_M
  'C', // F18_N
  'C', // F18_O
  'C', // F19
  'C', // F19_H
  'C', // F19_J
  'C', // F19_K
  'C', // F19_L
  'C', // F19_M
  'C', // F19_N
  'C', // F19_O
  'C', // F20
  'C', // F20_H
  'C', // F20_J
  'C', // F20_K
  'C', // F20_L
  'C', // F20_M
  'C', // F20_N
  'C', // F20_O
  'C', // F21
  'C', // F21_H
  'C', // F21_J
  'C', // F21_K
  'C', // F21_L
  'C', // F21_M
  'C', // F21_N
  'C', // F21_O
  'C', // F22
  'C', // F22_H
  'C', // F22_J
  'C', // F22_K
  'C', // F22_L
  'C', // F22_M
  'C', // F22_N
  'C', // F22_O
  'E', // F24
  'E', // F24_H
  'C', // F24_J
  'C', // F24_K
  'C', // F24_L
  'C', // F24_M
  'C', // F24_N
  'C', // F24_O
  'E', // F25
  'E', // F25_H
  'C', // F25_J
  'C', // F25_K
  'C', // F25_L
  'C', // F25_M
  'C', // F25_N
  'C', // F25_O
  'E', // F26
  'E', // F26_H
  'C', // F26_J
  'C', // F26_K
  'C', // F26_L
  'C', // F26_M
  'C', // F26_N
  'C', // F26_O
  'E', // F27
  'E', // F27_H
  'C', // F27_J
  'C', // F27_K
  'C', // F27_L
  'C', // F27_M
  'C', // F27_N
  'C', // F27_O
  'E', // F28
  'E', // F28_H
  'C', // F28_J
  'C', // F28_K
  'C', // F28_L
  'C', // F28_M
  'C', // F28_N
  'C', // F28_O
  'E', // F29
  'E', // F29_H
  'C', // F29_J
  'C', // F29_K
  'C', // F29_L
  'C', // F29_M
  'C', // F29_N
  'C', // F29_O
  'E', // F30
  'E', // F30_H
  'C', // F30_J
  'C', // F30_K
  'C', // F30_L
  'C', // F30_M
  'C', // F30_N
  'C', // F30_O
  'E', // F31
  'E', // F31_H
  'C', // F31_J
  'C', // F31_K
  'C', // F31_L
  'C', // F31_M
  'C', // F31_N
  'C', // F31_O
  'C', // F23
  'C', // F23_H
  'C', // F23_J
  'C', // F23_K
  'C', // F23_L
  'C', // F23_M
  'C', // F23_N
  'C' // no trailing comma // F23_O
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  vecX_rule,
  /*    9 */  vecY_rule,
  /*   10 */  FlagsReg_rule,
  /*   11 */  immI_rule,
  /*   12 */  immIU1_rule,
  /*   13 */  immIU2_rule,
  /*   14 */  immIU3_rule,
  /*   15 */  immIU4_rule,
  /*   16 */  immIU5_rule,
  /*   17 */  immIU6_rule,
  /*   18 */  immIU8_rule,
  /*   19 */  immI10_rule,
  /*   20 */  immI12_rule,
  /*   21 */  immI_M65536_rule,
  /*   22 */  immI_M1_rule,
  /*   23 */  immI_0_rule,
  /*   24 */  immI_1_rule,
  /*   25 */  immI_2_rule,
  /*   26 */  immI_16_rule,
  /*   27 */  immI_24_rule,
  /*   28 */  immI_32_rule,
  /*   29 */  immI_255_rule,
  /*   30 */  immI_65535_rule,
  /*   31 */  immI_MaxI_rule,
  /*   32 */  immI_M2047_2048_rule,
  /*   33 */  immI_0_3_rule,
  /*   34 */  immI_0_31_rule,
  /*   35 */  immI_0_4095_rule,
  /*   36 */  immI_1_4_rule,
  /*   37 */  immI_32_63_rule,
  /*   38 */  immI_M128_255_rule,
  /*   39 */  immI_nonneg_mask_rule,
  /*   40 */  immL_rule,
  /*   41 */  immLU5_rule,
  /*   42 */  immL10_rule,
  /*   43 */  immL12_rule,
  /*   44 */  immL32_rule,
  /*   45 */  immL_M121_rule,
  /*   46 */  immL_M8_rule,
  /*   47 */  immL_M7_rule,
  /*   48 */  immL_M5_rule,
  /*   49 */  immL_M4_rule,
  /*   50 */  immL_0_rule,
  /*   51 */  immL_7_rule,
  /*   52 */  immL_MaxUI_rule,
  /*   53 */  immL_M2047_2048_rule,
  /*   54 */  immL_0_4095_rule,
  /*   55 */  immL_nonneg_mask_rule,
  /*   56 */  immP_rule,
  /*   57 */  immP_0_rule,
  /*   58 */  immP_no_oop_cheap_rule,
  /*   59 */  immN_rule,
  /*   60 */  immN_0_rule,
  /*   61 */  immNKlass_rule,
  /*   62 */  immF_rule,
  /*   63 */  immF_0_rule,
  /*   64 */  immD_rule,
  /*   65 */  immD_0_rule,
  /*   66 */  mRegI_rule,
  /*   67 */  no_Ax_mRegI_rule,
  /*   68 */  mS0RegI_rule,
  /*   69 */  mS1RegI_rule,
  /*   70 */  mS3RegI_rule,
  /*   71 */  mS4RegI_rule,
  /*   72 */  mS5RegI_rule,
  /*   73 */  mS6RegI_rule,
  /*   74 */  mS7RegI_rule,
  /*   75 */  mT0RegI_rule,
  /*   76 */  mT1RegI_rule,
  /*   77 */  mT2RegI_rule,
  /*   78 */  mT3RegI_rule,
  /*   79 */  mT8RegI_rule,
  /*   80 */  mT4RegI_rule,
  /*   81 */  mA0RegI_rule,
  /*   82 */  mA1RegI_rule,
  /*   83 */  mA2RegI_rule,
  /*   84 */  mA3RegI_rule,
  /*   85 */  mA4RegI_rule,
  /*   86 */  mA5RegI_rule,
  /*   87 */  mA6RegI_rule,
  /*   88 */  mA7RegI_rule,
  /*   89 */  mRegN_rule,
  /*   90 */  t0_RegN_rule,
  /*   91 */  t1_RegN_rule,
  /*   92 */  t3_RegN_rule,
  /*   93 */  t8_RegN_rule,
  /*   94 */  a0_RegN_rule,
  /*   95 */  a1_RegN_rule,
  /*   96 */  a2_RegN_rule,
  /*   97 */  a3_RegN_rule,
  /*   98 */  a4_RegN_rule,
  /*   99 */  a5_RegN_rule,
  /*  100 */  a6_RegN_rule,
  /*  101 */  a7_RegN_rule,
  /*  102 */  s0_RegN_rule,
  /*  103 */  s1_RegN_rule,
  /*  104 */  s2_RegN_rule,
  /*  105 */  s3_RegN_rule,
  /*  106 */  s4_RegN_rule,
  /*  107 */  s5_RegN_rule,
  /*  108 */  s6_RegN_rule,
  /*  109 */  s7_RegN_rule,
  /*  110 */  mRegP_rule,
  /*  111 */  no_T8_mRegP_rule,
  /*  112 */  no_Ax_mRegP_rule,
  /*  113 */  s1_RegP_rule,
  /*  114 */  s3_RegP_rule,
  /*  115 */  s4_RegP_rule,
  /*  116 */  s5_RegP_rule,
  /*  117 */  s6_RegP_rule,
  /*  118 */  s7_RegP_rule,
  /*  119 */  t0_RegP_rule,
  /*  120 */  t1_RegP_rule,
  /*  121 */  t2_RegP_rule,
  /*  122 */  t3_RegP_rule,
  /*  123 */  t8_RegP_rule,
  /*  124 */  a0_RegP_rule,
  /*  125 */  a1_RegP_rule,
  /*  126 */  a2_RegP_rule,
  /*  127 */  a3_RegP_rule,
  /*  128 */  a4_RegP_rule,
  /*  129 */  a5_RegP_rule,
  /*  130 */  a6_RegP_rule,
  /*  131 */  a7_RegP_rule,
  /*  132 */  v0_RegP_rule,
  /*  133 */  v1_RegP_rule,
  /*  134 */  mRegL_rule,
  /*  135 */  mRegI2L_rule,
  /*  136 */  mRegL2I_rule,
  /*  137 */  v0RegL_rule,
  /*  138 */  v1RegL_rule,
  /*  139 */  a0RegL_rule,
  /*  140 */  a1RegL_rule,
  /*  141 */  a2RegL_rule,
  /*  142 */  a3RegL_rule,
  /*  143 */  t0RegL_rule,
  /*  144 */  t1RegL_rule,
  /*  145 */  t3RegL_rule,
  /*  146 */  t8RegL_rule,
  /*  147 */  a4RegL_rule,
  /*  148 */  a5RegL_rule,
  /*  149 */  a6RegL_rule,
  /*  150 */  a7RegL_rule,
  /*  151 */  s0RegL_rule,
  /*  152 */  s1RegL_rule,
  /*  153 */  s3RegL_rule,
  /*  154 */  s4RegL_rule,
  /*  155 */  s7RegL_rule,
  /*  156 */  regF_rule,
  /*  157 */  regD_rule,
  /*  158 */  indirect_rule,
  /*  159 */  indOffset12_rule,
  /*  160 */  indOffset12I2L_rule,
  /*  161 */  indIndex_rule,
  /*  162 */  indIndexI2L_rule,
  /*  163 */  indirectNarrow_rule,
  /*  164 */  indOffset12Narrow_rule,
  /*  165 */  cmpOp_rule,
  /*  166 */  cmpOpEqNe_rule,
  /*  167 */  stackSlotP_rule,
  /*  168 */  stackSlotI_rule,
  /*  169 */  stackSlotF_rule,
  /*  170 */  stackSlotD_rule,
  /*  171 */  stackSlotL_rule,
  // last operand
  /*  172 */  memory_rule,
  /*  173 */  memory_loadRange_rule,
  /*  174 */  mRegLorI2L_rule,
  /*  175 */  mRegIorL2I_rule,
  // last operand class
  /*  176 */  _ConvI2L_immI12__rule,
  /*  177 */  _ConvI2L_mRegI__rule,
  /*  178 */  _DecodeN_mRegN__rule,
  /*  179 */  _LoadI_memory__rule,
  /*  180 */  _LShiftI__LoadI_memory__immI_24_rule,
  /*  181 */  _LShiftI__LoadI_memory__immI_16_rule,
  /*  182 */  _LoadN_memory__rule,
  /*  183 */  _LoadNKlass_memory__rule,
  /*  184 */  _EncodeP_mRegP__rule,
  /*  185 */  _EncodePKlass_mRegP__rule,
  /*  186 */  _LoadB_memory__rule,
  /*  187 */  _LoadUB_memory__rule,
  /*  188 */  _LoadS_memory__rule,
  /*  189 */  _LShiftI__LoadS_memory__immI_24_rule,
  /*  190 */  _CmpI_mRegI_mRegI_rule,
  /*  191 */  _CmpI_mRegI_immI_rule,
  /*  192 */  _CmpP_mRegP_immP_0_rule,
  /*  193 */  _CmpP__DecodeN_mRegN__immP_0_rule,
  /*  194 */  _CmpP_mRegP_mRegP_rule,
  /*  195 */  _CmpN_mRegN_immN_0_rule,
  /*  196 */  _CmpN_mRegN_mRegN_rule,
  /*  197 */  _CmpU_mRegI_mRegI_rule,
  /*  198 */  _CmpU_mRegI_immI_rule,
  /*  199 */  _CmpL_mRegLorI2L_mRegLorI2L_rule,
  /*  200 */  _CmpUL_mRegLorI2L_mRegLorI2L_rule,
  /*  201 */  _CmpL_mRegL_immL_rule,
  /*  202 */  _CmpUL_mRegL_immL_rule,
  /*  203 */  _CmpF_regF_regF_rule,
  /*  204 */  _CmpD_regD_regD_rule,
  /*  205 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  206 */  _Binary_mRegI_mRegI_rule,
  /*  207 */  _Binary_cmpOp__CmpP_mRegP_mRegP_rule,
  /*  208 */  _Binary_cmpOp__CmpN_mRegN_mRegN_rule,
  /*  209 */  _Binary_cmpOp__CmpU_mRegI_mRegI_rule,
  /*  210 */  _Binary_mRegP_mRegP_rule,
  /*  211 */  _Binary_cmpOp__CmpF_regF_regF_rule,
  /*  212 */  _Binary_mRegN_mRegN_rule,
  /*  213 */  _Binary_cmpOp__CmpD_regD_regD_rule,
  /*  214 */  _Binary_cmpOp__CmpL_mRegLorI2L_mRegLorI2L_rule,
  /*  215 */  _Binary_mRegI_mRegIorL2I_rule,
  /*  216 */  _Binary_cmpOp__CmpUL_mRegLorI2L_mRegLorI2L_rule,
  /*  217 */  _Binary_mRegL_mRegL_rule,
  /*  218 */  _CmpL_mRegL_mRegL_rule,
  /*  219 */  _Binary_cmpOp__CmpL_mRegL_mRegL_rule,
  /*  220 */  _CmpUL_mRegL_mRegL_rule,
  /*  221 */  _Binary_cmpOp__CmpUL_mRegL_mRegL_rule,
  /*  222 */  _Binary_regD_regD_rule,
  /*  223 */  _Binary_regF_regF_rule,
  /*  224 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  225 */  _Binary_a6_RegP_mA7RegI_rule,
  /*  226 */  _Binary_a6_RegP_immI_1_4_rule,
  /*  227 */  _Binary_a6_RegP_immI_1_rule,
  /*  228 */  _Binary_a5_RegP_mA6RegI_rule,
  /*  229 */  _Binary_a4_RegP_a5_RegP_rule,
  /*  230 */  _LShiftI_mRegI_immI_1_4_rule,
  /*  231 */  _AndL_mRegLorI2L_immL_M8_rule,
  /*  232 */  _LShiftL__ConvI2L_mRegI__immI_1_4_rule,
  /*  233 */  _ConvF2D_regF__rule,
  /*  234 */  _SqrtD__ConvF2D_regF___rule,
  /*  235 */  _NegF_regF__rule,
  /*  236 */  _NegD_regD__rule,
  /*  237 */  _Binary__NegF_regF__regF_rule,
  /*  238 */  _Binary_regF__NegF_regF__rule,
  /*  239 */  _Binary__NegD_regD__regD_rule,
  /*  240 */  _Binary_regD__NegD_regD__rule,
  /*  241 */  _Binary_regD_immD_0_rule,
  /*  242 */  _XorI_mRegI_immI_M1_rule,
  /*  243 */  _AndL_mRegL_immL_0_4095_rule,
  /*  244 */  _CastP2X_mRegP__rule,
  /*  245 */  _LShiftI_mRegI_immI_16_rule,
  /*  246 */  _AndL_mRegL_immL_7_rule,
  /*  247 */  _ConvL2I__AndL_mRegL_immL_7__rule,
  /*  248 */  _LShiftI__ConvL2I__AndL_mRegL_immL_7__immI_16_rule,
  /*  249 */  _LShiftI_mRegI_immI_24_rule,
  /*  250 */  _ConvL2I_mRegL__rule,
  /*  251 */  _RShiftL_mRegLorI2L_immI_32_63_rule,
  /*  252 */  _URShiftL_mRegLorI2L_immI_0_31_rule,
  /*  253 */  _ConvL2I__URShiftL_mRegLorI2L_immI_0_31__rule,
  /*  254 */  _URShiftL_mRegLorI2L_immI_32_63_rule,
  /*  255 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  256 */  _AndI_mRegI_immI_1_rule,
  /*  257 */  _LShiftI__AndI_mRegI_immI_1_immI_0_31_rule,
  /*  258 */  _LShiftI_mRegI_immI_0_31_rule,
  /*  259 */  _LShiftL_mRegLorI2L_immI_32_63_rule,
  /*  260 */  _LShiftL_mRegLorI2L_immI_0_31_rule,
  /*  261 */  _LoadUS_memory__rule,
  /*  262 */  _LShiftL_mRegLorI2L_immI_0_3_rule,
  /*  263 */  _AndL__ConvI2L_mRegI__immL_MaxUI_rule,
  /*  264 */  _LShiftL__ConvI2L_mRegI__immI_32_rule,
  /*  265 */  _ConvI2L__ConvL2I_mRegL___rule,
  /*  266 */  _ConvI2L__LoadI_memory___rule,
  /*  267 */  _LoadL_memory__rule,
  /*  268 */  _ReplicateB_immIU5__rule,
  /*  269 */  _ReplicateS_immIU5__rule,
  /*  270 */  _ReplicateI_immIU5__rule,
  /*  271 */  _ReplicateL_immLU5__rule,
  /*  272 */  _SubVI_vecX_vecX_rule,
  /*  273 */  _SubVL_vecX_vecX_rule,
  /*  274 */  _SubVI_vecY_vecY_rule,
  /*  275 */  _SubVL_vecY_vecY_rule,
  /*  276 */  _MulVB_vecX_vecX_rule,
  /*  277 */  _MulVS_vecX_vecX_rule,
  /*  278 */  _MulVI_vecX_vecX_rule,
  /*  279 */  _MulVL_vecX_vecX_rule,
  /*  280 */  _Binary_vecX_vecX_rule,
  /*  281 */  _MulVB_vecY_vecY_rule,
  /*  282 */  _MulVS_vecY_vecY_rule,
  /*  283 */  _MulVI_vecY_vecY_rule,
  /*  284 */  _MulVL_vecY_vecY_rule,
  /*  285 */  _Binary_vecY_vecY_rule,
  /*  286 */  _NegVF_vecX__rule,
  /*  287 */  _NegVD_vecX__rule,
  /*  288 */  _NegVF_vecY__rule,
  /*  289 */  _NegVD_vecY__rule,
  /*  290 */  _Binary__NegVF_vecX__vecX_rule,
  /*  291 */  _Binary_vecX__NegVF_vecX__rule,
  /*  292 */  _Binary__NegVD_vecX__vecX_rule,
  /*  293 */  _Binary_vecX__NegVD_vecX__rule,
  /*  294 */  _Binary__NegVF_vecY__vecY_rule,
  /*  295 */  _Binary_vecY__NegVF_vecY__rule,
  /*  296 */  _Binary__NegVD_vecY__vecY_rule,
  /*  297 */  _Binary_vecY__NegVD_vecY__rule,
  /*  298 */  _LShiftCntV_immI__rule,
  /*  299 */  _RShiftCntV_immI__rule,
  /*  300 */  _ReplicateB_immIU8__rule,
  /*  301 */  _OrV_vecX_vecX_rule,
  /*  302 */  _ReplicateB_immI_M1__rule,
  /*  303 */  _ReplicateS_immI_M1__rule,
  /*  304 */  _ReplicateI_immI_M1__rule,
  /*  305 */  _OrV_vecX__ReplicateB_immIU8__rule,
  /*  306 */  _OrV__ReplicateB_immIU8__vecX_rule,
  /*  307 */  _OrV_vecY_vecY_rule,
  /*  308 */  _OrV_vecY__ReplicateB_immIU8__rule,
  /*  309 */  _OrV__ReplicateB_immIU8__vecY_rule,
  /*  310 */  _XorV_vecX__ReplicateB_immI_M1__rule,
  /*  311 */  _XorV__ReplicateB_immI_M1__vecX_rule,
  /*  312 */  _XorV_vecX__ReplicateS_immI_M1__rule,
  /*  313 */  _XorV__ReplicateS_immI_M1__vecX_rule,
  /*  314 */  _XorV_vecX__ReplicateI_immI_M1__rule,
  /*  315 */  _XorV__ReplicateI_immI_M1__vecX_rule,
  /*  316 */  _XorV_vecY__ReplicateB_immI_M1__rule,
  /*  317 */  _XorV__ReplicateB_immI_M1__vecY_rule,
  /*  318 */  _XorV_vecY__ReplicateS_immI_M1__rule,
  /*  319 */  _XorV__ReplicateS_immI_M1__vecY_rule,
  /*  320 */  _XorV_vecY__ReplicateI_immI_M1__rule,
  /*  321 */  _XorV__ReplicateI_immI_M1__vecY_rule,
  /*  322 */  _Binary_vecX_mRegI_rule,
  /*  323 */  _Binary_vecX_mRegL_rule,
  /*  324 */  _Binary_vecX_regF_rule,
  /*  325 */  _Binary_vecX_regD_rule,
  /*  326 */  _Binary_vecY_mRegI_rule,
  /*  327 */  _Binary_vecY_mRegL_rule,
  /*  328 */  _Binary_vecY_regF_rule,
  /*  329 */  _Binary_vecY_regD_rule,
  // last internally defined operand
  /*  330 */  stackSlotI_rule,
  /*  331 */  stackSlotL_rule,
  /*  332 */  stackSlotP_rule,
  /*  333 */  stackSlotF_rule,
  /*  334 */  stackSlotD_rule,
  /*  335 */  mRegI_rule,
  /*  336 */  mRegL_rule,
  /*  337 */  mRegP_rule,
  /*  338 */  mRegP_rule,
  /*  339 */  mRegP_rule,
  /*  340 */  mRegN_rule,
  /*  341 */  mRegN_rule,
  /*  342 */  mRegN_rule,
  /*  343 */  regF_rule,
  /*  344 */  regF_rule,
  /*  345 */  regD_rule,
  /*  346 */  regD_rule,
  /*  347 */  mRegI_rule,
  /*  348 */  mRegL_rule,
  /*  349 */  mRegP_rule,
  /*  350 */  regF_rule,
  /*  351 */  regD_rule,
  /*  352 */  mRegP_rule,
  /*  353 */  mRegP_rule,
  /*  354 */  mRegL_rule,
  /*  355 */  mRegI_rule,
  /*  356 */  regF_rule,
  /*  357 */  mRegL_rule,
  /*  358 */  regD_rule,
  /*  359 */  regF_rule,
  /*  360 */  regD_rule,
  /*  361 */  regF_rule,
  /*  362 */  regD_rule,
  /*  363 */  mRegI_rule,
  /*  364 */  mRegI_rule,
  /*  365 */  mRegP_rule,
  /*  366 */  mRegP_rule,
  /*  367 */  mRegI_rule,
  /*  368 */  mRegL_rule,
  /*  369 */  regF_rule,
  /*  370 */  regD_rule,
  /*  371 */  vecX_rule,
  /*  372 */  vecY_rule,
  /*  373 */  FlagsReg_rule,
  /*  374 */  FlagsReg_rule,
  /*  375 */  FlagsReg_rule,
  /*  376 */  FlagsReg_rule,
  /*  377 */  FlagsReg_rule,
  /*  378 */  regF_rule,
  /*  379 */  regD_rule,
  /*  380 */  mRegI_rule,
  /*  381 */  mRegI_rule,
  /*  382 */  mRegI_rule,
  /*  383 */  mRegI_rule,
  /*  384 */  mRegI_rule,
  /*  385 */  mRegI_rule,
  /*  386 */  mRegI_rule,
  /*  387 */  mRegI_rule,
  /*  388 */  vecX_rule,
  /*  389 */  vecX_rule,
  /*  390 */  vecY_rule,
  /*  391 */  vecY_rule,
  /*  392 */  vecX_rule,
  /*  393 */  vecX_rule,
  /*  394 */  vecX_rule,
  /*  395 */  vecY_rule,
  /*  396 */  vecY_rule,
  /*  397 */  vecY_rule,
  /*  398 */  vecX_rule,
  /*  399 */  vecX_rule,
  /*  400 */  vecY_rule,
  /*  401 */  vecY_rule,
  /*  402 */  vecX_rule,
  /*  403 */  vecX_rule,
  /*  404 */  vecY_rule,
  /*  405 */  vecY_rule,
  /*  406 */  vecY_rule,
  /*  407 */  vecY_rule,
  /*  408 */  vecY_rule,
  /*  409 */  vecX_rule,
  /*  410 */  vecY_rule,
  /*  411 */  vecY_rule,
  /*  412 */  vecY_rule,
  /*  413 */  vecX_rule,
  /*  414 */  vecY_rule,
  /*  415 */  vecX_rule,
  /*  416 */  vecY_rule,
  /*  417 */  vecY_rule,
  /*  418 */  vecX_rule,
  /*  419 */  vecY_rule,
  /*  420 */  vecX_rule,
  /*  421 */  vecY_rule,
  /*  422 */  vecY_rule,
  /*  423 */  vecX_rule,
  /*  424 */  vecX_rule,
  /*  425 */  vecY_rule,
  /*  426 */  vecY_rule,
  /*  427 */  vecX_rule,
  /*  428 */  vecY_rule,
  /*  429 */  vecX_rule,
  /*  430 */  vecY_rule,
  /*  431 */  vecY_rule,
  /*  432 */  vecX_rule,
  /*  433 */  vecY_rule,
  /*  434 */  mRegI_rule,
  /*  435 */  mRegL_rule,
  /*  436 */  mRegI_rule,
  /*  437 */  mRegI_rule,
  /*  438 */  mRegI_rule,
  /*  439 */  mRegI_rule,
  /*  440 */  mRegL_rule,
  /*  441 */  mRegL_rule,
  /*  442 */  Universe_rule,
  /*  443 */  Universe_rule,
  /*  444 */  Universe_rule,
  /*  445 */  Universe_rule,
  /*  446 */  mRegN_rule,
  /*  447 */  mRegP_rule,
  /*  448 */  mRegP_rule,
  /*  449 */  mRegP_rule,
  /*  450 */  mRegN_rule,
  /*  451 */  mRegP_rule,
  /*  452 */  mRegI_rule,
  /*  453 */  Universe_rule,
  /*  454 */  Universe_rule,
  /*  455 */  Universe_rule,
  /*  456 */  Universe_rule,
  /*  457 */  Universe_rule,
  /*  458 */  Universe_rule,
  /*  459 */  Universe_rule,
  /*  460 */  Universe_rule,
  /*  461 */  Universe_rule,
  /*  462 */  Universe_rule,
  /*  463 */  Universe_rule,
  /*  464 */  Universe_rule,
  /*  465 */  Universe_rule,
  /*  466 */  Universe_rule,
  /*  467 */  Universe_rule,
  /*  468 */  Universe_rule,
  /*  469 */  mRegI_rule,
  /*  470 */  mRegL_rule,
  /*  471 */  mRegI_rule,
  /*  472 */  mRegL_rule,
  /*  473 */  mRegI_rule,
  /*  474 */  mRegI_rule,
  /*  475 */  mRegL_rule,
  /*  476 */  Universe_rule,
  /*  477 */  Universe_rule,
  /*  478 */  Universe_rule,
  /*  479 */  Universe_rule,
  /*  480 */  regF_rule,
  /*  481 */  Universe_rule,
  /*  482 */  a0_RegP_rule,
  /*  483 */  Universe_rule,
  /*  484 */  Universe_rule,
  /*  485 */  Universe_rule,
  /*  486 */  Universe_rule,
  /*  487 */  Universe_rule,
  /*  488 */  Universe_rule,
  /*  489 */  Universe_rule,
  /*  490 */  Universe_rule,
  /*  491 */  Universe_rule,
  /*  492 */  Universe_rule,
  /*  493 */  Universe_rule,
  /*  494 */  Universe_rule,
  /*  495 */  Universe_rule,
  /*  496 */  Universe_rule,
  /*  497 */  Universe_rule,
  /*  498 */  Universe_rule,
  /*  499 */  Universe_rule,
  /*  500 */  Universe_rule,
  /*  501 */  Universe_rule,
  /*  502 */  Universe_rule,
  /*  503 */  Universe_rule,
  /*  504 */  Universe_rule,
  /*  505 */  Universe_rule,
  /*  506 */  Universe_rule,
  /*  507 */  Universe_rule,
  /*  508 */  Universe_rule,
  /*  509 */  Universe_rule,
  /*  510 */  Universe_rule,
  /*  511 */  Universe_rule,
  /*  512 */  Universe_rule,
  /*  513 */  Universe_rule,
  /*  514 */  Universe_rule,
  /*  515 */  Universe_rule,
  /*  516 */  Universe_rule,
  /*  517 */  Universe_rule,
  /*  518 */  Universe_rule,
  /*  519 */  Universe_rule,
  /*  520 */  Universe_rule,
  /*  521 */  Universe_rule,
  /*  522 */  Universe_rule,
  /*  523 */  Universe_rule,
  /*  524 */  Universe_rule,
  /*  525 */  Universe_rule,
  /*  526 */  Universe_rule,
  /*  527 */  Universe_rule,
  /*  528 */  Universe_rule,
  /*  529 */  Universe_rule,
  /*  530 */  Universe_rule,
  /*  531 */  Universe_rule,
  /*  532 */  Universe_rule,
  /*  533 */  Universe_rule,
  /*  534 */  Universe_rule,
  /*  535 */  mRegI_rule,
  /*  536 */  mRegI_rule,
  /*  537 */  mRegI_rule,
  /*  538 */  mRegI_rule,
  /*  539 */  mRegI_rule,
  /*  540 */  mRegP_rule,
  /*  541 */  mRegP_rule,
  /*  542 */  mRegP_rule,
  /*  543 */  mRegN_rule,
  /*  544 */  mRegP_rule,
  /*  545 */  mRegN_rule,
  /*  546 */  mRegI_rule,
  /*  547 */  mRegI_rule,
  /*  548 */  mRegI_rule,
  /*  549 */  mRegP_rule,
  /*  550 */  mRegP_rule,
  /*  551 */  mRegI_rule,
  /*  552 */  mRegP_rule,
  /*  553 */  mRegP_rule,
  /*  554 */  mRegL_rule,
  /*  555 */  mRegN_rule,
  /*  556 */  mRegN_rule,
  /*  557 */  mRegN_rule,
  /*  558 */  mRegN_rule,
  /*  559 */  mRegL_rule,
  /*  560 */  mRegL_rule,
  /*  561 */  mRegL_rule,
  /*  562 */  mRegL_rule,
  /*  563 */  mRegL_rule,
  /*  564 */  mRegL_rule,
  /*  565 */  mRegL_rule,
  /*  566 */  mRegL_rule,
  /*  567 */  mRegL_rule,
  /*  568 */  mRegL_rule,
  /*  569 */  mRegL_rule,
  /*  570 */  regD_rule,
  /*  571 */  regF_rule,
  /*  572 */  regD_rule,
  /*  573 */  regD_rule,
  /*  574 */  mRegI_rule,
  /*  575 */  regF_rule,
  /*  576 */  mRegI_rule,
  /*  577 */  mRegI_rule,
  /*  578 */  mRegI_rule,
  /*  579 */  mRegI_rule,
  /*  580 */  Universe_rule,
  /*  581 */  Universe_rule,
  /*  582 */  no_Ax_mRegI_rule,
  /*  583 */  no_Ax_mRegI_rule,
  /*  584 */  no_Ax_mRegI_rule,
  /*  585 */  no_Ax_mRegI_rule,
  /*  586 */  mT8RegI_rule,
  /*  587 */  mT8RegI_rule,
  /*  588 */  mT8RegI_rule,
  /*  589 */  mT8RegI_rule,
  /*  590 */  mT8RegI_rule,
  /*  591 */  mT8RegI_rule,
  /*  592 */  no_Ax_mRegI_rule,
  /*  593 */  no_Ax_mRegI_rule,
  /*  594 */  no_Ax_mRegI_rule,
  /*  595 */  no_Ax_mRegI_rule,
  /*  596 */  Universe_rule,
  /*  597 */  no_Ax_mRegI_rule,
  /*  598 */  no_Ax_mRegI_rule,
  /*  599 */  no_Ax_mRegI_rule,
  /*  600 */  mRegI_rule,
  /*  601 */  mRegI_rule,
  /*  602 */  mRegI_rule,
  /*  603 */  mRegI_rule,
  /*  604 */  mRegP_rule,
  /*  605 */  mRegP_rule,
  /*  606 */  mRegP_rule,
  /*  607 */  mRegP_rule,
  /*  608 */  mRegL_rule,
  /*  609 */  mRegL_rule,
  /*  610 */  mRegI_rule,
  /*  611 */  mRegL_rule,
  /*  612 */  mRegI_rule,
  /*  613 */  mRegI_rule,
  /*  614 */  mRegI_rule,
  /*  615 */  mRegL_rule,
  /*  616 */  mRegL_rule,
  /*  617 */  mRegL_rule,
  /*  618 */  mRegI_rule,
  /*  619 */  mRegL_rule,
  /*  620 */  mRegI_rule,
  /*  621 */  mRegI_rule,
  /*  622 */  regF_rule,
  /*  623 */  regD_rule,
  /*  624 */  mRegL_rule,
  /*  625 */  mRegL_rule,
  /*  626 */  mRegL_rule,
  /*  627 */  regF_rule,
  /*  628 */  regF_rule,
  /*  629 */  regD_rule,
  /*  630 */  regD_rule,
  /*  631 */  regF_rule,
  /*  632 */  regD_rule,
  /*  633 */  regD_rule,
  /*  634 */  regF_rule,
  /*  635 */  regF_rule,
  /*  636 */  regD_rule,
  /*  637 */  regF_rule,
  /*  638 */  regD_rule,
  /*  639 */  regF_rule,
  /*  640 */  regF_rule,
  /*  641 */  regD_rule,
  /*  642 */  regD_rule,
  /*  643 */  regF_rule,
  /*  644 */  regF_rule,
  /*  645 */  regD_rule,
  /*  646 */  regD_rule,
  /*  647 */  regF_rule,
  /*  648 */  regD_rule,
  /*  649 */  mRegI_rule,
  /*  650 */  mRegI_rule,
  /*  651 */  mRegL_rule,
  /*  652 */  mRegI_rule,
  /*  653 */  mRegI_rule,
  /*  654 */  mRegL_rule,
  /*  655 */  mRegI_rule,
  /*  656 */  mRegI_rule,
  /*  657 */  mRegI_rule,
  /*  658 */  mRegI_rule,
  /*  659 */  mRegI_rule,
  /*  660 */  mRegI_rule,
  /*  661 */  mRegI_rule,
  /*  662 */  mRegI_rule,
  /*  663 */  mRegI_rule,
  /*  664 */  mRegI_rule,
  /*  665 */  mRegI_rule,
  /*  666 */  mRegI_rule,
  /*  667 */  mRegL_rule,
  /*  668 */  mRegL_rule,
  /*  669 */  mRegI_rule,
  /*  670 */  mRegL_rule,
  /*  671 */  mRegL_rule,
  /*  672 */  mRegL_rule,
  /*  673 */  mRegL_rule,
  /*  674 */  mRegL_rule,
  /*  675 */  mRegL_rule,
  /*  676 */  mRegL_rule,
  /*  677 */  mRegL_rule,
  /*  678 */  mRegL_rule,
  /*  679 */  mRegI_rule,
  /*  680 */  mRegI_rule,
  /*  681 */  mRegI_rule,
  /*  682 */  mRegI_rule,
  /*  683 */  mRegI_rule,
  /*  684 */  mRegI_rule,
  /*  685 */  mRegI_rule,
  /*  686 */  mRegL_rule,
  /*  687 */  mRegL_rule,
  /*  688 */  mRegL_rule,
  /*  689 */  mRegI_rule,
  /*  690 */  mRegL_rule,
  /*  691 */  mRegL_rule,
  /*  692 */  mRegL_rule,
  /*  693 */  mRegI_rule,
  /*  694 */  mRegL_rule,
  /*  695 */  mRegL_rule,
  /*  696 */  mRegI_rule,
  /*  697 */  mRegL_rule,
  /*  698 */  mRegI_rule,
  /*  699 */  mRegI_rule,
  /*  700 */  mRegI_rule,
  /*  701 */  mRegI_rule,
  /*  702 */  mRegI_rule,
  /*  703 */  mRegL_rule,
  /*  704 */  mRegL_rule,
  /*  705 */  mRegI_rule,
  /*  706 */  mRegI_rule,
  /*  707 */  mRegI_rule,
  /*  708 */  mRegI_rule,
  /*  709 */  mRegL_rule,
  /*  710 */  mRegL_rule,
  /*  711 */  mRegL_rule,
  /*  712 */  mRegL_rule,
  /*  713 */  mRegI_rule,
  /*  714 */  mRegI_rule,
  /*  715 */  mRegL_rule,
  /*  716 */  mRegL_rule,
  /*  717 */  mRegL_rule,
  /*  718 */  mRegL_rule,
  /*  719 */  mRegI_rule,
  /*  720 */  mRegL_rule,
  /*  721 */  mRegI_rule,
  /*  722 */  mRegI_rule,
  /*  723 */  mRegL_rule,
  /*  724 */  mRegL_rule,
  /*  725 */  mRegI_rule,
  /*  726 */  mRegI_rule,
  /*  727 */  mRegI_rule,
  /*  728 */  mRegL_rule,
  /*  729 */  mRegI_rule,
  /*  730 */  regD_rule,
  /*  731 */  mRegI_rule,
  /*  732 */  mRegL_rule,
  /*  733 */  mRegI_rule,
  /*  734 */  mRegL_rule,
  /*  735 */  regF_rule,
  /*  736 */  regF_rule,
  /*  737 */  regD_rule,
  /*  738 */  mRegI_rule,
  /*  739 */  mRegI_rule,
  /*  740 */  regD_rule,
  /*  741 */  regD_rule,
  /*  742 */  regF_rule,
  /*  743 */  mRegN_rule,
  /*  744 */  mRegN_rule,
  /*  745 */  mRegP_rule,
  /*  746 */  mRegP_rule,
  /*  747 */  mRegN_rule,
  /*  748 */  mRegP_rule,
  /*  749 */  mRegP_rule,
  /*  750 */  Universe_rule,
  /*  751 */  Universe_rule,
  /*  752 */  Universe_rule,
  /*  753 */  Universe_rule,
  /*  754 */  Universe_rule,
  /*  755 */  Universe_rule,
  /*  756 */  Universe_rule,
  /*  757 */  mRegI_rule,
  /*  758 */  mRegL_rule,
  /*  759 */  Universe_rule,
  /*  760 */  Universe_rule,
  /*  761 */  Universe_rule,
  /*  762 */  Universe_rule,
  /*  763 */  regD_rule,
  /*  764 */  regD_rule,
  /*  765 */  Universe_rule,
  /*  766 */  Universe_rule,
  /*  767 */  Universe_rule,
  /*  768 */  Universe_rule,
  /*  769 */  mRegP_rule,
  /*  770 */  mRegP_rule,
  /*  771 */  mRegP_rule,
  /*  772 */  mRegI_rule,
  /*  773 */  mRegI_rule,
  /*  774 */  mRegI_rule,
  /*  775 */  mRegI_rule,
  /*  776 */  mRegI_rule,
  /*  777 */  mRegL_rule,
  /*  778 */  mRegN_rule,
  /*  779 */  mRegP_rule,
  /*  780 */  mRegL_rule,
  /*  781 */  Universe_rule,
  /*  782 */  mRegI_rule,
  /*  783 */  Universe_rule,
  /*  784 */  mRegI_rule,
  /*  785 */  mRegL_rule,
  /*  786 */  mRegP_rule,
  /*  787 */  mRegN_rule,
  /*  788 */  mRegI_rule,
  /*  789 */  mRegI_rule,
  /*  790 */  mRegI_rule,
  /*  791 */  mRegI_rule,
  /*  792 */  mRegI_rule,
  /*  793 */  mRegI_rule,
  /*  794 */  mRegI_rule,
  /*  795 */  mRegI_rule,
  /*  796 */  mRegL_rule,
  /*  797 */  mRegL_rule,
  /*  798 */  mRegL_rule,
  /*  799 */  mRegL_rule,
  /*  800 */  mRegL_rule,
  /*  801 */  mRegL_rule,
  /*  802 */  mRegL_rule,
  /*  803 */  mRegL_rule,
  /*  804 */  Universe_rule,
  /*  805 */  mRegI_rule,
  /*  806 */  mRegL_rule,
  /*  807 */  mRegI_rule,
  /*  808 */  mRegI_rule,
  /*  809 */  vecX_rule,
  /*  810 */  vecY_rule,
  /*  811 */  Universe_rule,
  /*  812 */  Universe_rule,
  /*  813 */  vecX_rule,
  /*  814 */  vecX_rule,
  /*  815 */  vecX_rule,
  /*  816 */  vecX_rule,
  /*  817 */  vecX_rule,
  /*  818 */  vecX_rule,
  /*  819 */  vecX_rule,
  /*  820 */  vecX_rule,
  /*  821 */  vecX_rule,
  /*  822 */  vecX_rule,
  /*  823 */  vecY_rule,
  /*  824 */  vecY_rule,
  /*  825 */  vecY_rule,
  /*  826 */  vecY_rule,
  /*  827 */  vecY_rule,
  /*  828 */  vecY_rule,
  /*  829 */  vecY_rule,
  /*  830 */  vecY_rule,
  /*  831 */  vecY_rule,
  /*  832 */  vecY_rule,
  /*  833 */  vecX_rule,
  /*  834 */  vecX_rule,
  /*  835 */  vecX_rule,
  /*  836 */  vecX_rule,
  /*  837 */  vecX_rule,
  /*  838 */  vecX_rule,
  /*  839 */  vecX_rule,
  /*  840 */  vecX_rule,
  /*  841 */  vecX_rule,
  /*  842 */  vecX_rule,
  /*  843 */  vecX_rule,
  /*  844 */  vecX_rule,
  /*  845 */  vecX_rule,
  /*  846 */  vecX_rule,
  /*  847 */  vecY_rule,
  /*  848 */  vecY_rule,
  /*  849 */  vecY_rule,
  /*  850 */  vecY_rule,
  /*  851 */  vecY_rule,
  /*  852 */  vecY_rule,
  /*  853 */  vecY_rule,
  /*  854 */  vecY_rule,
  /*  855 */  vecY_rule,
  /*  856 */  vecY_rule,
  /*  857 */  vecY_rule,
  /*  858 */  vecY_rule,
  /*  859 */  vecY_rule,
  /*  860 */  vecY_rule,
  /*  861 */  vecX_rule,
  /*  862 */  vecX_rule,
  /*  863 */  vecX_rule,
  /*  864 */  vecX_rule,
  /*  865 */  vecX_rule,
  /*  866 */  vecX_rule,
  /*  867 */  vecX_rule,
  /*  868 */  vecX_rule,
  /*  869 */  vecX_rule,
  /*  870 */  vecX_rule,
  /*  871 */  vecY_rule,
  /*  872 */  vecY_rule,
  /*  873 */  vecY_rule,
  /*  874 */  vecY_rule,
  /*  875 */  vecY_rule,
  /*  876 */  vecY_rule,
  /*  877 */  vecY_rule,
  /*  878 */  vecY_rule,
  /*  879 */  vecY_rule,
  /*  880 */  vecY_rule,
  /*  881 */  vecX_rule,
  /*  882 */  vecX_rule,
  /*  883 */  vecX_rule,
  /*  884 */  vecX_rule,
  /*  885 */  vecX_rule,
  /*  886 */  vecX_rule,
  /*  887 */  vecY_rule,
  /*  888 */  vecY_rule,
  /*  889 */  vecY_rule,
  /*  890 */  vecY_rule,
  /*  891 */  vecY_rule,
  /*  892 */  vecY_rule,
  /*  893 */  vecX_rule,
  /*  894 */  vecX_rule,
  /*  895 */  vecY_rule,
  /*  896 */  vecY_rule,
  /*  897 */  vecX_rule,
  /*  898 */  vecX_rule,
  /*  899 */  vecX_rule,
  /*  900 */  vecX_rule,
  /*  901 */  vecY_rule,
  /*  902 */  vecY_rule,
  /*  903 */  vecY_rule,
  /*  904 */  vecY_rule,
  /*  905 */  vecX_rule,
  /*  906 */  vecX_rule,
  /*  907 */  vecY_rule,
  /*  908 */  vecY_rule,
  /*  909 */  vecX_rule,
  /*  910 */  vecX_rule,
  /*  911 */  vecX_rule,
  /*  912 */  vecX_rule,
  /*  913 */  vecX_rule,
  /*  914 */  vecX_rule,
  /*  915 */  vecY_rule,
  /*  916 */  vecY_rule,
  /*  917 */  vecY_rule,
  /*  918 */  vecY_rule,
  /*  919 */  vecY_rule,
  /*  920 */  vecY_rule,
  /*  921 */  vecX_rule,
  /*  922 */  vecX_rule,
  /*  923 */  vecX_rule,
  /*  924 */  vecX_rule,
  /*  925 */  vecX_rule,
  /*  926 */  vecX_rule,
  /*  927 */  vecY_rule,
  /*  928 */  vecY_rule,
  /*  929 */  vecY_rule,
  /*  930 */  vecY_rule,
  /*  931 */  vecY_rule,
  /*  932 */  vecY_rule,
  /*  933 */  vecX_rule,
  /*  934 */  vecX_rule,
  /*  935 */  vecX_rule,
  /*  936 */  vecX_rule,
  /*  937 */  vecX_rule,
  /*  938 */  vecX_rule,
  /*  939 */  vecX_rule,
  /*  940 */  vecX_rule,
  /*  941 */  vecX_rule,
  /*  942 */  vecX_rule,
  /*  943 */  vecY_rule,
  /*  944 */  vecY_rule,
  /*  945 */  vecY_rule,
  /*  946 */  vecY_rule,
  /*  947 */  vecY_rule,
  /*  948 */  vecY_rule,
  /*  949 */  vecY_rule,
  /*  950 */  vecY_rule,
  /*  951 */  vecY_rule,
  /*  952 */  vecY_rule,
  /*  953 */  vecX_rule,
  /*  954 */  vecX_rule,
  /*  955 */  vecX_rule,
  /*  956 */  vecX_rule,
  /*  957 */  vecX_rule,
  /*  958 */  vecX_rule,
  /*  959 */  vecY_rule,
  /*  960 */  vecY_rule,
  /*  961 */  vecY_rule,
  /*  962 */  vecY_rule,
  /*  963 */  vecY_rule,
  /*  964 */  vecY_rule,
  /*  965 */  vecX_rule,
  /*  966 */  vecX_rule,
  /*  967 */  vecX_rule,
  /*  968 */  vecX_rule,
  /*  969 */  vecY_rule,
  /*  970 */  vecY_rule,
  /*  971 */  vecY_rule,
  /*  972 */  vecY_rule,
  /*  973 */  vecX_rule,
  /*  974 */  vecX_rule,
  /*  975 */  vecX_rule,
  /*  976 */  vecX_rule,
  /*  977 */  vecY_rule,
  /*  978 */  vecY_rule,
  /*  979 */  vecY_rule,
  /*  980 */  vecY_rule,
  /*  981 */  vecX_rule,
  /*  982 */  vecY_rule,
  /*  983 */  vecX_rule,
  /*  984 */  vecX_rule,
  /*  985 */  vecX_rule,
  /*  986 */  vecX_rule,
  /*  987 */  vecX_rule,
  /*  988 */  vecX_rule,
  /*  989 */  vecX_rule,
  /*  990 */  vecX_rule,
  /*  991 */  vecY_rule,
  /*  992 */  vecY_rule,
  /*  993 */  vecY_rule,
  /*  994 */  vecY_rule,
  /*  995 */  vecY_rule,
  /*  996 */  vecY_rule,
  /*  997 */  vecY_rule,
  /*  998 */  vecY_rule,
  /*  999 */  vecX_rule,
  /* 1000 */  vecX_rule,
  /* 1001 */  vecX_rule,
  /* 1002 */  vecX_rule,
  /* 1003 */  vecX_rule,
  /* 1004 */  vecX_rule,
  /* 1005 */  vecX_rule,
  /* 1006 */  vecX_rule,
  /* 1007 */  vecY_rule,
  /* 1008 */  vecY_rule,
  /* 1009 */  vecY_rule,
  /* 1010 */  vecY_rule,
  /* 1011 */  vecY_rule,
  /* 1012 */  vecY_rule,
  /* 1013 */  vecY_rule,
  /* 1014 */  vecY_rule,
  /* 1015 */  vecX_rule,
  /* 1016 */  vecX_rule,
  /* 1017 */  vecX_rule,
  /* 1018 */  vecX_rule,
  /* 1019 */  vecX_rule,
  /* 1020 */  vecX_rule,
  /* 1021 */  vecX_rule,
  /* 1022 */  vecX_rule,
  /* 1023 */  vecY_rule,
  /* 1024 */  vecY_rule,
  /* 1025 */  vecY_rule,
  /* 1026 */  vecY_rule,
  /* 1027 */  vecY_rule,
  /* 1028 */  vecY_rule,
  /* 1029 */  vecY_rule,
  /* 1030 */  vecY_rule,
  /* 1031 */  vecX_rule,
  /* 1032 */  vecX_rule,
  /* 1033 */  vecX_rule,
  /* 1034 */  vecX_rule,
  /* 1035 */  vecY_rule,
  /* 1036 */  vecY_rule,
  /* 1037 */  vecY_rule,
  /* 1038 */  vecY_rule,
  /* 1039 */  vecX_rule,
  /* 1040 */  vecX_rule,
  /* 1041 */  vecX_rule,
  /* 1042 */  vecX_rule,
  /* 1043 */  vecY_rule,
  /* 1044 */  vecY_rule,
  /* 1045 */  vecY_rule,
  /* 1046 */  vecY_rule,
  /* 1047 */  vecX_rule,
  /* 1048 */  vecX_rule,
  /* 1049 */  vecX_rule,
  /* 1050 */  vecY_rule,
  /* 1051 */  vecY_rule,
  /* 1052 */  vecY_rule,
  /* 1053 */  vecX_rule,
  /* 1054 */  vecX_rule,
  /* 1055 */  vecX_rule,
  /* 1056 */  vecY_rule,
  /* 1057 */  vecY_rule,
  /* 1058 */  vecY_rule,
  /* 1059 */  vecX_rule,
  /* 1060 */  vecX_rule,
  /* 1061 */  vecX_rule,
  /* 1062 */  vecY_rule,
  /* 1063 */  vecX_rule,
  /* 1064 */  vecX_rule,
  /* 1065 */  vecX_rule,
  /* 1066 */  vecX_rule,
  /* 1067 */  vecX_rule,
  /* 1068 */  vecX_rule,
  /* 1069 */  vecX_rule,
  /* 1070 */  vecX_rule,
  /* 1071 */  vecX_rule,
  /* 1072 */  vecX_rule,
  /* 1073 */  vecX_rule,
  /* 1074 */  vecX_rule,
  /* 1075 */  vecY_rule,
  /* 1076 */  vecY_rule,
  /* 1077 */  vecY_rule,
  /* 1078 */  vecY_rule,
  /* 1079 */  vecY_rule,
  /* 1080 */  vecY_rule,
  /* 1081 */  vecY_rule,
  /* 1082 */  vecY_rule,
  /* 1083 */  vecY_rule,
  /* 1084 */  vecY_rule,
  /* 1085 */  vecX_rule,
  /* 1086 */  vecX_rule,
  /* 1087 */  vecX_rule,
  /* 1088 */  vecX_rule,
  /* 1089 */  vecX_rule,
  /* 1090 */  vecX_rule,
  /* 1091 */  vecX_rule,
  /* 1092 */  vecX_rule,
  /* 1093 */  vecX_rule,
  /* 1094 */  vecX_rule,
  /* 1095 */  vecX_rule,
  /* 1096 */  vecX_rule,
  /* 1097 */  vecY_rule,
  /* 1098 */  vecY_rule,
  /* 1099 */  vecY_rule,
  /* 1100 */  vecY_rule,
  /* 1101 */  vecY_rule,
  /* 1102 */  vecY_rule,
  /* 1103 */  vecY_rule,
  /* 1104 */  vecY_rule,
  /* 1105 */  vecY_rule,
  /* 1106 */  vecY_rule,
  /* 1107 */  vecY_rule,
  /* 1108 */  vecY_rule,
  /* 1109 */  vecX_rule,
  /* 1110 */  vecX_rule,
  /* 1111 */  vecX_rule,
  /* 1112 */  vecX_rule,
  /* 1113 */  vecX_rule,
  /* 1114 */  vecX_rule,
  /* 1115 */  vecX_rule,
  /* 1116 */  vecX_rule,
  /* 1117 */  vecX_rule,
  /* 1118 */  vecX_rule,
  /* 1119 */  vecX_rule,
  /* 1120 */  vecX_rule,
  /* 1121 */  vecY_rule,
  /* 1122 */  vecY_rule,
  /* 1123 */  vecY_rule,
  /* 1124 */  vecY_rule,
  /* 1125 */  vecY_rule,
  /* 1126 */  vecY_rule,
  /* 1127 */  vecY_rule,
  /* 1128 */  vecY_rule,
  /* 1129 */  vecY_rule,
  /* 1130 */  vecY_rule,
  /* 1131 */  vecY_rule,
  /* 1132 */  vecY_rule,
  /* 1133 */  mRegI_rule,
  /* 1134 */  mRegI_rule,
  /* 1135 */  mRegI_rule,
  /* 1136 */  mRegL_rule,
  /* 1137 */  regF_rule,
  /* 1138 */  regD_rule,
  /* 1139 */  mRegI_rule,
  /* 1140 */  mRegI_rule,
  /* 1141 */  mRegI_rule,
  /* 1142 */  mRegL_rule,
  /* 1143 */  regF_rule,
  /* 1144 */  regD_rule,
  /* 1145 */  mRegI_rule,
  /* 1146 */  mRegI_rule,
  /* 1147 */  mRegI_rule,
  /* 1148 */  mRegL_rule,
  /* 1149 */  regF_rule,
  /* 1150 */  regD_rule,
  /* 1151 */  mRegI_rule,
  /* 1152 */  mRegI_rule,
  /* 1153 */  mRegI_rule,
  /* 1154 */  mRegL_rule,
  /* 1155 */  regF_rule,
  /* 1156 */  regD_rule,
  /* 1157 */  mRegI_rule,
  /* 1158 */  mRegI_rule,
  /* 1159 */  mRegI_rule,
  /* 1160 */  mRegL_rule,
  /* 1161 */  mRegI_rule,
  /* 1162 */  mRegI_rule,
  /* 1163 */  mRegI_rule,
  /* 1164 */  mRegL_rule,
  /* 1165 */  mRegI_rule,
  /* 1166 */  mRegI_rule,
  /* 1167 */  mRegI_rule,
  /* 1168 */  mRegL_rule,
  /* 1169 */  mRegI_rule,
  /* 1170 */  mRegI_rule,
  /* 1171 */  mRegI_rule,
  /* 1172 */  mRegL_rule,
  /* 1173 */  mRegI_rule,
  /* 1174 */  mRegI_rule,
  /* 1175 */  mRegI_rule,
  /* 1176 */  mRegL_rule,
  /* 1177 */  mRegI_rule,
  /* 1178 */  mRegI_rule,
  /* 1179 */  mRegI_rule,
  /* 1180 */  mRegL_rule,
  /* 1181 */  mRegI_rule,
  /* 1182 */  mRegI_rule,
  /* 1183 */  mRegI_rule,
  /* 1184 */  mRegL_rule,
  /* 1185 */  mRegI_rule,
  /* 1186 */  mRegI_rule,
  /* 1187 */  mRegI_rule,
  /* 1188 */  mRegL_rule,
  /* 1189 */  mRegI_rule,
  /* 1190 */  mRegI_rule,
  /* 1191 */  mRegI_rule,
  /* 1192 */  mRegL_rule,
  /* 1193 */  mRegI_rule,
  /* 1194 */  mRegI_rule,
  /* 1195 */  mRegI_rule,
  /* 1196 */  mRegL_rule,
  /* 1197 */  vecX_rule,
  /* 1198 */  vecY_rule,
  /* 1199 */  vecX_rule,
  /* 1200 */  vecX_rule,
  /* 1201 */  vecX_rule,
  /* 1202 */  vecX_rule,
  /* 1203 */  vecX_rule,
  /* 1204 */  vecY_rule,
  /* 1205 */  vecX_rule,
  /* 1206 */  vecX_rule,
  /* 1207 */  vecX_rule,
  /* 1208 */  vecX_rule,
  /* 1209 */  vecX_rule,
  /* 1210 */  vecX_rule,
  /* 1211 */  vecX_rule,
  /* 1212 */  vecX_rule,
  /* 1213 */  vecY_rule,
  /* 1214 */  vecY_rule,
  /* 1215 */  vecY_rule,
  /* 1216 */  vecY_rule,
  /* 1217 */  vecY_rule,
  /* 1218 */  vecY_rule,
  /* 1219 */  vecX_rule,
  /* 1220 */  vecY_rule,
  /* 1221 */  vecX_rule,
  /* 1222 */  vecY_rule,
  /* 1223 */  vecX_rule,
  /* 1224 */  mRegI_rule,
  /* 1225 */  mRegI_rule,
  /* 1226 */  mRegI_rule,
  /* 1227 */  mRegI_rule,
  /* 1228 */  vecX_rule,
  /* 1229 */  vecY_rule,
  /* 1230 */  vecX_rule,
  /* 1231 */  vecY_rule,
  /* 1232 */  vecY_rule,
  /* 1233 */  mRegI_rule,
  /* 1234 */  mRegI_rule,
  /* 1235 */  mRegI_rule,
  /* 1236 */  mRegI_rule,
  /* 1237 */  mRegN_rule,
  /* 1238 */  mRegP_rule,
  /* 1239 */  mRegN_rule,
  /* 1240 */  mRegP_rule,
  /* 1241 */  mRegI_rule,
  /* 1242 */  mRegI_rule,
  /* 1243 */  mRegI_rule,
  /* 1244 */  mRegI_rule,
  /* 1245 */  mRegP_rule,
  /* 1246 */  mRegI_rule,
  /* 1247 */  mRegI_rule,
  /* 1248 */  mRegI_rule,
  /* 1249 */  mRegI_rule,
  /* 1250 */  mRegP_rule,
  /* 1251 */  mRegP_rule,
  /* 1252 */  mRegP_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  0,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  /*  130 */  0,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  0,
  /*  134 */  0,
  /*  135 */  mRegI_rule,
  /*  136 */  mRegL_rule,
  /*  137 */  0,
  /*  138 */  0,
  /*  139 */  0,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  0,
  /*  148 */  0,
  /*  149 */  0,
  /*  150 */  0,
  /*  151 */  0,
  /*  152 */  0,
  /*  153 */  0,
  /*  154 */  0,
  /*  155 */  0,
  /*  156 */  0,
  /*  157 */  0,
  /*  158 */  0,
  /*  159 */  mRegP_rule,
  /*  160 */  mRegP_rule,
  /*  161 */  mRegP_rule,
  /*  162 */  mRegP_rule,
  /*  163 */  mRegN_rule,
  /*  164 */  _DecodeN_mRegN__rule,
  /*  165 */  0,
  /*  166 */  0,
  /*  167 */  0,
  /*  168 */  0,
  /*  169 */  0,
  /*  170 */  0,
  /*  171 */  0,
  // last operand
  /*  172 */  0,
  /*  173 */  0,
  /*  174 */  0,
  /*  175 */  0,
  // last operand class
  /*  176 */  immI12_rule,
  /*  177 */  mRegI_rule,
  /*  178 */  mRegN_rule,
  /*  179 */  memory_rule,
  /*  180 */  _LoadI_memory__rule,
  /*  181 */  _LoadI_memory__rule,
  /*  182 */  memory_rule,
  /*  183 */  memory_rule,
  /*  184 */  mRegP_rule,
  /*  185 */  mRegP_rule,
  /*  186 */  memory_rule,
  /*  187 */  memory_rule,
  /*  188 */  memory_rule,
  /*  189 */  _LoadS_memory__rule,
  /*  190 */  mRegI_rule,
  /*  191 */  mRegI_rule,
  /*  192 */  mRegP_rule,
  /*  193 */  _DecodeN_mRegN__rule,
  /*  194 */  mRegP_rule,
  /*  195 */  mRegN_rule,
  /*  196 */  mRegN_rule,
  /*  197 */  mRegI_rule,
  /*  198 */  mRegI_rule,
  /*  199 */  mRegLorI2L_rule,
  /*  200 */  mRegLorI2L_rule,
  /*  201 */  mRegL_rule,
  /*  202 */  mRegL_rule,
  /*  203 */  regF_rule,
  /*  204 */  regD_rule,
  /*  205 */  cmpOp_rule,
  /*  206 */  mRegI_rule,
  /*  207 */  cmpOp_rule,
  /*  208 */  cmpOp_rule,
  /*  209 */  cmpOp_rule,
  /*  210 */  mRegP_rule,
  /*  211 */  cmpOp_rule,
  /*  212 */  mRegN_rule,
  /*  213 */  cmpOp_rule,
  /*  214 */  cmpOp_rule,
  /*  215 */  mRegI_rule,
  /*  216 */  cmpOp_rule,
  /*  217 */  mRegL_rule,
  /*  218 */  mRegL_rule,
  /*  219 */  cmpOp_rule,
  /*  220 */  mRegL_rule,
  /*  221 */  cmpOp_rule,
  /*  222 */  regD_rule,
  /*  223 */  regF_rule,
  /*  224 */  a4_RegP_rule,
  /*  225 */  a6_RegP_rule,
  /*  226 */  a6_RegP_rule,
  /*  227 */  a6_RegP_rule,
  /*  228 */  a5_RegP_rule,
  /*  229 */  a4_RegP_rule,
  /*  230 */  mRegI_rule,
  /*  231 */  mRegLorI2L_rule,
  /*  232 */  _ConvI2L_mRegI__rule,
  /*  233 */  regF_rule,
  /*  234 */  _ConvF2D_regF__rule,
  /*  235 */  regF_rule,
  /*  236 */  regD_rule,
  /*  237 */  _NegF_regF__rule,
  /*  238 */  regF_rule,
  /*  239 */  _NegD_regD__rule,
  /*  240 */  regD_rule,
  /*  241 */  regD_rule,
  /*  242 */  mRegI_rule,
  /*  243 */  mRegL_rule,
  /*  244 */  mRegP_rule,
  /*  245 */  mRegI_rule,
  /*  246 */  mRegL_rule,
  /*  247 */  _AndL_mRegL_immL_7_rule,
  /*  248 */  _ConvL2I__AndL_mRegL_immL_7__rule,
  /*  249 */  mRegI_rule,
  /*  250 */  mRegL_rule,
  /*  251 */  mRegLorI2L_rule,
  /*  252 */  mRegLorI2L_rule,
  /*  253 */  _URShiftL_mRegLorI2L_immI_0_31_rule,
  /*  254 */  mRegLorI2L_rule,
  /*  255 */  mRegI_rule,
  /*  256 */  mRegI_rule,
  /*  257 */  _AndI_mRegI_immI_1_rule,
  /*  258 */  mRegI_rule,
  /*  259 */  mRegLorI2L_rule,
  /*  260 */  mRegLorI2L_rule,
  /*  261 */  memory_rule,
  /*  262 */  mRegLorI2L_rule,
  /*  263 */  _ConvI2L_mRegI__rule,
  /*  264 */  _ConvI2L_mRegI__rule,
  /*  265 */  _ConvL2I_mRegL__rule,
  /*  266 */  _LoadI_memory__rule,
  /*  267 */  memory_rule,
  /*  268 */  immIU5_rule,
  /*  269 */  immIU5_rule,
  /*  270 */  immIU5_rule,
  /*  271 */  immLU5_rule,
  /*  272 */  vecX_rule,
  /*  273 */  vecX_rule,
  /*  274 */  vecY_rule,
  /*  275 */  vecY_rule,
  /*  276 */  vecX_rule,
  /*  277 */  vecX_rule,
  /*  278 */  vecX_rule,
  /*  279 */  vecX_rule,
  /*  280 */  vecX_rule,
  /*  281 */  vecY_rule,
  /*  282 */  vecY_rule,
  /*  283 */  vecY_rule,
  /*  284 */  vecY_rule,
  /*  285 */  vecY_rule,
  /*  286 */  vecX_rule,
  /*  287 */  vecX_rule,
  /*  288 */  vecY_rule,
  /*  289 */  vecY_rule,
  /*  290 */  _NegVF_vecX__rule,
  /*  291 */  vecX_rule,
  /*  292 */  _NegVD_vecX__rule,
  /*  293 */  vecX_rule,
  /*  294 */  _NegVF_vecY__rule,
  /*  295 */  vecY_rule,
  /*  296 */  _NegVD_vecY__rule,
  /*  297 */  vecY_rule,
  /*  298 */  immI_rule,
  /*  299 */  immI_rule,
  /*  300 */  immIU8_rule,
  /*  301 */  vecX_rule,
  /*  302 */  immI_M1_rule,
  /*  303 */  immI_M1_rule,
  /*  304 */  immI_M1_rule,
  /*  305 */  vecX_rule,
  /*  306 */  _ReplicateB_immIU8__rule,
  /*  307 */  vecY_rule,
  /*  308 */  vecY_rule,
  /*  309 */  _ReplicateB_immIU8__rule,
  /*  310 */  vecX_rule,
  /*  311 */  _ReplicateB_immI_M1__rule,
  /*  312 */  vecX_rule,
  /*  313 */  _ReplicateS_immI_M1__rule,
  /*  314 */  vecX_rule,
  /*  315 */  _ReplicateI_immI_M1__rule,
  /*  316 */  vecY_rule,
  /*  317 */  _ReplicateB_immI_M1__rule,
  /*  318 */  vecY_rule,
  /*  319 */  _ReplicateS_immI_M1__rule,
  /*  320 */  vecY_rule,
  /*  321 */  _ReplicateI_immI_M1__rule,
  /*  322 */  vecX_rule,
  /*  323 */  vecX_rule,
  /*  324 */  vecX_rule,
  /*  325 */  vecX_rule,
  /*  326 */  vecY_rule,
  /*  327 */  vecY_rule,
  /*  328 */  vecY_rule,
  /*  329 */  vecY_rule,
  // last internally defined operand
  /*  330 */  mRegI_rule,
  /*  331 */  mRegL_rule,
  /*  332 */  mRegP_rule,
  /*  333 */  regF_rule,
  /*  334 */  regD_rule,
  /*  335 */  immI_rule,
  /*  336 */  immL_rule,
  /*  337 */  immP_rule,
  /*  338 */  immP_no_oop_cheap_rule,
  /*  339 */  immP_0_rule,
  /*  340 */  immN_0_rule,
  /*  341 */  immN_rule,
  /*  342 */  immNKlass_rule,
  /*  343 */  immF_0_rule,
  /*  344 */  immF_rule,
  /*  345 */  immD_0_rule,
  /*  346 */  immD_rule,
  /*  347 */  stackSlotI_rule,
  /*  348 */  stackSlotL_rule,
  /*  349 */  stackSlotP_rule,
  /*  350 */  stackSlotF_rule,
  /*  351 */  stackSlotD_rule,
  /*  352 */  indOffset12Narrow_rule,
  /*  353 */  mRegL_rule,
  /*  354 */  mRegP_rule,
  /*  355 */  regF_rule,
  /*  356 */  mRegI_rule,
  /*  357 */  regD_rule,
  /*  358 */  mRegL_rule,
  /*  359 */  regF_rule,
  /*  360 */  regD_rule,
  /*  361 */  regF_rule,
  /*  362 */  regD_rule,
  /*  363 */  mRegI_rule,
  /*  364 */  mRegP_rule,
  /*  365 */  mRegP_rule,
  /*  366 */  mRegP_rule,
  /*  367 */  mRegI_rule,
  /*  368 */  mRegL_rule,
  /*  369 */  regF_rule,
  /*  370 */  regD_rule,
  /*  371 */  vecX_rule,
  /*  372 */  vecY_rule,
  /*  373 */  mRegP_rule,
  /*  374 */  mRegP_rule,
  /*  375 */  memory_rule,
  /*  376 */  memory_rule,
  /*  377 */  memory_rule,
  /*  378 */  regF_rule,
  /*  379 */  regD_rule,
  /*  380 */  mRegIorL2I_rule,
  /*  381 */  mRegL_rule,
  /*  382 */  mRegIorL2I_rule,
  /*  383 */  mRegL_rule,
  /*  384 */  mRegIorL2I_rule,
  /*  385 */  _LoadI_memory__rule,
  /*  386 */  mRegL_rule,
  /*  387 */  _LoadL_memory__rule,
  /*  388 */  vecX_rule,
  /*  389 */  vecX_rule,
  /*  390 */  vecY_rule,
  /*  391 */  vecY_rule,
  /*  392 */  vecX_rule,
  /*  393 */  vecX_rule,
  /*  394 */  vecX_rule,
  /*  395 */  vecY_rule,
  /*  396 */  vecY_rule,
  /*  397 */  vecY_rule,
  /*  398 */  vecX_rule,
  /*  399 */  vecX_rule,
  /*  400 */  vecY_rule,
  /*  401 */  vecY_rule,
  /*  402 */  mRegI_rule,
  /*  403 */  mRegI_rule,
  /*  404 */  mRegI_rule,
  /*  405 */  mRegI_rule,
  /*  406 */  vecX_rule,
  /*  407 */  vecX_rule,
  /*  408 */  vecX_rule,
  /*  409 */  vecX_rule,
  /*  410 */  vecX_rule,
  /*  411 */  vecY_rule,
  /*  412 */  vecX_rule,
  /*  413 */  vecX_rule,
  /*  414 */  vecY_rule,
  /*  415 */  vecX_rule,
  /*  416 */  vecY_rule,
  /*  417 */  vecX_rule,
  /*  418 */  vecX_rule,
  /*  419 */  vecY_rule,
  /*  420 */  vecX_rule,
  /*  421 */  vecY_rule,
  /*  422 */  vecX_rule,
  /*  423 */  vecY_rule,
  /*  424 */  vecX_rule,
  /*  425 */  vecY_rule,
  /*  426 */  vecX_rule,
  /*  427 */  immI_0_rule,
  /*  428 */  immI_0_rule,
  /*  429 */  vecX_rule,
  /*  430 */  vecY_rule,
  /*  431 */  vecX_rule,
  /*  432 */  vecX_rule,
  /*  433 */  vecY_rule,
  /*  434 */  memory_rule,
  /*  435 */  _LoadI_memory__rule,
  /*  436 */  _LShiftI__LoadI_memory__immI_24_rule,
  /*  437 */  _LoadI_memory__rule,
  /*  438 */  _LShiftI__LoadI_memory__immI_16_rule,
  /*  439 */  _LoadI_memory__rule,
  /*  440 */  memory_rule,
  /*  441 */  memory_rule,
  /*  442 */  memory_rule,
  /*  443 */  indirect_rule,
  /*  444 */  memory_rule,
  /*  445 */  indirect_rule,
  /*  446 */  memory_rule,
  /*  447 */  _LoadN_memory__rule,
  /*  448 */  memory_rule,
  /*  449 */  memory_rule,
  /*  450 */  memory_rule,
  /*  451 */  _LoadNKlass_memory__rule,
  /*  452 */  memory_loadRange_rule,
  /*  453 */  memory_rule,
  /*  454 */  indirect_rule,
  /*  455 */  memory_rule,
  /*  456 */  indirect_rule,
  /*  457 */  memory_rule,
  /*  458 */  indirect_rule,
  /*  459 */  memory_rule,
  /*  460 */  indirect_rule,
  /*  461 */  memory_rule,
  /*  462 */  indirect_rule,
  /*  463 */  memory_rule,
  /*  464 */  indirect_rule,
  /*  465 */  memory_rule,
  /*  466 */  indirect_rule,
  /*  467 */  memory_rule,
  /*  468 */  memory_rule,
  /*  469 */  memory_rule,
  /*  470 */  _LoadB_memory__rule,
  /*  471 */  memory_rule,
  /*  472 */  _LoadUB_memory__rule,
  /*  473 */  memory_rule,
  /*  474 */  _LShiftI__LoadS_memory__immI_24_rule,
  /*  475 */  _LoadS_memory__rule,
  /*  476 */  memory_rule,
  /*  477 */  indirect_rule,
  /*  478 */  memory_rule,
  /*  479 */  indirect_rule,
  /*  480 */  memory_rule,
  /*  481 */  mRegP_rule,
  /*  482 */  0,
  /*  483 */  0,
  /*  484 */  0,
  /*  485 */  cmpOp_rule,
  /*  486 */  cmpOp_rule,
  /*  487 */  cmpOpEqNe_rule,
  /*  488 */  cmpOpEqNe_rule,
  /*  489 */  cmpOpEqNe_rule,
  /*  490 */  cmpOp_rule,
  /*  491 */  cmpOpEqNe_rule,
  /*  492 */  cmpOp_rule,
  /*  493 */  cmpOp_rule,
  /*  494 */  cmpOp_rule,
  /*  495 */  cmpOp_rule,
  /*  496 */  cmpOp_rule,
  /*  497 */  cmpOp_rule,
  /*  498 */  cmpOp_rule,
  /*  499 */  cmpOp_rule,
  /*  500 */  cmpOp_rule,
  /*  501 */  cmpOp_rule,
  /*  502 */  cmpOp_rule,
  /*  503 */  0,
  /*  504 */  cmpOp_rule,
  /*  505 */  cmpOp_rule,
  /*  506 */  cmpOpEqNe_rule,
  /*  507 */  cmpOpEqNe_rule,
  /*  508 */  cmpOpEqNe_rule,
  /*  509 */  cmpOp_rule,
  /*  510 */  cmpOp_rule,
  /*  511 */  cmpOp_rule,
  /*  512 */  cmpOp_rule,
  /*  513 */  cmpOp_rule,
  /*  514 */  cmpOp_rule,
  /*  515 */  cmpOp_rule,
  /*  516 */  cmpOp_rule,
  /*  517 */  cmpOp_rule,
  /*  518 */  cmpOp_rule,
  /*  519 */  cmpOp_rule,
  /*  520 */  cmpOp_rule,
  /*  521 */  cmpOp_rule,
  /*  522 */  0,
  /*  523 */  0,
  /*  524 */  0,
  /*  525 */  0,
  /*  526 */  0,
  /*  527 */  0,
  /*  528 */  0,
  /*  529 */  0,
  /*  530 */  0,
  /*  531 */  0,
  /*  532 */  0,
  /*  533 */  0,
  /*  534 */  0,
  /*  535 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  536 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  537 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  538 */  _Binary_cmpOp__CmpP_mRegP_mRegP_rule,
  /*  539 */  _Binary_cmpOp__CmpN_mRegN_mRegN_rule,
  /*  540 */  _Binary_cmpOp__CmpU_mRegI_mRegI_rule,
  /*  541 */  _Binary_cmpOp__CmpF_regF_regF_rule,
  /*  542 */  _Binary_cmpOp__CmpN_mRegN_mRegN_rule,
  /*  543 */  _Binary_cmpOp__CmpP_mRegP_mRegP_rule,
  /*  544 */  _Binary_cmpOp__CmpD_regD_regD_rule,
  /*  545 */  _Binary_cmpOp__CmpN_mRegN_mRegN_rule,
  /*  546 */  _Binary_cmpOp__CmpU_mRegI_mRegI_rule,
  /*  547 */  _Binary_cmpOp__CmpL_mRegLorI2L_mRegLorI2L_rule,
  /*  548 */  _Binary_cmpOp__CmpUL_mRegLorI2L_mRegLorI2L_rule,
  /*  549 */  _Binary_cmpOp__CmpL_mRegLorI2L_mRegLorI2L_rule,
  /*  550 */  _Binary_cmpOp__CmpUL_mRegLorI2L_mRegLorI2L_rule,
  /*  551 */  _Binary_cmpOp__CmpD_regD_regD_rule,
  /*  552 */  _Binary_cmpOp__CmpP_mRegP_mRegP_rule,
  /*  553 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  554 */  _Binary_cmpOp__CmpP_mRegP_mRegP_rule,
  /*  555 */  _Binary_cmpOp__CmpU_mRegI_mRegI_rule,
  /*  556 */  _Binary_cmpOp__CmpL_mRegL_mRegL_rule,
  /*  557 */  _Binary_cmpOp__CmpUL_mRegL_mRegL_rule,
  /*  558 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  559 */  _Binary_cmpOp__CmpU_mRegI_mRegI_rule,
  /*  560 */  _Binary_cmpOp__CmpF_regF_regF_rule,
  /*  561 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  562 */  _Binary_cmpOp__CmpL_mRegL_mRegL_rule,
  /*  563 */  _Binary_cmpOp__CmpUL_mRegL_mRegL_rule,
  /*  564 */  _Binary_cmpOp__CmpL_mRegL_mRegL_rule,
  /*  565 */  _Binary_cmpOp__CmpUL_mRegL_mRegL_rule,
  /*  566 */  _Binary_cmpOp__CmpL_mRegL_mRegL_rule,
  /*  567 */  _Binary_cmpOp__CmpUL_mRegL_mRegL_rule,
  /*  568 */  _Binary_cmpOp__CmpN_mRegN_mRegN_rule,
  /*  569 */  _Binary_cmpOp__CmpD_regD_regD_rule,
  /*  570 */  _Binary_cmpOp__CmpD_regD_regD_rule,
  /*  571 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  572 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  573 */  _Binary_cmpOp__CmpP_mRegP_mRegP_rule,
  /*  574 */  _Binary_cmpOp__CmpF_regF_regF_rule,
  /*  575 */  _Binary_cmpOp__CmpF_regF_regF_rule,
  /*  576 */  mRegL_rule,
  /*  577 */  mRegL_rule,
  /*  578 */  regF_rule,
  /*  579 */  regD_rule,
  /*  580 */  t8RegL_rule,
  /*  581 */  immL_rule,
  /*  582 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  583 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  584 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  585 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  586 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  587 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  588 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  589 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  590 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  591 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  592 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  593 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  594 */  a4_RegP_rule,
  /*  595 */  a4_RegP_rule,
  /*  596 */  a4_RegP_rule,
  /*  597 */  _Binary_a4_RegP_a5_RegP_rule,
  /*  598 */  a4_RegP_rule,
  /*  599 */  a4_RegP_rule,
  /*  600 */  mRegIorL2I_rule,
  /*  601 */  mRegIorL2I_rule,
  /*  602 */  mRegI_rule,
  /*  603 */  _LShiftI_mRegI_immI_1_4_rule,
  /*  604 */  mRegP_rule,
  /*  605 */  mRegP_rule,
  /*  606 */  mRegP_rule,
  /*  607 */  mRegP_rule,
  /*  608 */  mRegLorI2L_rule,
  /*  609 */  mRegLorI2L_rule,
  /*  610 */  mRegI_rule,
  /*  611 */  mRegLorI2L_rule,
  /*  612 */  mRegIorL2I_rule,
  /*  613 */  mRegIorL2I_rule,
  /*  614 */  immI_0_rule,
  /*  615 */  immL_0_rule,
  /*  616 */  mRegL_rule,
  /*  617 */  mRegLorI2L_rule,
  /*  618 */  mRegIorL2I_rule,
  /*  619 */  mRegLorI2L_rule,
  /*  620 */  mRegI_rule,
  /*  621 */  mRegI_rule,
  /*  622 */  regF_rule,
  /*  623 */  regD_rule,
  /*  624 */  mRegLorI2L_rule,
  /*  625 */  mRegL_rule,
  /*  626 */  mRegL_rule,
  /*  627 */  regF_rule,
  /*  628 */  regF_rule,
  /*  629 */  regD_rule,
  /*  630 */  regD_rule,
  /*  631 */  regF_rule,
  /*  632 */  regD_rule,
  /*  633 */  regD_rule,
  /*  634 */  _SqrtD__ConvF2D_regF___rule,
  /*  635 */  regF_rule,
  /*  636 */  regD_rule,
  /*  637 */  _NegF_regF__rule,
  /*  638 */  _NegD_regD__rule,
  /*  639 */  _NegF_regF__rule,
  /*  640 */  _NegF_regF__rule,
  /*  641 */  _NegD_regD__rule,
  /*  642 */  _NegD_regD__rule,
  /*  643 */  regF_rule,
  /*  644 */  regF_rule,
  /*  645 */  regD_rule,
  /*  646 */  regD_rule,
  /*  647 */  regF_rule,
  /*  648 */  regD_rule,
  /*  649 */  mRegI_rule,
  /*  650 */  mRegI_rule,
  /*  651 */  mRegL_rule,
  /*  652 */  mRegI_rule,
  /*  653 */  mRegIorL2I_rule,
  /*  654 */  mRegL_rule,
  /*  655 */  immI_255_rule,
  /*  656 */  _LoadB_memory__rule,
  /*  657 */  _LoadB_memory__rule,
  /*  658 */  mRegI_rule,
  /*  659 */  mRegI_rule,
  /*  660 */  _XorI_mRegI_immI_M1_rule,
  /*  661 */  mRegI_rule,
  /*  662 */  _XorI_mRegI_immI_M1_rule,
  /*  663 */  _XorI_mRegI_immI_M1_rule,
  /*  664 */  mRegI_rule,
  /*  665 */  _XorI_mRegI_immI_M1_rule,
  /*  666 */  mRegI_rule,
  /*  667 */  mRegL_rule,
  /*  668 */  mRegL_rule,
  /*  669 */  _AndL_mRegL_immL_0_4095_rule,
  /*  670 */  mRegL_rule,
  /*  671 */  mRegL_rule,
  /*  672 */  mRegL_rule,
  /*  673 */  mRegL_rule,
  /*  674 */  mRegL_rule,
  /*  675 */  mRegLorI2L_rule,
  /*  676 */  _CastP2X_mRegP__rule,
  /*  677 */  mRegLorI2L_rule,
  /*  678 */  mRegL_rule,
  /*  679 */  mRegIorL2I_rule,
  /*  680 */  _LShiftI_mRegI_immI_16_rule,
  /*  681 */  _LShiftI__ConvL2I__AndL_mRegL_immL_7__immI_16_rule,
  /*  682 */  _LShiftI_mRegI_immI_16_rule,
  /*  683 */  _LShiftI_mRegI_immI_24_rule,
  /*  684 */  _ConvL2I_mRegL__rule,
  /*  685 */  mRegIorL2I_rule,
  /*  686 */  mRegLorI2L_rule,
  /*  687 */  mRegLorI2L_rule,
  /*  688 */  mRegLorI2L_rule,
  /*  689 */  _RShiftL_mRegLorI2L_immI_32_63_rule,
  /*  690 */  mRegLorI2L_rule,
  /*  691 */  mRegL_rule,
  /*  692 */  mRegLorI2L_rule,
  /*  693 */  _ConvL2I__URShiftL_mRegLorI2L_immI_0_31__rule,
  /*  694 */  _CastP2X_mRegP__rule,
  /*  695 */  mRegLorI2L_rule,
  /*  696 */  _URShiftL_mRegLorI2L_immI_32_63_rule,
  /*  697 */  _CastP2X_mRegP__rule,
  /*  698 */  mRegI_rule,
  /*  699 */  mRegI_rule,
  /*  700 */  mRegI_rule,
  /*  701 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  702 */  _LShiftI__AndI_mRegI_immI_1_immI_0_31_rule,
  /*  703 */  mRegL_rule,
  /*  704 */  _CastP2X_mRegP__rule,
  /*  705 */  mRegI_rule,
  /*  706 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  707 */  _LShiftI_mRegI_immI_0_31_rule,
  /*  708 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  709 */  _LShiftL_mRegLorI2L_immI_32_63_rule,
  /*  710 */  _URShiftL_mRegLorI2L_immI_0_31_rule,
  /*  711 */  _LShiftL_mRegLorI2L_immI_0_31_rule,
  /*  712 */  _URShiftL_mRegLorI2L_immI_32_63_rule,
  /*  713 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  714 */  _LShiftI_mRegI_immI_0_31_rule,
  /*  715 */  _URShiftL_mRegLorI2L_immI_0_31_rule,
  /*  716 */  _LShiftL_mRegLorI2L_immI_32_63_rule,
  /*  717 */  _URShiftL_mRegLorI2L_immI_32_63_rule,
  /*  718 */  _LShiftL_mRegLorI2L_immI_0_31_rule,
  /*  719 */  mRegI_rule,
  /*  720 */  mRegL_rule,
  /*  721 */  mRegI_rule,
  /*  722 */  mRegI_rule,
  /*  723 */  mRegL_rule,
  /*  724 */  mRegL_rule,
  /*  725 */  mRegI_rule,
  /*  726 */  mRegI_rule,
  /*  727 */  mRegI_rule,
  /*  728 */  mRegI_rule,
  /*  729 */  mRegLorI2L_rule,
  /*  730 */  mRegL_rule,
  /*  731 */  regD_rule,
  /*  732 */  regD_rule,
  /*  733 */  regF_rule,
  /*  734 */  regF_rule,
  /*  735 */  mRegL_rule,
  /*  736 */  mRegI_rule,
  /*  737 */  regD_rule,
  /*  738 */  mRegI_rule,
  /*  739 */  mRegI_rule,
  /*  740 */  mRegI_rule,
  /*  741 */  regF_rule,
  /*  742 */  regD_rule,
  /*  743 */  mRegP_rule,
  /*  744 */  mRegP_rule,
  /*  745 */  mRegN_rule,
  /*  746 */  mRegN_rule,
  /*  747 */  mRegP_rule,
  /*  748 */  mRegN_rule,
  /*  749 */  0,
  /*  750 */  0,
  /*  751 */  no_Ax_mRegP_rule,
  /*  752 */  0,
  /*  753 */  0,
  /*  754 */  0,
  /*  755 */  memory_rule,
  /*  756 */  0,
  /*  757 */  memory_rule,
  /*  758 */  _LoadUS_memory__rule,
  /*  759 */  memory_rule,
  /*  760 */  memory_rule,
  /*  761 */  memory_rule,
  /*  762 */  memory_rule,
  /*  763 */  memory_rule,
  /*  764 */  memory_rule,
  /*  765 */  memory_rule,
  /*  766 */  memory_rule,
  /*  767 */  memory_rule,
  /*  768 */  0,
  /*  769 */  mRegP_rule,
  /*  770 */  no_T8_mRegP_rule,
  /*  771 */  memory_rule,
  /*  772 */  mRegP_rule,
  /*  773 */  mRegP_rule,
  /*  774 */  mRegP_rule,
  /*  775 */  mRegP_rule,
  /*  776 */  indirect_rule,
  /*  777 */  indirect_rule,
  /*  778 */  indirect_rule,
  /*  779 */  indirect_rule,
  /*  780 */  indirect_rule,
  /*  781 */  indirect_rule,
  /*  782 */  indirect_rule,
  /*  783 */  indirect_rule,
  /*  784 */  indirect_rule,
  /*  785 */  indirect_rule,
  /*  786 */  indirect_rule,
  /*  787 */  indirect_rule,
  /*  788 */  indirect_rule,
  /*  789 */  indirect_rule,
  /*  790 */  indirect_rule,
  /*  791 */  indirect_rule,
  /*  792 */  indirect_rule,
  /*  793 */  mRegI_rule,
  /*  794 */  mRegI_rule,
  /*  795 */  mRegI_rule,
  /*  796 */  mRegL_rule,
  /*  797 */  _AndL__ConvI2L_mRegI__immL_MaxUI_rule,
  /*  798 */  _LShiftL__ConvI2L_mRegI__immI_32_rule,
  /*  799 */  _ConvI2L_mRegI__rule,
  /*  800 */  _ConvI2L__ConvL2I_mRegL___rule,
  /*  801 */  _ConvI2L__LoadI_memory___rule,
  /*  802 */  immL_MaxUI_rule,
  /*  803 */  _ConvI2L__LoadI_memory___rule,
  /*  804 */  mRegP_rule,
  /*  805 */  mRegIorL2I_rule,
  /*  806 */  mRegL_rule,
  /*  807 */  mRegIorL2I_rule,
  /*  808 */  mRegIorL2I_rule,
  /*  809 */  memory_rule,
  /*  810 */  memory_rule,
  /*  811 */  memory_rule,
  /*  812 */  memory_rule,
  /*  813 */  mRegI_rule,
  /*  814 */  immI_M128_255_rule,
  /*  815 */  mRegI_rule,
  /*  816 */  immI10_rule,
  /*  817 */  mRegI_rule,
  /*  818 */  immI10_rule,
  /*  819 */  mRegL_rule,
  /*  820 */  immL10_rule,
  /*  821 */  regF_rule,
  /*  822 */  regD_rule,
  /*  823 */  mRegI_rule,
  /*  824 */  immI_M128_255_rule,
  /*  825 */  mRegI_rule,
  /*  826 */  immI10_rule,
  /*  827 */  mRegI_rule,
  /*  828 */  immI10_rule,
  /*  829 */  mRegL_rule,
  /*  830 */  immL10_rule,
  /*  831 */  regF_rule,
  /*  832 */  regD_rule,
  /*  833 */  vecX_rule,
  /*  834 */  vecX_rule,
  /*  835 */  _ReplicateB_immIU5__rule,
  /*  836 */  vecX_rule,
  /*  837 */  vecX_rule,
  /*  838 */  _ReplicateS_immIU5__rule,
  /*  839 */  vecX_rule,
  /*  840 */  vecX_rule,
  /*  841 */  _ReplicateI_immIU5__rule,
  /*  842 */  vecX_rule,
  /*  843 */  vecX_rule,
  /*  844 */  _ReplicateL_immLU5__rule,
  /*  845 */  vecX_rule,
  /*  846 */  vecX_rule,
  /*  847 */  vecY_rule,
  /*  848 */  vecY_rule,
  /*  849 */  _ReplicateB_immIU5__rule,
  /*  850 */  vecY_rule,
  /*  851 */  vecY_rule,
  /*  852 */  _ReplicateS_immIU5__rule,
  /*  853 */  vecY_rule,
  /*  854 */  vecY_rule,
  /*  855 */  _ReplicateI_immIU5__rule,
  /*  856 */  vecY_rule,
  /*  857 */  vecY_rule,
  /*  858 */  _ReplicateL_immLU5__rule,
  /*  859 */  vecY_rule,
  /*  860 */  vecY_rule,
  /*  861 */  vecX_rule,
  /*  862 */  vecX_rule,
  /*  863 */  vecX_rule,
  /*  864 */  vecX_rule,
  /*  865 */  vecX_rule,
  /*  866 */  vecX_rule,
  /*  867 */  vecX_rule,
  /*  868 */  vecX_rule,
  /*  869 */  vecX_rule,
  /*  870 */  vecX_rule,
  /*  871 */  vecY_rule,
  /*  872 */  vecY_rule,
  /*  873 */  vecY_rule,
  /*  874 */  vecY_rule,
  /*  875 */  vecY_rule,
  /*  876 */  vecY_rule,
  /*  877 */  vecY_rule,
  /*  878 */  vecY_rule,
  /*  879 */  vecY_rule,
  /*  880 */  vecY_rule,
  /*  881 */  vecX_rule,
  /*  882 */  vecX_rule,
  /*  883 */  vecX_rule,
  /*  884 */  vecX_rule,
  /*  885 */  vecX_rule,
  /*  886 */  vecX_rule,
  /*  887 */  vecY_rule,
  /*  888 */  vecY_rule,
  /*  889 */  vecY_rule,
  /*  890 */  vecY_rule,
  /*  891 */  vecY_rule,
  /*  892 */  vecY_rule,
  /*  893 */  vecX_rule,
  /*  894 */  vecX_rule,
  /*  895 */  vecY_rule,
  /*  896 */  vecY_rule,
  /*  897 */  vecX_rule,
  /*  898 */  vecX_rule,
  /*  899 */  vecX_rule,
  /*  900 */  vecX_rule,
  /*  901 */  vecY_rule,
  /*  902 */  vecY_rule,
  /*  903 */  vecY_rule,
  /*  904 */  vecY_rule,
  /*  905 */  _SubVI_vecX_vecX_rule,
  /*  906 */  _SubVL_vecX_vecX_rule,
  /*  907 */  _SubVI_vecY_vecY_rule,
  /*  908 */  _SubVL_vecY_vecY_rule,
  /*  909 */  vecX_rule,
  /*  910 */  vecX_rule,
  /*  911 */  vecX_rule,
  /*  912 */  vecX_rule,
  /*  913 */  vecX_rule,
  /*  914 */  vecX_rule,
  /*  915 */  vecY_rule,
  /*  916 */  vecY_rule,
  /*  917 */  vecY_rule,
  /*  918 */  vecY_rule,
  /*  919 */  vecY_rule,
  /*  920 */  vecY_rule,
  /*  921 */  vecX_rule,
  /*  922 */  vecX_rule,
  /*  923 */  vecX_rule,
  /*  924 */  vecX_rule,
  /*  925 */  vecX_rule,
  /*  926 */  vecX_rule,
  /*  927 */  vecY_rule,
  /*  928 */  vecY_rule,
  /*  929 */  vecY_rule,
  /*  930 */  vecY_rule,
  /*  931 */  vecY_rule,
  /*  932 */  vecY_rule,
  /*  933 */  vecX_rule,
  /*  934 */  _MulVB_vecX_vecX_rule,
  /*  935 */  vecX_rule,
  /*  936 */  _MulVS_vecX_vecX_rule,
  /*  937 */  vecX_rule,
  /*  938 */  _MulVI_vecX_vecX_rule,
  /*  939 */  vecX_rule,
  /*  940 */  _MulVL_vecX_vecX_rule,
  /*  941 */  vecX_rule,
  /*  942 */  vecX_rule,
  /*  943 */  vecY_rule,
  /*  944 */  _MulVB_vecY_vecY_rule,
  /*  945 */  vecY_rule,
  /*  946 */  _MulVS_vecY_vecY_rule,
  /*  947 */  vecY_rule,
  /*  948 */  _MulVI_vecY_vecY_rule,
  /*  949 */  vecY_rule,
  /*  950 */  _MulVL_vecY_vecY_rule,
  /*  951 */  vecY_rule,
  /*  952 */  vecY_rule,
  /*  953 */  vecX_rule,
  /*  954 */  vecX_rule,
  /*  955 */  vecX_rule,
  /*  956 */  vecX_rule,
  /*  957 */  _NegVF_vecX__rule,
  /*  958 */  _NegVD_vecX__rule,
  /*  959 */  vecY_rule,
  /*  960 */  vecY_rule,
  /*  961 */  vecY_rule,
  /*  962 */  vecY_rule,
  /*  963 */  _NegVF_vecY__rule,
  /*  964 */  _NegVD_vecY__rule,
  /*  965 */  _NegVF_vecX__rule,
  /*  966 */  _NegVF_vecX__rule,
  /*  967 */  _NegVD_vecX__rule,
  /*  968 */  _NegVD_vecX__rule,
  /*  969 */  _NegVF_vecY__rule,
  /*  970 */  _NegVF_vecY__rule,
  /*  971 */  _NegVD_vecY__rule,
  /*  972 */  _NegVD_vecY__rule,
  /*  973 */  vecX_rule,
  /*  974 */  vecX_rule,
  /*  975 */  vecX_rule,
  /*  976 */  vecX_rule,
  /*  977 */  vecY_rule,
  /*  978 */  vecY_rule,
  /*  979 */  vecY_rule,
  /*  980 */  vecY_rule,
  /*  981 */  vecX_rule,
  /*  982 */  vecY_rule,
  /*  983 */  vecX_rule,
  /*  984 */  vecX_rule,
  /*  985 */  vecX_rule,
  /*  986 */  vecX_rule,
  /*  987 */  vecX_rule,
  /*  988 */  vecX_rule,
  /*  989 */  vecX_rule,
  /*  990 */  vecX_rule,
  /*  991 */  vecY_rule,
  /*  992 */  vecY_rule,
  /*  993 */  vecY_rule,
  /*  994 */  vecY_rule,
  /*  995 */  vecY_rule,
  /*  996 */  vecY_rule,
  /*  997 */  vecY_rule,
  /*  998 */  vecY_rule,
  /*  999 */  vecX_rule,
  /* 1000 */  vecX_rule,
  /* 1001 */  vecX_rule,
  /* 1002 */  vecX_rule,
  /* 1003 */  vecX_rule,
  /* 1004 */  vecX_rule,
  /* 1005 */  vecX_rule,
  /* 1006 */  vecX_rule,
  /* 1007 */  vecY_rule,
  /* 1008 */  vecY_rule,
  /* 1009 */  vecY_rule,
  /* 1010 */  vecY_rule,
  /* 1011 */  vecY_rule,
  /* 1012 */  vecY_rule,
  /* 1013 */  vecY_rule,
  /* 1014 */  vecY_rule,
  /* 1015 */  vecX_rule,
  /* 1016 */  vecX_rule,
  /* 1017 */  vecX_rule,
  /* 1018 */  vecX_rule,
  /* 1019 */  vecX_rule,
  /* 1020 */  vecX_rule,
  /* 1021 */  vecX_rule,
  /* 1022 */  vecX_rule,
  /* 1023 */  vecY_rule,
  /* 1024 */  vecY_rule,
  /* 1025 */  vecY_rule,
  /* 1026 */  vecY_rule,
  /* 1027 */  vecY_rule,
  /* 1028 */  vecY_rule,
  /* 1029 */  vecY_rule,
  /* 1030 */  vecY_rule,
  /* 1031 */  vecX_rule,
  /* 1032 */  vecX_rule,
  /* 1033 */  vecX_rule,
  /* 1034 */  vecX_rule,
  /* 1035 */  vecY_rule,
  /* 1036 */  vecY_rule,
  /* 1037 */  vecY_rule,
  /* 1038 */  vecY_rule,
  /* 1039 */  vecX_rule,
  /* 1040 */  vecX_rule,
  /* 1041 */  vecX_rule,
  /* 1042 */  vecX_rule,
  /* 1043 */  vecY_rule,
  /* 1044 */  vecY_rule,
  /* 1045 */  vecY_rule,
  /* 1046 */  vecY_rule,
  /* 1047 */  vecX_rule,
  /* 1048 */  vecX_rule,
  /* 1049 */  _ReplicateB_immIU8__rule,
  /* 1050 */  vecY_rule,
  /* 1051 */  vecY_rule,
  /* 1052 */  _ReplicateB_immIU8__rule,
  /* 1053 */  vecX_rule,
  /* 1054 */  vecX_rule,
  /* 1055 */  _ReplicateB_immIU8__rule,
  /* 1056 */  vecY_rule,
  /* 1057 */  vecY_rule,
  /* 1058 */  _ReplicateB_immIU8__rule,
  /* 1059 */  vecX_rule,
  /* 1060 */  vecX_rule,
  /* 1061 */  _ReplicateB_immIU8__rule,
  /* 1062 */  vecY_rule,
  /* 1063 */  vecX_rule,
  /* 1064 */  _ReplicateB_immIU8__rule,
  /* 1065 */  _OrV_vecX_vecX_rule,
  /* 1066 */  _ReplicateB_immI_M1__rule,
  /* 1067 */  _OrV_vecX_vecX_rule,
  /* 1068 */  _ReplicateS_immI_M1__rule,
  /* 1069 */  _OrV_vecX_vecX_rule,
  /* 1070 */  _ReplicateI_immI_M1__rule,
  /* 1071 */  _OrV_vecX__ReplicateB_immIU8__rule,
  /* 1072 */  _ReplicateB_immI_M1__rule,
  /* 1073 */  _OrV__ReplicateB_immIU8__vecX_rule,
  /* 1074 */  _ReplicateB_immI_M1__rule,
  /* 1075 */  _OrV_vecY_vecY_rule,
  /* 1076 */  _ReplicateB_immI_M1__rule,
  /* 1077 */  _OrV_vecY_vecY_rule,
  /* 1078 */  _ReplicateS_immI_M1__rule,
  /* 1079 */  _OrV_vecY_vecY_rule,
  /* 1080 */  _ReplicateI_immI_M1__rule,
  /* 1081 */  _OrV_vecY__ReplicateB_immIU8__rule,
  /* 1082 */  _ReplicateB_immI_M1__rule,
  /* 1083 */  _OrV__ReplicateB_immIU8__vecY_rule,
  /* 1084 */  _ReplicateB_immI_M1__rule,
  /* 1085 */  vecX_rule,
  /* 1086 */  _XorV_vecX__ReplicateB_immI_M1__rule,
  /* 1087 */  vecX_rule,
  /* 1088 */  _XorV__ReplicateB_immI_M1__vecX_rule,
  /* 1089 */  vecX_rule,
  /* 1090 */  _XorV_vecX__ReplicateS_immI_M1__rule,
  /* 1091 */  vecX_rule,
  /* 1092 */  _XorV__ReplicateS_immI_M1__vecX_rule,
  /* 1093 */  vecX_rule,
  /* 1094 */  _XorV_vecX__ReplicateI_immI_M1__rule,
  /* 1095 */  vecX_rule,
  /* 1096 */  _XorV__ReplicateI_immI_M1__vecX_rule,
  /* 1097 */  vecY_rule,
  /* 1098 */  _XorV_vecY__ReplicateB_immI_M1__rule,
  /* 1099 */  vecY_rule,
  /* 1100 */  _XorV__ReplicateB_immI_M1__vecY_rule,
  /* 1101 */  vecY_rule,
  /* 1102 */  _XorV_vecY__ReplicateS_immI_M1__rule,
  /* 1103 */  vecY_rule,
  /* 1104 */  _XorV__ReplicateS_immI_M1__vecY_rule,
  /* 1105 */  vecY_rule,
  /* 1106 */  _XorV_vecY__ReplicateI_immI_M1__rule,
  /* 1107 */  vecY_rule,
  /* 1108 */  _XorV__ReplicateI_immI_M1__vecY_rule,
  /* 1109 */  vecX_rule,
  /* 1110 */  _XorV_vecX__ReplicateB_immI_M1__rule,
  /* 1111 */  vecX_rule,
  /* 1112 */  _XorV__ReplicateB_immI_M1__vecX_rule,
  /* 1113 */  vecX_rule,
  /* 1114 */  _XorV_vecX__ReplicateS_immI_M1__rule,
  /* 1115 */  vecX_rule,
  /* 1116 */  _XorV__ReplicateS_immI_M1__vecX_rule,
  /* 1117 */  vecX_rule,
  /* 1118 */  _XorV_vecX__ReplicateI_immI_M1__rule,
  /* 1119 */  vecX_rule,
  /* 1120 */  _XorV__ReplicateI_immI_M1__vecX_rule,
  /* 1121 */  vecY_rule,
  /* 1122 */  _XorV_vecY__ReplicateB_immI_M1__rule,
  /* 1123 */  vecY_rule,
  /* 1124 */  _XorV__ReplicateB_immI_M1__vecY_rule,
  /* 1125 */  vecY_rule,
  /* 1126 */  _XorV_vecY__ReplicateS_immI_M1__rule,
  /* 1127 */  vecY_rule,
  /* 1128 */  _XorV__ReplicateS_immI_M1__vecY_rule,
  /* 1129 */  vecY_rule,
  /* 1130 */  _XorV_vecY__ReplicateI_immI_M1__rule,
  /* 1131 */  vecY_rule,
  /* 1132 */  _XorV__ReplicateI_immI_M1__vecY_rule,
  /* 1133 */  mRegI_rule,
  /* 1134 */  mRegI_rule,
  /* 1135 */  mRegI_rule,
  /* 1136 */  mRegL_rule,
  /* 1137 */  regF_rule,
  /* 1138 */  regD_rule,
  /* 1139 */  mRegI_rule,
  /* 1140 */  mRegI_rule,
  /* 1141 */  mRegI_rule,
  /* 1142 */  mRegL_rule,
  /* 1143 */  regF_rule,
  /* 1144 */  regD_rule,
  /* 1145 */  mRegI_rule,
  /* 1146 */  mRegI_rule,
  /* 1147 */  mRegI_rule,
  /* 1148 */  mRegL_rule,
  /* 1149 */  regF_rule,
  /* 1150 */  regD_rule,
  /* 1151 */  mRegI_rule,
  /* 1152 */  mRegI_rule,
  /* 1153 */  mRegI_rule,
  /* 1154 */  mRegL_rule,
  /* 1155 */  regF_rule,
  /* 1156 */  regD_rule,
  /* 1157 */  mRegI_rule,
  /* 1158 */  mRegI_rule,
  /* 1159 */  mRegI_rule,
  /* 1160 */  mRegL_rule,
  /* 1161 */  mRegI_rule,
  /* 1162 */  mRegI_rule,
  /* 1163 */  mRegI_rule,
  /* 1164 */  mRegL_rule,
  /* 1165 */  mRegI_rule,
  /* 1166 */  mRegI_rule,
  /* 1167 */  mRegI_rule,
  /* 1168 */  mRegL_rule,
  /* 1169 */  mRegI_rule,
  /* 1170 */  mRegI_rule,
  /* 1171 */  mRegI_rule,
  /* 1172 */  mRegL_rule,
  /* 1173 */  mRegI_rule,
  /* 1174 */  mRegI_rule,
  /* 1175 */  mRegI_rule,
  /* 1176 */  mRegL_rule,
  /* 1177 */  mRegI_rule,
  /* 1178 */  mRegI_rule,
  /* 1179 */  mRegI_rule,
  /* 1180 */  mRegL_rule,
  /* 1181 */  mRegI_rule,
  /* 1182 */  mRegI_rule,
  /* 1183 */  mRegI_rule,
  /* 1184 */  mRegL_rule,
  /* 1185 */  mRegI_rule,
  /* 1186 */  mRegI_rule,
  /* 1187 */  mRegI_rule,
  /* 1188 */  mRegL_rule,
  /* 1189 */  mRegI_rule,
  /* 1190 */  mRegI_rule,
  /* 1191 */  mRegI_rule,
  /* 1192 */  mRegL_rule,
  /* 1193 */  mRegI_rule,
  /* 1194 */  mRegI_rule,
  /* 1195 */  mRegI_rule,
  /* 1196 */  mRegL_rule,
  /* 1197 */  vecX_rule,
  /* 1198 */  vecY_rule,
  /* 1199 */  vecY_rule,
  /* 1200 */  vecY_rule,
  /* 1201 */  vecY_rule,
  /* 1202 */  vecY_rule,
  /* 1203 */  vecY_rule,
  /* 1204 */  vecX_rule,
  /* 1205 */  vecY_rule,
  /* 1206 */  vecY_rule,
  /* 1207 */  _Binary_vecX_mRegI_rule,
  /* 1208 */  _Binary_vecX_mRegI_rule,
  /* 1209 */  _Binary_vecX_mRegI_rule,
  /* 1210 */  _Binary_vecX_mRegL_rule,
  /* 1211 */  _Binary_vecX_regF_rule,
  /* 1212 */  _Binary_vecX_regD_rule,
  /* 1213 */  _Binary_vecY_mRegI_rule,
  /* 1214 */  _Binary_vecY_mRegI_rule,
  /* 1215 */  _Binary_vecY_mRegI_rule,
  /* 1216 */  _Binary_vecY_mRegL_rule,
  /* 1217 */  _Binary_vecY_regF_rule,
  /* 1218 */  _Binary_vecY_regD_rule,
  /* 1219 */  _Binary_vecX_vecX_rule,
  /* 1220 */  _Binary_vecY_vecY_rule,
  /* 1221 */  vecX_rule,
  /* 1222 */  vecY_rule,
  /* 1223 */  vecY_rule,
  /* 1224 */  vecX_rule,
  /* 1225 */  vecX_rule,
  /* 1226 */  vecY_rule,
  /* 1227 */  vecY_rule,
  /* 1228 */  _Binary_vecX_vecX_rule,
  /* 1229 */  _Binary_vecY_vecY_rule,
  /* 1230 */  vecX_rule,
  /* 1231 */  vecY_rule,
  /* 1232 */  vecY_rule,
  /* 1233 */  indirect_rule,
  /* 1234 */  indirect_rule,
  /* 1235 */  indirect_rule,
  /* 1236 */  indirect_rule,
  /* 1237 */  indirect_rule,
  /* 1238 */  indirect_rule,
  /* 1239 */  indirect_rule,
  /* 1240 */  indirect_rule,
  /* 1241 */  indirect_rule,
  /* 1242 */  indirect_rule,
  /* 1243 */  indirect_rule,
  /* 1244 */  indirect_rule,
  /* 1245 */  memory_rule,
  /* 1246 */  mRegP_rule,
  /* 1247 */  mRegP_rule,
  /* 1248 */  mRegP_rule,
  /* 1249 */  mRegP_rule,
  /* 1250 */  mRegP_rule,
  /* 1251 */  mRegP_rule,
  /* 1252 */  mRegP_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  0,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  /*  130 */  0,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  0,
  /*  134 */  0,
  /*  135 */  0,
  /*  136 */  0,
  /*  137 */  0,
  /*  138 */  0,
  /*  139 */  0,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  0,
  /*  148 */  0,
  /*  149 */  0,
  /*  150 */  0,
  /*  151 */  0,
  /*  152 */  0,
  /*  153 */  0,
  /*  154 */  0,
  /*  155 */  0,
  /*  156 */  0,
  /*  157 */  0,
  /*  158 */  0,
  /*  159 */  immL12_rule,
  /*  160 */  _ConvI2L_immI12__rule,
  /*  161 */  mRegL_rule,
  /*  162 */  _ConvI2L_mRegI__rule,
  /*  163 */  0,
  /*  164 */  immL12_rule,
  /*  165 */  0,
  /*  166 */  0,
  /*  167 */  0,
  /*  168 */  0,
  /*  169 */  0,
  /*  170 */  0,
  /*  171 */  0,
  // last operand
  /*  172 */  0,
  /*  173 */  0,
  /*  174 */  0,
  /*  175 */  0,
  // last operand class
  /*  176 */  0,
  /*  177 */  0,
  /*  178 */  0,
  /*  179 */  0,
  /*  180 */  immI_24_rule,
  /*  181 */  immI_16_rule,
  /*  182 */  0,
  /*  183 */  0,
  /*  184 */  0,
  /*  185 */  0,
  /*  186 */  0,
  /*  187 */  0,
  /*  188 */  0,
  /*  189 */  immI_24_rule,
  /*  190 */  mRegI_rule,
  /*  191 */  immI_rule,
  /*  192 */  immP_0_rule,
  /*  193 */  immP_0_rule,
  /*  194 */  mRegP_rule,
  /*  195 */  immN_0_rule,
  /*  196 */  mRegN_rule,
  /*  197 */  mRegI_rule,
  /*  198 */  immI_rule,
  /*  199 */  mRegLorI2L_rule,
  /*  200 */  mRegLorI2L_rule,
  /*  201 */  immL_rule,
  /*  202 */  immL_rule,
  /*  203 */  regF_rule,
  /*  204 */  regD_rule,
  /*  205 */  _CmpI_mRegI_mRegI_rule,
  /*  206 */  mRegI_rule,
  /*  207 */  _CmpP_mRegP_mRegP_rule,
  /*  208 */  _CmpN_mRegN_mRegN_rule,
  /*  209 */  _CmpU_mRegI_mRegI_rule,
  /*  210 */  mRegP_rule,
  /*  211 */  _CmpF_regF_regF_rule,
  /*  212 */  mRegN_rule,
  /*  213 */  _CmpD_regD_regD_rule,
  /*  214 */  _CmpL_mRegLorI2L_mRegLorI2L_rule,
  /*  215 */  mRegIorL2I_rule,
  /*  216 */  _CmpUL_mRegLorI2L_mRegLorI2L_rule,
  /*  217 */  mRegL_rule,
  /*  218 */  mRegL_rule,
  /*  219 */  _CmpL_mRegL_mRegL_rule,
  /*  220 */  mRegL_rule,
  /*  221 */  _CmpUL_mRegL_mRegL_rule,
  /*  222 */  regD_rule,
  /*  223 */  regF_rule,
  /*  224 */  mA5RegI_rule,
  /*  225 */  mA7RegI_rule,
  /*  226 */  immI_1_4_rule,
  /*  227 */  immI_1_rule,
  /*  228 */  mA6RegI_rule,
  /*  229 */  a5_RegP_rule,
  /*  230 */  immI_1_4_rule,
  /*  231 */  immL_M8_rule,
  /*  232 */  immI_1_4_rule,
  /*  233 */  0,
  /*  234 */  0,
  /*  235 */  0,
  /*  236 */  0,
  /*  237 */  regF_rule,
  /*  238 */  _NegF_regF__rule,
  /*  239 */  regD_rule,
  /*  240 */  _NegD_regD__rule,
  /*  241 */  immD_0_rule,
  /*  242 */  immI_M1_rule,
  /*  243 */  immL_0_4095_rule,
  /*  244 */  0,
  /*  245 */  immI_16_rule,
  /*  246 */  immL_7_rule,
  /*  247 */  0,
  /*  248 */  immI_16_rule,
  /*  249 */  immI_24_rule,
  /*  250 */  0,
  /*  251 */  immI_32_63_rule,
  /*  252 */  immI_0_31_rule,
  /*  253 */  0,
  /*  254 */  immI_32_63_rule,
  /*  255 */  immI_0_31_rule,
  /*  256 */  immI_1_rule,
  /*  257 */  immI_0_31_rule,
  /*  258 */  immI_0_31_rule,
  /*  259 */  immI_32_63_rule,
  /*  260 */  immI_0_31_rule,
  /*  261 */  0,
  /*  262 */  immI_0_3_rule,
  /*  263 */  immL_MaxUI_rule,
  /*  264 */  immI_32_rule,
  /*  265 */  0,
  /*  266 */  0,
  /*  267 */  0,
  /*  268 */  0,
  /*  269 */  0,
  /*  270 */  0,
  /*  271 */  0,
  /*  272 */  vecX_rule,
  /*  273 */  vecX_rule,
  /*  274 */  vecY_rule,
  /*  275 */  vecY_rule,
  /*  276 */  vecX_rule,
  /*  277 */  vecX_rule,
  /*  278 */  vecX_rule,
  /*  279 */  vecX_rule,
  /*  280 */  vecX_rule,
  /*  281 */  vecY_rule,
  /*  282 */  vecY_rule,
  /*  283 */  vecY_rule,
  /*  284 */  vecY_rule,
  /*  285 */  vecY_rule,
  /*  286 */  0,
  /*  287 */  0,
  /*  288 */  0,
  /*  289 */  0,
  /*  290 */  vecX_rule,
  /*  291 */  _NegVF_vecX__rule,
  /*  292 */  vecX_rule,
  /*  293 */  _NegVD_vecX__rule,
  /*  294 */  vecY_rule,
  /*  295 */  _NegVF_vecY__rule,
  /*  296 */  vecY_rule,
  /*  297 */  _NegVD_vecY__rule,
  /*  298 */  0,
  /*  299 */  0,
  /*  300 */  0,
  /*  301 */  vecX_rule,
  /*  302 */  0,
  /*  303 */  0,
  /*  304 */  0,
  /*  305 */  _ReplicateB_immIU8__rule,
  /*  306 */  vecX_rule,
  /*  307 */  vecY_rule,
  /*  308 */  _ReplicateB_immIU8__rule,
  /*  309 */  vecY_rule,
  /*  310 */  _ReplicateB_immI_M1__rule,
  /*  311 */  vecX_rule,
  /*  312 */  _ReplicateS_immI_M1__rule,
  /*  313 */  vecX_rule,
  /*  314 */  _ReplicateI_immI_M1__rule,
  /*  315 */  vecX_rule,
  /*  316 */  _ReplicateB_immI_M1__rule,
  /*  317 */  vecY_rule,
  /*  318 */  _ReplicateS_immI_M1__rule,
  /*  319 */  vecY_rule,
  /*  320 */  _ReplicateI_immI_M1__rule,
  /*  321 */  vecY_rule,
  /*  322 */  mRegI_rule,
  /*  323 */  mRegL_rule,
  /*  324 */  regF_rule,
  /*  325 */  regD_rule,
  /*  326 */  mRegI_rule,
  /*  327 */  mRegL_rule,
  /*  328 */  regF_rule,
  /*  329 */  regD_rule,
  // last internally defined operand
  /*  330 */  0,
  /*  331 */  0,
  /*  332 */  0,
  /*  333 */  0,
  /*  334 */  0,
  /*  335 */  0,
  /*  336 */  0,
  /*  337 */  0,
  /*  338 */  0,
  /*  339 */  0,
  /*  340 */  0,
  /*  341 */  0,
  /*  342 */  0,
  /*  343 */  0,
  /*  344 */  0,
  /*  345 */  0,
  /*  346 */  0,
  /*  347 */  0,
  /*  348 */  0,
  /*  349 */  0,
  /*  350 */  0,
  /*  351 */  0,
  /*  352 */  0,
  /*  353 */  0,
  /*  354 */  0,
  /*  355 */  0,
  /*  356 */  0,
  /*  357 */  0,
  /*  358 */  0,
  /*  359 */  0,
  /*  360 */  0,
  /*  361 */  0,
  /*  362 */  0,
  /*  363 */  0,
  /*  364 */  0,
  /*  365 */  0,
  /*  366 */  0,
  /*  367 */  0,
  /*  368 */  0,
  /*  369 */  0,
  /*  370 */  0,
  /*  371 */  0,
  /*  372 */  0,
  /*  373 */  mRegP_rule,
  /*  374 */  mRegP_rule,
  /*  375 */  _Binary_mRegP_mRegP_rule,
  /*  376 */  _Binary_mRegI_mRegI_rule,
  /*  377 */  _Binary_mRegL_mRegL_rule,
  /*  378 */  0,
  /*  379 */  0,
  /*  380 */  0,
  /*  381 */  0,
  /*  382 */  0,
  /*  383 */  0,
  /*  384 */  0,
  /*  385 */  0,
  /*  386 */  0,
  /*  387 */  0,
  /*  388 */  0,
  /*  389 */  0,
  /*  390 */  0,
  /*  391 */  0,
  /*  392 */  0,
  /*  393 */  0,
  /*  394 */  0,
  /*  395 */  0,
  /*  396 */  0,
  /*  397 */  0,
  /*  398 */  0,
  /*  399 */  0,
  /*  400 */  0,
  /*  401 */  0,
  /*  402 */  0,
  /*  403 */  0,
  /*  404 */  0,
  /*  405 */  0,
  /*  406 */  0,
  /*  407 */  0,
  /*  408 */  0,
  /*  409 */  0,
  /*  410 */  0,
  /*  411 */  0,
  /*  412 */  0,
  /*  413 */  0,
  /*  414 */  0,
  /*  415 */  0,
  /*  416 */  0,
  /*  417 */  0,
  /*  418 */  0,
  /*  419 */  0,
  /*  420 */  0,
  /*  421 */  0,
  /*  422 */  0,
  /*  423 */  0,
  /*  424 */  0,
  /*  425 */  0,
  /*  426 */  0,
  /*  427 */  0,
  /*  428 */  0,
  /*  429 */  0,
  /*  430 */  0,
  /*  431 */  0,
  /*  432 */  0,
  /*  433 */  0,
  /*  434 */  0,
  /*  435 */  0,
  /*  436 */  immI_24_rule,
  /*  437 */  immI_255_rule,
  /*  438 */  immI_16_rule,
  /*  439 */  immI_65535_rule,
  /*  440 */  0,
  /*  441 */  0,
  /*  442 */  mRegL_rule,
  /*  443 */  mRegL_rule,
  /*  444 */  immL_0_rule,
  /*  445 */  immL_0_rule,
  /*  446 */  0,
  /*  447 */  0,
  /*  448 */  0,
  /*  449 */  0,
  /*  450 */  0,
  /*  451 */  0,
  /*  452 */  0,
  /*  453 */  mRegP_rule,
  /*  454 */  mRegP_rule,
  /*  455 */  immP_0_rule,
  /*  456 */  immP_0_rule,
  /*  457 */  mRegN_rule,
  /*  458 */  mRegN_rule,
  /*  459 */  _EncodeP_mRegP__rule,
  /*  460 */  _EncodeP_mRegP__rule,
  /*  461 */  mRegN_rule,
  /*  462 */  mRegN_rule,
  /*  463 */  _EncodePKlass_mRegP__rule,
  /*  464 */  _EncodePKlass_mRegP__rule,
  /*  465 */  immN_0_rule,
  /*  466 */  immN_0_rule,
  /*  467 */  immI_0_rule,
  /*  468 */  mRegIorL2I_rule,
  /*  469 */  0,
  /*  470 */  0,
  /*  471 */  0,
  /*  472 */  0,
  /*  473 */  0,
  /*  474 */  immI_24_rule,
  /*  475 */  0,
  /*  476 */  immI_0_rule,
  /*  477 */  immI_0_rule,
  /*  478 */  mRegIorL2I_rule,
  /*  479 */  mRegIorL2I_rule,
  /*  480 */  0,
  /*  481 */  mRegP_rule,
  /*  482 */  0,
  /*  483 */  0,
  /*  484 */  0,
  /*  485 */  _CmpI_mRegI_mRegI_rule,
  /*  486 */  _CmpI_mRegI_immI_rule,
  /*  487 */  FlagsReg_rule,
  /*  488 */  _CmpP_mRegP_immP_0_rule,
  /*  489 */  _CmpP__DecodeN_mRegN__immP_0_rule,
  /*  490 */  _CmpP_mRegP_mRegP_rule,
  /*  491 */  _CmpN_mRegN_immN_0_rule,
  /*  492 */  _CmpN_mRegN_mRegN_rule,
  /*  493 */  _CmpU_mRegI_mRegI_rule,
  /*  494 */  _CmpU_mRegI_immI_rule,
  /*  495 */  _CmpI_mRegI_mRegI_rule,
  /*  496 */  _CmpI_mRegI_immI_rule,
  /*  497 */  _CmpL_mRegLorI2L_mRegLorI2L_rule,
  /*  498 */  _CmpUL_mRegLorI2L_mRegLorI2L_rule,
  /*  499 */  _CmpL_mRegL_immL_rule,
  /*  500 */  _CmpUL_mRegL_immL_rule,
  /*  501 */  _CmpF_regF_regF_rule,
  /*  502 */  _CmpD_regD_regD_rule,
  /*  503 */  0,
  /*  504 */  _CmpI_mRegI_mRegI_rule,
  /*  505 */  _CmpI_mRegI_immI_rule,
  /*  506 */  FlagsReg_rule,
  /*  507 */  _CmpP_mRegP_immP_0_rule,
  /*  508 */  _CmpP__DecodeN_mRegN__immP_0_rule,
  /*  509 */  _CmpP_mRegP_mRegP_rule,
  /*  510 */  _CmpN_mRegN_immN_0_rule,
  /*  511 */  _CmpN_mRegN_mRegN_rule,
  /*  512 */  _CmpU_mRegI_mRegI_rule,
  /*  513 */  _CmpU_mRegI_immI_rule,
  /*  514 */  _CmpI_mRegI_mRegI_rule,
  /*  515 */  _CmpI_mRegI_immI_rule,
  /*  516 */  _CmpL_mRegLorI2L_mRegLorI2L_rule,
  /*  517 */  _CmpUL_mRegLorI2L_mRegLorI2L_rule,
  /*  518 */  _CmpL_mRegL_immL_rule,
  /*  519 */  _CmpUL_mRegL_immL_rule,
  /*  520 */  _CmpF_regF_regF_rule,
  /*  521 */  _CmpD_regD_regD_rule,
  /*  522 */  0,
  /*  523 */  0,
  /*  524 */  0,
  /*  525 */  0,
  /*  526 */  0,
  /*  527 */  0,
  /*  528 */  0,
  /*  529 */  0,
  /*  530 */  0,
  /*  531 */  0,
  /*  532 */  0,
  /*  533 */  0,
  /*  534 */  0,
  /*  535 */  _Binary_mRegI_mRegI_rule,
  /*  536 */  _Binary_mRegI_mRegI_rule,
  /*  537 */  _Binary_mRegI_mRegI_rule,
  /*  538 */  _Binary_mRegI_mRegI_rule,
  /*  539 */  _Binary_mRegI_mRegI_rule,
  /*  540 */  _Binary_mRegP_mRegP_rule,
  /*  541 */  _Binary_mRegP_mRegP_rule,
  /*  542 */  _Binary_mRegP_mRegP_rule,
  /*  543 */  _Binary_mRegN_mRegN_rule,
  /*  544 */  _Binary_mRegP_mRegP_rule,
  /*  545 */  _Binary_mRegN_mRegN_rule,
  /*  546 */  _Binary_mRegI_mRegI_rule,
  /*  547 */  _Binary_mRegI_mRegIorL2I_rule,
  /*  548 */  _Binary_mRegI_mRegIorL2I_rule,
  /*  549 */  _Binary_mRegP_mRegP_rule,
  /*  550 */  _Binary_mRegP_mRegP_rule,
  /*  551 */  _Binary_mRegI_mRegI_rule,
  /*  552 */  _Binary_mRegP_mRegP_rule,
  /*  553 */  _Binary_mRegP_mRegP_rule,
  /*  554 */  _Binary_mRegL_mRegL_rule,
  /*  555 */  _Binary_mRegN_mRegN_rule,
  /*  556 */  _Binary_mRegN_mRegN_rule,
  /*  557 */  _Binary_mRegN_mRegN_rule,
  /*  558 */  _Binary_mRegN_mRegN_rule,
  /*  559 */  _Binary_mRegL_mRegL_rule,
  /*  560 */  _Binary_mRegL_mRegL_rule,
  /*  561 */  _Binary_mRegL_mRegL_rule,
  /*  562 */  _Binary_mRegL_mRegL_rule,
  /*  563 */  _Binary_mRegL_mRegL_rule,
  /*  564 */  _Binary_mRegL_mRegL_rule,
  /*  565 */  _Binary_mRegL_mRegL_rule,
  /*  566 */  _Binary_mRegL_mRegL_rule,
  /*  567 */  _Binary_mRegL_mRegL_rule,
  /*  568 */  _Binary_mRegL_mRegL_rule,
  /*  569 */  _Binary_mRegL_mRegL_rule,
  /*  570 */  _Binary_regD_regD_rule,
  /*  571 */  _Binary_regF_regF_rule,
  /*  572 */  _Binary_regD_regD_rule,
  /*  573 */  _Binary_regD_regD_rule,
  /*  574 */  _Binary_mRegI_mRegI_rule,
  /*  575 */  _Binary_regF_regF_rule,
  /*  576 */  immL_0_rule,
  /*  577 */  mRegL_rule,
  /*  578 */  regF_rule,
  /*  579 */  regD_rule,
  /*  580 */  t3_RegP_rule,
  /*  581 */  t3_RegP_rule,
  /*  582 */  _Binary_a6_RegP_mA7RegI_rule,
  /*  583 */  _Binary_a6_RegP_mA7RegI_rule,
  /*  584 */  _Binary_a6_RegP_mA7RegI_rule,
  /*  585 */  _Binary_a6_RegP_mA7RegI_rule,
  /*  586 */  _Binary_a6_RegP_mA7RegI_rule,
  /*  587 */  _Binary_a6_RegP_mA7RegI_rule,
  /*  588 */  _Binary_a6_RegP_mA7RegI_rule,
  /*  589 */  _Binary_a6_RegP_immI_1_4_rule,
  /*  590 */  _Binary_a6_RegP_immI_1_4_rule,
  /*  591 */  _Binary_a6_RegP_immI_1_rule,
  /*  592 */  mA6RegI_rule,
  /*  593 */  mA6RegI_rule,
  /*  594 */  mA5RegI_rule,
  /*  595 */  _Binary_a5_RegP_mA6RegI_rule,
  /*  596 */  _Binary_a5_RegP_mA6RegI_rule,
  /*  597 */  mA6RegI_rule,
  /*  598 */  _Binary_a5_RegP_mA6RegI_rule,
  /*  599 */  _Binary_a5_RegP_mA6RegI_rule,
  /*  600 */  mRegIorL2I_rule,
  /*  601 */  immI12_rule,
  /*  602 */  _LShiftI_mRegI_immI_1_4_rule,
  /*  603 */  mRegI_rule,
  /*  604 */  mRegLorI2L_rule,
  /*  605 */  _AndL_mRegLorI2L_immL_M8_rule,
  /*  606 */  immL12_rule,
  /*  607 */  _LShiftL__ConvI2L_mRegI__immI_1_4_rule,
  /*  608 */  mRegLorI2L_rule,
  /*  609 */  immL12_rule,
  /*  610 */  0,
  /*  611 */  0,
  /*  612 */  mRegIorL2I_rule,
  /*  613 */  immI_M2047_2048_rule,
  /*  614 */  mRegIorL2I_rule,
  /*  615 */  mRegLorI2L_rule,
  /*  616 */  immL_M2047_2048_rule,
  /*  617 */  mRegLorI2L_rule,
  /*  618 */  mRegIorL2I_rule,
  /*  619 */  mRegLorI2L_rule,
  /*  620 */  mRegI_rule,
  /*  621 */  mRegI_rule,
  /*  622 */  regF_rule,
  /*  623 */  regD_rule,
  /*  624 */  mRegLorI2L_rule,
  /*  625 */  mRegL_rule,
  /*  626 */  mRegL_rule,
  /*  627 */  regF_rule,
  /*  628 */  regF_rule,
  /*  629 */  regD_rule,
  /*  630 */  regD_rule,
  /*  631 */  regF_rule,
  /*  632 */  regD_rule,
  /*  633 */  0,
  /*  634 */  0,
  /*  635 */  _Binary_regF_regF_rule,
  /*  636 */  _Binary_regD_regD_rule,
  /*  637 */  _Binary_regF_regF_rule,
  /*  638 */  _Binary_regD_regD_rule,
  /*  639 */  _Binary__NegF_regF__regF_rule,
  /*  640 */  _Binary_regF__NegF_regF__rule,
  /*  641 */  _Binary__NegD_regD__regD_rule,
  /*  642 */  _Binary_regD__NegD_regD__rule,
  /*  643 */  _Binary__NegF_regF__regF_rule,
  /*  644 */  _Binary_regF__NegF_regF__rule,
  /*  645 */  _Binary__NegD_regD__regD_rule,
  /*  646 */  _Binary_regD__NegD_regD__rule,
  /*  647 */  regF_rule,
  /*  648 */  _Binary_regD_immD_0_rule,
  /*  649 */  immI_0_4095_rule,
  /*  650 */  immI_nonneg_mask_rule,
  /*  651 */  immL_nonneg_mask_rule,
  /*  652 */  immI_0_4095_rule,
  /*  653 */  immI_M1_rule,
  /*  654 */  immL_0_4095_rule,
  /*  655 */  _LoadB_memory__rule,
  /*  656 */  immI_255_rule,
  /*  657 */  immI_255_rule,
  /*  658 */  mRegI_rule,
  /*  659 */  _XorI_mRegI_immI_M1_rule,
  /*  660 */  mRegI_rule,
  /*  661 */  _XorI_mRegI_immI_M1_rule,
  /*  662 */  mRegI_rule,
  /*  663 */  mRegI_rule,
  /*  664 */  _XorI_mRegI_immI_M1_rule,
  /*  665 */  mRegI_rule,
  /*  666 */  _XorI_mRegI_immI_M1_rule,
  /*  667 */  mRegLorI2L_rule,
  /*  668 */  immL_0_4095_rule,
  /*  669 */  0,
  /*  670 */  immL_M8_rule,
  /*  671 */  immL_M5_rule,
  /*  672 */  immL_M7_rule,
  /*  673 */  immL_M4_rule,
  /*  674 */  immL_M121_rule,
  /*  675 */  mRegLorI2L_rule,
  /*  676 */  mRegLorI2L_rule,
  /*  677 */  _CastP2X_mRegP__rule,
  /*  678 */  mRegL_rule,
  /*  679 */  immIU5_rule,
  /*  680 */  immI_M65536_rule,
  /*  681 */  immI_16_rule,
  /*  682 */  immI_16_rule,
  /*  683 */  immI_24_rule,
  /*  684 */  immIU5_rule,
  /*  685 */  mRegI_rule,
  /*  686 */  immIU6_rule,
  /*  687 */  mRegI_rule,
  /*  688 */  immIU6_rule,
  /*  689 */  0,
  /*  690 */  mRegI_rule,
  /*  691 */  mRegI_rule,
  /*  692 */  immI_0_31_rule,
  /*  693 */  immI_MaxI_rule,
  /*  694 */  immI_0_31_rule,
  /*  695 */  immI_32_63_rule,
  /*  696 */  0,
  /*  697 */  immI_32_63_rule,
  /*  698 */  mRegI_rule,
  /*  699 */  immI_0_4095_rule,
  /*  700 */  mRegI_rule,
  /*  701 */  _LShiftI__AndI_mRegI_immI_1_immI_0_31_rule,
  /*  702 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  703 */  _CastP2X_mRegP__rule,
  /*  704 */  mRegL_rule,
  /*  705 */  immIU5_rule,
  /*  706 */  immI_nonneg_mask_rule,
  /*  707 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  708 */  _LShiftI_mRegI_immI_0_31_rule,
  /*  709 */  _URShiftL_mRegLorI2L_immI_0_31_rule,
  /*  710 */  _LShiftL_mRegLorI2L_immI_32_63_rule,
  /*  711 */  _URShiftL_mRegLorI2L_immI_32_63_rule,
  /*  712 */  _LShiftL_mRegLorI2L_immI_0_31_rule,
  /*  713 */  _LShiftI_mRegI_immI_0_31_rule,
  /*  714 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  715 */  _LShiftL_mRegLorI2L_immI_32_63_rule,
  /*  716 */  _URShiftL_mRegLorI2L_immI_0_31_rule,
  /*  717 */  _LShiftL_mRegLorI2L_immI_0_31_rule,
  /*  718 */  _URShiftL_mRegLorI2L_immI_32_63_rule,
  /*  719 */  mRegI_rule,
  /*  720 */  mRegI_rule,
  /*  721 */  immI_rule,
  /*  722 */  mRegI_rule,
  /*  723 */  immI_rule,
  /*  724 */  mRegI_rule,
  /*  725 */  mRegI_rule,
  /*  726 */  immIU5_rule,
  /*  727 */  mRegI_rule,
  /*  728 */  0,
  /*  729 */  0,
  /*  730 */  0,
  /*  731 */  0,
  /*  732 */  0,
  /*  733 */  0,
  /*  734 */  0,
  /*  735 */  0,
  /*  736 */  0,
  /*  737 */  immI_rule,
  /*  738 */  immI_0_rule,
  /*  739 */  mRegI_rule,
  /*  740 */  0,
  /*  741 */  0,
  /*  742 */  0,
  /*  743 */  0,
  /*  744 */  0,
  /*  745 */  0,
  /*  746 */  0,
  /*  747 */  0,
  /*  748 */  0,
  /*  749 */  0,
  /*  750 */  0,
  /*  751 */  mRegP_rule,
  /*  752 */  0,
  /*  753 */  0,
  /*  754 */  0,
  /*  755 */  0,
  /*  756 */  0,
  /*  757 */  0,
  /*  758 */  0,
  /*  759 */  mRegIorL2I_rule,
  /*  760 */  immI_0_rule,
  /*  761 */  regF_rule,
  /*  762 */  immF_0_rule,
  /*  763 */  0,
  /*  764 */  0,
  /*  765 */  regD_rule,
  /*  766 */  immD_0_rule,
  /*  767 */  immI_0_rule,
  /*  768 */  0,
  /*  769 */  _LShiftL_mRegLorI2L_immI_0_3_rule,
  /*  770 */  no_T8_mRegP_rule,
  /*  771 */  0,
  /*  772 */  _Binary_mRegI_mRegI_rule,
  /*  773 */  _Binary_mRegL_mRegL_rule,
  /*  774 */  _Binary_mRegP_mRegP_rule,
  /*  775 */  _Binary_mRegN_mRegN_rule,
  /*  776 */  mRegI_rule,
  /*  777 */  mRegL_rule,
  /*  778 */  mRegN_rule,
  /*  779 */  mRegP_rule,
  /*  780 */  mRegL_rule,
  /*  781 */  mRegL_rule,
  /*  782 */  mRegIorL2I_rule,
  /*  783 */  mRegIorL2I_rule,
  /*  784 */  _Binary_mRegI_mRegI_rule,
  /*  785 */  _Binary_mRegL_mRegL_rule,
  /*  786 */  _Binary_mRegP_mRegP_rule,
  /*  787 */  _Binary_mRegN_mRegN_rule,
  /*  788 */  _Binary_mRegI_mRegI_rule,
  /*  789 */  _Binary_mRegL_mRegL_rule,
  /*  790 */  _Binary_mRegP_mRegP_rule,
  /*  791 */  _Binary_mRegP_mRegP_rule,
  /*  792 */  _Binary_mRegN_mRegN_rule,
  /*  793 */  mRegI_rule,
  /*  794 */  mRegI_rule,
  /*  795 */  immI_0_rule,
  /*  796 */  immL_MaxUI_rule,
  /*  797 */  _LShiftL__ConvI2L_mRegI__immI_32_rule,
  /*  798 */  _AndL__ConvI2L_mRegI__immL_MaxUI_rule,
  /*  799 */  immL_MaxUI_rule,
  /*  800 */  immL_MaxUI_rule,
  /*  801 */  immL_MaxUI_rule,
  /*  802 */  _ConvI2L__LoadI_memory___rule,
  /*  803 */  immL_MaxUI_rule,
  /*  804 */  0,
  /*  805 */  0,
  /*  806 */  0,
  /*  807 */  0,
  /*  808 */  0,
  /*  809 */  0,
  /*  810 */  0,
  /*  811 */  vecX_rule,
  /*  812 */  vecY_rule,
  /*  813 */  0,
  /*  814 */  0,
  /*  815 */  0,
  /*  816 */  0,
  /*  817 */  0,
  /*  818 */  0,
  /*  819 */  0,
  /*  820 */  0,
  /*  821 */  0,
  /*  822 */  0,
  /*  823 */  0,
  /*  824 */  0,
  /*  825 */  0,
  /*  826 */  0,
  /*  827 */  0,
  /*  828 */  0,
  /*  829 */  0,
  /*  830 */  0,
  /*  831 */  0,
  /*  832 */  0,
  /*  833 */  vecX_rule,
  /*  834 */  _ReplicateB_immIU5__rule,
  /*  835 */  vecX_rule,
  /*  836 */  vecX_rule,
  /*  837 */  _ReplicateS_immIU5__rule,
  /*  838 */  vecX_rule,
  /*  839 */  vecX_rule,
  /*  840 */  _ReplicateI_immIU5__rule,
  /*  841 */  vecX_rule,
  /*  842 */  vecX_rule,
  /*  843 */  _ReplicateL_immLU5__rule,
  /*  844 */  vecX_rule,
  /*  845 */  vecX_rule,
  /*  846 */  vecX_rule,
  /*  847 */  vecY_rule,
  /*  848 */  _ReplicateB_immIU5__rule,
  /*  849 */  vecY_rule,
  /*  850 */  vecY_rule,
  /*  851 */  _ReplicateS_immIU5__rule,
  /*  852 */  vecY_rule,
  /*  853 */  vecY_rule,
  /*  854 */  _ReplicateI_immIU5__rule,
  /*  855 */  vecY_rule,
  /*  856 */  vecY_rule,
  /*  857 */  _ReplicateL_immLU5__rule,
  /*  858 */  vecY_rule,
  /*  859 */  vecY_rule,
  /*  860 */  vecY_rule,
  /*  861 */  vecX_rule,
  /*  862 */  _ReplicateB_immIU5__rule,
  /*  863 */  vecX_rule,
  /*  864 */  _ReplicateS_immIU5__rule,
  /*  865 */  vecX_rule,
  /*  866 */  _ReplicateI_immIU5__rule,
  /*  867 */  vecX_rule,
  /*  868 */  _ReplicateL_immLU5__rule,
  /*  869 */  vecX_rule,
  /*  870 */  vecX_rule,
  /*  871 */  vecY_rule,
  /*  872 */  _ReplicateB_immIU5__rule,
  /*  873 */  vecY_rule,
  /*  874 */  _ReplicateS_immIU5__rule,
  /*  875 */  vecY_rule,
  /*  876 */  _ReplicateI_immIU5__rule,
  /*  877 */  vecY_rule,
  /*  878 */  _ReplicateL_immLU5__rule,
  /*  879 */  vecY_rule,
  /*  880 */  vecY_rule,
  /*  881 */  vecX_rule,
  /*  882 */  vecX_rule,
  /*  883 */  vecX_rule,
  /*  884 */  vecX_rule,
  /*  885 */  vecX_rule,
  /*  886 */  vecX_rule,
  /*  887 */  vecY_rule,
  /*  888 */  vecY_rule,
  /*  889 */  vecY_rule,
  /*  890 */  vecY_rule,
  /*  891 */  vecY_rule,
  /*  892 */  vecY_rule,
  /*  893 */  vecX_rule,
  /*  894 */  vecX_rule,
  /*  895 */  vecY_rule,
  /*  896 */  vecY_rule,
  /*  897 */  0,
  /*  898 */  0,
  /*  899 */  0,
  /*  900 */  0,
  /*  901 */  0,
  /*  902 */  0,
  /*  903 */  0,
  /*  904 */  0,
  /*  905 */  0,
  /*  906 */  0,
  /*  907 */  0,
  /*  908 */  0,
  /*  909 */  vecX_rule,
  /*  910 */  vecX_rule,
  /*  911 */  vecX_rule,
  /*  912 */  vecX_rule,
  /*  913 */  vecX_rule,
  /*  914 */  vecX_rule,
  /*  915 */  vecY_rule,
  /*  916 */  vecY_rule,
  /*  917 */  vecY_rule,
  /*  918 */  vecY_rule,
  /*  919 */  vecY_rule,
  /*  920 */  vecY_rule,
  /*  921 */  vecX_rule,
  /*  922 */  vecX_rule,
  /*  923 */  vecX_rule,
  /*  924 */  vecX_rule,
  /*  925 */  vecX_rule,
  /*  926 */  vecX_rule,
  /*  927 */  vecY_rule,
  /*  928 */  vecY_rule,
  /*  929 */  vecY_rule,
  /*  930 */  vecY_rule,
  /*  931 */  vecY_rule,
  /*  932 */  vecY_rule,
  /*  933 */  _MulVB_vecX_vecX_rule,
  /*  934 */  vecX_rule,
  /*  935 */  _MulVS_vecX_vecX_rule,
  /*  936 */  vecX_rule,
  /*  937 */  _MulVI_vecX_vecX_rule,
  /*  938 */  vecX_rule,
  /*  939 */  _MulVL_vecX_vecX_rule,
  /*  940 */  vecX_rule,
  /*  941 */  _Binary_vecX_vecX_rule,
  /*  942 */  _Binary_vecX_vecX_rule,
  /*  943 */  _MulVB_vecY_vecY_rule,
  /*  944 */  vecY_rule,
  /*  945 */  _MulVS_vecY_vecY_rule,
  /*  946 */  vecY_rule,
  /*  947 */  _MulVI_vecY_vecY_rule,
  /*  948 */  vecY_rule,
  /*  949 */  _MulVL_vecY_vecY_rule,
  /*  950 */  vecY_rule,
  /*  951 */  _Binary_vecY_vecY_rule,
  /*  952 */  _Binary_vecY_vecY_rule,
  /*  953 */  _MulVB_vecX_vecX_rule,
  /*  954 */  _MulVS_vecX_vecX_rule,
  /*  955 */  _MulVI_vecX_vecX_rule,
  /*  956 */  _MulVL_vecX_vecX_rule,
  /*  957 */  _Binary_vecX_vecX_rule,
  /*  958 */  _Binary_vecX_vecX_rule,
  /*  959 */  _MulVB_vecY_vecY_rule,
  /*  960 */  _MulVS_vecY_vecY_rule,
  /*  961 */  _MulVI_vecY_vecY_rule,
  /*  962 */  _MulVL_vecY_vecY_rule,
  /*  963 */  _Binary_vecY_vecY_rule,
  /*  964 */  _Binary_vecY_vecY_rule,
  /*  965 */  _Binary__NegVF_vecX__vecX_rule,
  /*  966 */  _Binary_vecX__NegVF_vecX__rule,
  /*  967 */  _Binary__NegVD_vecX__vecX_rule,
  /*  968 */  _Binary_vecX__NegVD_vecX__rule,
  /*  969 */  _Binary__NegVF_vecY__vecY_rule,
  /*  970 */  _Binary_vecY__NegVF_vecY__rule,
  /*  971 */  _Binary__NegVD_vecY__vecY_rule,
  /*  972 */  _Binary_vecY__NegVD_vecY__rule,
  /*  973 */  _Binary__NegVF_vecX__vecX_rule,
  /*  974 */  _Binary_vecX__NegVF_vecX__rule,
  /*  975 */  _Binary__NegVD_vecX__vecX_rule,
  /*  976 */  _Binary_vecX__NegVD_vecX__rule,
  /*  977 */  _Binary__NegVF_vecY__vecY_rule,
  /*  978 */  _Binary_vecY__NegVF_vecY__rule,
  /*  979 */  _Binary__NegVD_vecY__vecY_rule,
  /*  980 */  _Binary_vecY__NegVD_vecY__rule,
  /*  981 */  vecX_rule,
  /*  982 */  vecY_rule,
  /*  983 */  vecX_rule,
  /*  984 */  _LShiftCntV_immI__rule,
  /*  985 */  vecX_rule,
  /*  986 */  _LShiftCntV_immI__rule,
  /*  987 */  vecX_rule,
  /*  988 */  _LShiftCntV_immI__rule,
  /*  989 */  vecX_rule,
  /*  990 */  _LShiftCntV_immI__rule,
  /*  991 */  vecY_rule,
  /*  992 */  _LShiftCntV_immI__rule,
  /*  993 */  vecY_rule,
  /*  994 */  _LShiftCntV_immI__rule,
  /*  995 */  vecY_rule,
  /*  996 */  _LShiftCntV_immI__rule,
  /*  997 */  vecY_rule,
  /*  998 */  _LShiftCntV_immI__rule,
  /*  999 */  vecX_rule,
  /* 1000 */  _RShiftCntV_immI__rule,
  /* 1001 */  vecX_rule,
  /* 1002 */  _RShiftCntV_immI__rule,
  /* 1003 */  vecX_rule,
  /* 1004 */  _RShiftCntV_immI__rule,
  /* 1005 */  vecX_rule,
  /* 1006 */  _RShiftCntV_immI__rule,
  /* 1007 */  vecY_rule,
  /* 1008 */  _RShiftCntV_immI__rule,
  /* 1009 */  vecY_rule,
  /* 1010 */  _RShiftCntV_immI__rule,
  /* 1011 */  vecY_rule,
  /* 1012 */  _RShiftCntV_immI__rule,
  /* 1013 */  vecY_rule,
  /* 1014 */  _RShiftCntV_immI__rule,
  /* 1015 */  vecX_rule,
  /* 1016 */  _RShiftCntV_immI__rule,
  /* 1017 */  vecX_rule,
  /* 1018 */  _RShiftCntV_immI__rule,
  /* 1019 */  vecX_rule,
  /* 1020 */  _RShiftCntV_immI__rule,
  /* 1021 */  vecX_rule,
  /* 1022 */  _RShiftCntV_immI__rule,
  /* 1023 */  vecY_rule,
  /* 1024 */  _RShiftCntV_immI__rule,
  /* 1025 */  vecY_rule,
  /* 1026 */  _RShiftCntV_immI__rule,
  /* 1027 */  vecY_rule,
  /* 1028 */  _RShiftCntV_immI__rule,
  /* 1029 */  vecY_rule,
  /* 1030 */  _RShiftCntV_immI__rule,
  /* 1031 */  vecX_rule,
  /* 1032 */  immI_rule,
  /* 1033 */  vecX_rule,
  /* 1034 */  immI_rule,
  /* 1035 */  vecY_rule,
  /* 1036 */  immI_rule,
  /* 1037 */  vecY_rule,
  /* 1038 */  immI_rule,
  /* 1039 */  vecX_rule,
  /* 1040 */  immI_rule,
  /* 1041 */  vecX_rule,
  /* 1042 */  immI_rule,
  /* 1043 */  vecY_rule,
  /* 1044 */  immI_rule,
  /* 1045 */  vecY_rule,
  /* 1046 */  immI_rule,
  /* 1047 */  vecX_rule,
  /* 1048 */  _ReplicateB_immIU8__rule,
  /* 1049 */  vecX_rule,
  /* 1050 */  vecY_rule,
  /* 1051 */  _ReplicateB_immIU8__rule,
  /* 1052 */  vecY_rule,
  /* 1053 */  vecX_rule,
  /* 1054 */  _ReplicateB_immIU8__rule,
  /* 1055 */  vecX_rule,
  /* 1056 */  vecY_rule,
  /* 1057 */  _ReplicateB_immIU8__rule,
  /* 1058 */  vecY_rule,
  /* 1059 */  vecX_rule,
  /* 1060 */  _ReplicateB_immIU8__rule,
  /* 1061 */  vecX_rule,
  /* 1062 */  vecY_rule,
  /* 1063 */  _ReplicateB_immIU8__rule,
  /* 1064 */  vecX_rule,
  /* 1065 */  _ReplicateB_immI_M1__rule,
  /* 1066 */  _OrV_vecX_vecX_rule,
  /* 1067 */  _ReplicateS_immI_M1__rule,
  /* 1068 */  _OrV_vecX_vecX_rule,
  /* 1069 */  _ReplicateI_immI_M1__rule,
  /* 1070 */  _OrV_vecX_vecX_rule,
  /* 1071 */  _ReplicateB_immI_M1__rule,
  /* 1072 */  _OrV_vecX__ReplicateB_immIU8__rule,
  /* 1073 */  _ReplicateB_immI_M1__rule,
  /* 1074 */  _OrV__ReplicateB_immIU8__vecX_rule,
  /* 1075 */  _ReplicateB_immI_M1__rule,
  /* 1076 */  _OrV_vecY_vecY_rule,
  /* 1077 */  _ReplicateS_immI_M1__rule,
  /* 1078 */  _OrV_vecY_vecY_rule,
  /* 1079 */  _ReplicateI_immI_M1__rule,
  /* 1080 */  _OrV_vecY_vecY_rule,
  /* 1081 */  _ReplicateB_immI_M1__rule,
  /* 1082 */  _OrV_vecY__ReplicateB_immIU8__rule,
  /* 1083 */  _ReplicateB_immI_M1__rule,
  /* 1084 */  _OrV__ReplicateB_immIU8__vecY_rule,
  /* 1085 */  _XorV_vecX__ReplicateB_immI_M1__rule,
  /* 1086 */  vecX_rule,
  /* 1087 */  _XorV__ReplicateB_immI_M1__vecX_rule,
  /* 1088 */  vecX_rule,
  /* 1089 */  _XorV_vecX__ReplicateS_immI_M1__rule,
  /* 1090 */  vecX_rule,
  /* 1091 */  _XorV__ReplicateS_immI_M1__vecX_rule,
  /* 1092 */  vecX_rule,
  /* 1093 */  _XorV_vecX__ReplicateI_immI_M1__rule,
  /* 1094 */  vecX_rule,
  /* 1095 */  _XorV__ReplicateI_immI_M1__vecX_rule,
  /* 1096 */  vecX_rule,
  /* 1097 */  _XorV_vecY__ReplicateB_immI_M1__rule,
  /* 1098 */  vecY_rule,
  /* 1099 */  _XorV__ReplicateB_immI_M1__vecY_rule,
  /* 1100 */  vecY_rule,
  /* 1101 */  _XorV_vecY__ReplicateS_immI_M1__rule,
  /* 1102 */  vecY_rule,
  /* 1103 */  _XorV__ReplicateS_immI_M1__vecY_rule,
  /* 1104 */  vecY_rule,
  /* 1105 */  _XorV_vecY__ReplicateI_immI_M1__rule,
  /* 1106 */  vecY_rule,
  /* 1107 */  _XorV__ReplicateI_immI_M1__vecY_rule,
  /* 1108 */  vecY_rule,
  /* 1109 */  _XorV_vecX__ReplicateB_immI_M1__rule,
  /* 1110 */  vecX_rule,
  /* 1111 */  _XorV__ReplicateB_immI_M1__vecX_rule,
  /* 1112 */  vecX_rule,
  /* 1113 */  _XorV_vecX__ReplicateS_immI_M1__rule,
  /* 1114 */  vecX_rule,
  /* 1115 */  _XorV__ReplicateS_immI_M1__vecX_rule,
  /* 1116 */  vecX_rule,
  /* 1117 */  _XorV_vecX__ReplicateI_immI_M1__rule,
  /* 1118 */  vecX_rule,
  /* 1119 */  _XorV__ReplicateI_immI_M1__vecX_rule,
  /* 1120 */  vecX_rule,
  /* 1121 */  _XorV_vecY__ReplicateB_immI_M1__rule,
  /* 1122 */  vecY_rule,
  /* 1123 */  _XorV__ReplicateB_immI_M1__vecY_rule,
  /* 1124 */  vecY_rule,
  /* 1125 */  _XorV_vecY__ReplicateS_immI_M1__rule,
  /* 1126 */  vecY_rule,
  /* 1127 */  _XorV__ReplicateS_immI_M1__vecY_rule,
  /* 1128 */  vecY_rule,
  /* 1129 */  _XorV_vecY__ReplicateI_immI_M1__rule,
  /* 1130 */  vecY_rule,
  /* 1131 */  _XorV__ReplicateI_immI_M1__vecY_rule,
  /* 1132 */  vecY_rule,
  /* 1133 */  vecX_rule,
  /* 1134 */  vecX_rule,
  /* 1135 */  vecX_rule,
  /* 1136 */  vecX_rule,
  /* 1137 */  vecX_rule,
  /* 1138 */  vecX_rule,
  /* 1139 */  vecY_rule,
  /* 1140 */  vecY_rule,
  /* 1141 */  vecY_rule,
  /* 1142 */  vecY_rule,
  /* 1143 */  vecY_rule,
  /* 1144 */  vecY_rule,
  /* 1145 */  vecX_rule,
  /* 1146 */  vecX_rule,
  /* 1147 */  vecX_rule,
  /* 1148 */  vecX_rule,
  /* 1149 */  vecX_rule,
  /* 1150 */  vecX_rule,
  /* 1151 */  vecY_rule,
  /* 1152 */  vecY_rule,
  /* 1153 */  vecY_rule,
  /* 1154 */  vecY_rule,
  /* 1155 */  vecY_rule,
  /* 1156 */  vecY_rule,
  /* 1157 */  vecX_rule,
  /* 1158 */  vecX_rule,
  /* 1159 */  vecX_rule,
  /* 1160 */  vecX_rule,
  /* 1161 */  vecY_rule,
  /* 1162 */  vecY_rule,
  /* 1163 */  vecY_rule,
  /* 1164 */  vecY_rule,
  /* 1165 */  vecX_rule,
  /* 1166 */  vecX_rule,
  /* 1167 */  vecX_rule,
  /* 1168 */  vecX_rule,
  /* 1169 */  vecY_rule,
  /* 1170 */  vecY_rule,
  /* 1171 */  vecY_rule,
  /* 1172 */  vecY_rule,
  /* 1173 */  vecX_rule,
  /* 1174 */  vecX_rule,
  /* 1175 */  vecX_rule,
  /* 1176 */  vecX_rule,
  /* 1177 */  vecY_rule,
  /* 1178 */  vecY_rule,
  /* 1179 */  vecY_rule,
  /* 1180 */  vecY_rule,
  /* 1181 */  vecX_rule,
  /* 1182 */  vecX_rule,
  /* 1183 */  vecX_rule,
  /* 1184 */  vecX_rule,
  /* 1185 */  vecY_rule,
  /* 1186 */  vecY_rule,
  /* 1187 */  vecY_rule,
  /* 1188 */  vecY_rule,
  /* 1189 */  vecX_rule,
  /* 1190 */  vecX_rule,
  /* 1191 */  vecX_rule,
  /* 1192 */  vecX_rule,
  /* 1193 */  vecY_rule,
  /* 1194 */  vecY_rule,
  /* 1195 */  vecY_rule,
  /* 1196 */  vecY_rule,
  /* 1197 */  immI_rule,
  /* 1198 */  immI_rule,
  /* 1199 */  0,
  /* 1200 */  0,
  /* 1201 */  0,
  /* 1202 */  0,
  /* 1203 */  0,
  /* 1204 */  0,
  /* 1205 */  0,
  /* 1206 */  0,
  /* 1207 */  immIU4_rule,
  /* 1208 */  immIU3_rule,
  /* 1209 */  immIU2_rule,
  /* 1210 */  immIU1_rule,
  /* 1211 */  immIU2_rule,
  /* 1212 */  immIU1_rule,
  /* 1213 */  immIU5_rule,
  /* 1214 */  immIU4_rule,
  /* 1215 */  immIU3_rule,
  /* 1216 */  immIU2_rule,
  /* 1217 */  immIU3_rule,
  /* 1218 */  immIU2_rule,
  /* 1219 */  vecX_rule,
  /* 1220 */  vecY_rule,
  /* 1221 */  immI_1_rule,
  /* 1222 */  immI_1_rule,
  /* 1223 */  immI_2_rule,
  /* 1224 */  vecX_rule,
  /* 1225 */  vecX_rule,
  /* 1226 */  vecY_rule,
  /* 1227 */  vecY_rule,
  /* 1228 */  immI_rule,
  /* 1229 */  immI_rule,
  /* 1230 */  vecX_rule,
  /* 1231 */  vecY_rule,
  /* 1232 */  vecY_rule,
  /* 1233 */  _Binary_mRegP_mRegP_rule,
  /* 1234 */  _Binary_mRegN_mRegN_rule,
  /* 1235 */  _Binary_mRegP_mRegP_rule,
  /* 1236 */  _Binary_mRegN_mRegN_rule,
  /* 1237 */  _Binary_mRegN_mRegN_rule,
  /* 1238 */  _Binary_mRegP_mRegP_rule,
  /* 1239 */  _Binary_mRegN_mRegN_rule,
  /* 1240 */  _Binary_mRegP_mRegP_rule,
  /* 1241 */  _Binary_mRegN_mRegN_rule,
  /* 1242 */  _Binary_mRegP_mRegP_rule,
  /* 1243 */  _Binary_mRegN_mRegN_rule,
  /* 1244 */  _Binary_mRegP_mRegP_rule,
  /* 1245 */  0,
  /* 1246 */  _Binary_mRegP_mRegP_rule,
  /* 1247 */  _Binary_mRegP_mRegP_rule,
  /* 1248 */  _Binary_mRegP_mRegP_rule,
  /* 1249 */  _Binary_mRegP_mRegP_rule,
  /* 1250 */  _Binary_mRegP_mRegP_rule,
  /* 1251 */  _Binary_mRegP_mRegP_rule,
  /* 1252 */  mRegP_rule,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "VECX",
  /*    9 */  "VECY",
  /*   10 */  "FLAGSREG",
  /*   11 */  "IMMI",
  /*   12 */  "IMMIU1",
  /*   13 */  "IMMIU2",
  /*   14 */  "IMMIU3",
  /*   15 */  "IMMIU4",
  /*   16 */  "IMMIU5",
  /*   17 */  "IMMIU6",
  /*   18 */  "IMMIU8",
  /*   19 */  "IMMI10",
  /*   20 */  "IMMI12",
  /*   21 */  "IMMI_M65536",
  /*   22 */  "IMMI_M1",
  /*   23 */  "IMMI_0",
  /*   24 */  "IMMI_1",
  /*   25 */  "IMMI_2",
  /*   26 */  "IMMI_16",
  /*   27 */  "IMMI_24",
  /*   28 */  "IMMI_32",
  /*   29 */  "IMMI_255",
  /*   30 */  "IMMI_65535",
  /*   31 */  "IMMI_MAXI",
  /*   32 */  "IMMI_M2047_2048",
  /*   33 */  "IMMI_0_3",
  /*   34 */  "IMMI_0_31",
  /*   35 */  "IMMI_0_4095",
  /*   36 */  "IMMI_1_4",
  /*   37 */  "IMMI_32_63",
  /*   38 */  "IMMI_M128_255",
  /*   39 */  "IMMI_NONNEG_MASK",
  /*   40 */  "IMML",
  /*   41 */  "IMMLU5",
  /*   42 */  "IMML10",
  /*   43 */  "IMML12",
  /*   44 */  "IMML32",
  /*   45 */  "IMML_M121",
  /*   46 */  "IMML_M8",
  /*   47 */  "IMML_M7",
  /*   48 */  "IMML_M5",
  /*   49 */  "IMML_M4",
  /*   50 */  "IMML_0",
  /*   51 */  "IMML_7",
  /*   52 */  "IMML_MAXUI",
  /*   53 */  "IMML_M2047_2048",
  /*   54 */  "IMML_0_4095",
  /*   55 */  "IMML_NONNEG_MASK",
  /*   56 */  "IMMP",
  /*   57 */  "IMMP_0",
  /*   58 */  "IMMP_NO_OOP_CHEAP",
  /*   59 */  "IMMN",
  /*   60 */  "IMMN_0",
  /*   61 */  "IMMNKLASS",
  /*   62 */  "IMMF",
  /*   63 */  "IMMF_0",
  /*   64 */  "IMMD",
  /*   65 */  "IMMD_0",
  /*   66 */  "MREGI",
  /*   67 */  "NO_AX_MREGI",
  /*   68 */  "MS0REGI",
  /*   69 */  "MS1REGI",
  /*   70 */  "MS3REGI",
  /*   71 */  "MS4REGI",
  /*   72 */  "MS5REGI",
  /*   73 */  "MS6REGI",
  /*   74 */  "MS7REGI",
  /*   75 */  "MT0REGI",
  /*   76 */  "MT1REGI",
  /*   77 */  "MT2REGI",
  /*   78 */  "MT3REGI",
  /*   79 */  "MT8REGI",
  /*   80 */  "MT4REGI",
  /*   81 */  "MA0REGI",
  /*   82 */  "MA1REGI",
  /*   83 */  "MA2REGI",
  /*   84 */  "MA3REGI",
  /*   85 */  "MA4REGI",
  /*   86 */  "MA5REGI",
  /*   87 */  "MA6REGI",
  /*   88 */  "MA7REGI",
  /*   89 */  "MREGN",
  /*   90 */  "T0_REGN",
  /*   91 */  "T1_REGN",
  /*   92 */  "T3_REGN",
  /*   93 */  "T8_REGN",
  /*   94 */  "A0_REGN",
  /*   95 */  "A1_REGN",
  /*   96 */  "A2_REGN",
  /*   97 */  "A3_REGN",
  /*   98 */  "A4_REGN",
  /*   99 */  "A5_REGN",
  /*  100 */  "A6_REGN",
  /*  101 */  "A7_REGN",
  /*  102 */  "S0_REGN",
  /*  103 */  "S1_REGN",
  /*  104 */  "S2_REGN",
  /*  105 */  "S3_REGN",
  /*  106 */  "S4_REGN",
  /*  107 */  "S5_REGN",
  /*  108 */  "S6_REGN",
  /*  109 */  "S7_REGN",
  /*  110 */  "MREGP",
  /*  111 */  "NO_T8_MREGP",
  /*  112 */  "NO_AX_MREGP",
  /*  113 */  "S1_REGP",
  /*  114 */  "S3_REGP",
  /*  115 */  "S4_REGP",
  /*  116 */  "S5_REGP",
  /*  117 */  "S6_REGP",
  /*  118 */  "S7_REGP",
  /*  119 */  "T0_REGP",
  /*  120 */  "T1_REGP",
  /*  121 */  "T2_REGP",
  /*  122 */  "T3_REGP",
  /*  123 */  "T8_REGP",
  /*  124 */  "A0_REGP",
  /*  125 */  "A1_REGP",
  /*  126 */  "A2_REGP",
  /*  127 */  "A3_REGP",
  /*  128 */  "A4_REGP",
  /*  129 */  "A5_REGP",
  /*  130 */  "A6_REGP",
  /*  131 */  "A7_REGP",
  /*  132 */  "V0_REGP",
  /*  133 */  "V1_REGP",
  /*  134 */  "MREGL",
  /*  135 */  "MREGI2L",
  /*  136 */  "MREGL2I",
  /*  137 */  "V0REGL",
  /*  138 */  "V1REGL",
  /*  139 */  "A0REGL",
  /*  140 */  "A1REGL",
  /*  141 */  "A2REGL",
  /*  142 */  "A3REGL",
  /*  143 */  "T0REGL",
  /*  144 */  "T1REGL",
  /*  145 */  "T3REGL",
  /*  146 */  "T8REGL",
  /*  147 */  "A4REGL",
  /*  148 */  "A5REGL",
  /*  149 */  "A6REGL",
  /*  150 */  "A7REGL",
  /*  151 */  "S0REGL",
  /*  152 */  "S1REGL",
  /*  153 */  "S3REGL",
  /*  154 */  "S4REGL",
  /*  155 */  "S7REGL",
  /*  156 */  "REGF",
  /*  157 */  "REGD",
  /*  158 */  "INDIRECT",
  /*  159 */  "INDOFFSET12",
  /*  160 */  "INDOFFSET12I2L",
  /*  161 */  "INDINDEX",
  /*  162 */  "INDINDEXI2L",
  /*  163 */  "INDIRECTNARROW",
  /*  164 */  "INDOFFSET12NARROW",
  /*  165 */  "CMPOP",
  /*  166 */  "CMPOPEQNE",
  /*  167 */  "STACKSLOTP",
  /*  168 */  "STACKSLOTI",
  /*  169 */  "STACKSLOTF",
  /*  170 */  "STACKSLOTD",
  /*  171 */  "STACKSLOTL",
  // last operand
  /*  172 */  "MEMORY",
  /*  173 */  "MEMORY_LOADRANGE",
  /*  174 */  "MREGLORI2L",
  /*  175 */  "MREGIORL2I",
  // last operand class
  /*  176 */  "_ConvI2L_immI12_",
  /*  177 */  "_ConvI2L_mRegI_",
  /*  178 */  "_DecodeN_mRegN_",
  /*  179 */  "_LoadI_memory_",
  /*  180 */  "_LShiftI__LoadI_memory__immI_24",
  /*  181 */  "_LShiftI__LoadI_memory__immI_16",
  /*  182 */  "_LoadN_memory_",
  /*  183 */  "_LoadNKlass_memory_",
  /*  184 */  "_EncodeP_mRegP_",
  /*  185 */  "_EncodePKlass_mRegP_",
  /*  186 */  "_LoadB_memory_",
  /*  187 */  "_LoadUB_memory_",
  /*  188 */  "_LoadS_memory_",
  /*  189 */  "_LShiftI__LoadS_memory__immI_24",
  /*  190 */  "_CmpI_mRegI_mRegI",
  /*  191 */  "_CmpI_mRegI_immI",
  /*  192 */  "_CmpP_mRegP_immP_0",
  /*  193 */  "_CmpP__DecodeN_mRegN__immP_0",
  /*  194 */  "_CmpP_mRegP_mRegP",
  /*  195 */  "_CmpN_mRegN_immN_0",
  /*  196 */  "_CmpN_mRegN_mRegN",
  /*  197 */  "_CmpU_mRegI_mRegI",
  /*  198 */  "_CmpU_mRegI_immI",
  /*  199 */  "_CmpL_mRegLorI2L_mRegLorI2L",
  /*  200 */  "_CmpUL_mRegLorI2L_mRegLorI2L",
  /*  201 */  "_CmpL_mRegL_immL",
  /*  202 */  "_CmpUL_mRegL_immL",
  /*  203 */  "_CmpF_regF_regF",
  /*  204 */  "_CmpD_regD_regD",
  /*  205 */  "_Binary_cmpOp__CmpI_mRegI_mRegI",
  /*  206 */  "_Binary_mRegI_mRegI",
  /*  207 */  "_Binary_cmpOp__CmpP_mRegP_mRegP",
  /*  208 */  "_Binary_cmpOp__CmpN_mRegN_mRegN",
  /*  209 */  "_Binary_cmpOp__CmpU_mRegI_mRegI",
  /*  210 */  "_Binary_mRegP_mRegP",
  /*  211 */  "_Binary_cmpOp__CmpF_regF_regF",
  /*  212 */  "_Binary_mRegN_mRegN",
  /*  213 */  "_Binary_cmpOp__CmpD_regD_regD",
  /*  214 */  "_Binary_cmpOp__CmpL_mRegLorI2L_mRegLorI2L",
  /*  215 */  "_Binary_mRegI_mRegIorL2I",
  /*  216 */  "_Binary_cmpOp__CmpUL_mRegLorI2L_mRegLorI2L",
  /*  217 */  "_Binary_mRegL_mRegL",
  /*  218 */  "_CmpL_mRegL_mRegL",
  /*  219 */  "_Binary_cmpOp__CmpL_mRegL_mRegL",
  /*  220 */  "_CmpUL_mRegL_mRegL",
  /*  221 */  "_Binary_cmpOp__CmpUL_mRegL_mRegL",
  /*  222 */  "_Binary_regD_regD",
  /*  223 */  "_Binary_regF_regF",
  /*  224 */  "_Binary_a4_RegP_mA5RegI",
  /*  225 */  "_Binary_a6_RegP_mA7RegI",
  /*  226 */  "_Binary_a6_RegP_immI_1_4",
  /*  227 */  "_Binary_a6_RegP_immI_1",
  /*  228 */  "_Binary_a5_RegP_mA6RegI",
  /*  229 */  "_Binary_a4_RegP_a5_RegP",
  /*  230 */  "_LShiftI_mRegI_immI_1_4",
  /*  231 */  "_AndL_mRegLorI2L_immL_M8",
  /*  232 */  "_LShiftL__ConvI2L_mRegI__immI_1_4",
  /*  233 */  "_ConvF2D_regF_",
  /*  234 */  "_SqrtD__ConvF2D_regF__",
  /*  235 */  "_NegF_regF_",
  /*  236 */  "_NegD_regD_",
  /*  237 */  "_Binary__NegF_regF__regF",
  /*  238 */  "_Binary_regF__NegF_regF_",
  /*  239 */  "_Binary__NegD_regD__regD",
  /*  240 */  "_Binary_regD__NegD_regD_",
  /*  241 */  "_Binary_regD_immD_0",
  /*  242 */  "_XorI_mRegI_immI_M1",
  /*  243 */  "_AndL_mRegL_immL_0_4095",
  /*  244 */  "_CastP2X_mRegP_",
  /*  245 */  "_LShiftI_mRegI_immI_16",
  /*  246 */  "_AndL_mRegL_immL_7",
  /*  247 */  "_ConvL2I__AndL_mRegL_immL_7_",
  /*  248 */  "_LShiftI__ConvL2I__AndL_mRegL_immL_7__immI_16",
  /*  249 */  "_LShiftI_mRegI_immI_24",
  /*  250 */  "_ConvL2I_mRegL_",
  /*  251 */  "_RShiftL_mRegLorI2L_immI_32_63",
  /*  252 */  "_URShiftL_mRegLorI2L_immI_0_31",
  /*  253 */  "_ConvL2I__URShiftL_mRegLorI2L_immI_0_31_",
  /*  254 */  "_URShiftL_mRegLorI2L_immI_32_63",
  /*  255 */  "_URShiftI_mRegI_immI_0_31",
  /*  256 */  "_AndI_mRegI_immI_1",
  /*  257 */  "_LShiftI__AndI_mRegI_immI_1_immI_0_31",
  /*  258 */  "_LShiftI_mRegI_immI_0_31",
  /*  259 */  "_LShiftL_mRegLorI2L_immI_32_63",
  /*  260 */  "_LShiftL_mRegLorI2L_immI_0_31",
  /*  261 */  "_LoadUS_memory_",
  /*  262 */  "_LShiftL_mRegLorI2L_immI_0_3",
  /*  263 */  "_AndL__ConvI2L_mRegI__immL_MaxUI",
  /*  264 */  "_LShiftL__ConvI2L_mRegI__immI_32",
  /*  265 */  "_ConvI2L__ConvL2I_mRegL__",
  /*  266 */  "_ConvI2L__LoadI_memory__",
  /*  267 */  "_LoadL_memory_",
  /*  268 */  "_ReplicateB_immIU5_",
  /*  269 */  "_ReplicateS_immIU5_",
  /*  270 */  "_ReplicateI_immIU5_",
  /*  271 */  "_ReplicateL_immLU5_",
  /*  272 */  "_SubVI_vecX_vecX",
  /*  273 */  "_SubVL_vecX_vecX",
  /*  274 */  "_SubVI_vecY_vecY",
  /*  275 */  "_SubVL_vecY_vecY",
  /*  276 */  "_MulVB_vecX_vecX",
  /*  277 */  "_MulVS_vecX_vecX",
  /*  278 */  "_MulVI_vecX_vecX",
  /*  279 */  "_MulVL_vecX_vecX",
  /*  280 */  "_Binary_vecX_vecX",
  /*  281 */  "_MulVB_vecY_vecY",
  /*  282 */  "_MulVS_vecY_vecY",
  /*  283 */  "_MulVI_vecY_vecY",
  /*  284 */  "_MulVL_vecY_vecY",
  /*  285 */  "_Binary_vecY_vecY",
  /*  286 */  "_NegVF_vecX_",
  /*  287 */  "_NegVD_vecX_",
  /*  288 */  "_NegVF_vecY_",
  /*  289 */  "_NegVD_vecY_",
  /*  290 */  "_Binary__NegVF_vecX__vecX",
  /*  291 */  "_Binary_vecX__NegVF_vecX_",
  /*  292 */  "_Binary__NegVD_vecX__vecX",
  /*  293 */  "_Binary_vecX__NegVD_vecX_",
  /*  294 */  "_Binary__NegVF_vecY__vecY",
  /*  295 */  "_Binary_vecY__NegVF_vecY_",
  /*  296 */  "_Binary__NegVD_vecY__vecY",
  /*  297 */  "_Binary_vecY__NegVD_vecY_",
  /*  298 */  "_LShiftCntV_immI_",
  /*  299 */  "_RShiftCntV_immI_",
  /*  300 */  "_ReplicateB_immIU8_",
  /*  301 */  "_OrV_vecX_vecX",
  /*  302 */  "_ReplicateB_immI_M1_",
  /*  303 */  "_ReplicateS_immI_M1_",
  /*  304 */  "_ReplicateI_immI_M1_",
  /*  305 */  "_OrV_vecX__ReplicateB_immIU8_",
  /*  306 */  "_OrV__ReplicateB_immIU8__vecX",
  /*  307 */  "_OrV_vecY_vecY",
  /*  308 */  "_OrV_vecY__ReplicateB_immIU8_",
  /*  309 */  "_OrV__ReplicateB_immIU8__vecY",
  /*  310 */  "_XorV_vecX__ReplicateB_immI_M1_",
  /*  311 */  "_XorV__ReplicateB_immI_M1__vecX",
  /*  312 */  "_XorV_vecX__ReplicateS_immI_M1_",
  /*  313 */  "_XorV__ReplicateS_immI_M1__vecX",
  /*  314 */  "_XorV_vecX__ReplicateI_immI_M1_",
  /*  315 */  "_XorV__ReplicateI_immI_M1__vecX",
  /*  316 */  "_XorV_vecY__ReplicateB_immI_M1_",
  /*  317 */  "_XorV__ReplicateB_immI_M1__vecY",
  /*  318 */  "_XorV_vecY__ReplicateS_immI_M1_",
  /*  319 */  "_XorV__ReplicateS_immI_M1__vecY",
  /*  320 */  "_XorV_vecY__ReplicateI_immI_M1_",
  /*  321 */  "_XorV__ReplicateI_immI_M1__vecY",
  /*  322 */  "_Binary_vecX_mRegI",
  /*  323 */  "_Binary_vecX_mRegL",
  /*  324 */  "_Binary_vecX_regF",
  /*  325 */  "_Binary_vecX_regD",
  /*  326 */  "_Binary_vecY_mRegI",
  /*  327 */  "_Binary_vecY_mRegL",
  /*  328 */  "_Binary_vecY_regF",
  /*  329 */  "_Binary_vecY_regD",
  // last internally defined operand
  /*  330 */  "storeSSI",
  /*  331 */  "storeSSL",
  /*  332 */  "storeSSP",
  /*  333 */  "storeSSF",
  /*  334 */  "storeSSD",
  /*  335 */  "loadConI",
  /*  336 */  "loadConL",
  /*  337 */  "loadConP_general",
  /*  338 */  "loadConP_no_oop_cheap",
  /*  339 */  "loadConP_immP_0",
  /*  340 */  "loadConN_immN_0",
  /*  341 */  "loadConN",
  /*  342 */  "loadConNKlass",
  /*  343 */  "loadConF_immF_0",
  /*  344 */  "loadConF",
  /*  345 */  "loadConD_immD_0",
  /*  346 */  "loadConD",
  /*  347 */  "loadSSI",
  /*  348 */  "loadSSL",
  /*  349 */  "loadSSP",
  /*  350 */  "loadSSF",
  /*  351 */  "loadSSD",
  /*  352 */  "leaP12Narrow",
  /*  353 */  "castX2P",
  /*  354 */  "castP2X",
  /*  355 */  "MoveF2I_reg_reg",
  /*  356 */  "MoveI2F_reg_reg",
  /*  357 */  "MoveD2L_reg_reg",
  /*  358 */  "MoveL2D_reg_reg",
  /*  359 */  "negF_reg",
  /*  360 */  "negD_reg",
  /*  361 */  "absF_reg",
  /*  362 */  "absD_reg",
  /*  363 */  "convI2B",
  /*  364 */  "convP2B",
  /*  365 */  "checkCastPP",
  /*  366 */  "castPP",
  /*  367 */  "castII",
  /*  368 */  "castLL",
  /*  369 */  "castFF",
  /*  370 */  "castDD",
  /*  371 */  "castVVX",
  /*  372 */  "castVVY",
  /*  373 */  "cmpFastLock",
  /*  374 */  "cmpFastUnlock",
  /*  375 */  "storePConditional",
  /*  376 */  "storeIConditional",
  /*  377 */  "storeLConditional",
  /*  378 */  "roundFloat_nop",
  /*  379 */  "roundDouble_nop",
  /*  380 */  "countLeadingZerosI",
  /*  381 */  "countLeadingZerosL",
  /*  382 */  "countTrailingZerosI",
  /*  383 */  "countTrailingZerosL",
  /*  384 */  "popCountI",
  /*  385 */  "popCountI_mem",
  /*  386 */  "popCountL",
  /*  387 */  "popCountL_mem",
  /*  388 */  "abs4F",
  /*  389 */  "abs2D",
  /*  390 */  "abs8F",
  /*  391 */  "abs4D",
  /*  392 */  "neg4I",
  /*  393 */  "neg4F",
  /*  394 */  "neg2D",
  /*  395 */  "neg8I",
  /*  396 */  "neg8F",
  /*  397 */  "neg4D",
  /*  398 */  "sqrt4F",
  /*  399 */  "sqrt2D",
  /*  400 */  "sqrt8F",
  /*  401 */  "sqrt4D",
  /*  402 */  "shiftcntX",
  /*  403 */  "shiftcntX_0",
  /*  404 */  "shiftcntY",
  /*  405 */  "shiftcntY_0",
  /*  406 */  "cvt16Bto16S",
  /*  407 */  "cvt8Sto8I",
  /*  408 */  "cvt8Sto8F",
  /*  409 */  "cvt4Ito4F",
  /*  410 */  "cvt4Ito4L",
  /*  411 */  "cvt8Ito8F",
  /*  412 */  "cvt4Ito4D",
  /*  413 */  "cvt2Lto2D",
  /*  414 */  "cvt4Lto4D",
  /*  415 */  "cvt4Fto4I",
  /*  416 */  "cvt8Fto8I",
  /*  417 */  "cvt4Fto4D",
  /*  418 */  "cvt2Dto2L",
  /*  419 */  "cvt4Dto4L",
  /*  420 */  "reinterpretX",
  /*  421 */  "reinterpretY",
  /*  422 */  "reinterpretX2Y",
  /*  423 */  "reinterpretY2X",
  /*  424 */  "loadmask16B",
  /*  425 */  "loadmask32B",
  /*  426 */  "loadmask16S",
  /*  427 */  "loadcon16B",
  /*  428 */  "loadcon32B",
  /*  429 */  "loadShuffle16B",
  /*  430 */  "loadShuffle32B",
  /*  431 */  "loadShuffle16S",
  /*  432 */  "popcount4I",
  /*  433 */  "popcount8I",
  /*  434 */  "loadI",
  /*  435 */  "loadI_convI2L",
  /*  436 */  "loadI2B",
  /*  437 */  "loadI2UB",
  /*  438 */  "loadI2S",
  /*  439 */  "loadI2US",
  /*  440 */  "loadL",
  /*  441 */  "loadL_unaligned",
  /*  442 */  "storeL_reg",
  /*  443 */  "storeL_reg_volatile",
  /*  444 */  "storeL_immL_0",
  /*  445 */  "storeL_immL_0_volatile",
  /*  446 */  "loadN",
  /*  447 */  "loadN2P",
  /*  448 */  "loadP",
  /*  449 */  "loadKlass",
  /*  450 */  "loadNKlass",
  /*  451 */  "loadN2PKlass",
  /*  452 */  "loadRange",
  /*  453 */  "storeP",
  /*  454 */  "storeP_volatile",
  /*  455 */  "storeImmP_immP_0",
  /*  456 */  "storeImmP_immP_0_volatile",
  /*  457 */  "storeN",
  /*  458 */  "storeN_volatile",
  /*  459 */  "storeP2N",
  /*  460 */  "storeP2N_volatile",
  /*  461 */  "storeNKlass",
  /*  462 */  "storeNKlass_volatile",
  /*  463 */  "storeP2NKlass",
  /*  464 */  "storeP2NKlass_volatile",
  /*  465 */  "storeImmN_immN_0",
  /*  466 */  "storeImmN_immN_0_volatile",
  /*  467 */  "storeB_immB_0",
  /*  468 */  "storeB",
  /*  469 */  "loadB",
  /*  470 */  "loadB_convI2L",
  /*  471 */  "loadUB",
  /*  472 */  "loadUB_convI2L",
  /*  473 */  "loadS",
  /*  474 */  "loadS2B",
  /*  475 */  "loadS_convI2L",
  /*  476 */  "storeI_immI_0",
  /*  477 */  "storeI_immI_0_volatile",
  /*  478 */  "storeI",
  /*  479 */  "storeI_volatile",
  /*  480 */  "loadF",
  /*  481 */  "TailCalljmpInd",
  /*  482 */  "CreateException",
  /*  483 */  "RethrowException",
  /*  484 */  "jmpDir_long",
  /*  485 */  "jmpLoopEnd_long",
  /*  486 */  "jmpLoopEnd_reg_immI_long",
  /*  487 */  "jmpCon_flags_long",
  /*  488 */  "branchConP_0_long",
  /*  489 */  "branchConN2P_0_long",
  /*  490 */  "branchConP_long",
  /*  491 */  "cmpN_null_branch_long",
  /*  492 */  "cmpN_reg_branch_long",
  /*  493 */  "branchConIU_reg_reg_long",
  /*  494 */  "branchConIU_reg_imm_long",
  /*  495 */  "branchConI_reg_reg_long",
  /*  496 */  "branchConI_reg_imm_long",
  /*  497 */  "branchConL_regL_regL_long",
  /*  498 */  "branchConUL_regL_regL_long",
  /*  499 */  "branchConL_regL_immL_long",
  /*  500 */  "branchConUL_regL_immL_long",
  /*  501 */  "branchConF_reg_reg_long",
  /*  502 */  "branchConD_reg_reg_long",
  /*  503 */  "jmpDir_short",
  /*  504 */  "jmpLoopEnd_short",
  /*  505 */  "jmpLoopEnd_reg_immI_short",
  /*  506 */  "jmpCon_flags_short",
  /*  507 */  "branchConP_0_short",
  /*  508 */  "branchConN2P_0_short",
  /*  509 */  "branchConP_short",
  /*  510 */  "cmpN_null_branch_short",
  /*  511 */  "cmpN_reg_branch_short",
  /*  512 */  "branchConIU_reg_reg_short",
  /*  513 */  "branchConIU_reg_imm_short",
  /*  514 */  "branchConI_reg_reg_short",
  /*  515 */  "branchConI_reg_imm_short",
  /*  516 */  "branchConL_regL_regL_short",
  /*  517 */  "branchConUL_regL_regL_short",
  /*  518 */  "branchConL_regL_immL_short",
  /*  519 */  "branchConUL_regL_immL_short",
  /*  520 */  "branchConF_reg_reg_short",
  /*  521 */  "branchConD_reg_reg_short",
  /*  522 */  "CallRuntimeDirect",
  /*  523 */  "unnecessary_membar_acquire",
  /*  524 */  "membar_acquire",
  /*  525 */  "load_fence",
  /*  526 */  "membar_acquire_lock",
  /*  527 */  "unnecessary_membar_release",
  /*  528 */  "membar_release",
  /*  529 */  "store_fence",
  /*  530 */  "membar_release_lock",
  /*  531 */  "unnecessary_membar_volatile",
  /*  532 */  "membar_volatile",
  /*  533 */  "membar_storestore",
  /*  534 */  "membar_storestore_0",
  /*  535 */  "cmovI_cmpI_reg_reg",
  /*  536 */  "cmovI_cmpI_reg_reg2",
  /*  537 */  "cmovI_cmpI_dst_reg",
  /*  538 */  "cmovI_cmpP_reg_reg",
  /*  539 */  "cmovI_cmpN_reg_reg",
  /*  540 */  "cmovP_cmpU_reg_reg",
  /*  541 */  "cmovP_cmpF_reg_reg",
  /*  542 */  "cmovP_cmpN_reg_reg",
  /*  543 */  "cmovN_cmpP_reg_reg",
  /*  544 */  "cmovP_cmpD_reg_reg",
  /*  545 */  "cmovN_cmpN_reg_reg",
  /*  546 */  "cmovI_cmpU_reg_reg",
  /*  547 */  "cmovI_cmpL_reg_reg",
  /*  548 */  "cmovI_cmpUL_reg_reg",
  /*  549 */  "cmovP_cmpL_reg_reg",
  /*  550 */  "cmovP_cmpUL_reg_reg",
  /*  551 */  "cmovI_cmpD_reg_reg",
  /*  552 */  "cmovP_cmpP_reg_reg",
  /*  553 */  "cmovP_cmpI_reg_reg",
  /*  554 */  "cmovL_cmpP_reg_reg",
  /*  555 */  "cmovN_cmpU_reg_reg",
  /*  556 */  "cmovN_cmpL_reg_reg",
  /*  557 */  "cmovN_cmpUL_reg_reg",
  /*  558 */  "cmovN_cmpI_reg_reg",
  /*  559 */  "cmovL_cmpU_reg_reg",
  /*  560 */  "cmovL_cmpF_reg_reg",
  /*  561 */  "cmovL_cmpI_reg_reg",
  /*  562 */  "cmovL_cmpL_reg_reg",
  /*  563 */  "cmovL_cmpUL_reg_reg",
  /*  564 */  "cmovL_cmpL_reg_reg2",
  /*  565 */  "cmovL_cmpUL_reg_reg2",
  /*  566 */  "cmovL_cmpL_dst_reg",
  /*  567 */  "cmovL_cmpUL_dst_reg",
  /*  568 */  "cmovL_cmpN_reg_reg",
  /*  569 */  "cmovL_cmpD_reg_reg",
  /*  570 */  "cmovD_cmpD_reg_reg",
  /*  571 */  "cmovF_cmpI_reg_reg",
  /*  572 */  "cmovD_cmpI_reg_reg",
  /*  573 */  "cmovD_cmpP_reg_reg",
  /*  574 */  "cmovI_cmpF_reg_reg",
  /*  575 */  "cmovF_cmpF_reg_reg",
  /*  576 */  "cmpL3_reg_zero",
  /*  577 */  "cmpL3_reg_reg",
  /*  578 */  "cmpF3_reg_reg",
  /*  579 */  "cmpD3_reg_reg",
  /*  580 */  "clear_array",
  /*  581 */  "clear_array_imm",
  /*  582 */  "string_compareL",
  /*  583 */  "string_compareU",
  /*  584 */  "string_compareLU",
  /*  585 */  "string_compareUL",
  /*  586 */  "string_indexofUU",
  /*  587 */  "string_indexofLL",
  /*  588 */  "string_indexofUL",
  /*  589 */  "string_indexof_conUU",
  /*  590 */  "string_indexof_conLL",
  /*  591 */  "string_indexof_conUL",
  /*  592 */  "string_indexof_char",
  /*  593 */  "stringL_indexof_char",
  /*  594 */  "has_negatives",
  /*  595 */  "string_compress",
  /*  596 */  "string_inflate",
  /*  597 */  "string_equals",
  /*  598 */  "encode_iso_array",
  /*  599 */  "encode_ascii_array",
  /*  600 */  "addI_Reg_Reg",
  /*  601 */  "addI_Reg_imm",
  /*  602 */  "addI_salI_Reg_Reg_immI_1_4",
  /*  603 */  "addI_salI_Reg_Reg_immI_1_4_0",
  /*  604 */  "addP_reg_reg",
  /*  605 */  "addP_reg_reg_M8",
  /*  606 */  "addP_reg_imm12",
  /*  607 */  "addP_salL_Reg_RegI2L_immI_1_4",
  /*  608 */  "addL_Reg_Reg",
  /*  609 */  "addL_Reg_imm",
  /*  610 */  "absI_rReg",
  /*  611 */  "absL_rReg",
  /*  612 */  "subI_Reg_Reg",
  /*  613 */  "subI_Reg_immI_M2047_2048",
  /*  614 */  "negI_Reg",
  /*  615 */  "negL_Reg",
  /*  616 */  "subL_Reg_immL_M2047_2048",
  /*  617 */  "subL_Reg_Reg",
  /*  618 */  "modI_Reg_Reg",
  /*  619 */  "modL_reg_reg",
  /*  620 */  "mulI_Reg_Reg",
  /*  621 */  "divI_Reg_Reg",
  /*  622 */  "divF_Reg_Reg",
  /*  623 */  "divD_Reg_Reg",
  /*  624 */  "mulL_reg_reg",
  /*  625 */  "mulHiL_reg_reg",
  /*  626 */  "divL_reg_reg",
  /*  627 */  "addF_reg_reg",
  /*  628 */  "subF_reg_reg",
  /*  629 */  "addD_reg_reg",
  /*  630 */  "subD_reg_reg",
  /*  631 */  "mulF_reg_reg",
  /*  632 */  "mulD_reg_reg",
  /*  633 */  "sqrtD_reg",
  /*  634 */  "sqrtF_reg",
  /*  635 */  "maddF_reg_reg",
  /*  636 */  "maddD_reg_reg",
  /*  637 */  "msubF_reg_reg",
  /*  638 */  "msubD_reg_reg",
  /*  639 */  "mnaddF_reg_reg",
  /*  640 */  "mnaddF_reg_reg_0",
  /*  641 */  "mnaddD_reg_reg",
  /*  642 */  "mnaddD_reg_reg_0",
  /*  643 */  "mnsubF_reg_reg",
  /*  644 */  "mnsubF_reg_reg_0",
  /*  645 */  "mnsubD_reg_reg",
  /*  646 */  "mnsubD_reg_reg_0",
  /*  647 */  "copySignF_reg",
  /*  648 */  "copySignD_reg",
  /*  649 */  "andI_Reg_imm_0_4095",
  /*  650 */  "andI_Reg_immI_nonneg_mask",
  /*  651 */  "andL_Reg_immL_nonneg_mask",
  /*  652 */  "xorI_Reg_imm_0_4095",
  /*  653 */  "xorI_Reg_immI_M1",
  /*  654 */  "xorL_Reg_imm_0_4095",
  /*  655 */  "lbu_and_lmask",
  /*  656 */  "lbu_and_lmask_0",
  /*  657 */  "lbu_and_rmask",
  /*  658 */  "andI_Reg_Reg",
  /*  659 */  "andnI_Reg_nReg",
  /*  660 */  "andnI_Reg_nReg_0",
  /*  661 */  "ornI_Reg_nReg",
  /*  662 */  "ornI_Reg_nReg_0",
  /*  663 */  "andnI_nReg_Reg",
  /*  664 */  "andnI_nReg_Reg_0",
  /*  665 */  "ornI_nReg_Reg",
  /*  666 */  "ornI_nReg_Reg_0",
  /*  667 */  "andL_Reg_Reg",
  /*  668 */  "andL_Reg_imm_0_4095",
  /*  669 */  "andL2I_Reg_imm_0_4095",
  /*  670 */  "andL_Reg_immL_M8",
  /*  671 */  "andL_Reg_immL_M5",
  /*  672 */  "andL_Reg_immL_M7",
  /*  673 */  "andL_Reg_immL_M4",
  /*  674 */  "andL_Reg_immL_M121",
  /*  675 */  "orL_Reg_Reg",
  /*  676 */  "orL_Reg_P2XReg",
  /*  677 */  "orL_Reg_P2XReg_0",
  /*  678 */  "xorL_Reg_Reg",
  /*  679 */  "salI_Reg_imm",
  /*  680 */  "salI_Reg_imm_and_M65536",
  /*  681 */  "land7_2_s",
  /*  682 */  "i2s",
  /*  683 */  "i2b",
  /*  684 */  "salI_RegL2I_imm",
  /*  685 */  "salI_Reg_Reg",
  /*  686 */  "salL_Reg_imm",
  /*  687 */  "salL_Reg_Reg",
  /*  688 */  "sarL_Reg_imm",
  /*  689 */  "sarL2I_Reg_immI_32_63",
  /*  690 */  "sarL_Reg_Reg",
  /*  691 */  "slrL_Reg_Reg",
  /*  692 */  "slrL_Reg_immI_0_31",
  /*  693 */  "slrL_Reg_immI_0_31_and_max_int",
  /*  694 */  "slrL_P2XReg_immI_0_31",
  /*  695 */  "slrL_Reg_immI_32_63",
  /*  696 */  "slrL_Reg_immI_convL2I",
  /*  697 */  "slrL_P2XReg_immI_32_63",
  /*  698 */  "xorI_Reg_Reg",
  /*  699 */  "orI_Reg_imm",
  /*  700 */  "orI_Reg_Reg",
  /*  701 */  "rotI_shr_logical_Reg",
  /*  702 */  "rotI_shr_logical_Reg_0",
  /*  703 */  "orI_Reg_castP2X",
  /*  704 */  "orI_Reg_castP2X_0",
  /*  705 */  "shr_logical_Reg_imm",
  /*  706 */  "shr_logical_Reg_imm_nonneg_mask",
  /*  707 */  "rolI_Reg_immI_0_31",
  /*  708 */  "rolI_Reg_immI_0_31_0",
  /*  709 */  "rolL_Reg_immI_0_31",
  /*  710 */  "rolL_Reg_immI_0_31_0",
  /*  711 */  "rolL_Reg_immI_32_63",
  /*  712 */  "rolL_Reg_immI_32_63_0",
  /*  713 */  "rorI_Reg_immI_0_31",
  /*  714 */  "rorI_Reg_immI_0_31_0",
  /*  715 */  "rorL_Reg_immI_0_31",
  /*  716 */  "rorL_Reg_immI_0_31_0",
  /*  717 */  "rorL_Reg_immI_32_63",
  /*  718 */  "rorL_Reg_immI_32_63_0",
  /*  719 */  "rolI_reg",
  /*  720 */  "rolL_reg",
  /*  721 */  "rorI_imm",
  /*  722 */  "rorI_reg",
  /*  723 */  "rorL_imm",
  /*  724 */  "rorL_reg",
  /*  725 */  "shr_logical_Reg_Reg",
  /*  726 */  "shr_arith_Reg_imm",
  /*  727 */  "shr_arith_Reg_Reg",
  /*  728 */  "convI2L_reg",
  /*  729 */  "convL2I_reg",
  /*  730 */  "convL2D_reg",
  /*  731 */  "convD2I_reg_reg",
  /*  732 */  "convD2L_reg_reg",
  /*  733 */  "convF2I_reg_reg",
  /*  734 */  "convF2L_reg_reg",
  /*  735 */  "convL2F_reg",
  /*  736 */  "convI2F_reg",
  /*  737 */  "roundD",
  /*  738 */  "cmpLTMask_immI_0",
  /*  739 */  "cmpLTMask",
  /*  740 */  "convI2D_reg_reg",
  /*  741 */  "convF2D_reg_reg",
  /*  742 */  "convD2F_reg_reg",
  /*  743 */  "encodeHeapOop",
  /*  744 */  "encodeHeapOop_not_null",
  /*  745 */  "decodeHeapOop",
  /*  746 */  "decodeHeapOop_not_null",
  /*  747 */  "encodeKlass_not_null",
  /*  748 */  "decodeKlass_not_null",
  /*  749 */  "tlsLoadP",
  /*  750 */  "Ret",
  /*  751 */  "tailjmpInd",
  /*  752 */  "CallStaticJavaDirect",
  /*  753 */  "CallDynamicJavaDirect",
  /*  754 */  "CallLeafNoFPDirect",
  /*  755 */  "prefetchAlloc",
  /*  756 */  "CallLeafDirect",
  /*  757 */  "loadUS",
  /*  758 */  "loadUS_convI2L",
  /*  759 */  "storeC",
  /*  760 */  "storeC_0",
  /*  761 */  "storeF_reg",
  /*  762 */  "storeF_immF_0",
  /*  763 */  "loadD",
  /*  764 */  "loadD_unaligned",
  /*  765 */  "storeD_reg",
  /*  766 */  "storeD_immD_0",
  /*  767 */  "storeImmCM",
  /*  768 */  "ShouldNotReachHere",
  /*  769 */  "leaPIdxScale",
  /*  770 */  "partialSubtypeCheck",
  /*  771 */  "loadPLocked",
  /*  772 */  "compareAndSwapI",
  /*  773 */  "compareAndSwapL",
  /*  774 */  "compareAndSwapP",
  /*  775 */  "compareAndSwapN",
  /*  776 */  "get_and_setI",
  /*  777 */  "get_and_setL",
  /*  778 */  "get_and_setN",
  /*  779 */  "get_and_setP",
  /*  780 */  "get_and_addL",
  /*  781 */  "get_and_addL_no_res",
  /*  782 */  "get_and_addI",
  /*  783 */  "get_and_addI_no_res",
  /*  784 */  "compareAndExchangeI",
  /*  785 */  "compareAndExchangeL",
  /*  786 */  "compareAndExchangeP",
  /*  787 */  "compareAndExchangeN",
  /*  788 */  "weakCompareAndSwapI",
  /*  789 */  "weakCompareAndSwapL",
  /*  790 */  "weakCompareAndSwapP",
  /*  791 */  "weakCompareAndSwapP_acq",
  /*  792 */  "weakCompareAndSwapN",
  /*  793 */  "minI_Reg_Reg",
  /*  794 */  "maxI_Reg_Reg",
  /*  795 */  "maxI_Reg_zero",
  /*  796 */  "zerox_long_reg_reg",
  /*  797 */  "combine_i2l",
  /*  798 */  "combine_i2l_0",
  /*  799 */  "convI2L_reg_reg_zex",
  /*  800 */  "convL2I2L_reg_reg_zex",
  /*  801 */  "loadUI2L_rmask",
  /*  802 */  "loadUI2L_lmask",
  /*  803 */  "loadUI2L_lmask_0",
  /*  804 */  "safePoint_poll_tls",
  /*  805 */  "bytes_reverse_int",
  /*  806 */  "bytes_reverse_long",
  /*  807 */  "bytes_reverse_unsigned_short",
  /*  808 */  "bytes_reverse_short",
  /*  809 */  "loadV16",
  /*  810 */  "loadV32",
  /*  811 */  "storeV16",
  /*  812 */  "storeV32",
  /*  813 */  "repl16B",
  /*  814 */  "repl16B_imm",
  /*  815 */  "repl8S",
  /*  816 */  "repl8S_imm",
  /*  817 */  "repl4I",
  /*  818 */  "repl4I_imm",
  /*  819 */  "repl2L",
  /*  820 */  "repl2L_imm",
  /*  821 */  "repl4F",
  /*  822 */  "repl2D",
  /*  823 */  "repl32B",
  /*  824 */  "repl32B_imm",
  /*  825 */  "repl16S",
  /*  826 */  "repl16S_imm",
  /*  827 */  "repl8I",
  /*  828 */  "repl8I_imm",
  /*  829 */  "repl4L",
  /*  830 */  "repl4L_imm",
  /*  831 */  "repl8F",
  /*  832 */  "repl4D",
  /*  833 */  "add16B",
  /*  834 */  "add16B_imm",
  /*  835 */  "add16B_imm_0",
  /*  836 */  "add8S",
  /*  837 */  "add8S_imm",
  /*  838 */  "add8S_imm_0",
  /*  839 */  "add4I",
  /*  840 */  "add4I_imm",
  /*  841 */  "add4I_imm_0",
  /*  842 */  "add2L",
  /*  843 */  "add2L_imm",
  /*  844 */  "add2L_imm_0",
  /*  845 */  "add4F",
  /*  846 */  "add2D",
  /*  847 */  "add32B",
  /*  848 */  "add32B_imm",
  /*  849 */  "add32B_imm_0",
  /*  850 */  "add16S",
  /*  851 */  "add16S_imm",
  /*  852 */  "add16S_imm_0",
  /*  853 */  "add8I",
  /*  854 */  "add8I_imm",
  /*  855 */  "add8I_imm_0",
  /*  856 */  "add4L",
  /*  857 */  "add4L_imm",
  /*  858 */  "add4L_imm_0",
  /*  859 */  "add8F",
  /*  860 */  "add4D",
  /*  861 */  "sub16B",
  /*  862 */  "sub16B_imm",
  /*  863 */  "sub8S",
  /*  864 */  "sub8S_imm",
  /*  865 */  "sub4I",
  /*  866 */  "sub4I_imm",
  /*  867 */  "sub2L",
  /*  868 */  "sub2L_imm",
  /*  869 */  "sub4F",
  /*  870 */  "sub2D",
  /*  871 */  "sub32B",
  /*  872 */  "sub32B_imm",
  /*  873 */  "sub16S",
  /*  874 */  "sub16S_imm",
  /*  875 */  "sub8I",
  /*  876 */  "sub8I_imm",
  /*  877 */  "sub4L",
  /*  878 */  "sub4L_imm",
  /*  879 */  "sub8F",
  /*  880 */  "sub4D",
  /*  881 */  "mul16B",
  /*  882 */  "mul8S",
  /*  883 */  "mul4I",
  /*  884 */  "mul2L",
  /*  885 */  "mul4F",
  /*  886 */  "mul2D",
  /*  887 */  "mul32B",
  /*  888 */  "mul16S",
  /*  889 */  "mul8I",
  /*  890 */  "mul4L",
  /*  891 */  "mul8F",
  /*  892 */  "mul4D",
  /*  893 */  "div4F",
  /*  894 */  "div2D",
  /*  895 */  "div8F",
  /*  896 */  "div4D",
  /*  897 */  "abs16B",
  /*  898 */  "abs8S",
  /*  899 */  "abs4I",
  /*  900 */  "abs2L",
  /*  901 */  "abs32B",
  /*  902 */  "abs16S",
  /*  903 */  "abs8I",
  /*  904 */  "abs4L",
  /*  905 */  "absd4I",
  /*  906 */  "absd2L",
  /*  907 */  "absd8I",
  /*  908 */  "absd4L",
  /*  909 */  "max16B",
  /*  910 */  "max8S",
  /*  911 */  "max4I",
  /*  912 */  "max2L",
  /*  913 */  "max4F",
  /*  914 */  "max2D",
  /*  915 */  "max32B",
  /*  916 */  "max16S",
  /*  917 */  "max8I",
  /*  918 */  "max4L",
  /*  919 */  "max8F",
  /*  920 */  "max4D",
  /*  921 */  "min16B",
  /*  922 */  "min8S",
  /*  923 */  "min4I",
  /*  924 */  "min2L",
  /*  925 */  "min4F",
  /*  926 */  "min2D",
  /*  927 */  "min32B",
  /*  928 */  "min16S",
  /*  929 */  "min8I",
  /*  930 */  "min4L",
  /*  931 */  "min8F",
  /*  932 */  "min4D",
  /*  933 */  "madd16B",
  /*  934 */  "madd16B_0",
  /*  935 */  "madd8S",
  /*  936 */  "madd8S_0",
  /*  937 */  "madd4I",
  /*  938 */  "madd4I_0",
  /*  939 */  "madd2L",
  /*  940 */  "madd2L_0",
  /*  941 */  "madd4F",
  /*  942 */  "madd2D",
  /*  943 */  "madd32B",
  /*  944 */  "madd32B_0",
  /*  945 */  "madd16S",
  /*  946 */  "madd16S_0",
  /*  947 */  "madd8I",
  /*  948 */  "madd8I_0",
  /*  949 */  "madd4L",
  /*  950 */  "madd4L_0",
  /*  951 */  "madd8F",
  /*  952 */  "madd4D",
  /*  953 */  "msub16B",
  /*  954 */  "msub8S",
  /*  955 */  "msub4I",
  /*  956 */  "msub2L",
  /*  957 */  "msub4F",
  /*  958 */  "msub2D",
  /*  959 */  "msub32B",
  /*  960 */  "msub16S",
  /*  961 */  "msub8I",
  /*  962 */  "msub4L",
  /*  963 */  "msub8F",
  /*  964 */  "msub4D",
  /*  965 */  "nmadd4F",
  /*  966 */  "nmadd4F_0",
  /*  967 */  "nmadd2D",
  /*  968 */  "nmadd2D_0",
  /*  969 */  "nmadd8F",
  /*  970 */  "nmadd8F_0",
  /*  971 */  "nmadd4D",
  /*  972 */  "nmadd4D_0",
  /*  973 */  "nmsub4F",
  /*  974 */  "nmsub4F_0",
  /*  975 */  "nmsub2D",
  /*  976 */  "nmsub2D_0",
  /*  977 */  "nmsub8F",
  /*  978 */  "nmsub8F_0",
  /*  979 */  "nmsub4D",
  /*  980 */  "nmsub4D_0",
  /*  981 */  "muladd8Sto4I",
  /*  982 */  "muladd16Sto8I",
  /*  983 */  "sll16B",
  /*  984 */  "sll16B_imm",
  /*  985 */  "sll8S",
  /*  986 */  "sll8S_imm",
  /*  987 */  "sll4I",
  /*  988 */  "sll4I_imm",
  /*  989 */  "sll2L",
  /*  990 */  "sll2L_imm",
  /*  991 */  "sll32B",
  /*  992 */  "sll32B_imm",
  /*  993 */  "sll16S",
  /*  994 */  "sll16S_imm",
  /*  995 */  "sll8I",
  /*  996 */  "sll8I_imm",
  /*  997 */  "sll4L",
  /*  998 */  "sll4L_imm",
  /*  999 */  "srl16B",
  /* 1000 */  "srl16B_imm",
  /* 1001 */  "srl8S",
  /* 1002 */  "srl8S_imm",
  /* 1003 */  "srl4I",
  /* 1004 */  "srl4I_imm",
  /* 1005 */  "srl2L",
  /* 1006 */  "srl2L_imm",
  /* 1007 */  "srl32B",
  /* 1008 */  "srl32B_imm",
  /* 1009 */  "srl16S",
  /* 1010 */  "srl16S_imm",
  /* 1011 */  "srl8I",
  /* 1012 */  "srl8I_imm",
  /* 1013 */  "srl4L",
  /* 1014 */  "srl4L_imm",
  /* 1015 */  "sra16B",
  /* 1016 */  "sra16B_imm",
  /* 1017 */  "sra8S",
  /* 1018 */  "sra8S_imm",
  /* 1019 */  "sra4I",
  /* 1020 */  "sra4I_imm",
  /* 1021 */  "sra2L",
  /* 1022 */  "sra2L_imm",
  /* 1023 */  "sra32B",
  /* 1024 */  "sra32B_imm",
  /* 1025 */  "sra16S",
  /* 1026 */  "sra16S_imm",
  /* 1027 */  "sra8I",
  /* 1028 */  "sra8I_imm",
  /* 1029 */  "sra4L",
  /* 1030 */  "sra4L_imm",
  /* 1031 */  "rotr4I",
  /* 1032 */  "rotr4I_imm",
  /* 1033 */  "rotr2L",
  /* 1034 */  "rotr2L_imm",
  /* 1035 */  "rotr8I",
  /* 1036 */  "rotr8I_imm",
  /* 1037 */  "rotr4L",
  /* 1038 */  "rotr4L_imm",
  /* 1039 */  "rotl4I",
  /* 1040 */  "rotl4I_imm",
  /* 1041 */  "rotl2L",
  /* 1042 */  "rotl2L_imm",
  /* 1043 */  "rotl8I",
  /* 1044 */  "rotl8I_imm",
  /* 1045 */  "rotl4L",
  /* 1046 */  "rotl4L_imm",
  /* 1047 */  "andV16",
  /* 1048 */  "and16B_imm",
  /* 1049 */  "and16B_imm_0",
  /* 1050 */  "andV32",
  /* 1051 */  "and32B_imm",
  /* 1052 */  "and32B_imm_0",
  /* 1053 */  "orV16",
  /* 1054 */  "or16B_imm",
  /* 1055 */  "or16B_imm_0",
  /* 1056 */  "orV32",
  /* 1057 */  "or32B_imm",
  /* 1058 */  "or32B_imm_0",
  /* 1059 */  "xorV16",
  /* 1060 */  "xor16B_imm",
  /* 1061 */  "xor16B_imm_0",
  /* 1062 */  "xorV32",
  /* 1063 */  "xor32B_imm",
  /* 1064 */  "xor32B_imm_0",
  /* 1065 */  "norV16",
  /* 1066 */  "norV16_0",
  /* 1067 */  "norV16_1",
  /* 1068 */  "norV16_2",
  /* 1069 */  "norV16_3",
  /* 1070 */  "norV16_4",
  /* 1071 */  "nor16B_imm",
  /* 1072 */  "nor16B_imm_1",
  /* 1073 */  "nor16B_imm_0",
  /* 1074 */  "nor16B_imm_2",
  /* 1075 */  "norV32",
  /* 1076 */  "norV32_0",
  /* 1077 */  "norV32_1",
  /* 1078 */  "norV32_2",
  /* 1079 */  "norV32_3",
  /* 1080 */  "norV32_4",
  /* 1081 */  "nor32B_imm",
  /* 1082 */  "nor32B_imm_1",
  /* 1083 */  "nor32B_imm_0",
  /* 1084 */  "nor32B_imm_2",
  /* 1085 */  "andnV16",
  /* 1086 */  "andnV16_1",
  /* 1087 */  "andnV16_0",
  /* 1088 */  "andnV16_2",
  /* 1089 */  "andnV16_3",
  /* 1090 */  "andnV16_5",
  /* 1091 */  "andnV16_4",
  /* 1092 */  "andnV16_6",
  /* 1093 */  "andnV16_7",
  /* 1094 */  "andnV16_9",
  /* 1095 */  "andnV16_8",
  /* 1096 */  "andnV16_10",
  /* 1097 */  "andnV32",
  /* 1098 */  "andnV32_1",
  /* 1099 */  "andnV32_0",
  /* 1100 */  "andnV32_2",
  /* 1101 */  "andnV32_3",
  /* 1102 */  "andnV32_5",
  /* 1103 */  "andnV32_4",
  /* 1104 */  "andnV32_6",
  /* 1105 */  "andnV32_7",
  /* 1106 */  "andnV32_9",
  /* 1107 */  "andnV32_8",
  /* 1108 */  "andnV32_10",
  /* 1109 */  "ornV16",
  /* 1110 */  "ornV16_1",
  /* 1111 */  "ornV16_0",
  /* 1112 */  "ornV16_2",
  /* 1113 */  "ornV16_3",
  /* 1114 */  "ornV16_5",
  /* 1115 */  "ornV16_4",
  /* 1116 */  "ornV16_6",
  /* 1117 */  "ornV16_7",
  /* 1118 */  "ornV16_9",
  /* 1119 */  "ornV16_8",
  /* 1120 */  "ornV16_10",
  /* 1121 */  "ornV32",
  /* 1122 */  "ornV32_1",
  /* 1123 */  "ornV32_0",
  /* 1124 */  "ornV32_2",
  /* 1125 */  "ornV32_3",
  /* 1126 */  "ornV32_5",
  /* 1127 */  "ornV32_4",
  /* 1128 */  "ornV32_6",
  /* 1129 */  "ornV32_7",
  /* 1130 */  "ornV32_9",
  /* 1131 */  "ornV32_8",
  /* 1132 */  "ornV32_10",
  /* 1133 */  "reduce_add16B",
  /* 1134 */  "reduce_add8S",
  /* 1135 */  "reduce_add4I",
  /* 1136 */  "reduce_add2L",
  /* 1137 */  "reduce_add4F",
  /* 1138 */  "reduce_add2D",
  /* 1139 */  "reduce_add32B",
  /* 1140 */  "reduce_add16S",
  /* 1141 */  "reduce_add8I",
  /* 1142 */  "reduce_add4L",
  /* 1143 */  "reduce_add8F",
  /* 1144 */  "reduce_add4D",
  /* 1145 */  "reduce_mul16B",
  /* 1146 */  "reduce_mul8S",
  /* 1147 */  "reduce_mul4I",
  /* 1148 */  "reduce_mul2L",
  /* 1149 */  "reduce_mul4F",
  /* 1150 */  "reduce_mul2D",
  /* 1151 */  "reduce_mul32B",
  /* 1152 */  "reduce_mul16S",
  /* 1153 */  "reduce_mul8I",
  /* 1154 */  "reduce_mul4L",
  /* 1155 */  "reduce_mul8F",
  /* 1156 */  "reduce_mul4D",
  /* 1157 */  "reduce_max16B",
  /* 1158 */  "reduce_max8S",
  /* 1159 */  "reduce_max4I",
  /* 1160 */  "reduce_max2L",
  /* 1161 */  "reduce_max32B",
  /* 1162 */  "reduce_max16S",
  /* 1163 */  "reduce_max8I",
  /* 1164 */  "reduce_max4L",
  /* 1165 */  "reduce_min16B",
  /* 1166 */  "reduce_min8S",
  /* 1167 */  "reduce_min4I",
  /* 1168 */  "reduce_min2L",
  /* 1169 */  "reduce_min32B",
  /* 1170 */  "reduce_min16S",
  /* 1171 */  "reduce_min8I",
  /* 1172 */  "reduce_min4L",
  /* 1173 */  "reduce_and16B",
  /* 1174 */  "reduce_and8S",
  /* 1175 */  "reduce_and4I",
  /* 1176 */  "reduce_and2L",
  /* 1177 */  "reduce_and32B",
  /* 1178 */  "reduce_and16S",
  /* 1179 */  "reduce_and8I",
  /* 1180 */  "reduce_and4L",
  /* 1181 */  "reduce_or16B",
  /* 1182 */  "reduce_or8S",
  /* 1183 */  "reduce_or4I",
  /* 1184 */  "reduce_or2L",
  /* 1185 */  "reduce_or32B",
  /* 1186 */  "reduce_or16S",
  /* 1187 */  "reduce_or8I",
  /* 1188 */  "reduce_or4L",
  /* 1189 */  "reduce_xor16B",
  /* 1190 */  "reduce_xor8S",
  /* 1191 */  "reduce_xor4I",
  /* 1192 */  "reduce_xor2L",
  /* 1193 */  "reduce_xor32B",
  /* 1194 */  "reduce_xor16S",
  /* 1195 */  "reduce_xor8I",
  /* 1196 */  "reduce_xor4L",
  /* 1197 */  "round2D",
  /* 1198 */  "round4D",
  /* 1199 */  "cvt16Sto16B",
  /* 1200 */  "cvt8Ito8S",
  /* 1201 */  "cvt4Lto4I",
  /* 1202 */  "cvt4Lto4F",
  /* 1203 */  "cvt8Fto8S",
  /* 1204 */  "cvt4Fto4L",
  /* 1205 */  "cvt4Dto4I",
  /* 1206 */  "cvt4Dto4F",
  /* 1207 */  "insert16B",
  /* 1208 */  "insert8S",
  /* 1209 */  "insert4I",
  /* 1210 */  "insert2L",
  /* 1211 */  "insert4F",
  /* 1212 */  "insert2D",
  /* 1213 */  "insert32B",
  /* 1214 */  "insert16S",
  /* 1215 */  "insert8I",
  /* 1216 */  "insert4L",
  /* 1217 */  "insert8F",
  /* 1218 */  "insert4D",
  /* 1219 */  "blendV16",
  /* 1220 */  "blendV32",
  /* 1221 */  "storemask16B",
  /* 1222 */  "storemask32B",
  /* 1223 */  "storemask16S",
  /* 1224 */  "anytrue_in_maskV16",
  /* 1225 */  "alltrue_in_maskV16",
  /* 1226 */  "anytrue_in_maskV32",
  /* 1227 */  "alltrue_in_maskV32",
  /* 1228 */  "cmpV16",
  /* 1229 */  "cmpV32",
  /* 1230 */  "rearrange16B",
  /* 1231 */  "rearrange32B",
  /* 1232 */  "rearrange16S",
  /* 1233 */  "compareAndSwapP_shenandoah",
  /* 1234 */  "compareAndSwapN_shenandoah",
  /* 1235 */  "compareAndSwapPAcq_shenandoah",
  /* 1236 */  "compareAndSwapNAcq_shenandoah",
  /* 1237 */  "compareAndExchangeN_shenandoah",
  /* 1238 */  "compareAndExchangeP_shenandoah",
  /* 1239 */  "compareAndExchangeNAcq_shenandoah",
  /* 1240 */  "compareAndExchangePAcq_shenandoah",
  /* 1241 */  "weakCompareAndSwapN_shenandoah",
  /* 1242 */  "weakCompareAndSwapP_shenandoah",
  /* 1243 */  "weakCompareAndSwapNAcq_shenandoah",
  /* 1244 */  "weakCompareAndSwapPAcq_shenandoah",
  /* 1245 */  "zLoadP",
  /* 1246 */  "zCompareAndSwapP",
  /* 1247 */  "zCompareAndSwapP_acq",
  /* 1248 */  "zCompareAndSwapPWeak",
  /* 1249 */  "zCompareAndSwapPWeak_acq",
  /* 1250 */  "zCompareAndExchangeP",
  /* 1251 */  "zCompareAndExchangeP_acq",
  /* 1252 */  "zGetAndSetP",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  false,
  /*    9 */  false,
  /*   10 */  false,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  true,
  /*   45 */  true,
  /*   46 */  true,
  /*   47 */  true,
  /*   48 */  true,
  /*   49 */  true,
  /*   50 */  true,
  /*   51 */  true,
  /*   52 */  true,
  /*   53 */  true,
  /*   54 */  true,
  /*   55 */  true,
  /*   56 */  true,
  /*   57 */  true,
  /*   58 */  true,
  /*   59 */  true,
  /*   60 */  true,
  /*   61 */  true,
  /*   62 */  true,
  /*   63 */  true,
  /*   64 */  true,
  /*   65 */  true,
  /*   66 */  false,
  /*   67 */  false,
  /*   68 */  false,
  /*   69 */  false,
  /*   70 */  false,
  /*   71 */  false,
  /*   72 */  false,
  /*   73 */  false,
  /*   74 */  false,
  /*   75 */  false,
  /*   76 */  false,
  /*   77 */  false,
  /*   78 */  false,
  /*   79 */  false,
  /*   80 */  false,
  /*   81 */  false,
  /*   82 */  false,
  /*   83 */  false,
  /*   84 */  false,
  /*   85 */  false,
  /*   86 */  false,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  false,
  /*  105 */  false,
  /*  106 */  false,
  /*  107 */  false,
  /*  108 */  false,
  /*  109 */  false,
  /*  110 */  false,
  /*  111 */  false,
  /*  112 */  false,
  /*  113 */  false,
  /*  114 */  false,
  /*  115 */  false,
  /*  116 */  false,
  /*  117 */  false,
  /*  118 */  false,
  /*  119 */  false,
  /*  120 */  false,
  /*  121 */  false,
  /*  122 */  false,
  /*  123 */  false,
  /*  124 */  false,
  /*  125 */  false,
  /*  126 */  false,
  /*  127 */  false,
  /*  128 */  false,
  /*  129 */  false,
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  true,
  /*  166 */  true,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  // last operand
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  false,
  // last operand class
  /*  176 */  false,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  /*  182 */  false,
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  false,
  /*  192 */  false,
  /*  193 */  false,
  /*  194 */  false,
  /*  195 */  false,
  /*  196 */  false,
  /*  197 */  false,
  /*  198 */  false,
  /*  199 */  false,
  /*  200 */  false,
  /*  201 */  false,
  /*  202 */  false,
  /*  203 */  false,
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  /*  212 */  false,
  /*  213 */  false,
  /*  214 */  false,
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  /*  253 */  false,
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  // last internally defined operand
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  /*  683 */  false,
  /*  684 */  false,
  /*  685 */  false,
  /*  686 */  false,
  /*  687 */  false,
  /*  688 */  false,
  /*  689 */  false,
  /*  690 */  false,
  /*  691 */  false,
  /*  692 */  false,
  /*  693 */  false,
  /*  694 */  false,
  /*  695 */  false,
  /*  696 */  false,
  /*  697 */  false,
  /*  698 */  false,
  /*  699 */  false,
  /*  700 */  false,
  /*  701 */  false,
  /*  702 */  false,
  /*  703 */  false,
  /*  704 */  false,
  /*  705 */  false,
  /*  706 */  false,
  /*  707 */  false,
  /*  708 */  false,
  /*  709 */  false,
  /*  710 */  false,
  /*  711 */  false,
  /*  712 */  false,
  /*  713 */  false,
  /*  714 */  false,
  /*  715 */  false,
  /*  716 */  false,
  /*  717 */  false,
  /*  718 */  false,
  /*  719 */  false,
  /*  720 */  false,
  /*  721 */  false,
  /*  722 */  false,
  /*  723 */  false,
  /*  724 */  false,
  /*  725 */  false,
  /*  726 */  false,
  /*  727 */  false,
  /*  728 */  false,
  /*  729 */  false,
  /*  730 */  false,
  /*  731 */  false,
  /*  732 */  false,
  /*  733 */  false,
  /*  734 */  false,
  /*  735 */  false,
  /*  736 */  false,
  /*  737 */  false,
  /*  738 */  false,
  /*  739 */  false,
  /*  740 */  false,
  /*  741 */  false,
  /*  742 */  false,
  /*  743 */  false,
  /*  744 */  false,
  /*  745 */  false,
  /*  746 */  false,
  /*  747 */  false,
  /*  748 */  false,
  /*  749 */  false,
  /*  750 */  false,
  /*  751 */  false,
  /*  752 */  false,
  /*  753 */  false,
  /*  754 */  false,
  /*  755 */  false,
  /*  756 */  false,
  /*  757 */  false,
  /*  758 */  false,
  /*  759 */  false,
  /*  760 */  false,
  /*  761 */  false,
  /*  762 */  false,
  /*  763 */  false,
  /*  764 */  false,
  /*  765 */  false,
  /*  766 */  false,
  /*  767 */  false,
  /*  768 */  false,
  /*  769 */  false,
  /*  770 */  false,
  /*  771 */  false,
  /*  772 */  false,
  /*  773 */  false,
  /*  774 */  false,
  /*  775 */  false,
  /*  776 */  false,
  /*  777 */  false,
  /*  778 */  false,
  /*  779 */  false,
  /*  780 */  false,
  /*  781 */  false,
  /*  782 */  false,
  /*  783 */  false,
  /*  784 */  false,
  /*  785 */  false,
  /*  786 */  false,
  /*  787 */  false,
  /*  788 */  false,
  /*  789 */  false,
  /*  790 */  false,
  /*  791 */  false,
  /*  792 */  false,
  /*  793 */  false,
  /*  794 */  false,
  /*  795 */  false,
  /*  796 */  false,
  /*  797 */  false,
  /*  798 */  false,
  /*  799 */  false,
  /*  800 */  false,
  /*  801 */  false,
  /*  802 */  false,
  /*  803 */  false,
  /*  804 */  false,
  /*  805 */  false,
  /*  806 */  false,
  /*  807 */  false,
  /*  808 */  false,
  /*  809 */  false,
  /*  810 */  false,
  /*  811 */  false,
  /*  812 */  false,
  /*  813 */  false,
  /*  814 */  false,
  /*  815 */  false,
  /*  816 */  false,
  /*  817 */  false,
  /*  818 */  false,
  /*  819 */  false,
  /*  820 */  false,
  /*  821 */  false,
  /*  822 */  false,
  /*  823 */  false,
  /*  824 */  false,
  /*  825 */  false,
  /*  826 */  false,
  /*  827 */  false,
  /*  828 */  false,
  /*  829 */  false,
  /*  830 */  false,
  /*  831 */  false,
  /*  832 */  false,
  /*  833 */  false,
  /*  834 */  false,
  /*  835 */  false,
  /*  836 */  false,
  /*  837 */  false,
  /*  838 */  false,
  /*  839 */  false,
  /*  840 */  false,
  /*  841 */  false,
  /*  842 */  false,
  /*  843 */  false,
  /*  844 */  false,
  /*  845 */  false,
  /*  846 */  false,
  /*  847 */  false,
  /*  848 */  false,
  /*  849 */  false,
  /*  850 */  false,
  /*  851 */  false,
  /*  852 */  false,
  /*  853 */  false,
  /*  854 */  false,
  /*  855 */  false,
  /*  856 */  false,
  /*  857 */  false,
  /*  858 */  false,
  /*  859 */  false,
  /*  860 */  false,
  /*  861 */  false,
  /*  862 */  false,
  /*  863 */  false,
  /*  864 */  false,
  /*  865 */  false,
  /*  866 */  false,
  /*  867 */  false,
  /*  868 */  false,
  /*  869 */  false,
  /*  870 */  false,
  /*  871 */  false,
  /*  872 */  false,
  /*  873 */  false,
  /*  874 */  false,
  /*  875 */  false,
  /*  876 */  false,
  /*  877 */  false,
  /*  878 */  false,
  /*  879 */  false,
  /*  880 */  false,
  /*  881 */  false,
  /*  882 */  false,
  /*  883 */  false,
  /*  884 */  false,
  /*  885 */  false,
  /*  886 */  false,
  /*  887 */  false,
  /*  888 */  false,
  /*  889 */  false,
  /*  890 */  false,
  /*  891 */  false,
  /*  892 */  false,
  /*  893 */  false,
  /*  894 */  false,
  /*  895 */  false,
  /*  896 */  false,
  /*  897 */  false,
  /*  898 */  false,
  /*  899 */  false,
  /*  900 */  false,
  /*  901 */  false,
  /*  902 */  false,
  /*  903 */  false,
  /*  904 */  false,
  /*  905 */  false,
  /*  906 */  false,
  /*  907 */  false,
  /*  908 */  false,
  /*  909 */  false,
  /*  910 */  false,
  /*  911 */  false,
  /*  912 */  false,
  /*  913 */  false,
  /*  914 */  false,
  /*  915 */  false,
  /*  916 */  false,
  /*  917 */  false,
  /*  918 */  false,
  /*  919 */  false,
  /*  920 */  false,
  /*  921 */  false,
  /*  922 */  false,
  /*  923 */  false,
  /*  924 */  false,
  /*  925 */  false,
  /*  926 */  false,
  /*  927 */  false,
  /*  928 */  false,
  /*  929 */  false,
  /*  930 */  false,
  /*  931 */  false,
  /*  932 */  false,
  /*  933 */  false,
  /*  934 */  false,
  /*  935 */  false,
  /*  936 */  false,
  /*  937 */  false,
  /*  938 */  false,
  /*  939 */  false,
  /*  940 */  false,
  /*  941 */  false,
  /*  942 */  false,
  /*  943 */  false,
  /*  944 */  false,
  /*  945 */  false,
  /*  946 */  false,
  /*  947 */  false,
  /*  948 */  false,
  /*  949 */  false,
  /*  950 */  false,
  /*  951 */  false,
  /*  952 */  false,
  /*  953 */  false,
  /*  954 */  false,
  /*  955 */  false,
  /*  956 */  false,
  /*  957 */  false,
  /*  958 */  false,
  /*  959 */  false,
  /*  960 */  false,
  /*  961 */  false,
  /*  962 */  false,
  /*  963 */  false,
  /*  964 */  false,
  /*  965 */  false,
  /*  966 */  false,
  /*  967 */  false,
  /*  968 */  false,
  /*  969 */  false,
  /*  970 */  false,
  /*  971 */  false,
  /*  972 */  false,
  /*  973 */  false,
  /*  974 */  false,
  /*  975 */  false,
  /*  976 */  false,
  /*  977 */  false,
  /*  978 */  false,
  /*  979 */  false,
  /*  980 */  false,
  /*  981 */  false,
  /*  982 */  false,
  /*  983 */  false,
  /*  984 */  false,
  /*  985 */  false,
  /*  986 */  false,
  /*  987 */  false,
  /*  988 */  false,
  /*  989 */  false,
  /*  990 */  false,
  /*  991 */  false,
  /*  992 */  false,
  /*  993 */  false,
  /*  994 */  false,
  /*  995 */  false,
  /*  996 */  false,
  /*  997 */  false,
  /*  998 */  false,
  /*  999 */  false,
  /* 1000 */  false,
  /* 1001 */  false,
  /* 1002 */  false,
  /* 1003 */  false,
  /* 1004 */  false,
  /* 1005 */  false,
  /* 1006 */  false,
  /* 1007 */  false,
  /* 1008 */  false,
  /* 1009 */  false,
  /* 1010 */  false,
  /* 1011 */  false,
  /* 1012 */  false,
  /* 1013 */  false,
  /* 1014 */  false,
  /* 1015 */  false,
  /* 1016 */  false,
  /* 1017 */  false,
  /* 1018 */  false,
  /* 1019 */  false,
  /* 1020 */  false,
  /* 1021 */  false,
  /* 1022 */  false,
  /* 1023 */  false,
  /* 1024 */  false,
  /* 1025 */  false,
  /* 1026 */  false,
  /* 1027 */  false,
  /* 1028 */  false,
  /* 1029 */  false,
  /* 1030 */  false,
  /* 1031 */  false,
  /* 1032 */  false,
  /* 1033 */  false,
  /* 1034 */  false,
  /* 1035 */  false,
  /* 1036 */  false,
  /* 1037 */  false,
  /* 1038 */  false,
  /* 1039 */  false,
  /* 1040 */  false,
  /* 1041 */  false,
  /* 1042 */  false,
  /* 1043 */  false,
  /* 1044 */  false,
  /* 1045 */  false,
  /* 1046 */  false,
  /* 1047 */  false,
  /* 1048 */  false,
  /* 1049 */  false,
  /* 1050 */  false,
  /* 1051 */  false,
  /* 1052 */  false,
  /* 1053 */  false,
  /* 1054 */  false,
  /* 1055 */  false,
  /* 1056 */  false,
  /* 1057 */  false,
  /* 1058 */  false,
  /* 1059 */  false,
  /* 1060 */  false,
  /* 1061 */  false,
  /* 1062 */  false,
  /* 1063 */  false,
  /* 1064 */  false,
  /* 1065 */  false,
  /* 1066 */  false,
  /* 1067 */  false,
  /* 1068 */  false,
  /* 1069 */  false,
  /* 1070 */  false,
  /* 1071 */  false,
  /* 1072 */  false,
  /* 1073 */  false,
  /* 1074 */  false,
  /* 1075 */  false,
  /* 1076 */  false,
  /* 1077 */  false,
  /* 1078 */  false,
  /* 1079 */  false,
  /* 1080 */  false,
  /* 1081 */  false,
  /* 1082 */  false,
  /* 1083 */  false,
  /* 1084 */  false,
  /* 1085 */  false,
  /* 1086 */  false,
  /* 1087 */  false,
  /* 1088 */  false,
  /* 1089 */  false,
  /* 1090 */  false,
  /* 1091 */  false,
  /* 1092 */  false,
  /* 1093 */  false,
  /* 1094 */  false,
  /* 1095 */  false,
  /* 1096 */  false,
  /* 1097 */  false,
  /* 1098 */  false,
  /* 1099 */  false,
  /* 1100 */  false,
  /* 1101 */  false,
  /* 1102 */  false,
  /* 1103 */  false,
  /* 1104 */  false,
  /* 1105 */  false,
  /* 1106 */  false,
  /* 1107 */  false,
  /* 1108 */  false,
  /* 1109 */  false,
  /* 1110 */  false,
  /* 1111 */  false,
  /* 1112 */  false,
  /* 1113 */  false,
  /* 1114 */  false,
  /* 1115 */  false,
  /* 1116 */  false,
  /* 1117 */  false,
  /* 1118 */  false,
  /* 1119 */  false,
  /* 1120 */  false,
  /* 1121 */  false,
  /* 1122 */  false,
  /* 1123 */  false,
  /* 1124 */  false,
  /* 1125 */  false,
  /* 1126 */  false,
  /* 1127 */  false,
  /* 1128 */  false,
  /* 1129 */  false,
  /* 1130 */  false,
  /* 1131 */  false,
  /* 1132 */  false,
  /* 1133 */  false,
  /* 1134 */  false,
  /* 1135 */  false,
  /* 1136 */  false,
  /* 1137 */  false,
  /* 1138 */  false,
  /* 1139 */  false,
  /* 1140 */  false,
  /* 1141 */  false,
  /* 1142 */  false,
  /* 1143 */  false,
  /* 1144 */  false,
  /* 1145 */  false,
  /* 1146 */  false,
  /* 1147 */  false,
  /* 1148 */  false,
  /* 1149 */  false,
  /* 1150 */  false,
  /* 1151 */  false,
  /* 1152 */  false,
  /* 1153 */  false,
  /* 1154 */  false,
  /* 1155 */  false,
  /* 1156 */  false,
  /* 1157 */  false,
  /* 1158 */  false,
  /* 1159 */  false,
  /* 1160 */  false,
  /* 1161 */  false,
  /* 1162 */  false,
  /* 1163 */  false,
  /* 1164 */  false,
  /* 1165 */  false,
  /* 1166 */  false,
  /* 1167 */  false,
  /* 1168 */  false,
  /* 1169 */  false,
  /* 1170 */  false,
  /* 1171 */  false,
  /* 1172 */  false,
  /* 1173 */  false,
  /* 1174 */  false,
  /* 1175 */  false,
  /* 1176 */  false,
  /* 1177 */  false,
  /* 1178 */  false,
  /* 1179 */  false,
  /* 1180 */  false,
  /* 1181 */  false,
  /* 1182 */  false,
  /* 1183 */  false,
  /* 1184 */  false,
  /* 1185 */  false,
  /* 1186 */  false,
  /* 1187 */  false,
  /* 1188 */  false,
  /* 1189 */  false,
  /* 1190 */  false,
  /* 1191 */  false,
  /* 1192 */  false,
  /* 1193 */  false,
  /* 1194 */  false,
  /* 1195 */  false,
  /* 1196 */  false,
  /* 1197 */  false,
  /* 1198 */  false,
  /* 1199 */  false,
  /* 1200 */  false,
  /* 1201 */  false,
  /* 1202 */  false,
  /* 1203 */  false,
  /* 1204 */  false,
  /* 1205 */  false,
  /* 1206 */  false,
  /* 1207 */  false,
  /* 1208 */  false,
  /* 1209 */  false,
  /* 1210 */  false,
  /* 1211 */  false,
  /* 1212 */  false,
  /* 1213 */  false,
  /* 1214 */  false,
  /* 1215 */  false,
  /* 1216 */  false,
  /* 1217 */  false,
  /* 1218 */  false,
  /* 1219 */  false,
  /* 1220 */  false,
  /* 1221 */  false,
  /* 1222 */  false,
  /* 1223 */  false,
  /* 1224 */  false,
  /* 1225 */  false,
  /* 1226 */  false,
  /* 1227 */  false,
  /* 1228 */  false,
  /* 1229 */  false,
  /* 1230 */  false,
  /* 1231 */  false,
  /* 1232 */  false,
  /* 1233 */  false,
  /* 1234 */  false,
  /* 1235 */  false,
  /* 1236 */  false,
  /* 1237 */  false,
  /* 1238 */  false,
  /* 1239 */  false,
  /* 1240 */  false,
  /* 1241 */  false,
  /* 1242 */  false,
  /* 1243 */  false,
  /* 1244 */  false,
  /* 1245 */  false,
  /* 1246 */  false,
  /* 1247 */  false,
  /* 1248 */  false,
  /* 1249 */  false,
  /* 1250 */  false,
  /* 1251 */  false,
  /* 1252 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // VecA: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // VecZ: 13
  0, // RegVectMask: 14
  0, // RegFlags: 15
  0, // _last_machine_leaf: 16
  0, // AbsD: 17
  0, // AbsF: 18
  0, // AbsI: 19
  0, // AbsL: 20
  0, // AddD: 21
  0, // AddF: 22
  0, // AddI: 23
  0, // AddL: 24
  0, // AddP: 25
  0, // Allocate: 26
  0, // AllocateArray: 27
  0, // AndI: 28
  0, // AndL: 29
  0, // ArrayCopy: 30
  0, // AryEq: 31
  0, // AtanD: 32
  1, // Binary: 33
  0, // Blackhole: 34
  1, // Bool: 35
  0, // BoxLock: 36
  0, // ReverseBytesI: 37
  0, // ReverseBytesL: 38
  0, // ReverseBytesUS: 39
  0, // ReverseBytesS: 40
  0, // CProj: 41
  0, // CacheWB: 42
  0, // CacheWBPreSync: 43
  0, // CacheWBPostSync: 44
  0, // CallDynamicJava: 45
  0, // CallJava: 46
  0, // CallLeaf: 47
  0, // CallLeafNoFP: 48
  0, // CallLeafVector: 49
  0, // CallRuntime: 50
  0, // CallNative: 51
  0, // CallStaticJava: 52
  0, // CastDD: 53
  0, // CastFF: 54
  0, // CastII: 55
  0, // CastLL: 56
  0, // CastVV: 57
  0, // CastX2P: 58
  0, // CastP2X: 59
  0, // CastPP: 60
  0, // Catch: 61
  0, // CatchProj: 62
  0, // CheckCastPP: 63
  0, // ClearArray: 64
  0, // ConstraintCast: 65
  0, // CMoveD: 66
  0, // CMoveVD: 67
  0, // CMoveF: 68
  0, // CMoveVF: 69
  0, // CMoveI: 70
  0, // CMoveL: 71
  0, // CMoveP: 72
  0, // CMoveN: 73
  1, // CmpN: 74
  1, // CmpD: 75
  0, // CmpD3: 76
  1, // CmpF: 77
  0, // CmpF3: 78
  1, // CmpI: 79
  1, // CmpL: 80
  0, // CmpL3: 81
  0, // CmpLTMask: 82
  1, // CmpP: 83
  1, // CmpU: 84
  1, // CmpUL: 85
  0, // CompareAndSwapB: 86
  0, // CompareAndSwapS: 87
  0, // CompareAndSwapI: 88
  0, // CompareAndSwapL: 89
  0, // CompareAndSwapP: 90
  0, // CompareAndSwapN: 91
  0, // WeakCompareAndSwapB: 92
  0, // WeakCompareAndSwapS: 93
  0, // WeakCompareAndSwapI: 94
  0, // WeakCompareAndSwapL: 95
  0, // WeakCompareAndSwapP: 96
  0, // WeakCompareAndSwapN: 97
  0, // CompareAndExchangeB: 98
  0, // CompareAndExchangeS: 99
  0, // CompareAndExchangeI: 100
  0, // CompareAndExchangeL: 101
  0, // CompareAndExchangeP: 102
  0, // CompareAndExchangeN: 103
  0, // GetAndAddB: 104
  0, // GetAndAddS: 105
  0, // GetAndAddI: 106
  0, // GetAndAddL: 107
  0, // GetAndSetB: 108
  0, // GetAndSetS: 109
  0, // GetAndSetI: 110
  0, // GetAndSetL: 111
  0, // GetAndSetP: 112
  0, // GetAndSetN: 113
  0, // Con: 114
  0, // ConN: 115
  0, // ConNKlass: 116
  0, // ConD: 117
  0, // ConF: 118
  0, // ConI: 119
  0, // ConL: 120
  0, // ConP: 121
  0, // Conv2B: 122
  0, // ConvD2F: 123
  0, // ConvD2I: 124
  0, // ConvD2L: 125
  0, // ConvF2D: 126
  0, // ConvF2I: 127
  0, // ConvF2L: 128
  0, // ConvI2D: 129
  0, // ConvI2F: 130
  0, // ConvI2L: 131
  0, // ConvL2D: 132
  0, // ConvL2F: 133
  0, // ConvL2I: 134
  0, // CountedLoop: 135
  0, // CountedLoopEnd: 136
  0, // OuterStripMinedLoop: 137
  0, // OuterStripMinedLoopEnd: 138
  0, // LongCountedLoop: 139
  0, // LongCountedLoopEnd: 140
  0, // CountLeadingZerosI: 141
  0, // CountLeadingZerosL: 142
  0, // CountTrailingZerosI: 143
  0, // CountTrailingZerosL: 144
  0, // CreateEx: 145
  0, // DecodeN: 146
  0, // DecodeNKlass: 147
  0, // DivD: 148
  0, // DivF: 149
  0, // DivI: 150
  0, // DivL: 151
  0, // DivMod: 152
  0, // DivModI: 153
  0, // DivModL: 154
  0, // EncodeISOArray: 155
  0, // EncodeP: 156
  0, // EncodePKlass: 157
  1, // FastLock: 158
  1, // FastUnlock: 159
  0, // FmaD: 160
  0, // FmaF: 161
  0, // Goto: 162
  0, // Halt: 163
  0, // HasNegatives: 164
  0, // If: 165
  0, // RangeCheck: 166
  0, // IfFalse: 167
  0, // IfTrue: 168
  0, // Initialize: 169
  0, // JProj: 170
  0, // Jump: 171
  0, // JumpProj: 172
  0, // LShiftI: 173
  0, // LShiftL: 174
  0, // LoadB: 175
  0, // LoadUB: 176
  0, // LoadUS: 177
  0, // LoadD: 178
  0, // LoadD_unaligned: 179
  0, // LoadF: 180
  0, // LoadI: 181
  0, // LoadKlass: 182
  0, // LoadNKlass: 183
  0, // LoadL: 184
  0, // LoadL_unaligned: 185
  0, // LoadPLocked: 186
  0, // LoadP: 187
  0, // LoadN: 188
  0, // LoadRange: 189
  0, // LoadS: 190
  0, // Lock: 191
  0, // Loop: 192
  0, // LoopLimit: 193
  0, // Mach: 194
  0, // MachNullCheck: 195
  0, // MachProj: 196
  0, // MulAddS2I: 197
  0, // MaxI: 198
  0, // MaxL: 199
  0, // MaxD: 200
  0, // MaxF: 201
  0, // MemBarAcquire: 202
  0, // LoadFence: 203
  0, // SetVectMaskI: 204
  0, // MemBarAcquireLock: 205
  0, // MemBarCPUOrder: 206
  0, // MemBarRelease: 207
  0, // StoreFence: 208
  0, // StoreStoreFence: 209
  0, // MemBarReleaseLock: 210
  0, // MemBarVolatile: 211
  0, // MemBarStoreStore: 212
  0, // MergeMem: 213
  0, // MinI: 214
  0, // MinL: 215
  0, // MinF: 216
  0, // MinD: 217
  0, // ModD: 218
  0, // ModF: 219
  0, // ModI: 220
  0, // ModL: 221
  0, // MoveI2F: 222
  0, // MoveF2I: 223
  0, // MoveL2D: 224
  0, // MoveD2L: 225
  0, // MulD: 226
  0, // MulF: 227
  0, // MulHiL: 228
  0, // MulI: 229
  0, // MulL: 230
  0, // Multi: 231
  0, // NegI: 232
  0, // NegL: 233
  0, // NegD: 234
  0, // NegF: 235
  0, // NeverBranch: 236
  0, // OnSpinWait: 237
  0, // Opaque1: 238
  0, // OpaqueLoopInit: 239
  0, // OpaqueLoopStride: 240
  0, // Opaque2: 241
  0, // Opaque3: 242
  0, // Opaque4: 243
  0, // ProfileBoolean: 244
  0, // OrI: 245
  0, // OrL: 246
  1, // OverflowAddI: 247
  1, // OverflowSubI: 248
  1, // OverflowMulI: 249
  1, // OverflowAddL: 250
  1, // OverflowSubL: 251
  1, // OverflowMulL: 252
  0, // PCTable: 253
  0, // Parm: 254
  0, // PartialSubtypeCheck: 255
  0, // SubTypeCheck: 256
  0, // Phi: 257
  0, // PopCountI: 258
  0, // PopCountL: 259
  0, // PopCountVI: 260
  0, // PrefetchAllocation: 261
  0, // Proj: 262
  0, // RShiftI: 263
  0, // RShiftL: 264
  0, // Region: 265
  0, // Rethrow: 266
  0, // Return: 267
  0, // Root: 268
  0, // RoundDouble: 269
  0, // RoundDoubleMode: 270
  0, // RoundDoubleModeV: 271
  0, // RoundFloat: 272
  0, // RotateLeft: 273
  0, // RotateLeftV: 274
  0, // RotateRight: 275
  0, // RotateRightV: 276
  0, // SafePoint: 277
  0, // SafePointScalarObject: 278
  0, // ShenandoahCompareAndExchangeP: 279
  0, // ShenandoahCompareAndExchangeN: 280
  0, // ShenandoahCompareAndSwapN: 281
  0, // ShenandoahCompareAndSwapP: 282
  0, // ShenandoahWeakCompareAndSwapN: 283
  0, // ShenandoahWeakCompareAndSwapP: 284
  0, // ShenandoahIUBarrier: 285
  0, // ShenandoahLoadReferenceBarrier: 286
  0, // SCMemProj: 287
  0, // CopySignD: 288
  0, // CopySignF: 289
  0, // SignumD: 290
  0, // SignumF: 291
  0, // SqrtD: 292
  0, // SqrtF: 293
  0, // Start: 294
  0, // StartOSR: 295
  0, // StoreB: 296
  0, // StoreC: 297
  0, // StoreCM: 298
  0, // StorePConditional: 299
  0, // StoreIConditional: 300
  0, // StoreLConditional: 301
  0, // StoreD: 302
  0, // StoreF: 303
  0, // StoreI: 304
  0, // StoreL: 305
  0, // StoreP: 306
  0, // StoreN: 307
  0, // StoreNKlass: 308
  0, // StrComp: 309
  0, // StrCompressedCopy: 310
  0, // StrEquals: 311
  0, // StrIndexOf: 312
  0, // StrIndexOfChar: 313
  0, // StrInflatedCopy: 314
  0, // SubD: 315
  0, // SubF: 316
  0, // SubI: 317
  0, // SubL: 318
  0, // TailCall: 319
  0, // TailJump: 320
  0, // MacroLogicV: 321
  0, // ThreadLocal: 322
  0, // Unlock: 323
  0, // URShiftB: 324
  0, // URShiftS: 325
  0, // URShiftI: 326
  0, // URShiftL: 327
  0, // XorI: 328
  0, // XorL: 329
  0, // Vector: 330
  0, // AddVB: 331
  0, // AddVS: 332
  0, // AddVI: 333
  0, // AddReductionVI: 334
  0, // AddVL: 335
  0, // AddReductionVL: 336
  0, // AddVF: 337
  0, // AddReductionVF: 338
  0, // AddVD: 339
  0, // AddReductionVD: 340
  0, // SubVB: 341
  0, // SubVS: 342
  0, // SubVI: 343
  0, // SubVL: 344
  0, // SubVF: 345
  0, // SubVD: 346
  0, // MulVB: 347
  0, // MulVS: 348
  0, // MulVI: 349
  0, // MulReductionVI: 350
  0, // MulVL: 351
  0, // MulReductionVL: 352
  0, // MulVF: 353
  0, // MulReductionVF: 354
  0, // MulVD: 355
  0, // MulReductionVD: 356
  0, // MulAddVS2VI: 357
  0, // FmaVD: 358
  0, // FmaVF: 359
  0, // DivVF: 360
  0, // DivVD: 361
  0, // AbsVB: 362
  0, // AbsVS: 363
  0, // AbsVI: 364
  0, // AbsVL: 365
  0, // AbsVF: 366
  0, // AbsVD: 367
  0, // NegVI: 368
  0, // NegVF: 369
  0, // NegVD: 370
  0, // SqrtVD: 371
  0, // SqrtVF: 372
  0, // LShiftCntV: 373
  0, // RShiftCntV: 374
  0, // LShiftVB: 375
  0, // LShiftVS: 376
  0, // LShiftVI: 377
  0, // LShiftVL: 378
  0, // RShiftVB: 379
  0, // RShiftVS: 380
  0, // RShiftVI: 381
  0, // RShiftVL: 382
  0, // URShiftVB: 383
  0, // URShiftVS: 384
  0, // URShiftVI: 385
  0, // URShiftVL: 386
  0, // AndV: 387
  0, // AndReductionV: 388
  0, // OrV: 389
  0, // OrReductionV: 390
  0, // XorV: 391
  0, // XorReductionV: 392
  0, // MinV: 393
  0, // MaxV: 394
  0, // MinReductionV: 395
  0, // MaxReductionV: 396
  0, // LoadVector: 397
  0, // LoadVectorGather: 398
  0, // StoreVector: 399
  0, // StoreVectorScatter: 400
  0, // LoadVectorMasked: 401
  0, // StoreVectorMasked: 402
  0, // VectorCmpMasked: 403
  0, // VectorMaskGen: 404
  0, // VectorMaskOp: 405
  0, // VectorMaskTrueCount: 406
  0, // VectorMaskFirstTrue: 407
  0, // VectorMaskLastTrue: 408
  0, // Pack: 409
  0, // PackB: 410
  0, // PackS: 411
  0, // PackI: 412
  0, // PackL: 413
  0, // PackF: 414
  0, // PackD: 415
  0, // Pack2L: 416
  0, // Pack2D: 417
  0, // ReplicateB: 418
  0, // ReplicateS: 419
  0, // ReplicateI: 420
  0, // ReplicateL: 421
  0, // ReplicateF: 422
  0, // ReplicateD: 423
  0, // Extract: 424
  0, // ExtractB: 425
  0, // ExtractUB: 426
  0, // ExtractC: 427
  0, // ExtractS: 428
  0, // ExtractI: 429
  0, // ExtractL: 430
  0, // ExtractF: 431
  0, // ExtractD: 432
  0, // Digit: 433
  0, // LowerCase: 434
  0, // UpperCase: 435
  0, // Whitespace: 436
  0, // VectorBox: 437
  0, // VectorBoxAllocate: 438
  0, // VectorUnbox: 439
  0, // VectorMaskWrapper: 440
  0, // VectorMaskCmp: 441
  0, // VectorMaskCast: 442
  0, // VectorTest: 443
  0, // VectorBlend: 444
  0, // VectorRearrange: 445
  0, // VectorLoadMask: 446
  0, // VectorLoadShuffle: 447
  0, // VectorLoadConst: 448
  0, // VectorStoreMask: 449
  0, // VectorReinterpret: 450
  0, // VectorCast: 451
  0, // VectorCastB2X: 452
  0, // VectorCastS2X: 453
  0, // VectorCastI2X: 454
  0, // VectorCastL2X: 455
  0, // VectorCastF2X: 456
  0, // VectorCastD2X: 457
  0 // no trailing comma // VectorInsert: 458
};
//  The following instructions can cisc-spill



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "S7",
  "S7_H",
  "S0",
  "S0_H",
  "S1",
  "S1_H",
  "S2",
  "S2_H",
  "S4",
  "S4_H",
  "S5",
  "S5_H",
  "S6",
  "S6_H",
  "S3",
  "S3_H",
  "T2",
  "T2_H",
  "T3",
  "T3_H",
  "T8",
  "T8_H",
  "T4",
  "T4_H",
  "T1",
  "T1_H",
  "T6",
  "T6_H",
  "A7",
  "A7_H",
  "A6",
  "A6_H",
  "A5",
  "A5_H",
  "A4",
  "A4_H",
  "T5",
  "T5_H",
  "A3",
  "A3_H",
  "A2",
  "A2_H",
  "A1",
  "A1_H",
  "A0",
  "A0_H",
  "T0",
  "T0_H",
  "S8",
  "S8_H",
  "RA",
  "RA_H",
  "SP",
  "SP_H",
  "FP",
  "FP_H",
  "T7",
  "T7_H",
  "TP",
  "TP_H",
  "RX",
  "RX_H",
  "R0",
  "R0_H",
  "F0",
  "F0_H",
  "F0_J",
  "F0_K",
  "F0_L",
  "F0_M",
  "F0_N",
  "F0_O",
  "F1",
  "F1_H",
  "F1_J",
  "F1_K",
  "F1_L",
  "F1_M",
  "F1_N",
  "F1_O",
  "F2",
  "F2_H",
  "F2_J",
  "F2_K",
  "F2_L",
  "F2_M",
  "F2_N",
  "F2_O",
  "F3",
  "F3_H",
  "F3_J",
  "F3_K",
  "F3_L",
  "F3_M",
  "F3_N",
  "F3_O",
  "F4",
  "F4_H",
  "F4_J",
  "F4_K",
  "F4_L",
  "F4_M",
  "F4_N",
  "F4_O",
  "F5",
  "F5_H",
  "F5_J",
  "F5_K",
  "F5_L",
  "F5_M",
  "F5_N",
  "F5_O",
  "F6",
  "F6_H",
  "F6_J",
  "F6_K",
  "F6_L",
  "F6_M",
  "F6_N",
  "F6_O",
  "F7",
  "F7_H",
  "F7_J",
  "F7_K",
  "F7_L",
  "F7_M",
  "F7_N",
  "F7_O",
  "F8",
  "F8_H",
  "F8_J",
  "F8_K",
  "F8_L",
  "F8_M",
  "F8_N",
  "F8_O",
  "F9",
  "F9_H",
  "F9_J",
  "F9_K",
  "F9_L",
  "F9_M",
  "F9_N",
  "F9_O",
  "F10",
  "F10_H",
  "F10_J",
  "F10_K",
  "F10_L",
  "F10_M",
  "F10_N",
  "F10_O",
  "F11",
  "F11_H",
  "F11_J",
  "F11_K",
  "F11_L",
  "F11_M",
  "F11_N",
  "F11_O",
  "F12",
  "F12_H",
  "F12_J",
  "F12_K",
  "F12_L",
  "F12_M",
  "F12_N",
  "F12_O",
  "F13",
  "F13_H",
  "F13_J",
  "F13_K",
  "F13_L",
  "F13_M",
  "F13_N",
  "F13_O",
  "F14",
  "F14_H",
  "F14_J",
  "F14_K",
  "F14_L",
  "F14_M",
  "F14_N",
  "F14_O",
  "F15",
  "F15_H",
  "F15_J",
  "F15_K",
  "F15_L",
  "F15_M",
  "F15_N",
  "F15_O",
  "F16",
  "F16_H",
  "F16_J",
  "F16_K",
  "F16_L",
  "F16_M",
  "F16_N",
  "F16_O",
  "F17",
  "F17_H",
  "F17_J",
  "F17_K",
  "F17_L",
  "F17_M",
  "F17_N",
  "F17_O",
  "F18",
  "F18_H",
  "F18_J",
  "F18_K",
  "F18_L",
  "F18_M",
  "F18_N",
  "F18_O",
  "F19",
  "F19_H",
  "F19_J",
  "F19_K",
  "F19_L",
  "F19_M",
  "F19_N",
  "F19_O",
  "F20",
  "F20_H",
  "F20_J",
  "F20_K",
  "F20_L",
  "F20_M",
  "F20_N",
  "F20_O",
  "F21",
  "F21_H",
  "F21_J",
  "F21_K",
  "F21_L",
  "F21_M",
  "F21_N",
  "F21_O",
  "F22",
  "F22_H",
  "F22_J",
  "F22_K",
  "F22_L",
  "F22_M",
  "F22_N",
  "F22_O",
  "F24",
  "F24_H",
  "F24_J",
  "F24_K",
  "F24_L",
  "F24_M",
  "F24_N",
  "F24_O",
  "F25",
  "F25_H",
  "F25_J",
  "F25_K",
  "F25_L",
  "F25_M",
  "F25_N",
  "F25_O",
  "F26",
  "F26_H",
  "F26_J",
  "F26_K",
  "F26_L",
  "F26_M",
  "F26_N",
  "F26_O",
  "F27",
  "F27_H",
  "F27_J",
  "F27_K",
  "F27_L",
  "F27_M",
  "F27_N",
  "F27_O",
  "F28",
  "F28_H",
  "F28_J",
  "F28_K",
  "F28_L",
  "F28_M",
  "F28_N",
  "F28_O",
  "F29",
  "F29_H",
  "F29_J",
  "F29_K",
  "F29_L",
  "F29_M",
  "F29_N",
  "F29_O",
  "F30",
  "F30_H",
  "F30_J",
  "F30_K",
  "F30_L",
  "F30_M",
  "F30_N",
  "F30_O",
  "F31",
  "F31_H",
  "F31_J",
  "F31_K",
  "F31_L",
  "F31_M",
  "F31_N",
  "F31_O",
  "F23",
  "F23_H",
  "F23_J",
  "F23_K",
  "F23_L",
  "F23_M",
  "F23_N",
  "F23_O" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	S7->as_VMReg(),
	S7->as_VMReg()->next(),
	S0->as_VMReg(),
	S0->as_VMReg()->next(),
	S1->as_VMReg(),
	S1->as_VMReg()->next(),
	S2->as_VMReg(),
	S2->as_VMReg()->next(),
	S4->as_VMReg(),
	S4->as_VMReg()->next(),
	S5->as_VMReg(),
	S5->as_VMReg()->next(),
	S6->as_VMReg(),
	S6->as_VMReg()->next(),
	S3->as_VMReg(),
	S3->as_VMReg()->next(),
	T2->as_VMReg(),
	T2->as_VMReg()->next(),
	T3->as_VMReg(),
	T3->as_VMReg()->next(),
	T8->as_VMReg(),
	T8->as_VMReg()->next(),
	T4->as_VMReg(),
	T4->as_VMReg()->next(),
	T1->as_VMReg(),
	T1->as_VMReg()->next(),
	T6->as_VMReg(),
	T6->as_VMReg()->next(),
	A7->as_VMReg(),
	A7->as_VMReg()->next(),
	A6->as_VMReg(),
	A6->as_VMReg()->next(),
	A5->as_VMReg(),
	A5->as_VMReg()->next(),
	A4->as_VMReg(),
	A4->as_VMReg()->next(),
	T5->as_VMReg(),
	T5->as_VMReg()->next(),
	A3->as_VMReg(),
	A3->as_VMReg()->next(),
	A2->as_VMReg(),
	A2->as_VMReg()->next(),
	A1->as_VMReg(),
	A1->as_VMReg()->next(),
	A0->as_VMReg(),
	A0->as_VMReg()->next(),
	T0->as_VMReg(),
	T0->as_VMReg()->next(),
	S8->as_VMReg(),
	S8->as_VMReg()->next(),
	RA->as_VMReg(),
	RA->as_VMReg()->next(),
	SP->as_VMReg(),
	SP->as_VMReg()->next(),
	FP->as_VMReg(),
	FP->as_VMReg()->next(),
	T7->as_VMReg(),
	T7->as_VMReg()->next(),
	TP->as_VMReg(),
	TP->as_VMReg()->next(),
	RX->as_VMReg(),
	RX->as_VMReg()->next(),
	R0->as_VMReg(),
	R0->as_VMReg()->next(),
	F0->as_VMReg()          ,
	F0->as_VMReg()->next()  ,
	F0->as_VMReg()->next(2) ,
	F0->as_VMReg()->next(3) ,
	F0->as_VMReg()->next(4) ,
	F0->as_VMReg()->next(5) ,
	F0->as_VMReg()->next(6) ,
	F0->as_VMReg()->next(7) ,
	F1->as_VMReg()          ,
	F1->as_VMReg()->next()  ,
	F1->as_VMReg()->next(2) ,
	F1->as_VMReg()->next(3) ,
	F1->as_VMReg()->next(4) ,
	F1->as_VMReg()->next(5) ,
	F1->as_VMReg()->next(6) ,
	F1->as_VMReg()->next(7) ,
	F2->as_VMReg()          ,
	F2->as_VMReg()->next()  ,
	F2->as_VMReg()->next(2) ,
	F2->as_VMReg()->next(3) ,
	F2->as_VMReg()->next(4) ,
	F2->as_VMReg()->next(5) ,
	F2->as_VMReg()->next(6) ,
	F2->as_VMReg()->next(7) ,
	F3->as_VMReg()          ,
	F3->as_VMReg()->next()  ,
	F3->as_VMReg()->next(2) ,
	F3->as_VMReg()->next(3) ,
	F3->as_VMReg()->next(4) ,
	F3->as_VMReg()->next(5) ,
	F3->as_VMReg()->next(6) ,
	F3->as_VMReg()->next(7) ,
	F4->as_VMReg()          ,
	F4->as_VMReg()->next()  ,
	F4->as_VMReg()->next(2) ,
	F4->as_VMReg()->next(3) ,
	F4->as_VMReg()->next(4) ,
	F4->as_VMReg()->next(5) ,
	F4->as_VMReg()->next(6) ,
	F4->as_VMReg()->next(7) ,
	F5->as_VMReg()          ,
	F5->as_VMReg()->next()  ,
	F5->as_VMReg()->next(2) ,
	F5->as_VMReg()->next(3) ,
	F5->as_VMReg()->next(4) ,
	F5->as_VMReg()->next(5) ,
	F5->as_VMReg()->next(6) ,
	F5->as_VMReg()->next(7) ,
	F6->as_VMReg()          ,
	F6->as_VMReg()->next()  ,
	F6->as_VMReg()->next(2) ,
	F6->as_VMReg()->next(3) ,
	F6->as_VMReg()->next(4) ,
	F6->as_VMReg()->next(5) ,
	F6->as_VMReg()->next(6) ,
	F6->as_VMReg()->next(7) ,
	F7->as_VMReg()          ,
	F7->as_VMReg()->next()  ,
	F7->as_VMReg()->next(2) ,
	F7->as_VMReg()->next(3) ,
	F7->as_VMReg()->next(4) ,
	F7->as_VMReg()->next(5) ,
	F7->as_VMReg()->next(6) ,
	F7->as_VMReg()->next(7) ,
	F8->as_VMReg()          ,
	F8->as_VMReg()->next()  ,
	F8->as_VMReg()->next(2) ,
	F8->as_VMReg()->next(3) ,
	F8->as_VMReg()->next(4) ,
	F8->as_VMReg()->next(5) ,
	F8->as_VMReg()->next(6) ,
	F8->as_VMReg()->next(7) ,
	F9->as_VMReg()          ,
	F9->as_VMReg()->next()  ,
	F9->as_VMReg()->next(2) ,
	F9->as_VMReg()->next(3) ,
	F9->as_VMReg()->next(4) ,
	F9->as_VMReg()->next(5) ,
	F9->as_VMReg()->next(6) ,
	F9->as_VMReg()->next(7) ,
	F10->as_VMReg()          ,
	F10->as_VMReg()->next()  ,
	F10->as_VMReg()->next(2) ,
	F10->as_VMReg()->next(3) ,
	F10->as_VMReg()->next(4) ,
	F10->as_VMReg()->next(5) ,
	F10->as_VMReg()->next(6) ,
	F10->as_VMReg()->next(7) ,
	F11->as_VMReg()          ,
	F11->as_VMReg()->next()  ,
	F11->as_VMReg()->next(2) ,
	F11->as_VMReg()->next(3) ,
	F11->as_VMReg()->next(4) ,
	F11->as_VMReg()->next(5) ,
	F11->as_VMReg()->next(6) ,
	F11->as_VMReg()->next(7) ,
	F12->as_VMReg()          ,
	F12->as_VMReg()->next()  ,
	F12->as_VMReg()->next(2) ,
	F12->as_VMReg()->next(3) ,
	F12->as_VMReg()->next(4) ,
	F12->as_VMReg()->next(5) ,
	F12->as_VMReg()->next(6) ,
	F12->as_VMReg()->next(7) ,
	F13->as_VMReg()          ,
	F13->as_VMReg()->next()  ,
	F13->as_VMReg()->next(2) ,
	F13->as_VMReg()->next(3) ,
	F13->as_VMReg()->next(4) ,
	F13->as_VMReg()->next(5) ,
	F13->as_VMReg()->next(6) ,
	F13->as_VMReg()->next(7) ,
	F14->as_VMReg()          ,
	F14->as_VMReg()->next()  ,
	F14->as_VMReg()->next(2) ,
	F14->as_VMReg()->next(3) ,
	F14->as_VMReg()->next(4) ,
	F14->as_VMReg()->next(5) ,
	F14->as_VMReg()->next(6) ,
	F14->as_VMReg()->next(7) ,
	F15->as_VMReg()          ,
	F15->as_VMReg()->next()  ,
	F15->as_VMReg()->next(2) ,
	F15->as_VMReg()->next(3) ,
	F15->as_VMReg()->next(4) ,
	F15->as_VMReg()->next(5) ,
	F15->as_VMReg()->next(6) ,
	F15->as_VMReg()->next(7) ,
	F16->as_VMReg()          ,
	F16->as_VMReg()->next()  ,
	F16->as_VMReg()->next(2) ,
	F16->as_VMReg()->next(3) ,
	F16->as_VMReg()->next(4) ,
	F16->as_VMReg()->next(5) ,
	F16->as_VMReg()->next(6) ,
	F16->as_VMReg()->next(7) ,
	F17->as_VMReg()          ,
	F17->as_VMReg()->next()  ,
	F17->as_VMReg()->next(2) ,
	F17->as_VMReg()->next(3) ,
	F17->as_VMReg()->next(4) ,
	F17->as_VMReg()->next(5) ,
	F17->as_VMReg()->next(6) ,
	F17->as_VMReg()->next(7) ,
	F18->as_VMReg()          ,
	F18->as_VMReg()->next()  ,
	F18->as_VMReg()->next(2) ,
	F18->as_VMReg()->next(3) ,
	F18->as_VMReg()->next(4) ,
	F18->as_VMReg()->next(5) ,
	F18->as_VMReg()->next(6) ,
	F18->as_VMReg()->next(7) ,
	F19->as_VMReg()          ,
	F19->as_VMReg()->next()  ,
	F19->as_VMReg()->next(2) ,
	F19->as_VMReg()->next(3) ,
	F19->as_VMReg()->next(4) ,
	F19->as_VMReg()->next(5) ,
	F19->as_VMReg()->next(6) ,
	F19->as_VMReg()->next(7) ,
	F20->as_VMReg()          ,
	F20->as_VMReg()->next()  ,
	F20->as_VMReg()->next(2) ,
	F20->as_VMReg()->next(3) ,
	F20->as_VMReg()->next(4) ,
	F20->as_VMReg()->next(5) ,
	F20->as_VMReg()->next(6) ,
	F20->as_VMReg()->next(7) ,
	F21->as_VMReg()          ,
	F21->as_VMReg()->next()  ,
	F21->as_VMReg()->next(2) ,
	F21->as_VMReg()->next(3) ,
	F21->as_VMReg()->next(4) ,
	F21->as_VMReg()->next(5) ,
	F21->as_VMReg()->next(6) ,
	F21->as_VMReg()->next(7) ,
	F22->as_VMReg()          ,
	F22->as_VMReg()->next()  ,
	F22->as_VMReg()->next(2) ,
	F22->as_VMReg()->next(3) ,
	F22->as_VMReg()->next(4) ,
	F22->as_VMReg()->next(5) ,
	F22->as_VMReg()->next(6) ,
	F22->as_VMReg()->next(7) ,
	F24->as_VMReg()          ,
	F24->as_VMReg()->next()  ,
	F24->as_VMReg()->next(2) ,
	F24->as_VMReg()->next(3) ,
	F24->as_VMReg()->next(4) ,
	F24->as_VMReg()->next(5) ,
	F24->as_VMReg()->next(6) ,
	F24->as_VMReg()->next(7) ,
	F25->as_VMReg()          ,
	F25->as_VMReg()->next()  ,
	F25->as_VMReg()->next(2) ,
	F25->as_VMReg()->next(3) ,
	F25->as_VMReg()->next(4) ,
	F25->as_VMReg()->next(5) ,
	F25->as_VMReg()->next(6) ,
	F25->as_VMReg()->next(7) ,
	F26->as_VMReg()          ,
	F26->as_VMReg()->next()  ,
	F26->as_VMReg()->next(2) ,
	F26->as_VMReg()->next(3) ,
	F26->as_VMReg()->next(4) ,
	F26->as_VMReg()->next(5) ,
	F26->as_VMReg()->next(6) ,
	F26->as_VMReg()->next(7) ,
	F27->as_VMReg()          ,
	F27->as_VMReg()->next()  ,
	F27->as_VMReg()->next(2) ,
	F27->as_VMReg()->next(3) ,
	F27->as_VMReg()->next(4) ,
	F27->as_VMReg()->next(5) ,
	F27->as_VMReg()->next(6) ,
	F27->as_VMReg()->next(7) ,
	F28->as_VMReg()          ,
	F28->as_VMReg()->next()  ,
	F28->as_VMReg()->next(2) ,
	F28->as_VMReg()->next(3) ,
	F28->as_VMReg()->next(4) ,
	F28->as_VMReg()->next(5) ,
	F28->as_VMReg()->next(6) ,
	F28->as_VMReg()->next(7) ,
	F29->as_VMReg()          ,
	F29->as_VMReg()->next()  ,
	F29->as_VMReg()->next(2) ,
	F29->as_VMReg()->next(3) ,
	F29->as_VMReg()->next(4) ,
	F29->as_VMReg()->next(5) ,
	F29->as_VMReg()->next(6) ,
	F29->as_VMReg()->next(7) ,
	F30->as_VMReg()          ,
	F30->as_VMReg()->next()  ,
	F30->as_VMReg()->next(2) ,
	F30->as_VMReg()->next(3) ,
	F30->as_VMReg()->next(4) ,
	F30->as_VMReg()->next(5) ,
	F30->as_VMReg()->next(6) ,
	F30->as_VMReg()->next(7) ,
	F31->as_VMReg()          ,
	F31->as_VMReg()->next()  ,
	F31->as_VMReg()->next(2) ,
	F31->as_VMReg()->next(3) ,
	F31->as_VMReg()->next(4) ,
	F31->as_VMReg()->next(5) ,
	F31->as_VMReg()->next(6) ,
	F31->as_VMReg()->next(7) ,
	F23->as_VMReg()          ,
	F23->as_VMReg()->next()  ,
	F23->as_VMReg()->next(2) ,
	F23->as_VMReg()->next(3) ,
	F23->as_VMReg()->next(4) ,
	F23->as_VMReg()->next(5) ,
	F23->as_VMReg()->next(6) ,
	F23->as_VMReg()->next(7)  // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\x1E',  // S7
  (unsigned char)'\x1E',  // S7_H
  (unsigned char)'\x17',  // S0
  (unsigned char)'\x17',  // S0_H
  (unsigned char)'\x18',  // S1
  (unsigned char)'\x18',  // S1_H
  (unsigned char)'\x19',  // S2
  (unsigned char)'\x19',  // S2_H
  (unsigned char)'\x1B',  // S4
  (unsigned char)'\x1B',  // S4_H
  (unsigned char)'\x1C',  // S5
  (unsigned char)'\x1C',  // S5_H
  (unsigned char)'\x1D',  // S6
  (unsigned char)'\x1D',  // S6_H
  (unsigned char)'\x1A',  // S3
  (unsigned char)'\x1A',  // S3_H
  (unsigned char)'\xE',  // T2
  (unsigned char)'\xE',  // T2_H
  (unsigned char)'\xF',  // T3
  (unsigned char)'\xF',  // T3_H
  (unsigned char)'\x14',  // T8
  (unsigned char)'\x14',  // T8_H
  (unsigned char)'\x10',  // T4
  (unsigned char)'\x10',  // T4_H
  (unsigned char)'\xD',  // T1
  (unsigned char)'\xD',  // T1_H
  (unsigned char)'\x12',  // T6
  (unsigned char)'\x12',  // T6_H
  (unsigned char)'\xB',  // A7
  (unsigned char)'\xB',  // A7_H
  (unsigned char)'\xA',  // A6
  (unsigned char)'\xA',  // A6_H
  (unsigned char)'\x9',  // A5
  (unsigned char)'\x9',  // A5_H
  (unsigned char)'\x8',  // A4
  (unsigned char)'\x8',  // A4_H
  (unsigned char)'\x11',  // T5
  (unsigned char)'\x11',  // T5_H
  (unsigned char)'\x7',  // A3
  (unsigned char)'\x7',  // A3_H
  (unsigned char)'\x6',  // A2
  (unsigned char)'\x6',  // A2_H
  (unsigned char)'\x5',  // A1
  (unsigned char)'\x5',  // A1_H
  (unsigned char)'\x4',  // A0
  (unsigned char)'\x4',  // A0_H
  (unsigned char)'\xC',  // T0
  (unsigned char)'\xC',  // T0_H
  (unsigned char)'\x1F',  // S8
  (unsigned char)'\x1F',  // S8_H
  (unsigned char)'\x1',  // RA
  (unsigned char)'\x1',  // RA_H
  (unsigned char)'\x3',  // SP
  (unsigned char)'\x3',  // SP_H
  (unsigned char)'\x16',  // FP
  (unsigned char)'\x16',  // FP_H
  (unsigned char)'\x13',  // T7
  (unsigned char)'\x13',  // T7_H
  (unsigned char)'\x2',  // TP
  (unsigned char)'\x2',  // TP_H
  (unsigned char)'\x15',  // RX
  (unsigned char)'\x15',  // RX_H
  (unsigned char)'\x0',  // R0
  (unsigned char)'\x0',  // R0_H
  (unsigned char)'\x0',  // F0
  (unsigned char)'\x0',  // F0_H
  (unsigned char)'\x0',  // F0_J
  (unsigned char)'\x0',  // F0_K
  (unsigned char)'\x0',  // F0_L
  (unsigned char)'\x0',  // F0_M
  (unsigned char)'\x0',  // F0_N
  (unsigned char)'\x0',  // F0_O
  (unsigned char)'\x1',  // F1
  (unsigned char)'\x1',  // F1_H
  (unsigned char)'\x1',  // F1_J
  (unsigned char)'\x1',  // F1_K
  (unsigned char)'\x1',  // F1_L
  (unsigned char)'\x1',  // F1_M
  (unsigned char)'\x1',  // F1_N
  (unsigned char)'\x1',  // F1_O
  (unsigned char)'\x2',  // F2
  (unsigned char)'\x2',  // F2_H
  (unsigned char)'\x2',  // F2_J
  (unsigned char)'\x2',  // F2_K
  (unsigned char)'\x2',  // F2_L
  (unsigned char)'\x2',  // F2_M
  (unsigned char)'\x2',  // F2_N
  (unsigned char)'\x2',  // F2_O
  (unsigned char)'\x3',  // F3
  (unsigned char)'\x3',  // F3_H
  (unsigned char)'\x3',  // F3_J
  (unsigned char)'\x3',  // F3_K
  (unsigned char)'\x3',  // F3_L
  (unsigned char)'\x3',  // F3_M
  (unsigned char)'\x3',  // F3_N
  (unsigned char)'\x3',  // F3_O
  (unsigned char)'\x4',  // F4
  (unsigned char)'\x4',  // F4_H
  (unsigned char)'\x4',  // F4_J
  (unsigned char)'\x4',  // F4_K
  (unsigned char)'\x4',  // F4_L
  (unsigned char)'\x4',  // F4_M
  (unsigned char)'\x4',  // F4_N
  (unsigned char)'\x4',  // F4_O
  (unsigned char)'\x5',  // F5
  (unsigned char)'\x5',  // F5_H
  (unsigned char)'\x5',  // F5_J
  (unsigned char)'\x5',  // F5_K
  (unsigned char)'\x5',  // F5_L
  (unsigned char)'\x5',  // F5_M
  (unsigned char)'\x5',  // F5_N
  (unsigned char)'\x5',  // F5_O
  (unsigned char)'\x6',  // F6
  (unsigned char)'\x6',  // F6_H
  (unsigned char)'\x6',  // F6_J
  (unsigned char)'\x6',  // F6_K
  (unsigned char)'\x6',  // F6_L
  (unsigned char)'\x6',  // F6_M
  (unsigned char)'\x6',  // F6_N
  (unsigned char)'\x6',  // F6_O
  (unsigned char)'\x7',  // F7
  (unsigned char)'\x7',  // F7_H
  (unsigned char)'\x7',  // F7_J
  (unsigned char)'\x7',  // F7_K
  (unsigned char)'\x7',  // F7_L
  (unsigned char)'\x7',  // F7_M
  (unsigned char)'\x7',  // F7_N
  (unsigned char)'\x7',  // F7_O
  (unsigned char)'\x8',  // F8
  (unsigned char)'\x8',  // F8_H
  (unsigned char)'\x8',  // F8_J
  (unsigned char)'\x8',  // F8_K
  (unsigned char)'\x8',  // F8_L
  (unsigned char)'\x8',  // F8_M
  (unsigned char)'\x8',  // F8_N
  (unsigned char)'\x8',  // F8_O
  (unsigned char)'\x9',  // F9
  (unsigned char)'\x9',  // F9_H
  (unsigned char)'\x9',  // F9_J
  (unsigned char)'\x9',  // F9_K
  (unsigned char)'\x9',  // F9_L
  (unsigned char)'\x9',  // F9_M
  (unsigned char)'\x9',  // F9_N
  (unsigned char)'\x9',  // F9_O
  (unsigned char)'\xA',  // F10
  (unsigned char)'\xA',  // F10_H
  (unsigned char)'\xA',  // F10_J
  (unsigned char)'\xA',  // F10_K
  (unsigned char)'\xA',  // F10_L
  (unsigned char)'\xA',  // F10_M
  (unsigned char)'\xA',  // F10_N
  (unsigned char)'\xA',  // F10_O
  (unsigned char)'\xB',  // F11
  (unsigned char)'\xB',  // F11_H
  (unsigned char)'\xB',  // F11_J
  (unsigned char)'\xB',  // F11_K
  (unsigned char)'\xB',  // F11_L
  (unsigned char)'\xB',  // F11_M
  (unsigned char)'\xB',  // F11_N
  (unsigned char)'\xB',  // F11_O
  (unsigned char)'\xC',  // F12
  (unsigned char)'\xC',  // F12_H
  (unsigned char)'\xC',  // F12_J
  (unsigned char)'\xC',  // F12_K
  (unsigned char)'\xC',  // F12_L
  (unsigned char)'\xC',  // F12_M
  (unsigned char)'\xC',  // F12_N
  (unsigned char)'\xC',  // F12_O
  (unsigned char)'\xD',  // F13
  (unsigned char)'\xD',  // F13_H
  (unsigned char)'\xD',  // F13_J
  (unsigned char)'\xD',  // F13_K
  (unsigned char)'\xD',  // F13_L
  (unsigned char)'\xD',  // F13_M
  (unsigned char)'\xD',  // F13_N
  (unsigned char)'\xD',  // F13_O
  (unsigned char)'\xE',  // F14
  (unsigned char)'\xE',  // F14_H
  (unsigned char)'\xE',  // F14_J
  (unsigned char)'\xE',  // F14_K
  (unsigned char)'\xE',  // F14_L
  (unsigned char)'\xE',  // F14_M
  (unsigned char)'\xE',  // F14_N
  (unsigned char)'\xE',  // F14_O
  (unsigned char)'\xF',  // F15
  (unsigned char)'\xF',  // F15_H
  (unsigned char)'\xF',  // F15_J
  (unsigned char)'\xF',  // F15_K
  (unsigned char)'\xF',  // F15_L
  (unsigned char)'\xF',  // F15_M
  (unsigned char)'\xF',  // F15_N
  (unsigned char)'\xF',  // F15_O
  (unsigned char)'\x10',  // F16
  (unsigned char)'\x10',  // F16_H
  (unsigned char)'\x10',  // F16_J
  (unsigned char)'\x10',  // F16_K
  (unsigned char)'\x10',  // F16_L
  (unsigned char)'\x10',  // F16_M
  (unsigned char)'\x10',  // F16_N
  (unsigned char)'\x10',  // F16_O
  (unsigned char)'\x11',  // F17
  (unsigned char)'\x11',  // F17_H
  (unsigned char)'\x11',  // F17_J
  (unsigned char)'\x11',  // F17_K
  (unsigned char)'\x11',  // F17_L
  (unsigned char)'\x11',  // F17_M
  (unsigned char)'\x11',  // F17_N
  (unsigned char)'\x11',  // F17_O
  (unsigned char)'\x12',  // F18
  (unsigned char)'\x12',  // F18_H
  (unsigned char)'\x12',  // F18_J
  (unsigned char)'\x12',  // F18_K
  (unsigned char)'\x12',  // F18_L
  (unsigned char)'\x12',  // F18_M
  (unsigned char)'\x12',  // F18_N
  (unsigned char)'\x12',  // F18_O
  (unsigned char)'\x13',  // F19
  (unsigned char)'\x13',  // F19_H
  (unsigned char)'\x13',  // F19_J
  (unsigned char)'\x13',  // F19_K
  (unsigned char)'\x13',  // F19_L
  (unsigned char)'\x13',  // F19_M
  (unsigned char)'\x13',  // F19_N
  (unsigned char)'\x13',  // F19_O
  (unsigned char)'\x14',  // F20
  (unsigned char)'\x14',  // F20_H
  (unsigned char)'\x14',  // F20_J
  (unsigned char)'\x14',  // F20_K
  (unsigned char)'\x14',  // F20_L
  (unsigned char)'\x14',  // F20_M
  (unsigned char)'\x14',  // F20_N
  (unsigned char)'\x14',  // F20_O
  (unsigned char)'\x15',  // F21
  (unsigned char)'\x15',  // F21_H
  (unsigned char)'\x15',  // F21_J
  (unsigned char)'\x15',  // F21_K
  (unsigned char)'\x15',  // F21_L
  (unsigned char)'\x15',  // F21_M
  (unsigned char)'\x15',  // F21_N
  (unsigned char)'\x15',  // F21_O
  (unsigned char)'\x16',  // F22
  (unsigned char)'\x16',  // F22_H
  (unsigned char)'\x16',  // F22_J
  (unsigned char)'\x16',  // F22_K
  (unsigned char)'\x16',  // F22_L
  (unsigned char)'\x16',  // F22_M
  (unsigned char)'\x16',  // F22_N
  (unsigned char)'\x16',  // F22_O
  (unsigned char)'\x18',  // F24
  (unsigned char)'\x18',  // F24_H
  (unsigned char)'\x18',  // F24_J
  (unsigned char)'\x18',  // F24_K
  (unsigned char)'\x18',  // F24_L
  (unsigned char)'\x18',  // F24_M
  (unsigned char)'\x18',  // F24_N
  (unsigned char)'\x18',  // F24_O
  (unsigned char)'\x19',  // F25
  (unsigned char)'\x19',  // F25_H
  (unsigned char)'\x19',  // F25_J
  (unsigned char)'\x19',  // F25_K
  (unsigned char)'\x19',  // F25_L
  (unsigned char)'\x19',  // F25_M
  (unsigned char)'\x19',  // F25_N
  (unsigned char)'\x19',  // F25_O
  (unsigned char)'\x1A',  // F26
  (unsigned char)'\x1A',  // F26_H
  (unsigned char)'\x1A',  // F26_J
  (unsigned char)'\x1A',  // F26_K
  (unsigned char)'\x1A',  // F26_L
  (unsigned char)'\x1A',  // F26_M
  (unsigned char)'\x1A',  // F26_N
  (unsigned char)'\x1A',  // F26_O
  (unsigned char)'\x1B',  // F27
  (unsigned char)'\x1B',  // F27_H
  (unsigned char)'\x1B',  // F27_J
  (unsigned char)'\x1B',  // F27_K
  (unsigned char)'\x1B',  // F27_L
  (unsigned char)'\x1B',  // F27_M
  (unsigned char)'\x1B',  // F27_N
  (unsigned char)'\x1B',  // F27_O
  (unsigned char)'\x1C',  // F28
  (unsigned char)'\x1C',  // F28_H
  (unsigned char)'\x1C',  // F28_J
  (unsigned char)'\x1C',  // F28_K
  (unsigned char)'\x1C',  // F28_L
  (unsigned char)'\x1C',  // F28_M
  (unsigned char)'\x1C',  // F28_N
  (unsigned char)'\x1C',  // F28_O
  (unsigned char)'\x1D',  // F29
  (unsigned char)'\x1D',  // F29_H
  (unsigned char)'\x1D',  // F29_J
  (unsigned char)'\x1D',  // F29_K
  (unsigned char)'\x1D',  // F29_L
  (unsigned char)'\x1D',  // F29_M
  (unsigned char)'\x1D',  // F29_N
  (unsigned char)'\x1D',  // F29_O
  (unsigned char)'\x1E',  // F30
  (unsigned char)'\x1E',  // F30_H
  (unsigned char)'\x1E',  // F30_J
  (unsigned char)'\x1E',  // F30_K
  (unsigned char)'\x1E',  // F30_L
  (unsigned char)'\x1E',  // F30_M
  (unsigned char)'\x1E',  // F30_N
  (unsigned char)'\x1E',  // F30_O
  (unsigned char)'\x1F',  // F31
  (unsigned char)'\x1F',  // F31_H
  (unsigned char)'\x1F',  // F31_J
  (unsigned char)'\x1F',  // F31_K
  (unsigned char)'\x1F',  // F31_L
  (unsigned char)'\x1F',  // F31_M
  (unsigned char)'\x1F',  // F31_N
  (unsigned char)'\x1F',  // F31_O
  (unsigned char)'\x17',  // F23
  (unsigned char)'\x17',  // F23_H
  (unsigned char)'\x17',  // F23_J
  (unsigned char)'\x17',  // F23_K
  (unsigned char)'\x17',  // F23_L
  (unsigned char)'\x17',  // F23_M
  (unsigned char)'\x17',  // F23_N
  (unsigned char)'\x17' // no trailing comma  // F23_O
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone() const {
  return  new labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone() const {
  return  new methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *vecXOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORX_REG_mask();
}

const RegMask *vecYOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORY_REG_mask();
}

const RegMask *FlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T0_REG_mask();
}

const RegMask *mRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *no_Ax_mRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_AX_INT_REG_mask();
}

const RegMask *mS0RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S0_REG_mask();
}

const RegMask *mS1RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S1_REG_mask();
}

const RegMask *mS3RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S3_REG_mask();
}

const RegMask *mS4RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S4_REG_mask();
}

const RegMask *mS5RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S5_REG_mask();
}

const RegMask *mS6RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S6_REG_mask();
}

const RegMask *mS7RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S7_REG_mask();
}

const RegMask *mT0RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T0_REG_mask();
}

const RegMask *mT1RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T1_REG_mask();
}

const RegMask *mT2RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T2_REG_mask();
}

const RegMask *mT3RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T3_REG_mask();
}

const RegMask *mT8RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T8_REG_mask();
}

const RegMask *mT4RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T4_REG_mask();
}

const RegMask *mA0RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A0_REG_mask();
}

const RegMask *mA1RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A1_REG_mask();
}

const RegMask *mA2RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A2_REG_mask();
}

const RegMask *mA3RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A3_REG_mask();
}

const RegMask *mA4RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A4_REG_mask();
}

const RegMask *mA5RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A5_REG_mask();
}

const RegMask *mA6RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A6_REG_mask();
}

const RegMask *mA7RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A7_REG_mask();
}

const RegMask *mRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *t0_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T0_REG_mask();
}

const RegMask *t1_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T1_REG_mask();
}

const RegMask *t3_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T3_REG_mask();
}

const RegMask *t8_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T8_REG_mask();
}

const RegMask *a0_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A0_REG_mask();
}

const RegMask *a1_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A1_REG_mask();
}

const RegMask *a2_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A2_REG_mask();
}

const RegMask *a3_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A3_REG_mask();
}

const RegMask *a4_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A4_REG_mask();
}

const RegMask *a5_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A5_REG_mask();
}

const RegMask *a6_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A6_REG_mask();
}

const RegMask *a7_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A7_REG_mask();
}

const RegMask *s0_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S0_REG_mask();
}

const RegMask *s1_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S1_REG_mask();
}

const RegMask *s2_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S2_REG_mask();
}

const RegMask *s3_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S3_REG_mask();
}

const RegMask *s4_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S4_REG_mask();
}

const RegMask *s5_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S5_REG_mask();
}

const RegMask *s6_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S6_REG_mask();
}

const RegMask *s7_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S7_REG_mask();
}

const RegMask *mRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *no_T8_mRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_T8_P_REG_mask();
}

const RegMask *no_Ax_mRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_AX_P_REG_mask();
}

const RegMask *s1_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S1_LONG_REG_mask();
}

const RegMask *s3_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S3_LONG_REG_mask();
}

const RegMask *s4_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S4_LONG_REG_mask();
}

const RegMask *s5_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S5_LONG_REG_mask();
}

const RegMask *s6_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S6_LONG_REG_mask();
}

const RegMask *s7_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S7_LONG_REG_mask();
}

const RegMask *t0_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T0_LONG_REG_mask();
}

const RegMask *t1_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T1_LONG_REG_mask();
}

const RegMask *t2_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T2_LONG_REG_mask();
}

const RegMask *t3_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T3_LONG_REG_mask();
}

const RegMask *t8_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T8_LONG_REG_mask();
}

const RegMask *a0_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A0_LONG_REG_mask();
}

const RegMask *a1_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A1_LONG_REG_mask();
}

const RegMask *a2_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A2_LONG_REG_mask();
}

const RegMask *a3_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A3_LONG_REG_mask();
}

const RegMask *a4_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A4_LONG_REG_mask();
}

const RegMask *a5_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A5_LONG_REG_mask();
}

const RegMask *a6_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A6_LONG_REG_mask();
}

const RegMask *a7_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A7_LONG_REG_mask();
}

const RegMask *v0_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V0_LONG_REG_mask();
}

const RegMask *v1_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V1_LONG_REG_mask();
}

const RegMask *mRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_REG_mask();
}

const RegMask *mRegI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *mRegL2IOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_REG_mask();
}

const RegMask *v0RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V0_LONG_REG_mask();
}

const RegMask *v1RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V1_LONG_REG_mask();
}

const RegMask *a0RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A0_LONG_REG_mask();
}

const RegMask *a1RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A1_LONG_REG_mask();
}

const RegMask *a2RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A2_LONG_REG_mask();
}

const RegMask *a3RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A3_LONG_REG_mask();
}

const RegMask *t0RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T0_LONG_REG_mask();
}

const RegMask *t1RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T1_LONG_REG_mask();
}

const RegMask *t3RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T3_LONG_REG_mask();
}

const RegMask *t8RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T8_LONG_REG_mask();
}

const RegMask *a4RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A4_LONG_REG_mask();
}

const RegMask *a5RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A5_LONG_REG_mask();
}

const RegMask *a6RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A6_LONG_REG_mask();
}

const RegMask *a7RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A7_LONG_REG_mask();
}

const RegMask *s0RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S0_LONG_REG_mask();
}

const RegMask *s1RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S1_LONG_REG_mask();
}

const RegMask *s3RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S3_LONG_REG_mask();
}

const RegMask *s4RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S4_LONG_REG_mask();
}

const RegMask *s7RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S7_LONG_REG_mask();
}

const RegMask *regFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLT_REG_mask();
}

const RegMask *regDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DBL_REG_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *indOffset12Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *indOffset12I2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &P_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &P_REG_mask();
  case 1: return &INT_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indirectNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset12NarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

//------------------Define members for classes derived from MachNode----------
// Build short branch version of this instruction
MachNode *jmpDir_longNode::short_branch_version() {
  jmpDir_shortNode *node = new jmpDir_shortNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEnd_longNode::short_branch_version() {
  jmpLoopEnd_shortNode *node = new jmpLoopEnd_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEnd_reg_immI_longNode::short_branch_version() {
  jmpLoopEnd_reg_immI_shortNode *node = new jmpLoopEnd_reg_immI_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpCon_flags_longNode::short_branch_version() {
  jmpCon_flags_shortNode *node = new jmpCon_flags_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConP_0_longNode::short_branch_version() {
  branchConP_0_shortNode *node = new branchConP_0_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConN2P_0_longNode::short_branch_version() {
  branchConN2P_0_shortNode *node = new branchConN2P_0_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConP_longNode::short_branch_version() {
  branchConP_shortNode *node = new branchConP_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpN_reg_branch_longNode::short_branch_version() {
  cmpN_reg_branch_shortNode *node = new cmpN_reg_branch_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConIU_reg_reg_longNode::short_branch_version() {
  branchConIU_reg_reg_shortNode *node = new branchConIU_reg_reg_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConIU_reg_imm_longNode::short_branch_version() {
  branchConIU_reg_imm_shortNode *node = new branchConIU_reg_imm_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConI_reg_reg_longNode::short_branch_version() {
  branchConI_reg_reg_shortNode *node = new branchConI_reg_reg_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConI_reg_imm_longNode::short_branch_version() {
  branchConI_reg_imm_shortNode *node = new branchConI_reg_imm_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConL_regL_regL_longNode::short_branch_version() {
  branchConL_regL_regL_shortNode *node = new branchConL_regL_regL_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConUL_regL_regL_longNode::short_branch_version() {
  branchConUL_regL_regL_shortNode *node = new branchConUL_regL_regL_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConL_regL_immL_longNode::short_branch_version() {
  branchConL_regL_immL_shortNode *node = new branchConL_regL_immL_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConUL_regL_immL_longNode::short_branch_version() {
  branchConUL_regL_immL_shortNode *node = new branchConUL_regL_immL_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConF_reg_reg_longNode::short_branch_version() {
  branchConF_reg_reg_shortNode *node = new branchConF_reg_reg_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConD_reg_reg_longNode::short_branch_version() {
  branchConD_reg_reg_shortNode *node = new branchConD_reg_reg_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}


// Copy _idx, inputs and operands to new node
void MachNode::fill_new_machnode(MachNode* node) const {
  // New node must use same node index
  node->set_idx( _idx );
  // Copy machine-independent inputs
  for( uint j = 0; j < req(); j++ ) {
    node->add_req(in(j));
  }
  // Copy my operands, except for cisc position
  int nopnds = num_opnds();
  assert( node->num_opnds() == (uint)nopnds, "Must have same number of operands");
  MachOper **to = node->_opnds;
  for( int i = 0; i < nopnds; i++ ) {
    if( i != cisc_operand() ) 
      to[i] = _opnds[i]->clone();
  }
}

void jmpDir_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpDir_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEnd_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEnd_reg_immI_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_reg_immI_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpCon_flags_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpCon_flags_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConP_0_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConP_0_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConN2P_0_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConN2P_0_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConP_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConP_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_null_branch_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_null_branch_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_reg_branch_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_reg_branch_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConIU_reg_reg_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConIU_reg_reg_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConIU_reg_imm_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConIU_reg_imm_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConI_reg_reg_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConI_reg_reg_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConI_reg_imm_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConI_reg_imm_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConL_regL_regL_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConL_regL_regL_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConUL_regL_regL_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConUL_regL_regL_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConL_regL_immL_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConL_regL_immL_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConUL_regL_immL_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConUL_regL_immL_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConF_reg_reg_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConF_reg_reg_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConD_reg_reg_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConD_reg_reg_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpDir_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpDir_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEnd_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEnd_reg_immI_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_reg_immI_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpCon_flags_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpCon_flags_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConP_0_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConP_0_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConN2P_0_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConN2P_0_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConP_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConP_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_null_branch_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_null_branch_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_reg_branch_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_reg_branch_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConIU_reg_reg_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConIU_reg_reg_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConIU_reg_imm_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConIU_reg_imm_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConI_reg_reg_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConI_reg_reg_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConI_reg_imm_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConI_reg_imm_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConL_regL_regL_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConL_regL_regL_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConUL_regL_regL_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConUL_regL_regL_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConL_regL_immL_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConL_regL_immL_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConUL_regL_immL_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConUL_regL_immL_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConF_reg_reg_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConF_reg_reg_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConD_reg_reg_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConD_reg_reg_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int loadINode::reloc() const {
  return 1;
}

int loadI_convI2LNode::reloc() const {
  return 1;
}

int loadI2BNode::reloc() const {
  return 1;
}

int loadI2UBNode::reloc() const {
  return 1;
}

int loadI2SNode::reloc() const {
  return 1;
}

int loadI2USNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadL_unalignedNode::reloc() const {
  return 1;
}

int storeL_regNode::reloc() const {
  return 2;
}

int storeL_immL_0Node::reloc() const {
  return 2;
}

int loadNNode::reloc() const {
  return 1;
}

int loadN2PNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadNKlassNode::reloc() const {
  return 1;
}

int loadN2PKlassNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int storePNode::reloc() const {
  return 2;
}

int storeImmP_immP_0Node::reloc() const {
  return 3;
}

int storeImmP_immP_0_volatileNode::reloc() const {
  return 1;
}

int storeNNode::reloc() const {
  return 2;
}

int storeP2NNode::reloc() const {
  return 2;
}

int storeNKlassNode::reloc() const {
  return 2;
}

int storeP2NKlassNode::reloc() const {
  return 2;
}

int storeImmN_immN_0Node::reloc() const {
  return 2;
}

int storeB_immB_0Node::reloc() const {
  return 2;
}

int storeBNode::reloc() const {
  return 3;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB_convI2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB_convI2LNode::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2BNode::reloc() const {
  return 1;
}

int loadS_convI2LNode::reloc() const {
  return 1;
}

int storeI_immI_0Node::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 3;
}

int storeI_volatileNode::reloc() const {
  return 1;
}

int loadFNode::reloc() const {
  return 1;
}

int loadConP_generalNode::reloc() const {
  return 1;
}

int loadConP_no_oop_cheapNode::reloc() const {
  return 1;
}

int loadConP_immP_0Node::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int branchConP_0_longNode::reloc() const {
  return 1;
}

int branchConN2P_0_longNode::reloc() const {
  return 1;
}

int branchConL_regL_regL_longNode::reloc() const {
  return 2;
}

int branchConUL_regL_regL_longNode::reloc() const {
  return 2;
}

int branchConP_0_shortNode::reloc() const {
  return 1;
}

int branchConN2P_0_shortNode::reloc() const {
  return 1;
}

int branchConL_regL_regL_shortNode::reloc() const {
  return 2;
}

int branchConUL_regL_regL_shortNode::reloc() const {
  return 2;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int cmovI_cmpL_reg_regNode::reloc() const {
  return 3;
}

int cmovI_cmpUL_reg_regNode::reloc() const {
  return 3;
}

int cmovP_cmpL_reg_regNode::reloc() const {
  return 2;
}

int cmovP_cmpUL_reg_regNode::reloc() const {
  return 2;
}

int addI_Reg_RegNode::reloc() const {
  return 2;
}

int addI_Reg_immNode::reloc() const {
  return 1;
}

int addP_reg_regNode::reloc() const {
  return 1;
}

int addP_reg_reg_M8Node::reloc() const {
  return 1;
}

int addL_Reg_RegNode::reloc() const {
  return 2;
}

int addL_Reg_immNode::reloc() const {
  return 1;
}

int absL_rRegNode::reloc() const {
  return 1;
}

int subI_Reg_RegNode::reloc() const {
  return 2;
}

int subI_Reg_immI_M2047_2048Node::reloc() const {
  return 1;
}

int negI_RegNode::reloc() const {
  return 1;
}

int negL_RegNode::reloc() const {
  return 1;
}

int subL_Reg_RegNode::reloc() const {
  return 2;
}

int modI_Reg_RegNode::reloc() const {
  return 2;
}

int modL_reg_regNode::reloc() const {
  return 2;
}

int mulL_reg_regNode::reloc() const {
  return 2;
}

int msubF_reg_regNode::reloc() const {
  return 1;
}

int msubD_reg_regNode::reloc() const {
  return 1;
}

int mnaddF_reg_regNode::reloc() const {
  return 1;
}

int mnaddF_reg_reg_0Node::reloc() const {
  return 1;
}

int mnaddD_reg_regNode::reloc() const {
  return 1;
}

int mnaddD_reg_reg_0Node::reloc() const {
  return 1;
}

int copySignD_regNode::reloc() const {
  return 1;
}

int xorI_Reg_immI_M1Node::reloc() const {
  return 1;
}

int lbu_and_lmaskNode::reloc() const {
  return 1;
}

int lbu_and_lmask_0Node::reloc() const {
  return 1;
}

int lbu_and_rmaskNode::reloc() const {
  return 1;
}

int andL_Reg_RegNode::reloc() const {
  return 1;
}

int orL_Reg_RegNode::reloc() const {
  return 2;
}

int orL_Reg_P2XRegNode::reloc() const {
  return 1;
}

int orL_Reg_P2XReg_0Node::reloc() const {
  return 1;
}

int salI_Reg_immNode::reloc() const {
  return 1;
}

int salI_Reg_RegNode::reloc() const {
  return 1;
}

int salL_Reg_immNode::reloc() const {
  return 1;
}

int salL_Reg_RegNode::reloc() const {
  return 1;
}

int sarL_Reg_immNode::reloc() const {
  return 1;
}

int sarL2I_Reg_immI_32_63Node::reloc() const {
  return 1;
}

int sarL_Reg_RegNode::reloc() const {
  return 1;
}

int slrL_Reg_immI_0_31Node::reloc() const {
  return 1;
}

int slrL_Reg_immI_0_31_and_max_intNode::reloc() const {
  return 1;
}

int slrL_Reg_immI_32_63Node::reloc() const {
  return 1;
}

int slrL_Reg_immI_convL2INode::reloc() const {
  return 1;
}

int rolL_Reg_immI_0_31Node::reloc() const {
  return 2;
}

int rolL_Reg_immI_0_31_0Node::reloc() const {
  return 2;
}

int rolL_Reg_immI_32_63Node::reloc() const {
  return 2;
}

int rolL_Reg_immI_32_63_0Node::reloc() const {
  return 2;
}

int rorL_Reg_immI_0_31Node::reloc() const {
  return 2;
}

int rorL_Reg_immI_0_31_0Node::reloc() const {
  return 2;
}

int rorL_Reg_immI_32_63Node::reloc() const {
  return 2;
}

int rorL_Reg_immI_32_63_0Node::reloc() const {
  return 2;
}

int convL2I_regNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int tailjmpIndNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirectNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int prefetchAllocNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS_convI2LNode::reloc() const {
  return 1;
}

int storeCNode::reloc() const {
  return 3;
}

int storeC_0Node::reloc() const {
  return 2;
}

int loadConF_immF_0Node::reloc() const {
  return 2;
}

int loadConFNode::reloc() const {
  return 2;
}

int loadConD_immD_0Node::reloc() const {
  return 2;
}

int loadConDNode::reloc() const {
  return 2;
}

int storeF_regNode::reloc() const {
  return 2;
}

int storeF_immF_0Node::reloc() const {
  return 3;
}

int loadDNode::reloc() const {
  return 1;
}

int loadD_unalignedNode::reloc() const {
  return 1;
}

int storeD_regNode::reloc() const {
  return 2;
}

int storeD_immD_0Node::reloc() const {
  return 3;
}

int storeImmCMNode::reloc() const {
  return 2;
}

int leaPIdxScaleNode::reloc() const {
  return 1;
}

int storePConditionalNode::reloc() const {
  return 1;
}

int storeIConditionalNode::reloc() const {
  return 1;
}

int storeLConditionalNode::reloc() const {
  return 1;
}

int loadPLockedNode::reloc() const {
  return 1;
}

int get_and_addINode::reloc() const {
  return 1;
}

int get_and_addI_no_resNode::reloc() const {
  return 1;
}

int loadUI2L_rmaskNode::reloc() const {
  return 1;
}

int loadUI2L_lmaskNode::reloc() const {
  return 1;
}

int loadUI2L_lmask_0Node::reloc() const {
  return 1;
}

int safePoint_poll_tlsNode::reloc() const {
  return 1;
}

int bytes_reverse_intNode::reloc() const {
  return 1;
}

int bytes_reverse_unsigned_shortNode::reloc() const {
  return 1;
}

int bytes_reverse_shortNode::reloc() const {
  return 1;
}

int countLeadingZerosINode::reloc() const {
  return 1;
}

int countTrailingZerosINode::reloc() const {
  return 1;
}

int popCountINode::reloc() const {
  return 1;
}

int popCountI_memNode::reloc() const {
  return 1;
}

int popCountL_memNode::reloc() const {
  return 1;
}

int loadV16Node::reloc() const {
  return 1;
}

int loadV32Node::reloc() const {
  return 1;
}

int storeV16Node::reloc() const {
  return 2;
}

int storeV32Node::reloc() const {
  return 2;
}

int zLoadPNode::reloc() const {
  return 1;
}


void loadINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4543 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_INT);
  
#line 12110 "ad_loongarch.cpp"
  }
}

void loadI_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4554 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_INT);
  
#line 12126 "ad_loongarch.cpp"
  }
}

void loadI2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4566 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_BYTE);
  
#line 12143 "ad_loongarch.cpp"
  }
}

void loadI2UBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4578 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_BYTE);
  
#line 12160 "ad_loongarch.cpp"
  }
}

void loadI2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// sixteen
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4590 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_SHORT);
  
#line 12177 "ad_loongarch.cpp"
  }
}

void loadI2USNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4602 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_SHORT);
  
#line 12194 "ad_loongarch.cpp"
  }
}

void loadLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4615 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_LONG);
  
#line 12210 "ad_loongarch.cpp"
  }
}

void loadL_unalignedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4628 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_LONG);
  
#line 12226 "ad_loongarch.cpp"
  }
}

void storeL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4641 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_LONG);
  
#line 12243 "ad_loongarch.cpp"
  }
}

void storeL_reg_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4652 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_d(R0, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12260 "ad_loongarch.cpp"
  }
}

void storeL_immL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4664 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     __ loadstore_enc(R0, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_LONG);
  
#line 12277 "ad_loongarch.cpp"
  }
}

void storeL_immL_0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4675 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_d(AT, R0, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12294 "ad_loongarch.cpp"
  }
}

void loadNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4688 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
     assert(disp_reloc == relocInfo::none, "cannot have disp");
     __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_INT);
   
#line 12312 "ad_loongarch.cpp"
  }
}

void loadN2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4703 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
     assert(disp_reloc == relocInfo::none, "cannot have disp");
     __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_INT);
   
#line 12330 "ad_loongarch.cpp"
  }
}

void loadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4718 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");
    __ block_comment("loadP");
    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_LONG);
  
#line 12349 "ad_loongarch.cpp"
  }
}

void loadKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4733 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");
    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_LONG);
  
#line 12367 "ad_loongarch.cpp"
  }
}

void loadNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4748 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");
    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_INT);
  
#line 12385 "ad_loongarch.cpp"
  }
}

void loadN2PKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4763 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");
    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_INT);
  
#line 12403 "ad_loongarch.cpp"
  }
}

void loadConINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4777 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    value = opnd_array(1)->constant();
    __ li(dst, value);
  
#line 12421 "ad_loongarch.cpp"
  }
}

void loadConLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4790 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ li(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constantL());
  
#line 12437 "ad_loongarch.cpp"
  }
}

void loadRangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4802 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_INT);
  
#line 12453 "ad_loongarch.cpp"
  }
}

void storePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4815 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_LONG);
  
#line 12470 "ad_loongarch.cpp"
  }
}

void storeP_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4826 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_d(R0, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12487 "ad_loongarch.cpp"
  }
}

void storeImmP_immP_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4839 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     __ loadstore_enc(R0, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_LONG);
  
#line 12504 "ad_loongarch.cpp"
  }
}

void storeImmP_immP_0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4850 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_d(AT, R0, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12521 "ad_loongarch.cpp"
  }
}

void storeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4864 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_INT);
  
#line 12538 "ad_loongarch.cpp"
  }
}

void storeN_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4876 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_w(R0, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12555 "ad_loongarch.cpp"
  }
}

void storeP2NNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4889 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_INT);
  
#line 12572 "ad_loongarch.cpp"
  }
}

void storeP2N_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4902 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_w(R0, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12589 "ad_loongarch.cpp"
  }
}

void storeNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4915 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_INT);
  
#line 12606 "ad_loongarch.cpp"
  }
}

void storeNKlass_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4927 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_w(R0, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12623 "ad_loongarch.cpp"
  }
}

void storeP2NKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4940 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_INT);
  
#line 12640 "ad_loongarch.cpp"
  }
}

void storeP2NKlass_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4953 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_w(R0, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12657 "ad_loongarch.cpp"
  }
}

void storeImmN_immN_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4966 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     __ loadstore_enc(R0, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_INT);
  
#line 12674 "ad_loongarch.cpp"
  }
}

void storeImmN_immN_0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4978 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_w(AT, R0, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12691 "ad_loongarch.cpp"
  }
}

void storeB_immB_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4989 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(R0, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_BYTE);
  
#line 12708 "ad_loongarch.cpp"
  }
}

void storeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5000 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_BYTE);
  
#line 12725 "ad_loongarch.cpp"
  }
}

void loadBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5012 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_BYTE);
  
#line 12741 "ad_loongarch.cpp"
  }
}

void loadB_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5023 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_BYTE);
  
#line 12757 "ad_loongarch.cpp"
  }
}

void loadUBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5035 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_BYTE);
  
#line 12773 "ad_loongarch.cpp"
  }
}

void loadUB_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5046 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_BYTE);
  
#line 12789 "ad_loongarch.cpp"
  }
}

void loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5058 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_SHORT);
  
#line 12805 "ad_loongarch.cpp"
  }
}

void loadS2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5070 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_BYTE);
  
#line 12822 "ad_loongarch.cpp"
  }
}

void loadS_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5081 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_SHORT);
  
#line 12838 "ad_loongarch.cpp"
  }
}

void storeI_immI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5094 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(R0, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_INT);
  
#line 12855 "ad_loongarch.cpp"
  }
}

void storeI_immI_0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5105 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_w(AT, R0, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12872 "ad_loongarch.cpp"
  }
}

void storeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5118 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_INT);
  
#line 12889 "ad_loongarch.cpp"
  }
}

void storeI_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5129 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amswap_db_w(R0, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 12906 "ad_loongarch.cpp"
  }
}

void loadFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5141 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_FLOAT);
  
#line 12922 "ad_loongarch.cpp"
  }
}

void loadConP_generalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5153 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    long* value = (long*)opnd_array(1)->constant();

    if (opnd_array(1)->constant_reloc() == relocInfo::metadata_type){
      __ mov_metadata(dst, (Metadata*)value);
    } else if(opnd_array(1)->constant_reloc() == relocInfo::oop_type){
      __ movoop(dst, (jobject)value, /*immediate*/true);
    } else if (opnd_array(1)->constant_reloc() == relocInfo::none) {
      __ li(dst, (long)value);
    }
  
#line 12947 "ad_loongarch.cpp"
  }
}

void loadConP_no_oop_cheapNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5175 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(1)->constant_reloc() == relocInfo::metadata_type) {
      __ mov_metadata(opnd_array(0)->as_Register(ra_,this)/* dst */, (Metadata*)opnd_array(1)->constant());
    } else {
      __ li(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constant());
    }
  
#line 12967 "ad_loongarch.cpp"
  }
}

void loadConP_immP_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5192 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     Register dst_reg = opnd_array(0)->as_Register(ra_,this)/* dst */;
     __ add_d(dst_reg, R0, R0);
  
#line 12984 "ad_loongarch.cpp"
  }
}

void loadConN_immN_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5202 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ move(opnd_array(0)->as_Register(ra_,this)/* dst */, R0);
  
#line 13000 "ad_loongarch.cpp"
  }
}

void loadConNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5213 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ set_narrow_oop(dst, (jobject)opnd_array(1)->constant());
  
#line 13017 "ad_loongarch.cpp"
  }
}

void loadConNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5225 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ set_narrow_klass(dst, (Klass*)opnd_array(1)->constant());
  
#line 13034 "ad_loongarch.cpp"
  }
}

void TailCalljmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5242 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register target = opnd_array(1)->as_Register(ra_,this,idx1)/* jump_target */;
    Register    ptr = opnd_array(2)->as_Register(ra_,this,idx2)/* method_ptr */;

    // RA will be used in generate_forward_exception()
    __ push(RA);

    __ move(S3, ptr);
    __ jr(target);
  
#line 13058 "ad_loongarch.cpp"
  }
}

void CreateExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5265 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // X86 leaves this function empty
    __ block_comment("CreateException is empty in LA");
  
#line 13075 "ad_loongarch.cpp"
  }
}

void RethrowExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5308 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ block_comment("@ RethrowException");

    cbuf.set_insts_mark();
    cbuf.relocate(cbuf.insts_mark(), runtime_call_Relocation::spec());

    // call OptoRuntime::rethrow_stub to get the exception handler in parent method
    __ patchable_jump((address)OptoRuntime::rethrow_stub());
  
#line 13097 "ad_loongarch.cpp"
  }
}

void jmpDir_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5331 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Label* L = opnd_array(1)->label();
    __ jmp_far(*L);
  
#line 13114 "ad_loongarch.cpp"
  }
}

void jmpLoopEnd_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5347 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_long(flag, op1, op2, L, true /* signed */);
  
#line 13138 "ad_loongarch.cpp"
  }
}

void jmpLoopEnd_reg_immI_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5365 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();
    int     val  = opnd_array(3)->constant();

    if (val == 0) {
      __ cmp_branch_long(flag, op1, R0, L, true /* signed */);
    } else {
      __ li(AT, val);
      __ cmp_branch_long(flag, op1, AT, L, true /* signed */);
    }
  
#line 13167 "ad_loongarch.cpp"
  }
}

void jmpCon_flags_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5391 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Label*    L =  opnd_array(3)->label();
    switch(opnd_array(1)->ccode()) {
      case 0x01: //equal
        __ bne_long(opnd_array(2)->as_Register(ra_,this,idx2)/* cr */, R0, *L);
        break;
      case 0x02: //not equal
        __ beq_long(opnd_array(2)->as_Register(ra_,this,idx2)/* cr */, R0, *L);
        break;
      default:
        Unimplemented();
    }
  
#line 13195 "ad_loongarch.cpp"
  }
}

void branchConP_0_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5417 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Label*    L  = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_long(flag, op1, R0, L, true /* signed */);
  
#line 13218 "ad_loongarch.cpp"
  }
}

void branchConN2P_0_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5437 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Label*    L  = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_long(flag, op1, R0, L, true /* signed */);
  
#line 13241 "ad_loongarch.cpp"
  }
}

void branchConP_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5458 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */;
    Label*    L  = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_long(flag, op1, op2, L, false /* unsigned */);
  
#line 13265 "ad_loongarch.cpp"
  }
}

void cmpN_null_branch_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// null
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5478 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Label*    L  = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_long(flag, op1, R0, L, true /* signed */);
  
#line 13288 "ad_loongarch.cpp"
  }
}

void cmpN_reg_branch_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5497 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */;
    Label*    L  = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_long(flag, op1, op2, L, false /* unsigned */);
  
#line 13312 "ad_loongarch.cpp"
  }
}

void branchConIU_reg_reg_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5514 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_long(flag, op1, op2, L, false /* unsigned */);
  
#line 13336 "ad_loongarch.cpp"
  }
}

void branchConIU_reg_imm_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5533 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    int      val = opnd_array(3)->constant();
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    if (val == 0) {
      __ cmp_branch_long(flag, op1, R0, L, false /* unsigned */);
    } else {
      __ li(AT, val);
      __ cmp_branch_long(flag, op1, AT, L, false /* unsigned */);
    }
  
#line 13365 "ad_loongarch.cpp"
  }
}

void branchConI_reg_reg_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5556 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_long(flag, op1, op2, L, true /* signed */);
  
#line 13389 "ad_loongarch.cpp"
  }
}

void branchConI_reg_imm_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5575 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    int      val = opnd_array(3)->constant();
    Label*     L =  opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    if (val == 0) {
      __ cmp_branch_long(flag, op1, R0, L, true /* signed */);
    } else {
      __ li(AT, val);
      __ cmp_branch_long(flag, op1, AT, L, true /* signed */);
    }
  
#line 13418 "ad_loongarch.cpp"
  }
}

void branchConL_regL_regL_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5599 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register op2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */);

    Label*   target = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_long(flag, op1, op2, target, true /* signed */);
  
#line 13443 "ad_loongarch.cpp"
  }
}

void branchConUL_regL_regL_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5620 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register op2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */);
    Label*   target = opnd_array(4)->label();
    int      flag   = opnd_array(1)->ccode();

    __ cmp_branch_long(flag, op1, op2, target, false /* signed */);
  
#line 13467 "ad_loongarch.cpp"
  }
}

void branchConL_regL_immL_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5639 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Label*   target = opnd_array(4)->label();
    int      flag = opnd_array(1)->ccode();
    long      val = opnd_array(3)->constantL();

    if (val == 0) {
      __ cmp_branch_long(flag, op1, R0, target, true /* signed */);
    } else {
      __ li(AT, val);
      __ cmp_branch_long(flag, op1, AT, target, true /* signed */);
    }
  
#line 13496 "ad_loongarch.cpp"
  }
}

void branchConUL_regL_immL_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5663 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    long     val = opnd_array(3)->constantL();
    Label*   target = opnd_array(4)->label();
    int      flag   = opnd_array(1)->ccode();

    if (val == 0) {
      __ cmp_branch_long(flag, op1, R0, target, false /* signed */);
    } else {
      __ li(AT, val);
      __ cmp_branch_long(flag, op1, AT, target, false /* signed */);
    }
  
#line 13525 "ad_loongarch.cpp"
  }
}

void branchConF_reg_reg_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5687 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */;
    Label*     L =  opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ fcmp_ceq_s(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      case 0x02: //not_equal
        __ fcmp_ceq_s(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x03: //greater
        __ fcmp_cule_s(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x04: //greater_equal
        __ fcmp_cult_s(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x05: //less
        __ fcmp_cult_s(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      case 0x06: //less_equal
        __ fcmp_cule_s(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      default:
        Unimplemented();
    }
  
#line 13576 "ad_loongarch.cpp"
  }
}

void branchConD_reg_reg_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5732 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */;
    Label*     L =  opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ fcmp_ceq_d(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      case 0x02: //not_equal
        // c_ueq_d cannot distinguish NaN from equal. Double.isNaN(Double) is implemented by 'f != f', so the use of c_ueq_d causes bugs.
        __ fcmp_ceq_d(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x03: //greater
        __ fcmp_cule_d(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x04: //greater_equal
        __ fcmp_cult_d(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x05: //less
        __ fcmp_cult_d(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      case 0x06: //less_equal
        __ fcmp_cule_d(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      default:
        Unimplemented();
    }
  
#line 13628 "ad_loongarch.cpp"
  }
}

void jmpDir_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5785 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Label &L = *(opnd_array(1)->label());
    if(&L)
       __ b(L);
    else
       __ b(int(0));
  
#line 13648 "ad_loongarch.cpp"
  }
}

void jmpLoopEnd_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5805 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_short(flag, op1, op2, L, true /* signed */);
  
#line 13672 "ad_loongarch.cpp"
  }
}

void jmpLoopEnd_reg_immI_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5824 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();
    int     val  = opnd_array(3)->constant();

    if (val == 0) {
      __ cmp_branch_short(flag, op1, R0, L, true /* signed */);
    } else {
      __ li(AT, val);
      __ cmp_branch_short(flag, op1, AT, L, true /* signed */);
    }
  
#line 13701 "ad_loongarch.cpp"
  }
}

void jmpCon_flags_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5851 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Label    &L =  *(opnd_array(3)->label());
    switch(opnd_array(1)->ccode()) {
      case 0x01: //equal
        if (&L)
          __ bnez(opnd_array(2)->as_Register(ra_,this,idx2)/* cr */, L);
        else
          __ bnez(opnd_array(2)->as_Register(ra_,this,idx2)/* cr */, (int)0);
        break;
      case 0x02: //not equal
        if (&L)
          __ beqz(opnd_array(2)->as_Register(ra_,this,idx2)/* cr */, L);
        else
          __ beqz(opnd_array(2)->as_Register(ra_,this,idx2)/* cr */, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 13735 "ad_loongarch.cpp"
  }
}

void branchConP_0_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5884 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Label    &L  = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ cmp_branchEqNe_off21(flag, op1, L);
  
#line 13758 "ad_loongarch.cpp"
  }
}

void branchConN2P_0_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5905 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Label    &L  = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ cmp_branchEqNe_off21(flag, op1, L);
  
#line 13781 "ad_loongarch.cpp"
  }
}

void branchConP_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5927 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */;
    Label    &L  = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_short(flag, op1, op2, L, false /* unsigned */);
  
#line 13805 "ad_loongarch.cpp"
  }
}

void cmpN_null_branch_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// null
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5948 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Label    &L  = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ cmp_branchEqNe_off21(flag, op1, L);
  
#line 13828 "ad_loongarch.cpp"
  }
}

void cmpN_reg_branch_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5968 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */;
    Label    &L  = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_short(flag, op1, op2, L, false /* unsigned */);
  
#line 13852 "ad_loongarch.cpp"
  }
}

void branchConIU_reg_reg_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5986 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_short(flag, op1, op2, L, false /* unsigned */);
  
#line 13876 "ad_loongarch.cpp"
  }
}

void branchConIU_reg_imm_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6006 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    int      val = opnd_array(3)->constant();
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    if (val == 0) {
      __ cmp_branch_short(flag, op1, R0, L, false /* unsigned */);
    } else {
      __ li(AT, val);
      __ cmp_branch_short(flag, op1, AT, L, false /* unsigned */);
    }
  
#line 13905 "ad_loongarch.cpp"
  }
}

void branchConI_reg_reg_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6030 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_short(flag, op1, op2, L, true /* signed */);
  
#line 13929 "ad_loongarch.cpp"
  }
}

void branchConI_reg_imm_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6050 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    int      val = opnd_array(3)->constant();
    Label     &L =  *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    if (val == 0) {
      __ cmp_branch_short(flag, op1, R0, L, true /* signed */);
    } else {
      __ li(AT, val);
      __ cmp_branch_short(flag, op1, AT, L, true /* signed */);
    }
  
#line 13958 "ad_loongarch.cpp"
  }
}

void branchConL_regL_regL_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6075 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register op2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */);

    Label   &target = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ cmp_branch_short(flag, op1, op2, target, true /* signed */);
  
#line 13983 "ad_loongarch.cpp"
  }
}

void branchConUL_regL_regL_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6097 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register op2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */);
    Label&   target = *(opnd_array(4)->label());
    int      flag   = opnd_array(1)->ccode();

    __ cmp_branch_short(flag, op1, op2, target, false /* signed */);
  
#line 14007 "ad_loongarch.cpp"
  }
}

void branchConL_regL_immL_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6117 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Label   &target = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();
    long    val = opnd_array(3)->constantL();

    if (val == 0) {
      __ cmp_branch_short(flag, op1, R0, target, true /* signed */);
    } else {
      __ li(AT, val);
      __ cmp_branch_short(flag, op1, AT, target, true /* signed */);
    }
  
#line 14036 "ad_loongarch.cpp"
  }
}

void branchConUL_regL_immL_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6142 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    long     val = opnd_array(3)->constantL();
    Label&   target = *(opnd_array(4)->label());
    int      flag   = opnd_array(1)->ccode();

    if (val == 0) {
      __ cmp_branch_short(flag, op1, R0, target, false /* signed */);
    } else {
      __ li(AT, val);
      __ cmp_branch_short(flag, op1, AT, target, false /* signed */);
    }
  
#line 14065 "ad_loongarch.cpp"
  }
}

void branchConF_reg_reg_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6167 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */;
    Label     &L =  *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ fcmp_ceq_s(FCC0, reg_op1, reg_op2);
        if (&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      case 0x02: //not_equal
        __ fcmp_ceq_s(FCC0, reg_op1, reg_op2);
        if (&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x03: //greater
        __ fcmp_cule_s(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x04: //greater_equal
        __ fcmp_cult_s(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x05: //less
        __ fcmp_cult_s(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      case 0x06: //less_equal
        __ fcmp_cule_s(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 14134 "ad_loongarch.cpp"
  }
}

void branchConD_reg_reg_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6231 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */;
    Label     &L =  *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ fcmp_ceq_d(FCC0, reg_op1, reg_op2);
        if (&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      case 0x02: //not_equal
        // c_ueq_d cannot distinguish NaN from equal. Double.isNaN(Double) is implemented by 'f != f', so the use of c_ueq_d causes bugs.
        __ fcmp_ceq_d(FCC0, reg_op1, reg_op2);
        if (&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x03: //greater
        __ fcmp_cule_d(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x04: //greater_equal
        __ fcmp_cult_d(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x05: //less
        __ fcmp_cult_d(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      case 0x06: //less_equal
        __ fcmp_cule_d(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 14204 "ad_loongarch.cpp"
  }
}

void CallRuntimeDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2348 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    C2_MacroAssembler _masm(&cbuf);
    // This is the instruction starting address for relocation info.
    __ block_comment("Java_To_Runtime");
    cbuf.set_insts_mark();
    __ relocate(relocInfo::runtime_call_type);
    __ patchable_call((address)opnd_array(1)->method());
  
#line 14224 "ad_loongarch.cpp"
  }
}

void unnecessary_membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6317 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ block_comment("membar_acquire (elided)");
  
#line 14240 "ad_loongarch.cpp"
  }
}

void membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6329 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ membar(Assembler::Membar_mask_bits(__ LoadLoad|__ LoadStore));
  
#line 14256 "ad_loongarch.cpp"
  }
}

void load_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6340 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ membar(Assembler::Membar_mask_bits(__ LoadLoad|__ LoadStore));
  
#line 14272 "ad_loongarch.cpp"
  }
}

void membar_acquire_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_acquire_lockNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void unnecessary_membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6364 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ block_comment("membar_release (elided)");
  
#line 14301 "ad_loongarch.cpp"
  }
}

void membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6376 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // Attention: DO NOT DELETE THIS GUY!
    __ membar(Assembler::Membar_mask_bits(__ LoadStore|__ StoreStore));
  
#line 14318 "ad_loongarch.cpp"
  }
}

void store_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6390 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ membar(Assembler::Membar_mask_bits(__ LoadStore|__ StoreStore));
  
#line 14334 "ad_loongarch.cpp"
  }
}

void membar_release_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_release_lockNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void unnecessary_membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6415 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ block_comment("membar_volatile (elided)");
  
#line 14363 "ad_loongarch.cpp"
  }
}

void membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6427 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if( !os::is_MP() ) return;     // Not needed on single CPU
    __ membar(__ StoreLoad);

  
#line 14381 "ad_loongarch.cpp"
  }
}

void membar_storestoreNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6441 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ membar(__ StoreStore);
  
#line 14397 "ad_loongarch.cpp"
  }
}

void membar_storestore_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6441 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ membar(__ StoreStore);
  
#line 14413 "ad_loongarch.cpp"
  }
}

void castX2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6451 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

  if(src != dst)
    __ move(dst, src);
  
#line 14433 "ad_loongarch.cpp"
  }
}

void castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6466 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

  if(src != dst)
    __ move(dst, src);
  
#line 14453 "ad_loongarch.cpp"
  }
}

void MoveF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6481 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    __ movfr2gr_s(dst, src);
  
#line 14472 "ad_loongarch.cpp"
  }
}

void MoveI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6495 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ movgr2fr_w(dst, src);
  
#line 14491 "ad_loongarch.cpp"
  }
}

void MoveD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6509 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    __ movfr2gr_d(dst, src);
  
#line 14510 "ad_loongarch.cpp"
  }
}

void MoveL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6523 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    __ movgr2fr_d(dst, src);
  
#line 14529 "ad_loongarch.cpp"
  }
}

void cmovI_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6542 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, op1, op2, (MacroAssembler::CMCompare) flag, true);
  
#line 14552 "ad_loongarch.cpp"
  }
}

void cmovI_cmpI_reg_reg2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6562 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, op2, op1, (MacroAssembler::CMCompare) flag, true);
  
#line 14575 "ad_loongarch.cpp"
  }
}

void cmovI_cmpI_dst_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6582 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 14601 "ad_loongarch.cpp"
  }
}

void cmovI_cmpP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6602 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 14627 "ad_loongarch.cpp"
  }
}

void cmovI_cmpN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6623 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 14653 "ad_loongarch.cpp"
  }
}

void cmovP_cmpU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6643 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 14679 "ad_loongarch.cpp"
  }
}

void cmovP_cmpF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6665 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */;
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, true /* is_float */);
  
#line 14709 "ad_loongarch.cpp"
  }
}

void cmovP_cmpN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6686 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 14735 "ad_loongarch.cpp"
  }
}

void cmovN_cmpP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6706 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 14761 "ad_loongarch.cpp"
  }
}

void cmovP_cmpD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6727 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    FloatRegister reg_op2 = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, false /* is_float */);
  
#line 14791 "ad_loongarch.cpp"
  }
}

void cmovN_cmpN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6749 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 14817 "ad_loongarch.cpp"
  }
}

void cmovI_cmpU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6769 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 14843 "ad_loongarch.cpp"
  }
}

void cmovI_cmpL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6789 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src  = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 14869 "ad_loongarch.cpp"
  }
}

void cmovI_cmpUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6809 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src  = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 14895 "ad_loongarch.cpp"
  }
}

void cmovP_cmpL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6829 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src  = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 14921 "ad_loongarch.cpp"
  }
}

void cmovP_cmpUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6849 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src  = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 14947 "ad_loongarch.cpp"
  }
}

void cmovI_cmpD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6870 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    FloatRegister reg_op2 = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, false /* is_float */);
  
#line 14977 "ad_loongarch.cpp"
  }
}

void cmovP_cmpP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6892 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 15003 "ad_loongarch.cpp"
  }
}

void cmovP_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6912 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 15029 "ad_loongarch.cpp"
  }
}

void cmovL_cmpP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6932 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();
    Label L;

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 15056 "ad_loongarch.cpp"
  }
}

void cmovN_cmpU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6953 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 15082 "ad_loongarch.cpp"
  }
}

void cmovN_cmpL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6973 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src  = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 15108 "ad_loongarch.cpp"
  }
}

void cmovN_cmpUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6993 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src  = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 15134 "ad_loongarch.cpp"
  }
}

void cmovN_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7013 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 15160 "ad_loongarch.cpp"
  }
}

void cmovL_cmpU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7033 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 15186 "ad_loongarch.cpp"
  }
}

void cmovL_cmpF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7055 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */;
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, true /* is_float */);
  
#line 15216 "ad_loongarch.cpp"
  }
}

void cmovL_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7077 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 15242 "ad_loongarch.cpp"
  }
}

void cmovL_cmpL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7098 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, op1, op2, (MacroAssembler::CMCompare) flag, true);
  
#line 15265 "ad_loongarch.cpp"
  }
}

void cmovL_cmpUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7118 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, op1, op2, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 15288 "ad_loongarch.cpp"
  }
}

void cmovL_cmpL_reg_reg2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7138 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, op2, op1, (MacroAssembler::CMCompare) flag, true);
  
#line 15311 "ad_loongarch.cpp"
  }
}

void cmovL_cmpUL_reg_reg2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7158 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, op2, op1, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 15334 "ad_loongarch.cpp"
  }
}

void cmovL_cmpL_dst_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7177 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src  = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 15360 "ad_loongarch.cpp"
  }
}

void cmovL_cmpUL_dst_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7197 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src  = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 15386 "ad_loongarch.cpp"
  }
}

void cmovL_cmpN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7217 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 15412 "ad_loongarch.cpp"
  }
}

void cmovL_cmpD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7239 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    FloatRegister reg_op2 = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, false /* is_float */);
  
#line 15442 "ad_loongarch.cpp"
  }
}

void cmovD_cmpD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7261 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    FloatRegister reg_op2 = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    FloatRegister dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_float */);
  
#line 15468 "ad_loongarch.cpp"
  }
}

void cmovF_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7283 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    FloatRegister dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    FloatRegister tmp1 = as_FloatRegister(opnd_array(6)->reg(ra_,this,idx6)/* tmp3 */);
    FloatRegister tmp2 = as_FloatRegister(opnd_array(7)->reg(ra_,this,idx7)/* tmp4 */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag);
  
#line 15498 "ad_loongarch.cpp"
  }
}

void cmovD_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7307 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    FloatRegister dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    FloatRegister tmp1 = as_FloatRegister(opnd_array(6)->reg(ra_,this,idx6)/* tmp3 */);
    FloatRegister tmp2 = as_FloatRegister(opnd_array(7)->reg(ra_,this,idx7)/* tmp4 */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag);
  
#line 15528 "ad_loongarch.cpp"
  }
}

void cmovD_cmpP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7331 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    FloatRegister dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    FloatRegister tmp1 = as_FloatRegister(opnd_array(6)->reg(ra_,this,idx6)/* tmp3 */);
    FloatRegister tmp2 = as_FloatRegister(opnd_array(7)->reg(ra_,this,idx7)/* tmp4 */);
    int     flag = opnd_array(1)->ccode();

    // Use signed comparison here, because the most significant bit of the
    // user-space virtual address must be 0.
    __ cmp_cmov(op1, op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag);
  
#line 15560 "ad_loongarch.cpp"
  }
}

void cmovI_cmpF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7358 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */;
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, true /* is_float */);
  
#line 15590 "ad_loongarch.cpp"
  }
}

void cmovF_cmpF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7380 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */;
    FloatRegister dst = opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */;
    FloatRegister src = opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* src */;
    int flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_float */);
  
#line 15616 "ad_loongarch.cpp"
  }
}

void cmpL3_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7398 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register dst  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ slt(AT, opr1, R0);
    __ slt(dst, R0, opr1);
    __ sub_d(dst, dst, AT);
  
#line 15637 "ad_loongarch.cpp"
  }
}

void cmpL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7412 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register opr2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register dst  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ slt(AT, opr1, opr2);
    __ slt(dst, opr2, opr1);
    __ sub_d(dst, dst, AT);
  
#line 15660 "ad_loongarch.cpp"
  }
}

void cmpF3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7434 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fcmp_clt_s(FCC0, src2, src1);
    __ fcmp_cult_s(FCC1, src1, src2);
    __ movcf2gr(dst, FCC0);
    __ movcf2gr(AT, FCC1);
    __ sub_d(dst, dst, AT);

  
#line 15686 "ad_loongarch.cpp"
  }
}

void cmpD3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7453 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fcmp_clt_d(FCC0, src2, src1);
    __ fcmp_cult_d(FCC1, src1, src2);
    __ movcf2gr(dst, FCC0);
    __ movcf2gr(AT, FCC1);
    __ sub_d(dst, dst, AT);
  
#line 15711 "ad_loongarch.cpp"
  }
}

void clear_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7471 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    //Assume cnt is the number of bytes in an array to be cleared,
    //and base points to the starting address of the array.
    Register base = opnd_array(2)->as_Register(ra_,this,idx2)/* base */;
    Register cnt  = opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */;
    Label Loop, done;

    __ beq(cnt, R0, done);

    __ bind(Loop);
    __ st_d(R0, base, 0);
    __ addi_d(cnt, cnt, -1);
    __ addi_d(base, base, wordSize);
    __ bne(cnt, R0, Loop);

    __ bind(done);
  
#line 15742 "ad_loongarch.cpp"
  }
}

void clear_array_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7495 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    //Assume cnt is the number of bytes in an array to be cleared,
    //and base points to the starting address of the array.
    Register base = opnd_array(2)->as_Register(ra_,this,idx2)/* base */;
    long     cnt  = opnd_array(1)->constantL();
    Label Loop, done;

    int tmp = cnt % 8;
    int i = 0;
    for (; i < tmp; i++) {
      __ st_d(R0, base, i * 8);
    }
    if (cnt - tmp) {
      __ li(AT, cnt);
      __ alsl_d(AT, AT, base, 2);
      __ addi_d(base, base, i * 8);
      __ bind(Loop);
      __ st_d(R0, base,  0);
      __ st_d(R0, base,  8);
      __ st_d(R0, base, 16);
      __ st_d(R0, base, 24);
      __ st_d(R0, base, 32);
      __ st_d(R0, base, 40);
      __ st_d(R0, base, 48);
      __ st_d(R0, base, 56);
      __ addi_d(base, base, 64);
      __ blt(base, AT, Loop);
    }
  
#line 15785 "ad_loongarch.cpp"
  }
}

void string_compareLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7533 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      StrIntrinsicNode::LL, as_Register(T8_enc), as_Register(T3_enc));
  
#line 15806 "ad_loongarch.cpp"
  }
}

void string_compareUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7548 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      StrIntrinsicNode::UU, as_Register(T8_enc), as_Register(T3_enc));
  
#line 15827 "ad_loongarch.cpp"
  }
}

void string_compareLUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7563 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      StrIntrinsicNode::LU, as_Register(T8_enc), as_Register(T3_enc));
  
#line 15848 "ad_loongarch.cpp"
  }
}

void string_compareULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7578 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      StrIntrinsicNode::UL, as_Register(T8_enc), as_Register(T3_enc));
  
#line 15869 "ad_loongarch.cpp"
  }
}

void string_indexofUUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7595 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UU);
  
#line 15890 "ad_loongarch.cpp"
  }
}

void string_indexofLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7611 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::LL);
  
#line 15911 "ad_loongarch.cpp"
  }
}

void string_indexofULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7627 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UL);
  
#line 15932 "ad_loongarch.cpp"
  }
}

void string_indexof_conUUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7644 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof_linearscan(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                                 opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, noreg,
                                 icnt2, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UU);
  
#line 15954 "ad_loongarch.cpp"
  }
}

void string_indexof_conLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7661 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof_linearscan(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                                 opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, noreg,
                                 icnt2, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::LL);
  
#line 15976 "ad_loongarch.cpp"
  }
}

void string_indexof_conULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7678 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof_linearscan(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                                 opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, noreg,
                                 icnt2, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UL);
  
#line 15998 "ad_loongarch.cpp"
  }
}

void string_indexof_charNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7694 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ string_indexof_char(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                           opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                           opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 16022 "ad_loongarch.cpp"
  }
}

void stringL_indexof_charNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7710 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ stringL_indexof_char(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                            opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                            opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 16046 "ad_loongarch.cpp"
  }
}

void has_negativesNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// len
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7724 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ has_negatives(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* len */, opnd_array(0)->as_Register(ra_,this)/* result */);
  
#line 16063 "ad_loongarch.cpp"
  }
}

void string_compressNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7740 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ char_array_compress(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                           opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */,
                           opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 16087 "ad_loongarch.cpp"
  }
}

void string_inflateNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7756 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ byte_array_inflate(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                          opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */);
  
#line 16108 "ad_loongarch.cpp"
  }
}

void string_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7769 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ arrays_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                     opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, as_Register(T8_enc), as_Register(T3_enc), opnd_array(0)->as_Register(ra_,this)/* result */,
                     false/* byte */);
  
#line 16128 "ad_loongarch.cpp"
  }
}

void encode_iso_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7788 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                        opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */,
                        opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, false);
  
#line 16152 "ad_loongarch.cpp"
  }
}

void encode_ascii_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7807 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                        opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */,
                        opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, true);
  
#line 16176 "ad_loongarch.cpp"
  }
}

void addI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7822 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ add_w(dst, src1, src2);
  
#line 16196 "ad_loongarch.cpp"
  }
}

void addI_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7835 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int       imm = opnd_array(2)->constant();

    __ addi_w(dst, src1, imm);
  
#line 16217 "ad_loongarch.cpp"
  }
}

void addI_salI_Reg_Reg_immI_1_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7849 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    int        sh = opnd_array(3)->constant();
    __ alsl_w(dst, src2, src1, sh - 1);
  
#line 16239 "ad_loongarch.cpp"
  }
}

void addI_salI_Reg_Reg_immI_1_4_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7849 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(3)->as_Register(ra_,this,idx3)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;
    int        sh = opnd_array(2)->constant();
    __ alsl_w(dst, src2, src1, sh - 1);
  
#line 16261 "ad_loongarch.cpp"
  }
}

void addP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7864 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ add_d(dst, src1, src2);
  
#line 16281 "ad_loongarch.cpp"
  }
}

void addP_reg_reg_M8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// M8
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7878 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ bstrins_d(src2, R0, 2, 0);
    __ add_d(dst, src1, src2);
  
#line 16303 "ad_loongarch.cpp"
  }
}

void addP_reg_imm12Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7893 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    long     src2 = opnd_array(2)->constantL();
    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ addi_d(dst, src1, src2);
  
#line 16324 "ad_loongarch.cpp"
  }
}

void addP_salL_Reg_RegI2L_immI_1_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7908 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    int        sh = opnd_array(3)->constant();
    __ alsl_d(dst, src2, src1, sh - 1);
  
#line 16346 "ad_loongarch.cpp"
  }
}

void addL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7925 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ add_d(dst_reg, src1_reg, src2_reg);
  
#line 16367 "ad_loongarch.cpp"
  }
}

void addL_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7941 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst_reg  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int      src2_imm = opnd_array(2)->constantL();

    __ addi_d(dst_reg, src1_reg, src2_imm);
  
#line 16388 "ad_loongarch.cpp"
  }
}

void absI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7960 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(2)->as_Register(ra_,this,idx2)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;

    __ srai_w(AT, src, 31);
    __ xorr(dst, src, AT);
    __ sub_w(dst, dst, AT);
  
#line 16410 "ad_loongarch.cpp"
  }
}

void absL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7978 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(2)->as_Register(ra_,this,idx2)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;

    __ srai_d(AT, src, 63);
    __ xorr(dst, src, AT);
    __ sub_d(dst, dst, AT);
  
#line 16432 "ad_loongarch.cpp"
  }
}

void subI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7997 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ sub_w(dst, src1, src2);
  
#line 16452 "ad_loongarch.cpp"
  }
}

void subI_Reg_immI_M2047_2048Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8011 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    __ addi_w(dst, src1, -1 * opnd_array(2)->constant());
  
#line 16471 "ad_loongarch.cpp"
  }
}

void negI_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8024 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register  src = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;
    __ sub_w(dst, R0, src);
  
#line 16490 "ad_loongarch.cpp"
  }
}

void negL_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8037 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register  src = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;
    __ sub_d(dst, R0, src);
  
#line 16509 "ad_loongarch.cpp"
  }
}

void subL_Reg_immL_M2047_2048Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8050 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    __ addi_d(dst, src1, -1 * opnd_array(2)->constantL());
  
#line 16528 "ad_loongarch.cpp"
  }
}

void subL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8063 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ sub_d(dst, src1, src2);
  
#line 16549 "ad_loongarch.cpp"
  }
}

void modI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8078 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ mod_w(dst, src1, src2);
  
#line 16570 "ad_loongarch.cpp"
  }
}

void modL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8094 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register op1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register op2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ mod_d(dst, op1, op2);
  
#line 16591 "ad_loongarch.cpp"
  }
}

void mulI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8109 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
     Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
     Register dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;

     __ mul_w(dst, src1, src2);
  
#line 16612 "ad_loongarch.cpp"
  }
}

void divI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8124 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
     Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
     Register dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ div_w(dst, src1, src2);

  
#line 16634 "ad_loongarch.cpp"
  }
}

void divF_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8140 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     FloatRegister src1 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */;
     FloatRegister src2 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */;
     FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ fdiv_s(dst, src1, src2);
  
#line 16655 "ad_loongarch.cpp"
  }
}

void divD_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8155 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     FloatRegister src1 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */;
     FloatRegister src2 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */;
     FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ fdiv_d(dst, src1, src2);
  
#line 16676 "ad_loongarch.cpp"
  }
}

void mulL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8168 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register op1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register op2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ mul_d(dst, op1, op2);
  
#line 16697 "ad_loongarch.cpp"
  }
}

void mulHiL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8181 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register op1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register op2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ mulh_d(dst, op1, op2);
  
#line 16718 "ad_loongarch.cpp"
  }
}

void divL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8195 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register op1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register op2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ div_d(dst, op1, op2);
  
#line 16739 "ad_loongarch.cpp"
  }
}

void addF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8208 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    FloatRegister dst  = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fadd_s(dst, src1, src2);
  
#line 16760 "ad_loongarch.cpp"
  }
}

void subF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8221 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    FloatRegister dst  = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fsub_s(dst, src1, src2);
  
#line 16781 "ad_loongarch.cpp"
  }
}

void addD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8233 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    FloatRegister dst  = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fadd_d(dst, src1, src2);
  
#line 16802 "ad_loongarch.cpp"
  }
}

void subD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8246 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    FloatRegister dst  = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fsub_d(dst, src1, src2);
  
#line 16823 "ad_loongarch.cpp"
  }
}

void negF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8259 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fneg_s(dst, src);
  
#line 16842 "ad_loongarch.cpp"
  }
}

void negD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8271 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fneg_d(dst, src);
  
#line 16861 "ad_loongarch.cpp"
  }
}

void mulF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8284 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src1 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */;
    FloatRegister src2 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */;
    FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ fmul_s(dst, src1, src2);
  
#line 16882 "ad_loongarch.cpp"
  }
}

void mulD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8298 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src1 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */;
    FloatRegister src2 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */;
    FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ fmul_d(dst, src1, src2);
  
#line 16903 "ad_loongarch.cpp"
  }
}

void absF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8312 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fabs_s(dst, src);
  
#line 16922 "ad_loongarch.cpp"
  }
}

void absD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8329 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fabs_d(dst, src);
  
#line 16941 "ad_loongarch.cpp"
  }
}

void sqrtD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8342 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fsqrt_d(dst, src);
  
#line 16960 "ad_loongarch.cpp"
  }
}

void sqrtF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8355 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fsqrt_s(dst, src);
  
#line 16979 "ad_loongarch.cpp"
  }
}

void maddF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8371 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fmadd_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 16998 "ad_loongarch.cpp"
  }
}

void maddD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8386 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fmadd_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17017 "ad_loongarch.cpp"
  }
}

void msubF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8401 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fmsub_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17036 "ad_loongarch.cpp"
  }
}

void msubD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8416 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fmsub_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17055 "ad_loongarch.cpp"
  }
}

void mnaddF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8432 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fnmadd_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17074 "ad_loongarch.cpp"
  }
}

void mnaddF_reg_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8432 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fnmadd_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17093 "ad_loongarch.cpp"
  }
}

void mnaddD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8448 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fnmadd_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17112 "ad_loongarch.cpp"
  }
}

void mnaddD_reg_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8448 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fnmadd_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17131 "ad_loongarch.cpp"
  }
}

void mnsubF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8464 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fnmsub_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17150 "ad_loongarch.cpp"
  }
}

void mnsubF_reg_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8464 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fnmsub_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17169 "ad_loongarch.cpp"
  }
}

void mnsubD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8480 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fnmsub_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17188 "ad_loongarch.cpp"
  }
}

void mnsubD_reg_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8480 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fnmsub_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 17207 "ad_loongarch.cpp"
  }
}

void copySignF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8494 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fcopysign_s(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */,
                   opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */,
                   opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 17227 "ad_loongarch.cpp"
  }
}

void copySignD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8509 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fcopysign_d(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */,
                   opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */,
                   opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 17248 "ad_loongarch.cpp"
  }
}

void andI_Reg_imm_0_4095Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8528 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      val = opnd_array(2)->constant();

    __ andi(dst, src, val);

  
#line 17270 "ad_loongarch.cpp"
  }
}

void andI_Reg_immI_nonneg_maskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8544 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int     size = Assembler::is_int_mask(opnd_array(2)->constant());

    __ bstrpick_w(dst, src, size-1, 0);
  
#line 17291 "ad_loongarch.cpp"
  }
}

void andL_Reg_immL_nonneg_maskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8559 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int     size = Assembler::is_jlong_mask(opnd_array(2)->constantL());

    __ bstrpick_d(dst, src, size-1, 0);
  
#line 17312 "ad_loongarch.cpp"
  }
}

void xorI_Reg_imm_0_4095Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8574 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      val = opnd_array(2)->constant();

       __ xori(dst, src, val);
  
#line 17333 "ad_loongarch.cpp"
  }
}

void xorI_Reg_immI_M1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8589 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;

    __ orn(dst, R0, src);
  
#line 17353 "ad_loongarch.cpp"
  }
}

void xorL_Reg_imm_0_4095Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8603 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      val = opnd_array(2)->constantL();

    __ xori(dst, src, val);
  
#line 17374 "ad_loongarch.cpp"
  }
}

void lbu_and_lmaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8619 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), C2_MacroAssembler::LOAD_U_BYTE);
  
#line 17391 "ad_loongarch.cpp"
  }
}

void lbu_and_lmask_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8619 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_BYTE);
  
#line 17408 "ad_loongarch.cpp"
  }
}

void lbu_and_rmaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8630 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_BYTE);
  
#line 17425 "ad_loongarch.cpp"
  }
}

void andI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8640 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ andr(dst, src1, src2);
  
#line 17446 "ad_loongarch.cpp"
  }
}

void andnI_Reg_nRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// M1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8654 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ andn(dst, src1, src2);
  
#line 17468 "ad_loongarch.cpp"
  }
}

void andnI_Reg_nReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8654 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(3)->as_Register(ra_,this,idx3)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    __ andn(dst, src1, src2);
  
#line 17490 "ad_loongarch.cpp"
  }
}

void ornI_Reg_nRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// M1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8668 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ orn(dst, src1, src2);
  
#line 17512 "ad_loongarch.cpp"
  }
}

void ornI_Reg_nReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8668 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(3)->as_Register(ra_,this,idx3)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    __ orn(dst, src1, src2);
  
#line 17534 "ad_loongarch.cpp"
  }
}

void andnI_nReg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8682 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;

    __ andn(dst, src2, src1);
  
#line 17556 "ad_loongarch.cpp"
  }
}

void andnI_nReg_Reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// M1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8682 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    __ andn(dst, src2, src1);
  
#line 17578 "ad_loongarch.cpp"
  }
}

void ornI_nReg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8696 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;

    __ orn(dst, src2, src1);
  
#line 17600 "ad_loongarch.cpp"
  }
}

void ornI_nReg_Reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// M1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8696 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    __ orn(dst, src2, src1);
  
#line 17622 "ad_loongarch.cpp"
  }
}

void andL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8710 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ andr(dst_reg, src1_reg, src2_reg);
  
#line 17643 "ad_loongarch.cpp"
  }
}

void andL_Reg_imm_0_4095Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8725 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    long     val = opnd_array(2)->constantL();

    __ andi(dst, src, val);
  
#line 17664 "ad_loongarch.cpp"
  }
}

void andL2I_Reg_imm_0_4095Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8740 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    long     val = opnd_array(2)->constantL();

    __ andi(dst, src, val);
  
#line 17685 "ad_loongarch.cpp"
  }
}

void andL_Reg_immL_M8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M8
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8756 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ bstrins_d(dst, R0, 2, 0);
  
#line 17704 "ad_loongarch.cpp"
  }
}

void andL_Reg_immL_M5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M5
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8769 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ bstrins_d(dst, R0, 2, 2);
  
#line 17723 "ad_loongarch.cpp"
  }
}

void andL_Reg_immL_M7Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M7
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8782 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ bstrins_d(dst, R0, 2, 1);
  
#line 17742 "ad_loongarch.cpp"
  }
}

void andL_Reg_immL_M4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8795 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ bstrins_d(dst, R0, 1, 0);
  
#line 17761 "ad_loongarch.cpp"
  }
}

void andL_Reg_immL_M121Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M121
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8808 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ bstrins_d(dst, R0, 6, 3);
  
#line 17780 "ad_loongarch.cpp"
  }
}

void orL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8820 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst_reg  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1_reg = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2_reg = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ orr(dst_reg, src1_reg, src2_reg);
  
#line 17801 "ad_loongarch.cpp"
  }
}

void orL_Reg_P2XRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8833 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst_reg  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1_reg = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2_reg = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ orr(dst_reg, src1_reg, src2_reg);
  
#line 17822 "ad_loongarch.cpp"
  }
}

void orL_Reg_P2XReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8833 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst_reg  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1_reg = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register src2_reg = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    __ orr(dst_reg, src1_reg, src2_reg);
  
#line 17843 "ad_loongarch.cpp"
  }
}

void xorL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8847 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ xorr(dst_reg, src1_reg, src2_reg);
  
#line 17864 "ad_loongarch.cpp"
  }
}

void salI_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8862 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    shamt = opnd_array(2)->constant();

    __ slli_w(dst, src, shamt);
  
#line 17885 "ad_loongarch.cpp"
  }
}

void salI_Reg_imm_and_M65536Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8876 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ slli_w(dst, src, 16);
  
#line 17906 "ad_loongarch.cpp"
  }
}

void land7_2_sNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// seven
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// sixteen
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8890 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ andi(dst, src, 7);
  
#line 17927 "ad_loongarch.cpp"
  }
}

void i2sNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// sixteen
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8906 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ ext_w_h(dst, src);
  
#line 17947 "ad_loongarch.cpp"
  }
}

void i2bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8922 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ ext_w_b(dst, src);
  
#line 17967 "ad_loongarch.cpp"
  }
}

void salI_RegL2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8936 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    shamt = opnd_array(2)->constant();

    __ slli_w(dst, src, shamt);
  
#line 17988 "ad_loongarch.cpp"
  }
}

void salI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8951 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register shamt = opnd_array(2)->as_Register(ra_,this,idx2)/* shift */;
    __ sll_w(dst, src, shamt);
  
#line 18008 "ad_loongarch.cpp"
  }
}

void salL_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8966 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int      shamt = opnd_array(2)->constant();

    __ slli_d(dst_reg, src_reg, shamt);
  
#line 18029 "ad_loongarch.cpp"
  }
}

void salL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8981 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ sll_d(dst_reg, src_reg, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 18049 "ad_loongarch.cpp"
  }
}

void sarL_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8995 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int      shamt = opnd_array(2)->constant();

    __ srai_d(dst_reg, src_reg, shamt);
  
#line 18070 "ad_loongarch.cpp"
  }
}

void sarL2I_Reg_immI_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9009 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int      shamt   = opnd_array(2)->constant();

    __ srai_d(dst_reg, src_reg, shamt);
  
#line 18091 "ad_loongarch.cpp"
  }
}

void sarL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9024 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ sra_d(dst_reg, src_reg, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 18111 "ad_loongarch.cpp"
  }
}

void slrL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9038 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ srl_d(dst_reg, src_reg, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 18131 "ad_loongarch.cpp"
  }
}

void slrL_Reg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9051 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ srli_d(dst_reg, src_reg, shamt);
  
#line 18152 "ad_loongarch.cpp"
  }
}

void slrL_Reg_immI_0_31_and_max_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// max_int
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ bstrpick_d(dst_reg, src_reg, shamt+30, shamt);
  
#line 18174 "ad_loongarch.cpp"
  }
}

void slrL_P2XReg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9079 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ srli_d(dst_reg, src_reg, shamt);
  
#line 18195 "ad_loongarch.cpp"
  }
}

void slrL_Reg_immI_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9093 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ srli_d(dst_reg, src_reg, shamt);
  
#line 18216 "ad_loongarch.cpp"
  }
}

void slrL_Reg_immI_convL2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9108 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ srli_d(dst_reg, src_reg, shamt);
  
#line 18237 "ad_loongarch.cpp"
  }
}

void slrL_P2XReg_immI_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9122 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ srli_d(dst_reg, src_reg, shamt);
  
#line 18258 "ad_loongarch.cpp"
  }
}

void xorI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9139 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ xorr(dst, src1, src2);
  
#line 18278 "ad_loongarch.cpp"
  }
}

void orI_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9154 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ ori(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->constant());
  
#line 18295 "ad_loongarch.cpp"
  }
}

void orI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9166 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ orr(dst, src1, src2);
  
#line 18315 "ad_loongarch.cpp"
  }
}

void rotI_shr_logical_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9182 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register   dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register   src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int     rshift = opnd_array(2)->constant();

    __ rotri_w(dst, src, 1);
    if (rshift - 1) {
      __ srli_w(dst, dst, rshift - 1);
    }
  
#line 18341 "ad_loongarch.cpp"
  }
}

void rotI_shr_logical_Reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// one
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9182 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register   dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register   src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int     rshift = opnd_array(4)->constant();

    __ rotri_w(dst, src, 1);
    if (rshift - 1) {
      __ srli_w(dst, dst, rshift - 1);
    }
  
#line 18367 "ad_loongarch.cpp"
  }
}

void orI_Reg_castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9200 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ orr(dst, src1, src2);
  
#line 18387 "ad_loongarch.cpp"
  }
}

void orI_Reg_castP2X_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9200 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;
    __ orr(dst, src1, src2);
  
#line 18407 "ad_loongarch.cpp"
  }
}

void shr_logical_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9216 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    shift = opnd_array(2)->constant();

    __ srli_w(dst, src, shift);
  
#line 18428 "ad_loongarch.cpp"
  }
}

void shr_logical_Reg_imm_nonneg_maskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9230 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int      pos = opnd_array(2)->constant();
    int     size = Assembler::is_int_mask(opnd_array(3)->constant());

    __ bstrpick_w(dst, src, pos+size-1, pos);
  
#line 18451 "ad_loongarch.cpp"
  }
}

void rolI_Reg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9248 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_w(dst, src, sa);
  
#line 18473 "ad_loongarch.cpp"
  }
}

void rolI_Reg_immI_0_31_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9248 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_w(dst, src, sa);
  
#line 18495 "ad_loongarch.cpp"
  }
}

void rolL_Reg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9265 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_d(dst, src, sa);
  
#line 18517 "ad_loongarch.cpp"
  }
}

void rolL_Reg_immI_0_31_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9265 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_d(dst, src, sa);
  
#line 18539 "ad_loongarch.cpp"
  }
}

void rolL_Reg_immI_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9282 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_d(dst, src, sa);
  
#line 18561 "ad_loongarch.cpp"
  }
}

void rolL_Reg_immI_32_63_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9282 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_d(dst, src, sa);
  
#line 18583 "ad_loongarch.cpp"
  }
}

void rorI_Reg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9299 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_w(dst, src, sa);
  
#line 18605 "ad_loongarch.cpp"
  }
}

void rorI_Reg_immI_0_31_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9299 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_w(dst, src, sa);
  
#line 18627 "ad_loongarch.cpp"
  }
}

void rorL_Reg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9316 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_d(dst, src, sa);
  
#line 18649 "ad_loongarch.cpp"
  }
}

void rorL_Reg_immI_0_31_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9316 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_d(dst, src, sa);
  
#line 18671 "ad_loongarch.cpp"
  }
}

void rorL_Reg_immI_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9333 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_d(dst, src, sa);
  
#line 18693 "ad_loongarch.cpp"
  }
}

void rorL_Reg_immI_32_63_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9333 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_d(dst, src, sa);
  
#line 18715 "ad_loongarch.cpp"
  }
}

void rolI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9350 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     __ sub_w(AT, R0, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
     __ rotr_w(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, AT);
  
#line 18733 "ad_loongarch.cpp"
  }
}

void rolL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9364 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     __ sub_d(AT, R0, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
     __ rotr_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, AT);
  
#line 18751 "ad_loongarch.cpp"
  }
}

void rorI_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9379 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     __ rotri_w(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 18768 "ad_loongarch.cpp"
  }
}

void rorI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9392 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     __ rotr_w(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 18785 "ad_loongarch.cpp"
  }
}

void rorL_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9405 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ rotri_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 18802 "ad_loongarch.cpp"
  }
}

void rorL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9418 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ rotr_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 18819 "ad_loongarch.cpp"
  }
}

void shr_logical_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9430 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register shift = opnd_array(2)->as_Register(ra_,this,idx2)/* shift */;
    __ srl_w(dst, src, shift);
  
#line 18839 "ad_loongarch.cpp"
  }
}

void shr_arith_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9445 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    shift = opnd_array(2)->constant();
    __ srai_w(dst, src, shift);
  
#line 18859 "ad_loongarch.cpp"
  }
}

void shr_arith_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9459 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register shift = opnd_array(2)->as_Register(ra_,this,idx2)/* shift */;
    __ sra_w(dst, src, shift);
  
#line 18879 "ad_loongarch.cpp"
  }
}

void convI2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9475 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    if (dst != src) {
      __ addi_d(dst, R0, 1);
      __ maskeqz(dst, dst, src);
    } else {
      __ move(AT, src);
      __ addi_d(dst, R0, 1);
      __ maskeqz(dst, dst, AT);
    }
  
#line 18905 "ad_loongarch.cpp"
  }
}

void convI2L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9498 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    if(dst != src) __ slli_w(dst, src, 0);
  
#line 18924 "ad_loongarch.cpp"
  }
}

void convL2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9511 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    __ slli_w(dst, src, 0);
  
#line 18943 "ad_loongarch.cpp"
  }
}

void convL2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9524 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ movgr2fr_d(dst, src);
    __ ffint_d_l(dst, dst);
  
#line 18963 "ad_loongarch.cpp"
  }
}

void convD2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9544 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ ftintrz_w_d(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ movfr2gr_s(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
  
#line 18981 "ad_loongarch.cpp"
  }
}

void convD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9558 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ ftintrz_l_d(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ movfr2gr_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
  
#line 18999 "ad_loongarch.cpp"
  }
}

void convF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9574 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ ftintrz_w_s(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ movfr2gr_s(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
  
#line 19017 "ad_loongarch.cpp"
  }
}

void convF2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9588 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ ftintrz_l_s(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ movfr2gr_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
  
#line 19035 "ad_loongarch.cpp"
  }
}

void convL2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9600 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Label L;

    __ movgr2fr_d(dst, src);
    __ ffint_s_l(dst, dst);
  
#line 19056 "ad_loongarch.cpp"
  }
}

void convI2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9615 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register      src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ movgr2fr_w(dst, src);
    __ ffint_s_w(dst, dst);
  
#line 19076 "ad_loongarch.cpp"
  }
}

void roundDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9630 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    switch (opnd_array(2)->constant()) {
      case RoundDoubleModeNode::rmode_rint:  __ vfrintrne_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */); break;
      case RoundDoubleModeNode::rmode_floor: __ vfrintrm_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);  break;
      case RoundDoubleModeNode::rmode_ceil:  __ vfrintrp_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);  break;
    }
  
#line 19097 "ad_loongarch.cpp"
  }
}

void cmpLTMask_immI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9645 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

       Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
       Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

       __ srai_w(dst, src, 31);
    
#line 19117 "ad_loongarch.cpp"
  }
}

void cmpLTMaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9660 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register p   = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register q   = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ slt(dst, p, q);
    __ sub_d(dst, R0, dst);
    
#line 19139 "ad_loongarch.cpp"
  }
}

void convP2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9676 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    if (dst != src) {
      __ addi_d(dst, R0, 1);
      __ maskeqz(dst, dst, src);
    } else {
      __ move(AT, src);
      __ addi_d(dst, R0, 1);
      __ maskeqz(dst, dst, AT);
    }
  
#line 19165 "ad_loongarch.cpp"
  }
}

void convI2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9697 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register      src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;
    __ movgr2fr_w(dst ,src);
    __ ffint_d_w(dst, dst);
    
#line 19184 "ad_loongarch.cpp"
  }
}

void convF2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9709 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;
    FloatRegister src = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */;

    __ fcvt_d_s(dst, src);
  
#line 19203 "ad_loongarch.cpp"
  }
}

void convD2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9721 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;
    FloatRegister src = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */;

    __ fcvt_s_d(dst, src);
  
#line 19222 "ad_loongarch.cpp"
  }
}

void encodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9736 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ encode_heap_oop(dst, src);
  
#line 19241 "ad_loongarch.cpp"
  }
}

void encodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9749 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ encode_heap_oop_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 19257 "ad_loongarch.cpp"
  }
}

void decodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9760 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ decode_heap_oop(d, s);
  
#line 19276 "ad_loongarch.cpp"
  }
}

void decodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9774 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    if (s != d) {
      __ decode_heap_oop_not_null(d, s);
    } else {
      __ decode_heap_oop_not_null(d);
    }
  
#line 19298 "ad_loongarch.cpp"
  }
}

void encodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9789 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ encode_klass_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 19314 "ad_loongarch.cpp"
  }
}

void decodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9798 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    if (s != d) {
      __ decode_klass_not_null(d, s);
    } else {
      __ decode_klass_not_null(d);
    }
  
#line 19336 "ad_loongarch.cpp"
  }
}

void tlsLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9816 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
#ifdef OPT_THREAD
    __ move(dst, TREG);
#else
    __ get_thread(dst);
#endif
  
#line 19357 "ad_loongarch.cpp"
  }
}

void checkCastPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void castPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castIINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void castLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castLLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castFFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castFFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castDDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castDDNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castVVXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castVVXNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castVVYNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castVVYNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void RetNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9904 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

   __ jr(RA);
  
#line 19467 "ad_loongarch.cpp"
  }
}

void tailjmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9924 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register target = opnd_array(1)->as_Register(ra_,this,idx1)/* jump_target */;

    // V0, V1 are indicated in:
    //     [stubGenerator_loongarch.cpp] generate_forward_exception()
    //     [runtime_loongarch.cpp] OptoRuntime::generate_exception_blob()
    //
    Register oop  = opnd_array(2)->as_Register(ra_,this,idx2)/* ex_oop */;
    Register exception_oop = V0;
    Register exception_pc = V1;

    __ move(exception_pc, RA);
    __ move(exception_oop, oop);

    __ jr(target);
  
#line 19497 "ad_loongarch.cpp"
  }
}

void CallStaticJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2357 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // CALL to fixup routine.  Fixup routine uses ScopeDesc info to determine
    // who we intended to call.
    C2_MacroAssembler _masm(&cbuf);
    address addr = (address)opnd_array(1)->method();
    address call;
    __ block_comment("Java_Static_Call");

    if ( !_method ) {
      // A call to a runtime wrapper, e.g. new, new_typeArray_Java, uncommon_trap.
      call = __ trampoline_call(AddressLiteral(addr, relocInfo::runtime_call_type), &cbuf);
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
    } else {
      int method_index = resolved_method_index(cbuf);
      RelocationHolder rspec = _optimized_virtual ? opt_virtual_call_Relocation::spec(method_index)
                                     : static_call_Relocation::spec(method_index);
      call = __ trampoline_call(AddressLiteral(addr, rspec), &cbuf);
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      // Emit stub for static call
      address stub = CompiledStaticCall::emit_to_interp_stub(cbuf);
      if (stub == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
    }
  
#line 19541 "ad_loongarch.cpp"
  }
}

void CallDynamicJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2394 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ block_comment("Java_Dynamic_Call");
    address call = __ ic_call((address)opnd_array(1)->method(), resolved_method_index(cbuf));
    if (call == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 19562 "ad_loongarch.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2348 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    C2_MacroAssembler _masm(&cbuf);
    // This is the instruction starting address for relocation info.
    __ block_comment("Java_To_Runtime");
    cbuf.set_insts_mark();
    __ relocate(relocInfo::runtime_call_type);
    __ patchable_call((address)opnd_array(1)->method());
  
#line 19582 "ad_loongarch.cpp"
  }
}

void prefetchAllocNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9994 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if (index != -1) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }

      if (Assembler::is_simm(disp, 12)) {
        __ preld(8, AT, disp);
      } else {
        __ li(T4, disp);
        __ add_d(AT, AT, T4);
        __ preld(8, AT, 0);
      }
    } else {
      if (Assembler::is_simm(disp, 12)) {
        __ preld(8, as_Register(base), disp);
      } else {
        __ li(T4, disp);
        __ add_d(AT, as_Register(base), T4);
        __ preld(8, AT, 0);
      }
    }
  
#line 19625 "ad_loongarch.cpp"
  }
}

void CallLeafDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2348 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    C2_MacroAssembler _masm(&cbuf);
    // This is the instruction starting address for relocation info.
    __ block_comment("Java_To_Runtime");
    cbuf.set_insts_mark();
    __ relocate(relocInfo::runtime_call_type);
    __ patchable_call((address)opnd_array(1)->method());
  
#line 19645 "ad_loongarch.cpp"
  }
}

void loadUSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10046 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_SHORT);
  
#line 19661 "ad_loongarch.cpp"
  }
}

void loadUS_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10057 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_SHORT);
  
#line 19677 "ad_loongarch.cpp"
  }
}

void storeCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10069 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_CHAR);
  
#line 19694 "ad_loongarch.cpp"
  }
}

void storeC_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10080 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

     __ loadstore_enc(R0, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_SHORT);
  
#line 19711 "ad_loongarch.cpp"
  }
}

void loadConF_immF_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10092 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ movgr2fr_w(dst, R0);
  
#line 19729 "ad_loongarch.cpp"
  }
}

void loadConFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10106 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    int con_offset = constant_offset();

    if (Assembler::is_simm(con_offset, 12)) {
      __ fld_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_Register(ra_->get_encode(in(mach_constant_base_node_input()))), con_offset);
    } else {
      __ li(AT, con_offset);
      __ fldx_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_Register(ra_->get_encode(in(mach_constant_base_node_input()))), AT);
    }
  
#line 19752 "ad_loongarch.cpp"
  }
}

void loadConFNode::eval_constant(Compile* C) {
  {

#line 10107 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 19761 "ad_loongarch.cpp"
  }
}
void loadConD_immD_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10125 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ movgr2fr_d(dst, R0);
  
#line 19778 "ad_loongarch.cpp"
  }
}

void loadConDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10138 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    int con_offset = constant_offset();

    if (Assembler::is_simm(con_offset, 12)) {
      __ fld_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_Register(ra_->get_encode(in(mach_constant_base_node_input()))), con_offset);
    } else {
      __ li(AT, con_offset);
      __ fldx_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_Register(ra_->get_encode(in(mach_constant_base_node_input()))), AT);
    }
  
#line 19801 "ad_loongarch.cpp"
  }
}

void loadConDNode::eval_constant(Compile* C) {
  {

#line 10139 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 19810 "ad_loongarch.cpp"
  }
}
void storeF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10157 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_FLOAT);
  
#line 19826 "ad_loongarch.cpp"
  }
}

void storeF_immF_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10168 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(R0, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_INT);
  
#line 19843 "ad_loongarch.cpp"
  }
}

void loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10180 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_DOUBLE);
  
#line 19859 "ad_loongarch.cpp"
  }
}

void loadD_unalignedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10192 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_DOUBLE);
  
#line 19875 "ad_loongarch.cpp"
  }
}

void storeD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10203 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_DOUBLE);
  
#line 19892 "ad_loongarch.cpp"
  }
}

void storeD_immD_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10214 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(R0, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_LONG);
  
#line 19909 "ad_loongarch.cpp"
  }
}

void loadSSINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10226 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    guarantee( Assembler::is_simm(opnd_array(1)->disp(ra_,this,idx1), 12), "disp too long (loadSSI) !");
    __ ld_w(opnd_array(0)->as_Register(ra_,this)/* dst */, SP, opnd_array(1)->disp(ra_,this,idx1));
  
#line 19926 "ad_loongarch.cpp"
  }
}

void storeSSINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10239 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    guarantee( Assembler::is_simm(opnd_array(0)->disp(ra_,this,0), 12), "disp too long (storeSSI) !");
    __ st_w(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, SP, opnd_array(0)->disp(ra_,this,0));
  
#line 19943 "ad_loongarch.cpp"
  }
}

void loadSSLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10252 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    guarantee( Assembler::is_simm(opnd_array(1)->disp(ra_,this,idx1), 12), "disp too long (loadSSL) !");
    __ ld_d(opnd_array(0)->as_Register(ra_,this)/* dst */, SP, opnd_array(1)->disp(ra_,this,idx1));
  
#line 19960 "ad_loongarch.cpp"
  }
}

void storeSSLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10265 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    guarantee( Assembler::is_simm(opnd_array(0)->disp(ra_,this,0), 12), "disp too long (storeSSL) !");
    __ st_d(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, SP, opnd_array(0)->disp(ra_,this,0));
  
#line 19977 "ad_loongarch.cpp"
  }
}

void loadSSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10278 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    guarantee( Assembler::is_simm(opnd_array(1)->disp(ra_,this,idx1), 12), "disp too long (loadSSP) !");
    __ ld_d(opnd_array(0)->as_Register(ra_,this)/* dst */, SP, opnd_array(1)->disp(ra_,this,idx1));
  
#line 19994 "ad_loongarch.cpp"
  }
}

void storeSSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10291 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    guarantee( Assembler::is_simm(opnd_array(0)->disp(ra_,this,0), 12), "disp too long (storeSSP) !");
    __ st_d(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, SP, opnd_array(0)->disp(ra_,this,0));
  
#line 20011 "ad_loongarch.cpp"
  }
}

void loadSSFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10304 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    guarantee( Assembler::is_simm(opnd_array(1)->disp(ra_,this,idx1), 12), "disp too long (loadSSF) !");
    __ fld_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, SP, opnd_array(1)->disp(ra_,this,idx1));
  
#line 20028 "ad_loongarch.cpp"
  }
}

void storeSSFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10317 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    guarantee( Assembler::is_simm(opnd_array(0)->disp(ra_,this,0), 12), "disp too long (storeSSF) !");
    __ fst_s(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, SP, opnd_array(0)->disp(ra_,this,0));
  
#line 20045 "ad_loongarch.cpp"
  }
}

void loadSSDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10331 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    guarantee( Assembler::is_simm(opnd_array(1)->disp(ra_,this,idx1), 12), "disp too long (loadSSD) !");
    __ fld_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, SP, opnd_array(1)->disp(ra_,this,idx1));
  
#line 20062 "ad_loongarch.cpp"
  }
}

void storeSSDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10344 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    guarantee( Assembler::is_simm(opnd_array(0)->disp(ra_,this,0), 12), "disp too long (storeSSD) !");
    __ fst_d(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, SP, opnd_array(0)->disp(ra_,this,0));
  
#line 20079 "ad_loongarch.cpp"
  }
}

void cmpFastLockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// scr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10356 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fast_lock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(0)->as_Register(ra_,this)/* cr */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* scr */);
  
#line 20098 "ad_loongarch.cpp"
  }
}

void cmpFastUnlockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// scr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10369 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ fast_unlock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(0)->as_Register(ra_,this)/* cr */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* scr */);
  
#line 20117 "ad_loongarch.cpp"
  }
}

void storeImmCMNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10384 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ membar(__ StoreStore);
    __ loadstore_enc(R0, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_BYTE);
  
#line 20135 "ad_loongarch.cpp"
  }
}

void ShouldNotReachHereNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10399 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (is_reachable()) {
      __ stop(_halt_reason);
    }
  
#line 20153 "ad_loongarch.cpp"
  }
}

void leaP12NarrowNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10415 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register  base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int       disp = opnd_array(1)->disp(ra_,this,idx1);

    __ addi_d(dst, base, disp);
  
#line 20173 "ad_loongarch.cpp"
  }
}

void leaPIdxScaleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// reg
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lreg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10431 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register  dst   = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register  base  = opnd_array(1)->as_Register(ra_,this,idx1)/* reg */;
    Register  index = opnd_array(2)->as_Register(ra_,this,idx2)/* lreg */;
    int       scale = opnd_array(3)->constant();

    if (scale == 0) {
       __ add_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* reg */, index);
    } else {
       __ alsl_d(dst, index, base, scale - 1);
    }
 
#line 20200 "ad_loongarch.cpp"
  }
}

void partialSubtypeCheckNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 2405 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register result = opnd_array(0)->as_Register(ra_,this)/* result */;
    Register sub    = opnd_array(1)->as_Register(ra_,this,idx1)/* sub */;
    Register super  = opnd_array(2)->as_Register(ra_,this,idx2)/* super */;
    Register length = as_Register(T8_enc);
    Register tmp    = T4;
    Label miss;

    // result may be the same as sub
    //    47c   B40: #    B21 B41 <- B20  Freq: 0.155379
    //    47c     partialSubtypeCheck result=S1, sub=S1, super=S3, length=S0
    //    4bc     mov   S2, NULL #@loadConP
    //    4c0     beq   S1, S2, B21 #@branchConP  P=0.999999 C=-1.000000
    //
    C2_MacroAssembler _masm(&cbuf);
    Label done;
    __ check_klass_subtype_slow_path(sub, super, length, tmp,
        NULL, &miss,
        /*set_cond_codes:*/ true);
    // Refer to X86_64's RDI
    __ move(result, 0);
    __ b(done);

    __ bind(miss);
    __ li(result, 1);
    __ bind(done);
  
#line 20240 "ad_loongarch.cpp"
  }
}

void storePConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// heap_top_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10472 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));

    int     index = opnd_array(1)->index(ra_,this,idx1);
    int     scale = opnd_array(1)->scale();
    int      disp = opnd_array(1)->disp(ra_,this,idx1);

    guarantee(Assembler::is_simm(disp, 12), "");

    if (index != -1) {
      __ stop("in storePConditional: index != -1");
    } else {
      __ move(AT, newval);
      __ sc_d(AT, addr);
      __ move(opnd_array(0)->as_Register(ra_,this)/* cr */, AT);
    }
  
#line 20274 "ad_loongarch.cpp"
  }
}

void storeIConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10500 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register cr     = opnd_array(0)->as_Register(ra_,this)/* cr */;
    Address  addr(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));

    int     index = opnd_array(1)->index(ra_,this,idx1);
    int     scale = opnd_array(1)->scale();
    int      disp = opnd_array(1)->disp(ra_,this,idx1);

    guarantee(Assembler::is_simm(disp, 12), "");

    if (index != -1) {
      __ stop("in storeIConditional: index != -1");
    } else {
      if (cr != addr.base() && cr != oldval && cr != newval) {
        __ cmpxchg32(addr, oldval, newval, cr, true, false, true);
      } else {
        __ cmpxchg32(addr, oldval, newval, AT, true, false, true);
        __ move(cr, AT);
      }
    }
  
#line 20312 "ad_loongarch.cpp"
  }
}

void storeLConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10534 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register cr     = opnd_array(0)->as_Register(ra_,this)/* cr */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));

    int     index = opnd_array(1)->index(ra_,this,idx1);
    int     scale = opnd_array(1)->scale();
    int      disp = opnd_array(1)->disp(ra_,this,idx1);

    guarantee(Assembler::is_simm(disp, 12), "");

    if (index != -1) {
      __ stop("in storeIConditional: index != -1");
    } else {
      if (cr != addr.base() && cr != oldval && cr != newval) {
        __ cmpxchg(addr, oldval, newval, cr, false, true);
      } else {
        __ cmpxchg(addr, oldval, newval, AT, false, true);
        __ move(cr, AT);
      }
    }
  
#line 20350 "ad_loongarch.cpp"
  }
}

void loadPLockedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10568 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");
    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_LINKED_LONG);
  
#line 20368 "ad_loongarch.cpp"
  }
}

uint loadPLockedNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 12, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 12);
}

void compareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10581 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address  addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem_ptr */, 0);

    if (res != addr.base() && res != oldval && res != newval) {
      __ cmpxchg32(addr, oldval, newval, res, true, false, true /* acquire */);
    } else {
      __ cmpxchg32(addr, oldval, newval, AT, true, false, true /* acquire */);
      __ move(res, AT);
    }
  
#line 20401 "ad_loongarch.cpp"
  }
}

void compareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10602 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address  addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem_ptr */, 0);

    if (res != addr.base() && res != oldval && res != newval) {
      __ cmpxchg(addr, oldval, newval, res, false, true /* acquire */);
    } else {
      __ cmpxchg(addr, oldval, newval, AT, false, true /* acquire */);
      __ move(res, AT);
    }
  
#line 20429 "ad_loongarch.cpp"
  }
}

void compareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10623 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address  addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem_ptr */, 0);

    if (res != addr.base() && res != oldval && res != newval) {
      __ cmpxchg(addr, oldval, newval, res, false, true /* acquire */);
    } else {
      __ cmpxchg(addr, oldval, newval, AT, false, true /* acquire */);
      __ move(res, AT);
    }
  
#line 20457 "ad_loongarch.cpp"
  }
}

void compareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10643 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address  addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem_ptr */, 0);

    if (res != addr.base() && res != oldval && res != newval) {
      __ cmpxchg32(addr, oldval, newval, res, false, false, true /* acquire */);
    } else {
      __ cmpxchg32(addr, oldval, newval, AT, false, false, true /* acquire */);
      __ move(res, AT);
    }
  
#line 20485 "ad_loongarch.cpp"
  }
}

void get_and_setINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10663 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register prev = opnd_array(0)->as_Register(ra_,this)/* prev */;
    Register newv = opnd_array(2)->as_Register(ra_,this,idx2)/* newv */;
    Register addr = as_Register(opnd_array(1)->base(ra_,this,idx1));
    if (prev == newv || prev == addr) {
      __ amswap_db_w(AT, newv, addr);
      __ move(prev, AT);
    } else {
      __ amswap_db_w(prev, newv, addr);
    }
  
#line 20510 "ad_loongarch.cpp"
  }
}

void get_and_setLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10681 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register prev = opnd_array(0)->as_Register(ra_,this)/* prev */;
    Register newv = opnd_array(2)->as_Register(ra_,this,idx2)/* newv */;
    Register addr = as_Register(opnd_array(1)->base(ra_,this,idx1));
    if (prev == newv || prev == addr) {
      __ amswap_db_d(AT, newv, addr);
      __ move(prev, AT);
    } else {
      __ amswap_db_d(prev, newv, addr);
    }
  
#line 20535 "ad_loongarch.cpp"
  }
}

void get_and_setNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10699 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register prev = opnd_array(0)->as_Register(ra_,this)/* prev */;
    Register newv = opnd_array(2)->as_Register(ra_,this,idx2)/* newv */;
    Register addr = as_Register(opnd_array(1)->base(ra_,this,idx1));
    __ amswap_db_w(AT, newv, addr);
    __ bstrpick_d(prev, AT, 31, 0);
  
#line 20556 "ad_loongarch.cpp"
  }
}

void get_and_setPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10713 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register prev = opnd_array(0)->as_Register(ra_,this)/* prev */;
    Register newv = opnd_array(2)->as_Register(ra_,this,idx2)/* newv */;
    Register addr = as_Register(opnd_array(1)->base(ra_,this,idx1));
    if (prev == newv || prev == addr) {
      __ amswap_db_d(AT, newv, addr);
      __ move(prev, AT);
    } else {
      __ amswap_db_d(prev, newv, addr);
    }
  
#line 20581 "ad_loongarch.cpp"
  }
}

void get_and_addLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10731 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newv = opnd_array(0)->as_Register(ra_,this)/* newval */;
    Register incr = opnd_array(2)->as_Register(ra_,this,idx2)/* incr */;
    Register addr = as_Register(opnd_array(1)->base(ra_,this,idx1));
    if (newv == incr || newv == addr) {
      __ amadd_db_d(AT, incr, addr);
      __ move(newv, AT);
    } else {
      __ amadd_db_d(newv, incr, addr);
    }
  
#line 20606 "ad_loongarch.cpp"
  }
}

void get_and_addL_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10750 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amadd_db_d(R0, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 20623 "ad_loongarch.cpp"
  }
}

void get_and_addINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10760 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newv = opnd_array(0)->as_Register(ra_,this)/* newval */;
    Register incr = opnd_array(2)->as_Register(ra_,this,idx2)/* incr */;
    Register addr = as_Register(opnd_array(1)->base(ra_,this,idx1));
    if (newv == incr || newv == addr) {
      __ amadd_db_w(AT, incr, addr);
      __ move(newv, AT);
    } else {
      __ amadd_db_w(newv, incr, addr);
    }
  
#line 20648 "ad_loongarch.cpp"
  }
}

void get_and_addI_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10779 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ amadd_db_w(R0, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 20665 "ad_loongarch.cpp"
  }
}

void compareAndExchangeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10793 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(4)->as_Register(ra_,this,idx4)/* res */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)));
    __ cmpxchg32(addr, oldval, newval, res, true /* sign */, false /* retold */, true /* acquire */, false /* weak */, true /* exchange */);
  
#line 20688 "ad_loongarch.cpp"
  }
}

void compareAndExchangeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10811 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(4)->as_Register(ra_,this,idx4)/* res */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)));
    __ cmpxchg(addr, oldval, newval, res, false /* retold */, true /* acquire */, false /* weak */, true /* exchange */);
  
#line 20711 "ad_loongarch.cpp"
  }
}

void compareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10829 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(4)->as_Register(ra_,this,idx4)/* res */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)));
    __ cmpxchg(addr, oldval, newval, res, false /* retold */, true /* barrier */, false /* weak */, true /* exchange */);
  
#line 20734 "ad_loongarch.cpp"
  }
}

void compareAndExchangeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10847 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(4)->as_Register(ra_,this,idx4)/* res */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)));
    __ cmpxchg32(addr, oldval, newval, res, false /* sign */, false /* retold */, true /* acquire */, false /* weak */, true /* exchange */);
  
#line 20757 "ad_loongarch.cpp"
  }
}

void weakCompareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10864 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)));
    if (res != addr.base() && res != oldval && res != newval) {
      __ cmpxchg32(addr, oldval, newval, res, true /* sign */, false /* retold */, true /* acquire */, true /* weak */, false /* exchange */);
    } else {
      __ cmpxchg32(addr, oldval, newval, AT, true /* sign */, false /* retold */, true /* acquire */, true /* weak */, false /* exchange */);
      __ move(res, AT);
    }
  
#line 20784 "ad_loongarch.cpp"
  }
}

void weakCompareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10886 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)));
    if (res != addr.base() && res != oldval && res != newval) {
      __ cmpxchg(addr, oldval, newval, res, false /* retold */, true /* acquire */, true /* weak */, false /* exchange */);
    } else {
      __ cmpxchg(addr, oldval, newval, AT, false /* retold */, true /* acquire */, true /* weak */, false /* exchange */);
      __ move(res, AT);
    }
  
#line 20811 "ad_loongarch.cpp"
  }
}

void weakCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10908 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)));
    if (res != addr.base() && res != oldval && res != newval) {
      __ cmpxchg(addr, oldval, newval, res, false /* retold */, false /* acquire */, true /* weak */, false /* exchange */);
    } else {
      __ cmpxchg(addr, oldval, newval, AT, false /* retold */, false /* acquire */, true /* weak */, false /* exchange */);
      __ move(res, AT);
    }
  
#line 20838 "ad_loongarch.cpp"
  }
}

void weakCompareAndSwapP_acqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10930 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)));
    if (res != addr.base() && res != oldval && res != newval) {
      __ cmpxchg(addr, oldval, newval, res, false /* retold */, true /* acquire */, true /* weak */, false /* exchange */);
    } else {
      __ cmpxchg(addr, oldval, newval, AT, false /* retold */, true /* acquire */, true /* weak */, false /* exchange */);
      __ move(res, AT);
    }
  
#line 20865 "ad_loongarch.cpp"
  }
}

void weakCompareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10952 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)));
    if (res != addr.base() && res != oldval && res != newval) {
      __ cmpxchg32(addr, oldval, newval, res, false /* sign */, false /* retold */, true /* acquire */, true /* weak */, false /* exchange */);
    } else {
      __ cmpxchg32(addr, oldval, newval, AT, false /* sign */, false /* retold */, true /* acquire */, true /* weak */, false /* exchange */);
      __ move(res, AT);
    }
  
#line 20892 "ad_loongarch.cpp"
  }
}

void minI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10976 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst   = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    Register src   = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;

    __ slt(AT, src, dst);
    __ masknez(dst, dst, AT);
    __ maskeqz(AT, src, AT);
    __ OR(dst, dst, AT);
  
#line 20915 "ad_loongarch.cpp"
  }
}

void maxI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10996 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst   = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    Register src   = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;

    __ slt(AT, dst, src);
    __ masknez(dst, dst, AT);
    __ maskeqz(AT, src, AT);
    __ OR(dst, dst, AT);
  
#line 20938 "ad_loongarch.cpp"
  }
}

void maxI_Reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11015 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst   = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ slt(AT, dst, R0);
    __ masknez(dst, dst, AT);
  
#line 20958 "ad_loongarch.cpp"
  }
}

void zerox_long_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11030 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;

    __ bstrpick_d(dst, src, 31, 0);
  
#line 20978 "ad_loongarch.cpp"
  }
}

void combine_i2lNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// shift32
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11044 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;

    if (src1 == dst) {
       __ bstrins_d(dst, src2, 63, 32);
    } else if (src2 == dst) {
       __ slli_d(dst, dst, 32);
       __ bstrins_d(dst, src1, 31, 0);
    } else {
       __ bstrpick_d(dst, src1, 31, 0);
       __ bstrins_d(dst, src2, 63, 32);
    }
  
#line 21009 "ad_loongarch.cpp"
  }
}

void combine_i2l_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift32
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11044 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(3)->as_Register(ra_,this,idx3)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    if (src1 == dst) {
       __ bstrins_d(dst, src2, 63, 32);
    } else if (src2 == dst) {
       __ slli_d(dst, dst, 32);
       __ bstrins_d(dst, src1, 31, 0);
    } else {
       __ bstrpick_d(dst, src1, 31, 0);
       __ bstrins_d(dst, src2, 63, 32);
    }
  
#line 21040 "ad_loongarch.cpp"
  }
}

void convI2L_reg_reg_zexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11068 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;

    __ bstrpick_d(dst, src, 31, 0);
  
#line 21060 "ad_loongarch.cpp"
  }
}

void convL2I2L_reg_reg_zexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11082 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;

    __ bstrpick_d(dst, src, 31, 0);
  
#line 21080 "ad_loongarch.cpp"
  }
}

void loadUI2L_rmaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11097 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");
    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_INT);
  
#line 21099 "ad_loongarch.cpp"
  }
}

void loadUI2L_lmaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11109 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");
    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), C2_MacroAssembler::LOAD_U_INT);
  
#line 21118 "ad_loongarch.cpp"
  }
}

void loadUI2L_lmask_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11109 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");
    __ loadstore_enc(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_U_INT);
  
#line 21137 "ad_loongarch.cpp"
  }
}

void safePoint_poll_tlsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11128 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    Register poll_reg = opnd_array(1)->as_Register(ra_,this,idx1)/* poll */;

    __ block_comment("Safepoint:");
    __ relocate(relocInfo::poll_type);
    address pre_pc = __ pc();
    __ ld_w(AT, poll_reg, 0);
    assert(nativeInstruction_at(pre_pc)->is_safepoint_poll(), "must emit ld_w AT, [opnd_array(1)]");
  
#line 21159 "ad_loongarch.cpp"
  }
}

uint safePoint_poll_tlsNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void roundFloat_nopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void roundDouble_nopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void bytes_reverse_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11166 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ bswap_w(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21196 "ad_loongarch.cpp"
  }
}

void bytes_reverse_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11176 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ revb_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21212 "ad_loongarch.cpp"
  }
}

void bytes_reverse_unsigned_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11186 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ bswap_hu(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21228 "ad_loongarch.cpp"
  }
}

void bytes_reverse_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11196 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ bswap_h(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21244 "ad_loongarch.cpp"
  }
}

void countLeadingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11208 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ clz_w(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21260 "ad_loongarch.cpp"
  }
}

void countLeadingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11218 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ clz_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21276 "ad_loongarch.cpp"
  }
}

void countTrailingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11228 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ ctz_w(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21292 "ad_loongarch.cpp"
  }
}

void countTrailingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11238 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ ctz_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21308 "ad_loongarch.cpp"
  }
}

void popCountINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11254 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vinsgr2vr_w(fscratch, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0);
    __ vpcnt_w(fscratch, fscratch);
    __ vpickve2gr_wu(opnd_array(0)->as_Register(ra_,this)/* dst */, fscratch, 0);
  
#line 21326 "ad_loongarch.cpp"
  }
}

void popCountI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11271 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(fscratch, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_FLOAT);
    __ vpcnt_w(fscratch, fscratch);
    __ vpickve2gr_wu(opnd_array(0)->as_Register(ra_,this)/* dst */, fscratch, 0);
  
#line 21344 "ad_loongarch.cpp"
  }
}

void popCountLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11289 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vinsgr2vr_d(fscratch, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0);
    __ vpcnt_d(fscratch, fscratch);
    __ vpickve2gr_wu(opnd_array(0)->as_Register(ra_,this)/* dst */, fscratch, 0);
  
#line 21362 "ad_loongarch.cpp"
  }
}

void popCountL_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11306 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(fscratch, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_DOUBLE);
    __ vpcnt_d(fscratch, fscratch);
    __ vpickve2gr_wu(opnd_array(0)->as_Register(ra_,this)/* dst */, fscratch, 0);
  
#line 21380 "ad_loongarch.cpp"
  }
}

void loadV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11323 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_VECTORX);
  
#line 21396 "ad_loongarch.cpp"
  }
}

void loadV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11333 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::LOAD_VECTORY);
  
#line 21412 "ad_loongarch.cpp"
  }
}

void storeV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11345 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_VECTORX);
  
#line 21429 "ad_loongarch.cpp"
  }
}

void storeV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11355 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ loadstore_enc(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), C2_MacroAssembler::STORE_VECTORY);
  
#line 21446 "ad_loongarch.cpp"
  }
}

void repl16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11367 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vreplgr2vr_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21462 "ad_loongarch.cpp"
  }
}

void repl16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11377 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vldi(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, (opnd_array(1)->constant()& 0xff));
  
#line 21478 "ad_loongarch.cpp"
  }
}

void repl8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11387 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vreplgr2vr_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21494 "ad_loongarch.cpp"
  }
}

void repl8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11397 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vldi(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, (0b001 << 10 ) | (opnd_array(1)->constant()& 0x3ff));
  
#line 21510 "ad_loongarch.cpp"
  }
}

void repl4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11407 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vreplgr2vr_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21526 "ad_loongarch.cpp"
  }
}

void repl4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11417 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vldi(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, (0b010 << 10 ) | (opnd_array(1)->constant()& 0x3ff));
  
#line 21542 "ad_loongarch.cpp"
  }
}

void repl2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11427 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vreplgr2vr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21558 "ad_loongarch.cpp"
  }
}

void repl2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11437 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vldi(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, (0b011 << 10 ) | (opnd_array(1)->constantL()& 0x3ff));
  
#line 21574 "ad_loongarch.cpp"
  }
}

void repl4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11447 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vreplvei_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
  
#line 21590 "ad_loongarch.cpp"
  }
}

void repl2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11457 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vreplvei_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
  
#line 21606 "ad_loongarch.cpp"
  }
}

void repl32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11467 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvreplgr2vr_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21622 "ad_loongarch.cpp"
  }
}

void repl32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11477 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvldi(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, (opnd_array(1)->constant()& 0xff));
  
#line 21638 "ad_loongarch.cpp"
  }
}

void repl16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11487 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvreplgr2vr_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21654 "ad_loongarch.cpp"
  }
}

void repl16S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11497 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvldi(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, (0b001 << 10 ) | (opnd_array(1)->constant()& 0x3ff));
  
#line 21670 "ad_loongarch.cpp"
  }
}

void repl8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11507 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvreplgr2vr_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21686 "ad_loongarch.cpp"
  }
}

void repl8I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11517 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvldi(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, (0b010 << 10 ) | (opnd_array(1)->constant()& 0x3ff));
  
#line 21702 "ad_loongarch.cpp"
  }
}

void repl4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11527 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvreplgr2vr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21718 "ad_loongarch.cpp"
  }
}

void repl4L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11537 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvldi(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, (0b011 << 10 ) | (opnd_array(1)->constantL()& 0x3ff));
  
#line 21734 "ad_loongarch.cpp"
  }
}

void repl8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11547 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvreplve0_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 21750 "ad_loongarch.cpp"
  }
}

void repl4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11557 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvreplve0_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 21766 "ad_loongarch.cpp"
  }
}

void add16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11569 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vadd_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 21783 "ad_loongarch.cpp"
  }
}

void add16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11579 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vaddi_bu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 21800 "ad_loongarch.cpp"
  }
}

void add16B_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11579 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vaddi_bu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 21817 "ad_loongarch.cpp"
  }
}

void add8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11589 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vadd_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 21834 "ad_loongarch.cpp"
  }
}

void add8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11599 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vaddi_hu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 21851 "ad_loongarch.cpp"
  }
}

void add8S_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11599 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vaddi_hu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 21868 "ad_loongarch.cpp"
  }
}

void add4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11609 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vadd_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 21885 "ad_loongarch.cpp"
  }
}

void add4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11619 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vaddi_wu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 21902 "ad_loongarch.cpp"
  }
}

void add4I_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11619 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vaddi_wu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 21919 "ad_loongarch.cpp"
  }
}

void add2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11629 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vadd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 21936 "ad_loongarch.cpp"
  }
}

void add2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11639 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vaddi_du(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constantL());
  
#line 21953 "ad_loongarch.cpp"
  }
}

void add2L_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11639 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vaddi_du(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constantL());
  
#line 21970 "ad_loongarch.cpp"
  }
}

void add4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11649 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfadd_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 21987 "ad_loongarch.cpp"
  }
}

void add2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11659 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfadd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22004 "ad_loongarch.cpp"
  }
}

void add32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11669 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvadd_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22021 "ad_loongarch.cpp"
  }
}

void add32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11679 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvaddi_bu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 22038 "ad_loongarch.cpp"
  }
}

void add32B_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11679 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvaddi_bu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 22055 "ad_loongarch.cpp"
  }
}

void add16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11689 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvadd_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22072 "ad_loongarch.cpp"
  }
}

void add16S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11699 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvaddi_hu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 22089 "ad_loongarch.cpp"
  }
}

void add16S_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11699 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvaddi_hu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 22106 "ad_loongarch.cpp"
  }
}

void add8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11709 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvadd_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22123 "ad_loongarch.cpp"
  }
}

void add8I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11719 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvaddi_wu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 22140 "ad_loongarch.cpp"
  }
}

void add8I_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11719 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvaddi_wu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 22157 "ad_loongarch.cpp"
  }
}

void add4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11729 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvadd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22174 "ad_loongarch.cpp"
  }
}

void add4L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11739 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvaddi_du(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constantL());
  
#line 22191 "ad_loongarch.cpp"
  }
}

void add4L_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11739 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvaddi_du(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constantL());
  
#line 22208 "ad_loongarch.cpp"
  }
}

void add8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11749 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfadd_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22225 "ad_loongarch.cpp"
  }
}

void add4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11759 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfadd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22242 "ad_loongarch.cpp"
  }
}

void sub16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11771 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsub_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22259 "ad_loongarch.cpp"
  }
}

void sub16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11781 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsubi_bu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 22276 "ad_loongarch.cpp"
  }
}

void sub8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11791 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsub_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22293 "ad_loongarch.cpp"
  }
}

void sub8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11801 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsubi_hu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 22310 "ad_loongarch.cpp"
  }
}

void sub4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11811 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsub_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22327 "ad_loongarch.cpp"
  }
}

void sub4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11821 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsubi_wu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 22344 "ad_loongarch.cpp"
  }
}

void sub2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11831 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsub_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22361 "ad_loongarch.cpp"
  }
}

void sub2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11841 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsubi_du(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constantL());
  
#line 22378 "ad_loongarch.cpp"
  }
}

void sub4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11851 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfsub_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22395 "ad_loongarch.cpp"
  }
}

void sub2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11861 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfsub_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22412 "ad_loongarch.cpp"
  }
}

void sub32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11871 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsub_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22429 "ad_loongarch.cpp"
  }
}

void sub32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11881 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsubi_bu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 22446 "ad_loongarch.cpp"
  }
}

void sub16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11891 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsub_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22463 "ad_loongarch.cpp"
  }
}

void sub16S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11901 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsubi_hu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 22480 "ad_loongarch.cpp"
  }
}

void sub8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11911 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsub_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22497 "ad_loongarch.cpp"
  }
}

void sub8I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11921 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsubi_wu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 22514 "ad_loongarch.cpp"
  }
}

void sub4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11931 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsub_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22531 "ad_loongarch.cpp"
  }
}

void sub4L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11941 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsubi_du(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constantL());
  
#line 22548 "ad_loongarch.cpp"
  }
}

void sub8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11951 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfsub_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22565 "ad_loongarch.cpp"
  }
}

void sub4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11961 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfsub_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22582 "ad_loongarch.cpp"
  }
}

void mul16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11972 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmul_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22599 "ad_loongarch.cpp"
  }
}

void mul8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11982 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmul_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22616 "ad_loongarch.cpp"
  }
}

void mul4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11992 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmul_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22633 "ad_loongarch.cpp"
  }
}

void mul2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12002 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmul_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22650 "ad_loongarch.cpp"
  }
}

void mul4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12012 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfmul_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22667 "ad_loongarch.cpp"
  }
}

void mul2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12022 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfmul_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22684 "ad_loongarch.cpp"
  }
}

void mul32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12032 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmul_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22701 "ad_loongarch.cpp"
  }
}

void mul16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12042 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmul_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22718 "ad_loongarch.cpp"
  }
}

void mul8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12052 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmul_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22735 "ad_loongarch.cpp"
  }
}

void mul4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12062 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmul_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22752 "ad_loongarch.cpp"
  }
}

void mul8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12072 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfmul_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22769 "ad_loongarch.cpp"
  }
}

void mul4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12082 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfmul_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22786 "ad_loongarch.cpp"
  }
}

void div4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12093 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfdiv_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22803 "ad_loongarch.cpp"
  }
}

void div2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12103 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfdiv_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22820 "ad_loongarch.cpp"
  }
}

void div8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12113 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfdiv_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22837 "ad_loongarch.cpp"
  }
}

void div4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12123 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfdiv_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 22854 "ad_loongarch.cpp"
  }
}

void abs16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12136 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vxor_v(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
    __ vabsd_b(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 22872 "ad_loongarch.cpp"
  }
}

void abs8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12148 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vxor_v(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
    __ vabsd_h(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 22890 "ad_loongarch.cpp"
  }
}

void abs4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12160 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vxor_v(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
    __ vabsd_w(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 22908 "ad_loongarch.cpp"
  }
}

void abs2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12172 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vxor_v(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
    __ vabsd_d(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 22926 "ad_loongarch.cpp"
  }
}

void abs4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12183 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vbitclri_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x1f);
  
#line 22942 "ad_loongarch.cpp"
  }
}

void abs2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12193 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vbitclri_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x3f);
  
#line 22958 "ad_loongarch.cpp"
  }
}

void abs32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12204 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvxor_v(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
    __ xvabsd_b(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 22976 "ad_loongarch.cpp"
  }
}

void abs16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12216 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvxor_v(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
    __ xvabsd_h(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 22994 "ad_loongarch.cpp"
  }
}

void abs8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12228 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvxor_v(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
    __ xvabsd_w(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 23012 "ad_loongarch.cpp"
  }
}

void abs4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12240 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvxor_v(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
    __ xvabsd_d(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 23030 "ad_loongarch.cpp"
  }
}

void abs8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12251 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvbitclri_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x1f);
  
#line 23046 "ad_loongarch.cpp"
  }
}

void abs4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12261 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvbitclri_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x3f);
  
#line 23062 "ad_loongarch.cpp"
  }
}

void absd4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12273 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vabsd_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23079 "ad_loongarch.cpp"
  }
}

void absd2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12283 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vabsd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23096 "ad_loongarch.cpp"
  }
}

void absd8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12293 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvabsd_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23113 "ad_loongarch.cpp"
  }
}

void absd4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12303 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvabsd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23130 "ad_loongarch.cpp"
  }
}

void max16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12315 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmax_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23147 "ad_loongarch.cpp"
  }
}

void max8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12325 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmax_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23164 "ad_loongarch.cpp"
  }
}

void max4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12335 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmax_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23181 "ad_loongarch.cpp"
  }
}

void max2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12345 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmax_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23198 "ad_loongarch.cpp"
  }
}

void max4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12356 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfmax_s(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ vxor_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ vfdiv_s(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ vfcmp_cun_s(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ vbitsel_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
  
#line 23222 "ad_loongarch.cpp"
  }
}

void max2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12371 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfmax_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ vxor_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ vfdiv_d(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ vfcmp_cun_d(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ vbitsel_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
  
#line 23246 "ad_loongarch.cpp"
  }
}

void max32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12385 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmax_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23263 "ad_loongarch.cpp"
  }
}

void max16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12395 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmax_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23280 "ad_loongarch.cpp"
  }
}

void max8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12405 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmax_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23297 "ad_loongarch.cpp"
  }
}

void max4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12415 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmax_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23314 "ad_loongarch.cpp"
  }
}

void max8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12426 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfmax_s(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ xvxor_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ xvfdiv_s(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ xvfcmp_cun_s(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ xvbitsel_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
  
#line 23338 "ad_loongarch.cpp"
  }
}

void max4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12441 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfmax_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ xvxor_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ xvfdiv_d(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ xvfcmp_cun_d(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ xvbitsel_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
  
#line 23362 "ad_loongarch.cpp"
  }
}

void min16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12457 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmin_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23379 "ad_loongarch.cpp"
  }
}

void min8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12467 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmin_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23396 "ad_loongarch.cpp"
  }
}

void min4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12477 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmin_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23413 "ad_loongarch.cpp"
  }
}

void min2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12487 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmin_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23430 "ad_loongarch.cpp"
  }
}

void min4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12498 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfmin_s(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ vxor_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ vfdiv_s(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ vfcmp_cun_s(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ vbitsel_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
  
#line 23454 "ad_loongarch.cpp"
  }
}

void min2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12513 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfmin_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ vxor_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ vfdiv_d(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ vfcmp_cun_d(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ vbitsel_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
  
#line 23478 "ad_loongarch.cpp"
  }
}

void min32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12527 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmin_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23495 "ad_loongarch.cpp"
  }
}

void min16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12537 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmin_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23512 "ad_loongarch.cpp"
  }
}

void min8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12547 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmin_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23529 "ad_loongarch.cpp"
  }
}

void min4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12557 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmin_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23546 "ad_loongarch.cpp"
  }
}

void min8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12568 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfmin_s(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ xvxor_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ xvfdiv_s(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ xvfcmp_cun_s(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ xvbitsel_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
  
#line 23570 "ad_loongarch.cpp"
  }
}

void min4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12583 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfmin_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ xvxor_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ xvfdiv_d(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
    __ xvfcmp_cun_d(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ xvbitsel_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
  
#line 23594 "ad_loongarch.cpp"
  }
}

void neg4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12599 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    DEBUG_ONLY(Unimplemented()); // unverified
    __ vneg_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 23611 "ad_loongarch.cpp"
  }
}

void neg4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12610 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vbitrevi_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x1f);
  
#line 23627 "ad_loongarch.cpp"
  }
}

void neg2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12620 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vbitrevi_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x3f);
  
#line 23643 "ad_loongarch.cpp"
  }
}

void neg8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12630 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    DEBUG_ONLY(Unimplemented()); // unverified
    __ xvneg_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 23660 "ad_loongarch.cpp"
  }
}

void neg8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12641 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvbitrevi_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x1f);
  
#line 23676 "ad_loongarch.cpp"
  }
}

void neg4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12651 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvbitrevi_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x3f);
  
#line 23692 "ad_loongarch.cpp"
  }
}

void sqrt4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12663 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfsqrt_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 23708 "ad_loongarch.cpp"
  }
}

void sqrt2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12673 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfsqrt_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 23724 "ad_loongarch.cpp"
  }
}

void sqrt8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12683 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfsqrt_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 23740 "ad_loongarch.cpp"
  }
}

void sqrt4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12693 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfsqrt_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 23756 "ad_loongarch.cpp"
  }
}

void madd16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12705 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmadd_b(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 23774 "ad_loongarch.cpp"
  }
}

void madd16B_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12705 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmadd_b(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23792 "ad_loongarch.cpp"
  }
}

void madd8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12715 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmadd_h(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 23810 "ad_loongarch.cpp"
  }
}

void madd8S_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12715 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmadd_h(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23828 "ad_loongarch.cpp"
  }
}

void madd4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12725 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmadd_w(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 23846 "ad_loongarch.cpp"
  }
}

void madd4I_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12725 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmadd_w(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23864 "ad_loongarch.cpp"
  }
}

void madd2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12735 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmadd_d(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 23882 "ad_loongarch.cpp"
  }
}

void madd2L_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12735 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmadd_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23900 "ad_loongarch.cpp"
  }
}

void madd4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12746 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfmadd_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 23918 "ad_loongarch.cpp"
  }
}

void madd2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12757 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfmadd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 23936 "ad_loongarch.cpp"
  }
}

void madd32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12767 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmadd_b(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 23954 "ad_loongarch.cpp"
  }
}

void madd32B_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12767 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmadd_b(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 23972 "ad_loongarch.cpp"
  }
}

void madd16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12777 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmadd_h(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 23990 "ad_loongarch.cpp"
  }
}

void madd16S_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12777 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmadd_h(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 24008 "ad_loongarch.cpp"
  }
}

void madd8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12787 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmadd_w(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 24026 "ad_loongarch.cpp"
  }
}

void madd8I_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12787 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmadd_w(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 24044 "ad_loongarch.cpp"
  }
}

void madd4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12797 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmadd_d(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 24062 "ad_loongarch.cpp"
  }
}

void madd4L_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12797 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmadd_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 24080 "ad_loongarch.cpp"
  }
}

void madd8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12808 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfmadd_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24098 "ad_loongarch.cpp"
  }
}

void madd4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12819 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfmadd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24116 "ad_loongarch.cpp"
  }
}

void msub16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12831 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmsub_b(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 24134 "ad_loongarch.cpp"
  }
}

void msub8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12841 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmsub_h(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 24152 "ad_loongarch.cpp"
  }
}

void msub4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12851 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmsub_w(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 24170 "ad_loongarch.cpp"
  }
}

void msub2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12861 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vmsub_d(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 24188 "ad_loongarch.cpp"
  }
}

void msub4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12872 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfmsub_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24206 "ad_loongarch.cpp"
  }
}

void msub2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12883 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfmsub_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24224 "ad_loongarch.cpp"
  }
}

void msub32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12893 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmsub_b(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 24242 "ad_loongarch.cpp"
  }
}

void msub16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12903 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmsub_h(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 24260 "ad_loongarch.cpp"
  }
}

void msub8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12913 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmsub_w(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 24278 "ad_loongarch.cpp"
  }
}

void msub4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12923 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvmsub_d(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 24296 "ad_loongarch.cpp"
  }
}

void msub8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12934 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfmsub_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24314 "ad_loongarch.cpp"
  }
}

void msub4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12945 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfmsub_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24332 "ad_loongarch.cpp"
  }
}

void nmadd4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12959 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfnmadd_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24350 "ad_loongarch.cpp"
  }
}

void nmadd4F_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12959 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfnmadd_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24368 "ad_loongarch.cpp"
  }
}

void nmadd2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12971 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfnmadd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24386 "ad_loongarch.cpp"
  }
}

void nmadd2D_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12971 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfnmadd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24404 "ad_loongarch.cpp"
  }
}

void nmadd8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12983 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfnmadd_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24422 "ad_loongarch.cpp"
  }
}

void nmadd8F_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12983 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfnmadd_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24440 "ad_loongarch.cpp"
  }
}

void nmadd4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12995 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfnmadd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24458 "ad_loongarch.cpp"
  }
}

void nmadd4D_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12995 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfnmadd_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24476 "ad_loongarch.cpp"
  }
}

void nmsub4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13009 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfnmsub_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24494 "ad_loongarch.cpp"
  }
}

void nmsub4F_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13009 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfnmsub_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24512 "ad_loongarch.cpp"
  }
}

void nmsub2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13021 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfnmsub_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24530 "ad_loongarch.cpp"
  }
}

void nmsub2D_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13021 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vfnmsub_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24548 "ad_loongarch.cpp"
  }
}

void nmsub8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13033 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfnmsub_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24566 "ad_loongarch.cpp"
  }
}

void nmsub8F_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13033 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfnmsub_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24584 "ad_loongarch.cpp"
  }
}

void nmsub4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13045 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfnmsub_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24602 "ad_loongarch.cpp"
  }
}

void nmsub4D_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13045 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfnmsub_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */);
  
#line 24620 "ad_loongarch.cpp"
  }
}

void muladd8Sto4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13058 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    DEBUG_ONLY(Unimplemented()); // unverified
    __ vmulwev_w_h(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ vmulwod_w_h(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ vadd_w(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 24642 "ad_loongarch.cpp"
  }
}

void muladd16Sto8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13072 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    DEBUG_ONLY(Unimplemented()); // unverified
    __ xvmulwev_w_h(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ xvmulwod_w_h(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ xvadd_w(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 24664 "ad_loongarch.cpp"
  }
}

void shiftcntXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13088 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vreplgr2vr_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
  
#line 24680 "ad_loongarch.cpp"
  }
}

void shiftcntX_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13088 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vreplgr2vr_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
  
#line 24696 "ad_loongarch.cpp"
  }
}

void shiftcntYNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13099 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvreplgr2vr_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
  
#line 24712 "ad_loongarch.cpp"
  }
}

void shiftcntY_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13099 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvreplgr2vr_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
  
#line 24728 "ad_loongarch.cpp"
  }
}

void sll16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13112 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsll_b(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ vslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x8);
    __ vand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 24749 "ad_loongarch.cpp"
  }
}

void sll16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13124 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 8) {
      __ vxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    } else {
      __ vslli_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 24770 "ad_loongarch.cpp"
  }
}

void sll8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13139 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsll_h(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ vslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x10);
    __ vand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 24791 "ad_loongarch.cpp"
  }
}

void sll8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13151 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 16) {
      __ vxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    } else {
      __ vslli_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 24812 "ad_loongarch.cpp"
  }
}

void sll4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13165 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsll_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 24829 "ad_loongarch.cpp"
  }
}

void sll4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13175 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vslli_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 24846 "ad_loongarch.cpp"
  }
}

void sll2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13185 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsll_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 24863 "ad_loongarch.cpp"
  }
}

void sll2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13195 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vslli_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 24880 "ad_loongarch.cpp"
  }
}

void sll32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13206 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsll_b(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ xvslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x8);
    __ xvand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 24901 "ad_loongarch.cpp"
  }
}

void sll32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13218 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 8) {
      __ xvxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    } else {
      __ xvslli_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 24922 "ad_loongarch.cpp"
  }
}

void sll16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13233 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsll_h(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ xvslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x10);
    __ xvand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 24943 "ad_loongarch.cpp"
  }
}

void sll16S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13245 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 16) {
      __ xvxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    } else {
      __ xvslli_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 24964 "ad_loongarch.cpp"
  }
}

void sll8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13259 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsll_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 24981 "ad_loongarch.cpp"
  }
}

void sll8I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13269 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvslli_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 24998 "ad_loongarch.cpp"
  }
}

void sll4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13279 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsll_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25015 "ad_loongarch.cpp"
  }
}

void sll4L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13289 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvslli_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25032 "ad_loongarch.cpp"
  }
}

void srl16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13302 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsrl_b(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ vslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x8);
    __ vand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 25053 "ad_loongarch.cpp"
  }
}

void srl16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13314 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 8) {
      __ vxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    } else {
      __ vsrli_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 25074 "ad_loongarch.cpp"
  }
}

void srl8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13329 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsrl_h(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ vslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x10);
    __ vand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 25095 "ad_loongarch.cpp"
  }
}

void srl8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13341 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 16) {
      __ vxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    } else {
      __ vsrli_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 25116 "ad_loongarch.cpp"
  }
}

void srl4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13355 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsrl_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25133 "ad_loongarch.cpp"
  }
}

void srl4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13365 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsrli_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25150 "ad_loongarch.cpp"
  }
}

void srl2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13375 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsrl_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25167 "ad_loongarch.cpp"
  }
}

void srl2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13385 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsrli_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25184 "ad_loongarch.cpp"
  }
}

void srl32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13396 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsrl_b(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ xvslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x8);
    __ xvand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 25205 "ad_loongarch.cpp"
  }
}

void srl32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13408 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 8) {
      __ xvxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    } else {
      __ xvsrli_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 25226 "ad_loongarch.cpp"
  }
}

void srl16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13423 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsrl_h(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ xvslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x10);
    __ xvand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 25247 "ad_loongarch.cpp"
  }
}

void srl16S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13435 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 16) {
      __ xvxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    } else {
      __ xvsrli_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 25268 "ad_loongarch.cpp"
  }
}

void srl8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13449 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsrl_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25285 "ad_loongarch.cpp"
  }
}

void srl8I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13459 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsrli_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25302 "ad_loongarch.cpp"
  }
}

void srl4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13469 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsrl_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25319 "ad_loongarch.cpp"
  }
}

void srl4L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13479 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsrli_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25336 "ad_loongarch.cpp"
  }
}

void sra16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13492 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x8);
    __ vorn_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
    __ vsra_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 25356 "ad_loongarch.cpp"
  }
}

void sra16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13504 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 8) {
      __ vsrai_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 7);
    } else {
      __ vsrai_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 25377 "ad_loongarch.cpp"
  }
}

void sra8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13519 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x10);
    __ vorn_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
    __ vsra_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 25397 "ad_loongarch.cpp"
  }
}

void sra8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13531 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 16) {
      __ vsrai_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 15);
    } else {
      __ vsrai_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 25418 "ad_loongarch.cpp"
  }
}

void sra4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13545 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsra_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25435 "ad_loongarch.cpp"
  }
}

void sra4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13555 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsrai_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25452 "ad_loongarch.cpp"
  }
}

void sra2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13565 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsra_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25469 "ad_loongarch.cpp"
  }
}

void sra2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13575 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vsrai_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25486 "ad_loongarch.cpp"
  }
}

void sra32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13586 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x8);
    __ xvorn_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
    __ xvsra_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 25506 "ad_loongarch.cpp"
  }
}

void sra32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13598 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 8) {
      __ xvsrai_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 7);
    } else {
      __ xvsrai_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 25527 "ad_loongarch.cpp"
  }
}

void sra16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13613 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvslti_bu(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, 0x10);
    __ xvorn_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
    __ xvsra_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 25547 "ad_loongarch.cpp"
  }
}

void sra16S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13625 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(2)->constant()>= 16) {
      __ xvsrai_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 15);
    } else {
      __ xvsrai_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    }
  
#line 25568 "ad_loongarch.cpp"
  }
}

void sra8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13639 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsra_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25585 "ad_loongarch.cpp"
  }
}

void sra8I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13649 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsrai_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25602 "ad_loongarch.cpp"
  }
}

void sra4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13659 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsra_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25619 "ad_loongarch.cpp"
  }
}

void sra4L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13669 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvsrai_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25636 "ad_loongarch.cpp"
  }
}

void rotr4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13681 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vrotr_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25653 "ad_loongarch.cpp"
  }
}

void rotr4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13691 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vrotri_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25670 "ad_loongarch.cpp"
  }
}

void rotr2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13701 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vrotr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25687 "ad_loongarch.cpp"
  }
}

void rotr2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13711 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vrotri_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25704 "ad_loongarch.cpp"
  }
}

void rotr8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13721 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvrotr_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25721 "ad_loongarch.cpp"
  }
}

void rotr8I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13731 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvrotri_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25738 "ad_loongarch.cpp"
  }
}

void rotr4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13741 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvrotr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 25755 "ad_loongarch.cpp"
  }
}

void rotr4L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13751 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvrotri_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25772 "ad_loongarch.cpp"
  }
}

void rotl4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13764 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vneg_w(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ vrotr_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 25791 "ad_loongarch.cpp"
  }
}

void rotl4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13775 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vrotri_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (-opnd_array(2)->constant()) & 0x1f);
  
#line 25808 "ad_loongarch.cpp"
  }
}

void rotl2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13786 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vneg_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ vrotr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 25827 "ad_loongarch.cpp"
  }
}

void rotl2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13797 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vrotri_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (-opnd_array(2)->constant()) & 0x3f);
  
#line 25844 "ad_loongarch.cpp"
  }
}

void rotl8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13808 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvneg_w(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ xvrotr_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 25863 "ad_loongarch.cpp"
  }
}

void rotl8I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13819 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvrotri_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (-opnd_array(2)->constant()) & 0x1f);
  
#line 25880 "ad_loongarch.cpp"
  }
}

void rotl4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13830 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvneg_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ xvrotr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 25899 "ad_loongarch.cpp"
  }
}

void rotl4L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13841 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvrotri_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (-opnd_array(2)->constant()) & 0x3f);
  
#line 25916 "ad_loongarch.cpp"
  }
}

void andV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13853 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vand_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 25933 "ad_loongarch.cpp"
  }
}

void and16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13863 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandi_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25950 "ad_loongarch.cpp"
  }
}

void and16B_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13863 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandi_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 25967 "ad_loongarch.cpp"
  }
}

void andV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13873 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvand_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 25984 "ad_loongarch.cpp"
  }
}

void and32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13883 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandi_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 26001 "ad_loongarch.cpp"
  }
}

void and32B_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13883 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandi_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 26018 "ad_loongarch.cpp"
  }
}

void orV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13895 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 26035 "ad_loongarch.cpp"
  }
}

void or16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13905 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 26052 "ad_loongarch.cpp"
  }
}

void or16B_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13905 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 26069 "ad_loongarch.cpp"
  }
}

void orV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13915 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 26086 "ad_loongarch.cpp"
  }
}

void or32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13925 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 26103 "ad_loongarch.cpp"
  }
}

void or32B_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13925 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 26120 "ad_loongarch.cpp"
  }
}

void xorV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13937 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 26137 "ad_loongarch.cpp"
  }
}

void xor16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13947 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vxori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 26154 "ad_loongarch.cpp"
  }
}

void xor16B_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13947 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vxori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 26171 "ad_loongarch.cpp"
  }
}

void xorV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13957 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 26188 "ad_loongarch.cpp"
  }
}

void xor32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13967 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvxori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 26205 "ad_loongarch.cpp"
  }
}

void xor32B_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13967 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvxori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 26222 "ad_loongarch.cpp"
  }
}

void norV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13981 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 26240 "ad_loongarch.cpp"
  }
}

void norV16_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13981 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26258 "ad_loongarch.cpp"
  }
}

void norV16_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13981 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 26276 "ad_loongarch.cpp"
  }
}

void norV16_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13981 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26294 "ad_loongarch.cpp"
  }
}

void norV16_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13981 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 26312 "ad_loongarch.cpp"
  }
}

void norV16_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13981 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26330 "ad_loongarch.cpp"
  }
}

void nor16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13991 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vnori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 26348 "ad_loongarch.cpp"
  }
}

void nor16B_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13991 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vnori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(3)->constant());
  
#line 26366 "ad_loongarch.cpp"
  }
}

void nor16B_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13991 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vnori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 26384 "ad_loongarch.cpp"
  }
}

void nor16B_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13991 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vnori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src */, opnd_array(2)->constant());
  
#line 26402 "ad_loongarch.cpp"
  }
}

void norV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14003 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 26420 "ad_loongarch.cpp"
  }
}

void norV32_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14003 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26438 "ad_loongarch.cpp"
  }
}

void norV32_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14003 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 26456 "ad_loongarch.cpp"
  }
}

void norV32_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14003 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26474 "ad_loongarch.cpp"
  }
}

void norV32_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14003 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 26492 "ad_loongarch.cpp"
  }
}

void norV32_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14003 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvnor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26510 "ad_loongarch.cpp"
  }
}

void nor32B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14013 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvnori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 26528 "ad_loongarch.cpp"
  }
}

void nor32B_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14013 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvnori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(3)->constant());
  
#line 26546 "ad_loongarch.cpp"
  }
}

void nor32B_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14013 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvnori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(1)->constant());
  
#line 26564 "ad_loongarch.cpp"
  }
}

void nor32B_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14013 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvnori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src */, opnd_array(2)->constant());
  
#line 26582 "ad_loongarch.cpp"
  }
}

void andnV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26600 "ad_loongarch.cpp"
  }
}

void andnV16_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26618 "ad_loongarch.cpp"
  }
}

void andnV16_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26636 "ad_loongarch.cpp"
  }
}

void andnV16_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26654 "ad_loongarch.cpp"
  }
}

void andnV16_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26672 "ad_loongarch.cpp"
  }
}

void andnV16_5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26690 "ad_loongarch.cpp"
  }
}

void andnV16_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26708 "ad_loongarch.cpp"
  }
}

void andnV16_6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26726 "ad_loongarch.cpp"
  }
}

void andnV16_7Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26744 "ad_loongarch.cpp"
  }
}

void andnV16_9Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26762 "ad_loongarch.cpp"
  }
}

void andnV16_8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26780 "ad_loongarch.cpp"
  }
}

void andnV16_10Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14027 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26798 "ad_loongarch.cpp"
  }
}

void andnV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26816 "ad_loongarch.cpp"
  }
}

void andnV32_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26834 "ad_loongarch.cpp"
  }
}

void andnV32_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26852 "ad_loongarch.cpp"
  }
}

void andnV32_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26870 "ad_loongarch.cpp"
  }
}

void andnV32_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26888 "ad_loongarch.cpp"
  }
}

void andnV32_5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26906 "ad_loongarch.cpp"
  }
}

void andnV32_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26924 "ad_loongarch.cpp"
  }
}

void andnV32_6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26942 "ad_loongarch.cpp"
  }
}

void andnV32_7Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26960 "ad_loongarch.cpp"
  }
}

void andnV32_9Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 26978 "ad_loongarch.cpp"
  }
}

void andnV32_8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 26996 "ad_loongarch.cpp"
  }
}

void andnV32_10Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14039 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvandn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 27014 "ad_loongarch.cpp"
  }
}

void ornV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27032 "ad_loongarch.cpp"
  }
}

void ornV16_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 27050 "ad_loongarch.cpp"
  }
}

void ornV16_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 27068 "ad_loongarch.cpp"
  }
}

void ornV16_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27086 "ad_loongarch.cpp"
  }
}

void ornV16_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27104 "ad_loongarch.cpp"
  }
}

void ornV16_5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 27122 "ad_loongarch.cpp"
  }
}

void ornV16_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 27140 "ad_loongarch.cpp"
  }
}

void ornV16_6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27158 "ad_loongarch.cpp"
  }
}

void ornV16_7Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27176 "ad_loongarch.cpp"
  }
}

void ornV16_9Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 27194 "ad_loongarch.cpp"
  }
}

void ornV16_8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 27212 "ad_loongarch.cpp"
  }
}

void ornV16_10Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14053 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27230 "ad_loongarch.cpp"
  }
}

void ornV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27248 "ad_loongarch.cpp"
  }
}

void ornV32_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 27266 "ad_loongarch.cpp"
  }
}

void ornV32_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 27284 "ad_loongarch.cpp"
  }
}

void ornV32_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27302 "ad_loongarch.cpp"
  }
}

void ornV32_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27320 "ad_loongarch.cpp"
  }
}

void ornV32_5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 27338 "ad_loongarch.cpp"
  }
}

void ornV32_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 27356 "ad_loongarch.cpp"
  }
}

void ornV32_6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27374 "ad_loongarch.cpp"
  }
}

void ornV32_7Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27392 "ad_loongarch.cpp"
  }
}

void ornV32_9Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
  
#line 27410 "ad_loongarch.cpp"
  }
}

void ornV32_8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 27428 "ad_loongarch.cpp"
  }
}

void ornV32_10Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvorn_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 27446 "ad_loongarch.cpp"
  }
}

void reduce_add16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14078 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 16);
  
#line 27466 "ad_loongarch.cpp"
  }
}

void reduce_add8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14089 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 16);
  
#line 27486 "ad_loongarch.cpp"
  }
}

void reduce_add4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14100 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 16);
  
#line 27506 "ad_loongarch.cpp"
  }
}

void reduce_add2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14111 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, FNOREG, T_LONG, this->ideal_Opcode(), 16);
  
#line 27525 "ad_loongarch.cpp"
  }
}

void reduce_add4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14122 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, T_FLOAT, this->ideal_Opcode(), 16);
  
#line 27544 "ad_loongarch.cpp"
  }
}

void reduce_add2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14133 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, T_DOUBLE, this->ideal_Opcode(), 16);
  
#line 27563 "ad_loongarch.cpp"
  }
}

void reduce_add32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14144 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 32);
  
#line 27583 "ad_loongarch.cpp"
  }
}

void reduce_add16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14155 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 32);
  
#line 27603 "ad_loongarch.cpp"
  }
}

void reduce_add8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14166 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 32);
  
#line 27623 "ad_loongarch.cpp"
  }
}

void reduce_add4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14177 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_LONG, this->ideal_Opcode(), 32);
  
#line 27643 "ad_loongarch.cpp"
  }
}

void reduce_add8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14188 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, T_FLOAT, this->ideal_Opcode(), 32);
  
#line 27662 "ad_loongarch.cpp"
  }
}

void reduce_add4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14199 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, T_DOUBLE, this->ideal_Opcode(), 32);
  
#line 27681 "ad_loongarch.cpp"
  }
}

void reduce_mul16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14212 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 16);
  
#line 27701 "ad_loongarch.cpp"
  }
}

void reduce_mul8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14223 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 16);
  
#line 27721 "ad_loongarch.cpp"
  }
}

void reduce_mul4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14234 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 16);
  
#line 27741 "ad_loongarch.cpp"
  }
}

void reduce_mul2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14245 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, FNOREG, T_LONG, this->ideal_Opcode(), 16);
  
#line 27760 "ad_loongarch.cpp"
  }
}

void reduce_mul4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14256 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, T_FLOAT, this->ideal_Opcode(), 16);
  
#line 27779 "ad_loongarch.cpp"
  }
}

void reduce_mul2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14267 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, T_DOUBLE, this->ideal_Opcode(), 16);
  
#line 27798 "ad_loongarch.cpp"
  }
}

void reduce_mul32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14278 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 32);
  
#line 27818 "ad_loongarch.cpp"
  }
}

void reduce_mul16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14289 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 32);
  
#line 27838 "ad_loongarch.cpp"
  }
}

void reduce_mul8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14300 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 32);
  
#line 27858 "ad_loongarch.cpp"
  }
}

void reduce_mul4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14311 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_LONG, this->ideal_Opcode(), 32);
  
#line 27878 "ad_loongarch.cpp"
  }
}

void reduce_mul8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14322 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, T_FLOAT, this->ideal_Opcode(), 32);
  
#line 27897 "ad_loongarch.cpp"
  }
}

void reduce_mul4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14333 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, T_DOUBLE, this->ideal_Opcode(), 32);
  
#line 27916 "ad_loongarch.cpp"
  }
}

void reduce_max16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14346 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 16);
  
#line 27936 "ad_loongarch.cpp"
  }
}

void reduce_max8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14357 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 16);
  
#line 27956 "ad_loongarch.cpp"
  }
}

void reduce_max4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14368 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 16);
  
#line 27976 "ad_loongarch.cpp"
  }
}

void reduce_max2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14379 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, FNOREG, T_LONG, this->ideal_Opcode(), 16);
  
#line 27995 "ad_loongarch.cpp"
  }
}

void reduce_max32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14390 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 32);
  
#line 28015 "ad_loongarch.cpp"
  }
}

void reduce_max16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14401 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 32);
  
#line 28035 "ad_loongarch.cpp"
  }
}

void reduce_max8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14412 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 32);
  
#line 28055 "ad_loongarch.cpp"
  }
}

void reduce_max4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14423 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_LONG, this->ideal_Opcode(), 32);
  
#line 28075 "ad_loongarch.cpp"
  }
}

void reduce_min16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14436 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 16);
  
#line 28095 "ad_loongarch.cpp"
  }
}

void reduce_min8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14447 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 16);
  
#line 28115 "ad_loongarch.cpp"
  }
}

void reduce_min4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14458 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 16);
  
#line 28135 "ad_loongarch.cpp"
  }
}

void reduce_min2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14469 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, FNOREG, T_LONG, this->ideal_Opcode(), 16);
  
#line 28154 "ad_loongarch.cpp"
  }
}

void reduce_min32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14480 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 32);
  
#line 28174 "ad_loongarch.cpp"
  }
}

void reduce_min16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14491 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 32);
  
#line 28194 "ad_loongarch.cpp"
  }
}

void reduce_min8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14502 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 32);
  
#line 28214 "ad_loongarch.cpp"
  }
}

void reduce_min4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14513 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_LONG, this->ideal_Opcode(), 32);
  
#line 28234 "ad_loongarch.cpp"
  }
}

void reduce_and16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14526 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 16);
  
#line 28254 "ad_loongarch.cpp"
  }
}

void reduce_and8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14537 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 16);
  
#line 28274 "ad_loongarch.cpp"
  }
}

void reduce_and4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14548 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 16);
  
#line 28294 "ad_loongarch.cpp"
  }
}

void reduce_and2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14559 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, FNOREG, T_LONG, this->ideal_Opcode(), 16);
  
#line 28313 "ad_loongarch.cpp"
  }
}

void reduce_and32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14570 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 32);
  
#line 28333 "ad_loongarch.cpp"
  }
}

void reduce_and16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14581 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 32);
  
#line 28353 "ad_loongarch.cpp"
  }
}

void reduce_and8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14592 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 32);
  
#line 28373 "ad_loongarch.cpp"
  }
}

void reduce_and4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14603 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_LONG, this->ideal_Opcode(), 32);
  
#line 28393 "ad_loongarch.cpp"
  }
}

void reduce_or16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14616 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 16);
  
#line 28413 "ad_loongarch.cpp"
  }
}

void reduce_or8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14627 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 16);
  
#line 28433 "ad_loongarch.cpp"
  }
}

void reduce_or4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14638 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 16);
  
#line 28453 "ad_loongarch.cpp"
  }
}

void reduce_or2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14649 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, FNOREG, T_LONG, this->ideal_Opcode(), 16);
  
#line 28472 "ad_loongarch.cpp"
  }
}

void reduce_or32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14660 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 32);
  
#line 28492 "ad_loongarch.cpp"
  }
}

void reduce_or16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14671 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 32);
  
#line 28512 "ad_loongarch.cpp"
  }
}

void reduce_or8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14682 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 32);
  
#line 28532 "ad_loongarch.cpp"
  }
}

void reduce_or4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14693 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_LONG, this->ideal_Opcode(), 32);
  
#line 28552 "ad_loongarch.cpp"
  }
}

void reduce_xor16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14706 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 16);
  
#line 28572 "ad_loongarch.cpp"
  }
}

void reduce_xor8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14717 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 16);
  
#line 28592 "ad_loongarch.cpp"
  }
}

void reduce_xor4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14728 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 16);
  
#line 28612 "ad_loongarch.cpp"
  }
}

void reduce_xor2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14739 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, FNOREG, T_LONG, this->ideal_Opcode(), 16);
  
#line 28631 "ad_loongarch.cpp"
  }
}

void reduce_xor32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14750 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_BYTE, this->ideal_Opcode(), 32);
  
#line 28651 "ad_loongarch.cpp"
  }
}

void reduce_xor16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14761 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_SHORT, this->ideal_Opcode(), 32);
  
#line 28671 "ad_loongarch.cpp"
  }
}

void reduce_xor8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14772 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_INT, this->ideal_Opcode(), 32);
  
#line 28691 "ad_loongarch.cpp"
  }
}

void reduce_xor4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14783 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ reduce(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, T_LONG, this->ideal_Opcode(), 32);
  
#line 28711 "ad_loongarch.cpp"
  }
}

void round2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14795 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    switch (opnd_array(2)->constant()) {
      case RoundDoubleModeNode::rmode_rint:  __ vfrintrne_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */); break;
      case RoundDoubleModeNode::rmode_floor: __ vfrintrm_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);  break;
      case RoundDoubleModeNode::rmode_ceil:  __ vfrintrp_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);  break;
    }
  
#line 28732 "ad_loongarch.cpp"
  }
}

void round4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14809 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    switch (opnd_array(2)->constant()) {
      case RoundDoubleModeNode::rmode_rint:  __ xvfrintrne_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */); break;
      case RoundDoubleModeNode::rmode_floor: __ xvfrintrm_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);  break;
      case RoundDoubleModeNode::rmode_ceil:  __ xvfrintrp_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);  break;
    }
  
#line 28753 "ad_loongarch.cpp"
  }
}

void cvt16Bto16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14825 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vext2xv_h_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 28769 "ad_loongarch.cpp"
  }
}

void cvt16Sto16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14838 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvpermi_q(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x01);
    __ vsrlni_b_h(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
  
#line 28787 "ad_loongarch.cpp"
  }
}

void cvt8Sto8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14849 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vext2xv_w_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 28803 "ad_loongarch.cpp"
  }
}

void cvt8Sto8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14859 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vext2xv_w_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ xvffint_s_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
  
#line 28820 "ad_loongarch.cpp"
  }
}

void cvt8Ito8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14873 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvpermi_q(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x01);
    __ vsrlni_h_w(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
  
#line 28838 "ad_loongarch.cpp"
  }
}

void cvt4Ito4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14884 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vffint_s_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 28854 "ad_loongarch.cpp"
  }
}

void cvt4Ito4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14894 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vext2xv_d_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 28870 "ad_loongarch.cpp"
  }
}

void cvt8Ito8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14904 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvffint_s_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 28886 "ad_loongarch.cpp"
  }
}

void cvt4Ito4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14914 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vext2xv_d_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ xvffint_d_l(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
  
#line 28903 "ad_loongarch.cpp"
  }
}

void cvt4Lto4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14928 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvpermi_q(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x01);
    __ vsrlni_w_d(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
  
#line 28921 "ad_loongarch.cpp"
  }
}

void cvt4Lto4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14940 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvpermi_q(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x01);
    __ xvffint_s_l(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 28939 "ad_loongarch.cpp"
  }
}

void cvt2Lto2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14951 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vffint_d_l(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 28955 "ad_loongarch.cpp"
  }
}

void cvt4Lto4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14961 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvffint_d_l(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 28971 "ad_loongarch.cpp"
  }
}

void cvt8Fto8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14974 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vftintrz_w_s(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ xvpermi_q(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0x01);
    __ vsrlni_h_w(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 28991 "ad_loongarch.cpp"
  }
}

void cvt4Fto4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14986 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vftintrz_w_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29007 "ad_loongarch.cpp"
  }
}

void cvt8Fto8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14996 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvftintrz_w_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29023 "ad_loongarch.cpp"
  }
}

void cvt4Fto4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15007 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvpermi_d(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0b01010000);
    __ xvftintrzl_l_s(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 29041 "ad_loongarch.cpp"
  }
}

void cvt4Fto4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15018 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvpermi_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0b01010000);
    __ xvfcvtl_d_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
  
#line 29058 "ad_loongarch.cpp"
  }
}

void cvt4Dto4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15032 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvftintrz_w_d(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ xvpermi_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, 0b11011000);
  
#line 29076 "ad_loongarch.cpp"
  }
}

void cvt4Dto4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15044 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvfcvt_s_d(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ xvpermi_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, 0b11011000);
  
#line 29094 "ad_loongarch.cpp"
  }
}

void cvt2Dto2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15055 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vftintrz_l_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29110 "ad_loongarch.cpp"
  }
}

void cvt4Dto4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15065 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvftintrz_l_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29126 "ad_loongarch.cpp"
  }
}

void reinterpretXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15078 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // empty
  
#line 29142 "ad_loongarch.cpp"
  }
}

void reinterpretYNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15089 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // empty
  
#line 29158 "ad_loongarch.cpp"
  }
}

void reinterpretX2YNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15100 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // The higher 128-bits of the "dst" register must be cleared to zero.
    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */==  opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ xvinsgr2vr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, R0, 2);
      __ xvinsgr2vr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, R0, 3);
    } else {
      __ xvxor_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      __ xvpermi_q(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0b00110000);
    }
  
#line 29181 "ad_loongarch.cpp"
  }
}

void reinterpretY2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15118 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */==  opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      // empty
    } else {
      __ vori_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
    }
  
#line 29201 "ad_loongarch.cpp"
  }
}

void insert16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15134 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vinsgr2vr_b(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, opnd_array(3)->constant());
  
#line 29219 "ad_loongarch.cpp"
  }
}

void insert8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15144 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vinsgr2vr_h(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, opnd_array(3)->constant());
  
#line 29237 "ad_loongarch.cpp"
  }
}

void insert4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15154 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vinsgr2vr_w(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, opnd_array(3)->constant());
  
#line 29255 "ad_loongarch.cpp"
  }
}

void insert2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15164 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vinsgr2vr_d(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, opnd_array(3)->constant());
  
#line 29273 "ad_loongarch.cpp"
  }
}

void insert4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15175 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vpickve2gr_w(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */, 0);
    __ vinsgr2vr_w(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(3)->constant());
  
#line 29293 "ad_loongarch.cpp"
  }
}

void insert2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15187 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vpickve2gr_d(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */, 0);
    __ vinsgr2vr_d(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(3)->constant());
  
#line 29313 "ad_loongarch.cpp"
  }
}

void insert32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15198 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    int idx = opnd_array(3)->constant();
    int msbw, lsbw;
    switch (idx % 4) {
      case 0: msbw =  7, lsbw =  0; break;
      case 1: msbw = 15, lsbw =  8; break;
      case 2: msbw = 23, lsbw = 16; break;
      case 3: msbw = 31, lsbw = 24; break;
      default:
        ShouldNotReachHere();
    }
    __ xvpickve2gr_w(SCR1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, idx >> 2);
    __ bstrins_w(SCR1, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, msbw, lsbw);
    __ xvinsgr2vr_w(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, SCR1, idx >> 2);
  
#line 29343 "ad_loongarch.cpp"
  }
}

void insert16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15220 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    int idx = opnd_array(3)->constant();
    int msbw = (idx % 2) ? 31 : 15;
    int lsbw = (idx % 2) ? 16 :  0;
    __ xvpickve2gr_w(SCR1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, idx >> 1);
    __ bstrins_w(SCR1, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, msbw, lsbw);
    __ xvinsgr2vr_w(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, SCR1, idx >> 1);
  
#line 29366 "ad_loongarch.cpp"
  }
}

void insert8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15235 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvinsgr2vr_w(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, opnd_array(3)->constant());
  
#line 29384 "ad_loongarch.cpp"
  }
}

void insert4LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15245 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvinsgr2vr_d(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, opnd_array(3)->constant());
  
#line 29402 "ad_loongarch.cpp"
  }
}

void insert8FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15255 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvinsve0_w(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */, opnd_array(3)->constant());
  
#line 29420 "ad_loongarch.cpp"
  }
}

void insert4DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15265 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvinsve0_d(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */, opnd_array(3)->constant());
  
#line 29438 "ad_loongarch.cpp"
  }
}

void blendV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15278 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vbitsel_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* mask */);
  
#line 29456 "ad_loongarch.cpp"
  }
}

void blendV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15289 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvbitsel_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* mask */);
  
#line 29474 "ad_loongarch.cpp"
  }
}

void loadmask16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15301 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vneg_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29490 "ad_loongarch.cpp"
  }
}

void loadmask32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15311 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvneg_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29506 "ad_loongarch.cpp"
  }
}

void loadmask16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15321 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vext2xv_h_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ xvneg_h(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
  
#line 29523 "ad_loongarch.cpp"
  }
}

void storemask16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15334 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vneg_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29540 "ad_loongarch.cpp"
  }
}

void storemask32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15344 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvneg_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29557 "ad_loongarch.cpp"
  }
}

void storemask16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15355 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvpermi_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0b00001110);
    __ vsrlni_b_h(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
    __ vneg_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 29577 "ad_loongarch.cpp"
  }
}

void anytrue_in_maskV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15371 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // No need to use src2, src2 is all ones.
    __ vpermi_w(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, 0b00001110);
    __ vor_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
    __ vpickve2gr_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
    __ sltu(opnd_array(0)->as_Register(ra_,this)/* dst */, R0, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 29599 "ad_loongarch.cpp"
  }
}

void alltrue_in_maskV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15387 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // No need to use src2, src2 is all ones.
    __ vpermi_w(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, 0b00001110);
    __ vand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
    __ vpickve2gr_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
    __ sltui(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, -1);
    __ xori(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, 1);
  
#line 29622 "ad_loongarch.cpp"
  }
}

void anytrue_in_maskV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15404 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // No need to use src2, src2 is all ones.
    __ xvpermi_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, 0b00001110);
    __ vor_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */);
    __ vpermi_w(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, 0b00001110);
    __ vor_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */);
    __ vpickve2gr_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, 0);
    __ sltu(opnd_array(0)->as_Register(ra_,this)/* dst */, R0, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 29647 "ad_loongarch.cpp"
  }
}

void alltrue_in_maskV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15422 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // No need to use src2, src2 is all ones.
    __ xvpermi_d(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, 0b00001110);
    __ vand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */);
    __ vpermi_w(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, 0b00001110);
    __ vand_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */);
    __ vpickve2gr_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, 0);
    __ sltui(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, -1);
    __ xori(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, 1);
  
#line 29673 "ad_loongarch.cpp"
  }
}

void cmpV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15442 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    BasicType bt = vector_element_basic_type(this);
    __ vector_compare(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, bt, opnd_array(3)->constant(), 16);
  
#line 29692 "ad_loongarch.cpp"
  }
}

void cmpV32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15454 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    BasicType bt = vector_element_basic_type(this);
    __ vector_compare(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, bt, opnd_array(3)->constant(), 32);
  
#line 29711 "ad_loongarch.cpp"
  }
}

void loadcon16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15467 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ li(AT, (long)StubRoutines::la::vector_iota_indices());
    __ vld(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT, (int)0);
  
#line 29728 "ad_loongarch.cpp"
  }
}

void loadcon32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15478 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ li(AT, (long)StubRoutines::la::vector_iota_indices());
    __ xvld(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT, (int)0);
  
#line 29745 "ad_loongarch.cpp"
  }
}

void loadShuffle16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15491 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // empty
  
#line 29761 "ad_loongarch.cpp"
  }
}

void loadShuffle32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15501 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    // empty
  
#line 29777 "ad_loongarch.cpp"
  }
}

void loadShuffle16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15511 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vext2xv_hu_bu(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29793 "ad_loongarch.cpp"
  }
}

void rearrange16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15523 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vshuf_b(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shuffle */);
  
#line 29810 "ad_loongarch.cpp"
  }
}

void rearrange32BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15534 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvpermi_q(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x00);
    __ xvpermi_q(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x11);
    __ xvshuf_b(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shuffle */);
  
#line 29831 "ad_loongarch.cpp"
  }
}

void rearrange16SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15547 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvpermi_q(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x00);
    __ xvpermi_q(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0x11);
    __ xvshuf_h(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */);
  
#line 29852 "ad_loongarch.cpp"
  }
}

void popcount4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15561 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ vpcnt_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29868 "ad_loongarch.cpp"
  }
}

void popcount8INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15571 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    __ xvpcnt_w(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 29884 "ad_loongarch.cpp"
  }
}

void compareAndSwapP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 32 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 29904 "ad_loongarch.cpp"
  }
}

void compareAndSwapN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 66 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 29923 "ad_loongarch.cpp"
  }
}

void compareAndSwapPAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 39 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 29943 "ad_loongarch.cpp"
  }
}

void compareAndSwapNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 93 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 29962 "ad_loongarch.cpp"
  }
}

void compareAndExchangeN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 108 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*is_cae*/ true, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 29981 "ad_loongarch.cpp"
  }
}

void compareAndExchangeP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 123 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*is_cae*/ true, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 30000 "ad_loongarch.cpp"
  }
}

void compareAndExchangeNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 138 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*is_cae*/ true, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 30019 "ad_loongarch.cpp"
  }
}

void compareAndExchangePAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 153 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*is_cae*/ true, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 30038 "ad_loongarch.cpp"
  }
}

void weakCompareAndSwapN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 167 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 30058 "ad_loongarch.cpp"
  }
}

void weakCompareAndSwapP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 183 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 30078 "ad_loongarch.cpp"
  }
}

void weakCompareAndSwapNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 199 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 30098 "ad_loongarch.cpp"
  }
}

void weakCompareAndSwapPAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 215 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/shenandoah/shenandoah_loongarch_64.ad"

    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 30118 "ad_loongarch.cpp"
  }
}

void zLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 123 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"

    Address ref_addr = Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), as_Register(opnd_array(1)->index(ra_,this,idx1)), Address::no_scale, opnd_array(1)->disp(ra_,this,idx1));
    __ block_comment("zLoadP");
    __ ld_ptr(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, ref_addr);
    z_load_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, barrier_data());
  
#line 30139 "ad_loongarch.cpp"
  }
}

void zCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 142 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"

    __ block_comment("zCompareAndSwapP");
    z_compare_and_swap(_masm, this,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, false /* weak */, false /* acquire */);
  
#line 30162 "ad_loongarch.cpp"
  }
}

void zCompareAndSwapP_acqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 160 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"

    __ block_comment("zCompareAndSwapP_acq");
    z_compare_and_swap(_masm, this,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, false /* weak */, true /* acquire */);
  
#line 30185 "ad_loongarch.cpp"
  }
}

void zCompareAndSwapPWeakNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 180 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"

    __ block_comment("zCompareAndSwapPWeak");
    z_compare_and_swap(_masm, this,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, true /* weak */, false /* acquire */);
  
#line 30208 "ad_loongarch.cpp"
  }
}

void zCompareAndSwapPWeak_acqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 198 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"

    __ block_comment("zCompareAndSwapPWeak_acq");
    z_compare_and_swap(_masm, this,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, true /* weak */, true /* acquire */);
  
#line 30231 "ad_loongarch.cpp"
  }
}

void zCompareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 220 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"

    __ block_comment("zCompareAndExchangeP");
    z_compare_and_exchange(_masm, this,
                           opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */,
                           false /* weak */, false /* acquire */);
  
#line 30254 "ad_loongarch.cpp"
  }
}

void zCompareAndExchangeP_acqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 241 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"

    __ block_comment("zCompareAndExchangeP_acq");
    z_compare_and_exchange(_masm, this,
                           opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */,
                           false /* weak */, true /* acquire */);
  
#line 30277 "ad_loongarch.cpp"
  }
}

void zGetAndSetPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 258 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/gc/z/z_loongarch_64.ad"

    Register prev = opnd_array(3)->as_Register(ra_,this,idx3)/* prev */;
    Register newv = opnd_array(2)->as_Register(ra_,this,idx2)/* newv */;
    Register addr = opnd_array(1)->as_Register(ra_,this,idx1)/* mem */;
    __ block_comment("zGetAndSetP");
    if (prev == newv || prev == addr) {
      __ amswap_db_d(AT, newv, addr);
      __ move(prev, AT);
    } else {
      __ amswap_db_d(prev, newv, addr);
    }
    z_load_barrier(_masm, this, Address(noreg, 0), prev, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, barrier_data());
  
#line 30306 "ad_loongarch.cpp"
  }
}

const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI_convI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2UBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2SNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2USNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadL_unalignedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_regNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_reg_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_immL_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_immL_0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadN2PNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadN2PKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeP_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmP_immP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmP_immP_0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeN_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeP2NNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeP2N_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNKlass_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeP2NKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeP2NKlass_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmN_immN_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmN_immN_0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeB_immB_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB_convI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB_convI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS_convI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeI_immI_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeI_immI_0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeI_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* lbu_and_lmaskNode::memory_operand() const { return _opnds[2]; }
const MachOper* lbu_and_lmask_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* lbu_and_rmaskNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS_convI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeC_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_regNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_immF_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadD_unalignedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeD_regNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeD_immD_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmCMNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeIConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPLockedNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setNNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setPNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addL_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addI_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapP_acqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2L_rmaskNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2L_lmaskNode::memory_operand() const { return _opnds[2]; }
const MachOper* loadUI2L_lmask_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* popCountI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadV16Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV32Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV16Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV32Node::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* zLoadPNode::memory_operand() const { return _opnds[1]; }


const bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // VecA
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // VecZ
    false,  // RegVectMask
    false,  // RegFlags
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    true ,  // AbsI
    true ,  // AbsL
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    false,  // ArrayCopy
    false,  // AryEq
    false,  // AtanD
    true ,  // Binary
    false,  // Blackhole
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    true ,  // ReverseBytesUS
    true ,  // ReverseBytesS
    false,  // CProj
    false,  // CacheWB
    false,  // CacheWBPreSync
    false,  // CacheWBPostSync
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    false,  // CallLeafVector
    true ,  // CallRuntime
    false,  // CallNative
    true ,  // CallStaticJava
    true ,  // CastDD
    true ,  // CastFF
    true ,  // CastII
    true ,  // CastLL
    true ,  // CastVV
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    false,  // ConstraintCast
    true ,  // CMoveD
    false,  // CMoveVD
    true ,  // CMoveF
    false,  // CMoveVF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    true ,  // CMoveN
    true ,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    true ,  // CmpUL
    false,  // CompareAndSwapB
    false,  // CompareAndSwapS
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    true ,  // CompareAndSwapN
    false,  // WeakCompareAndSwapB
    false,  // WeakCompareAndSwapS
    true ,  // WeakCompareAndSwapI
    true ,  // WeakCompareAndSwapL
    true ,  // WeakCompareAndSwapP
    true ,  // WeakCompareAndSwapN
    false,  // CompareAndExchangeB
    false,  // CompareAndExchangeS
    true ,  // CompareAndExchangeI
    true ,  // CompareAndExchangeL
    true ,  // CompareAndExchangeP
    true ,  // CompareAndExchangeN
    false,  // GetAndAddB
    false,  // GetAndAddS
    true ,  // GetAndAddI
    true ,  // GetAndAddL
    false,  // GetAndSetB
    false,  // GetAndSetS
    true ,  // GetAndSetI
    true ,  // GetAndSetL
    true ,  // GetAndSetP
    true ,  // GetAndSetN
    false,  // Con
    true ,  // ConN
    true ,  // ConNKlass
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    true ,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    false,  // OuterStripMinedLoop
    false,  // OuterStripMinedLoopEnd
    false,  // LongCountedLoop
    false,  // LongCountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    true ,  // CreateEx
    true ,  // DecodeN
    true ,  // DecodeNKlass
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    false,  // DivMod
    false,  // DivModI
    false,  // DivModL
    true ,  // EncodeISOArray
    true ,  // EncodeP
    true ,  // EncodePKlass
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // FmaD
    true ,  // FmaF
    true ,  // Goto
    true ,  // Halt
    true ,  // HasNegatives
    true ,  // If
    false,  // RangeCheck
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    false,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    true ,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    true ,  // LoadNKlass
    true ,  // LoadL
    true ,  // LoadL_unaligned
    true ,  // LoadPLocked
    true ,  // LoadP
    true ,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    false,  // Loop
    false,  // LoopLimit
    false,  // Mach
    false,  // MachNullCheck
    false,  // MachProj
    false,  // MulAddS2I
    true ,  // MaxI
    false,  // MaxL
    false,  // MaxD
    false,  // MaxF
    true ,  // MemBarAcquire
    true ,  // LoadFence
    false,  // SetVectMaskI
    true ,  // MemBarAcquireLock
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // StoreFence
    true ,  // StoreStoreFence
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    false,  // MinL
    false,  // MinF
    false,  // MinD
    false,  // ModD
    false,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    true ,  // MulD
    true ,  // MulF
    true ,  // MulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    false,  // NegI
    false,  // NegL
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    false,  // OnSpinWait
    false,  // Opaque1
    false,  // OpaqueLoopInit
    false,  // OpaqueLoopStride
    false,  // Opaque2
    false,  // Opaque3
    false,  // Opaque4
    false,  // ProfileBoolean
    true ,  // OrI
    true ,  // OrL
    false,  // OverflowAddI
    false,  // OverflowSubI
    false,  // OverflowMulI
    false,  // OverflowAddL
    false,  // OverflowSubL
    false,  // OverflowMulL
    false,  // PCTable
    false,  // Parm
    true ,  // PartialSubtypeCheck
    false,  // SubTypeCheck
    false,  // Phi
    true ,  // PopCountI
    true ,  // PopCountL
    true ,  // PopCountVI
    true ,  // PrefetchAllocation
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    false,  // Root
    true ,  // RoundDouble
    true ,  // RoundDoubleMode
    true ,  // RoundDoubleModeV
    true ,  // RoundFloat
    true ,  // RotateLeft
    true ,  // RotateLeftV
    true ,  // RotateRight
    true ,  // RotateRightV
    true ,  // SafePoint
    false,  // SafePointScalarObject
    true ,  // ShenandoahCompareAndExchangeP
    true ,  // ShenandoahCompareAndExchangeN
    true ,  // ShenandoahCompareAndSwapN
    true ,  // ShenandoahCompareAndSwapP
    true ,  // ShenandoahWeakCompareAndSwapN
    true ,  // ShenandoahWeakCompareAndSwapP
    false,  // ShenandoahIUBarrier
    false,  // ShenandoahLoadReferenceBarrier
    false,  // SCMemProj
    true ,  // CopySignD
    true ,  // CopySignF
    false,  // SignumD
    false,  // SignumF
    true ,  // SqrtD
    false,  // SqrtF
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StorePConditional
    true ,  // StoreIConditional
    true ,  // StoreLConditional
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    true ,  // StoreN
    true ,  // StoreNKlass
    true ,  // StrComp
    true ,  // StrCompressedCopy
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // StrIndexOfChar
    true ,  // StrInflatedCopy
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    false,  // MacroLogicV
    true ,  // ThreadLocal
    false,  // Unlock
    false,  // URShiftB
    false,  // URShiftS
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    true ,  // AddVB
    true ,  // AddVS
    true ,  // AddVI
    true ,  // AddReductionVI
    true ,  // AddVL
    true ,  // AddReductionVL
    true ,  // AddVF
    true ,  // AddReductionVF
    true ,  // AddVD
    true ,  // AddReductionVD
    true ,  // SubVB
    true ,  // SubVS
    true ,  // SubVI
    true ,  // SubVL
    true ,  // SubVF
    true ,  // SubVD
    true ,  // MulVB
    true ,  // MulVS
    true ,  // MulVI
    true ,  // MulReductionVI
    true ,  // MulVL
    true ,  // MulReductionVL
    true ,  // MulVF
    true ,  // MulReductionVF
    true ,  // MulVD
    true ,  // MulReductionVD
    true ,  // MulAddVS2VI
    true ,  // FmaVD
    true ,  // FmaVF
    true ,  // DivVF
    true ,  // DivVD
    true ,  // AbsVB
    true ,  // AbsVS
    true ,  // AbsVI
    true ,  // AbsVL
    true ,  // AbsVF
    true ,  // AbsVD
    true ,  // NegVI
    true ,  // NegVF
    true ,  // NegVD
    true ,  // SqrtVD
    true ,  // SqrtVF
    true ,  // LShiftCntV
    true ,  // RShiftCntV
    true ,  // LShiftVB
    true ,  // LShiftVS
    true ,  // LShiftVI
    true ,  // LShiftVL
    true ,  // RShiftVB
    true ,  // RShiftVS
    true ,  // RShiftVI
    true ,  // RShiftVL
    true ,  // URShiftVB
    true ,  // URShiftVS
    true ,  // URShiftVI
    true ,  // URShiftVL
    true ,  // AndV
    true ,  // AndReductionV
    true ,  // OrV
    true ,  // OrReductionV
    true ,  // XorV
    true ,  // XorReductionV
    true ,  // MinV
    true ,  // MaxV
    true ,  // MinReductionV
    true ,  // MaxReductionV
    true ,  // LoadVector
    false,  // LoadVectorGather
    true ,  // StoreVector
    false,  // StoreVectorScatter
    false,  // LoadVectorMasked
    false,  // StoreVectorMasked
    false,  // VectorCmpMasked
    false,  // VectorMaskGen
    false,  // VectorMaskOp
    false,  // VectorMaskTrueCount
    false,  // VectorMaskFirstTrue
    false,  // VectorMaskLastTrue
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    true ,  // ReplicateB
    true ,  // ReplicateS
    true ,  // ReplicateI
    true ,  // ReplicateL
    true ,  // ReplicateF
    true ,  // ReplicateD
    false,  // Extract
    false,  // ExtractB
    false,  // ExtractUB
    false,  // ExtractC
    false,  // ExtractS
    false,  // ExtractI
    false,  // ExtractL
    false,  // ExtractF
    false,  // ExtractD
    false,  // Digit
    false,  // LowerCase
    false,  // UpperCase
    false,  // Whitespace
    false,  // VectorBox
    false,  // VectorBoxAllocate
    false,  // VectorUnbox
    false,  // VectorMaskWrapper
    true ,  // VectorMaskCmp
    false,  // VectorMaskCast
    true ,  // VectorTest
    true ,  // VectorBlend
    true ,  // VectorRearrange
    true ,  // VectorLoadMask
    true ,  // VectorLoadShuffle
    true ,  // VectorLoadConst
    true ,  // VectorStoreMask
    true ,  // VectorReinterpret
    false,  // VectorCast
    true ,  // VectorCastB2X
    true ,  // VectorCastS2X
    true ,  // VectorCastI2X
    true ,  // VectorCastL2X
    true ,  // VectorCastF2X
    true ,  // VectorCastD2X
    true    // VectorInsert
};


int Compile::sync_stack_slots() const { return 2; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::Name(RA_num); }

uint Compile::varargs_C_out_slots_killed() const { return 0; }

OptoRegPair Matcher::return_value(uint ideal_reg) {

#line 2542 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    assert( ideal_reg >= Op_RegI && ideal_reg <= Op_RegL, "only return normal values" );
                               /* -- , -- , Op_RegN, Op_RegI, Op_RegP, Op_RegF, Op_RegD, Op_RegL */
    static int lo[Op_RegL+1] = { 0, 0, V0_num,       V0_num,       V0_num,       F0_num,       F0_num,     V0_num };
    static int hi[Op_RegL+1] = { 0, 0, OptoReg::Bad, OptoReg::Bad, V0_H_num,     OptoReg::Bad, F0_H_num,   V0_H_num};
    return OptoRegPair(hi[ideal_reg],lo[ideal_reg]);
  
#line 30903 "ad_loongarch.cpp"

}

OptoRegPair Matcher::c_return_value(uint ideal_reg) {

#line 2530 "/builddir/build/BUILD/java-17-openjdk-17.0.9.0.9-1.an23.1.loongarch64/jdk-17.0.9+9/src/hotspot/cpu/loongarch/loongarch_64.ad"

    assert( ideal_reg >= Op_RegI && ideal_reg <= Op_RegL, "only return normal values" );
                               /* -- , -- , Op_RegN, Op_RegI, Op_RegP, Op_RegF, Op_RegD, Op_RegL */
    static int lo[Op_RegL+1] = { 0, 0, V0_num,       V0_num,       V0_num,       F0_num,       F0_num,    V0_num };
    static int hi[Op_RegL+1] = { 0, 0, OptoReg::Bad, OptoReg::Bad, V0_H_num,     OptoReg::Bad, F0_H_num,  V0_H_num };
    return OptoRegPair(hi[ideal_reg],lo[ideal_reg]);
  
#line 30917 "ad_loongarch.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(T1_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(FP_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(SP_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

bool Compile::needs_deep_clone_jvms() { return false; }

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DLOONGARCH64=1
#ifndef LOONGARCH64
#  error "LOONGARCH64 must be defined"
#endif // LOONGARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
